(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    363130,       9351]
NotebookOptionsPosition[    360231,       9246]
NotebookOutlinePosition[    360646,       9264]
CellTagsIndexPosition[    360603,       9261]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Copyright", " ", "2015", " ", "Thomas", " ", "Trogdon"}], " ", 
     "&"}], " ", "Deniz", " ", "Bilman"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "This", " ", "software", " ", "is", " ", "distributed", " ", "under", " ", 
    "the", " ", "terms", " ", "of", " ", "the", " ", "GNU", " ", "General", 
    " ", "Public", " ", "License"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.6344859954769497`*^9, 3.634486006067308*^9}}],

Cell[CellGroupData[{

Cell["Documentation", "Section",
 InitializationGroup->True,
 CellChangeTimes->{{3.513708165818142*^9, 3.51370816752608*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<RiemannHilbert`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"SetScatteringData", ";"}], "\[IndentingNewLine]", 
 RowBox[{"SetParams", ";"}], "\[IndentingNewLine]", 
 RowBox[{"GetScatteringData", ";"}], "\[IndentingNewLine]", 
 RowBox[{"ScatteringMatrixFiniteToda", ";"}], "\[IndentingNewLine]", 
 RowBox[{"ScatteringMatrixFiniteTodaC", ";"}], "\[IndentingNewLine]", 
 RowBox[{"LocatePolesToda", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ResiduesToda", ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "CircleRHP", ";", "\[IndentingNewLine]", "CircleRHPsamp", ";", 
    "\[IndentingNewLine]", "\[CapitalDelta]", ";", "\[IndentingNewLine]", 
    "z0", ";", "\[IndentingNewLine]", "ift", ";", "\[IndentingNewLine]", 
    "TodaInit", ";", "\[IndentingNewLine]", "\[Delta]1", ";", 
    "\[IndentingNewLine]", "TodaabOld", ";", "\[IndentingNewLine]", 
    "GetLastSolution", ";", "\[IndentingNewLine]", "DD", ";", 
    "\[IndentingNewLine]", "PoleList", ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"GetLastRHP", ";"}], "\[IndentingNewLine]", 
 RowBox[{"TodaAB", ";"}], "\[IndentingNewLine]", 
 RowBox[{"Todaab", ";"}], "\[IndentingNewLine]", 
 RowBox[{"TodaChoose", ";"}], "\[IndentingNewLine]", 
 RowBox[{"TodaABAuto", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TodaabAuto", ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"LogFun", ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"contours", ";"}], "\[IndentingNewLine]", 
 RowBox[{"TPoints", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CSPoints", ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Func", ";", "\[IndentingNewLine]", "Func2", ";", "\[IndentingNewLine]", 
    "XX", ";", "\[IndentingNewLine]", "sing", ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Delta]", ";"}], "\[IndentingNewLine]", 
 RowBox[{"U", ";"}], "\[IndentingNewLine]", 
 RowBox[{"ift", ";"}], "\[IndentingNewLine]", 
 RowBox[{"z0", ";"}], "\[IndentingNewLine]", 
 RowBox[{"CircleRHP", ";"}], "\[IndentingNewLine]", 
 RowBox[{"TodaChoose", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Begin", "[", "\"\<Private`\>\"", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.6344860611790037`*^9, 3.634486073289921*^9}, {
   3.634487026698937*^9, 3.6344870754556227`*^9}, {3.634551255247245*^9, 
   3.634551258684733*^9}, {3.634554446246501*^9, 3.6345544488444557`*^9}, {
   3.6345545417438374`*^9, 3.6345545726216183`*^9}, {3.6345549639938173`*^9, 
   3.634554966462879*^9}, {3.634559238973143*^9, 3.634559241012187*^9}, {
   3.6345619836945*^9, 3.634561990883029*^9}, {3.634563040425397*^9, 
   3.634563044600646*^9}, {3.634563641257056*^9, 3.634563645070589*^9}, {
   3.6345760735990067`*^9, 3.6345760858136168`*^9}, {3.634580624964077*^9, 
   3.634580631602056*^9}, {3.6345807114309*^9, 3.634580713678914*^9}, {
   3.6345812900986223`*^9, 3.634581295056362*^9}, {3.634581653318356*^9, 
   3.6345816555880537`*^9}, {3.634585375990884*^9, 3.6345853766044483`*^9}, {
   3.6345884832617493`*^9, 3.6345884863567123`*^9}, {3.634651690438616*^9, 
   3.6346516952044277`*^9}, {3.634657026432205*^9, 3.634657028124489*^9}, {
   3.634657218456439*^9, 3.634657248869526*^9}, {3.634672422050597*^9, 
   3.634672424464507*^9}, {3.634672722071262*^9, 3.634672723788631*^9}, {
   3.634733528694378*^9, 3.634733530028825*^9}, {3.634742549260598*^9, 
   3.634742550786779*^9}, {3.634744067271839*^9, 3.6347440674229803`*^9}, {
   3.6347535917477083`*^9, 3.6347535952740593`*^9}, {3.6362220025868683`*^9, 
   3.636222003936676*^9}, {3.6363190683295317`*^9, 3.636319069196724*^9}, {
   3.6363191809993668`*^9, 3.6363191829244823`*^9}, {3.636320218740953*^9, 
   3.636320220658053*^9}, {3.636362032784782*^9, 3.636362034090419*^9}, {
   3.6363628186854267`*^9, 3.636362838977544*^9}, {3.636368167893375*^9, 
   3.636368170106639*^9}, {3.6363685173151627`*^9, 3.636368517793003*^9}, {
   3.6363691287383747`*^9, 3.636369129152091*^9}, {3.636369503944141*^9, 
   3.636369507789816*^9}, {3.636369822519567*^9, 3.6363698234450483`*^9}, {
   3.63637562642584*^9, 3.63637562678239*^9}, {3.636376479088879*^9, 
   3.636376482222788*^9}, {3.63637909558319*^9, 3.636379100140192*^9}, {
   3.636381050217025*^9, 3.636381052246853*^9}, {3.636381477205596*^9, 
   3.6363814819061003`*^9}, {3.636381597978428*^9, 3.636381599254839*^9}, {
   3.636383108024353*^9, 3.636383109614057*^9}, {3.636386497034285*^9, 
   3.636386497401745*^9}, {3.636387047178896*^9, 3.636387049241022*^9}, {
   3.636387150456456*^9, 3.63638715280075*^9}, {3.636450556983528*^9, 
   3.636450560741959*^9}, {3.6364800317465687`*^9, 3.636480032359633*^9}, {
   3.636480181440402*^9, 3.636480185083521*^9}, {3.63654345053732*^9, 
   3.636543453734126*^9}, {3.6365576660767717`*^9, 3.6365576666427507`*^9}, {
   3.6365594334673653`*^9, 3.636559435201383*^9}, {3.6365600294394627`*^9, 
   3.636560030468853*^9}, {3.636560180092639*^9, 3.636560181138577*^9}, {
   3.63656058845818*^9, 3.6365605890296803`*^9}, {3.636562474709244*^9, 
   3.6365624815946007`*^9}, {3.636562619322864*^9, 3.636562620440343*^9}, {
   3.6365692067485247`*^9, 3.636569211714799*^9}, {3.636569573351755*^9, 
   3.636569575717104*^9}, {3.63657038553144*^9, 3.636570388441422*^9}, 
   3.637437611164629*^9, {3.645285670445713*^9, 3.6452856745867987`*^9}, {
   3.64528778497209*^9, 3.645287788866797*^9}, {3.645292561497209*^9, 
   3.645292562639009*^9}, {3.6454668557213*^9, 3.645466859005945*^9}, {
   3.645467131130117*^9, 3.64546713214359*^9}, {3.645467578227395*^9, 
   3.645467634971654*^9}, {3.645468023884245*^9, 3.645468028257765*^9}, {
   3.645484587583839*^9, 3.645484590245873*^9}, {3.6458076423253393`*^9, 
   3.6458076502510643`*^9}, {3.645809162874378*^9, 3.645809163536386*^9}, {
   3.647437246281213*^9, 3.647437248238608*^9}, {3.6474393371518307`*^9, 
   3.647439337837357*^9}, {3.647455358263167*^9, 3.647455360964813*^9}, {
   3.658593011826878*^9, 3.658593015120195*^9}, {3.658593933746673*^9, 
   3.658593934808641*^9}, {3.658594154053959*^9, 3.658594161091082*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Setup", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.546363064814*^9, 3.546363067493*^9}, {
  3.565745327189906*^9, 3.5657453277187843`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"z0", "[", 
    RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"IntervalToTopCircle", "[", 
     RowBox[{
      RowBox[{"-", "n"}], "/", "t"}], "]"}], 
    RowBox[{"Exp", "[", 
     RowBox[{"I", " ", "100", "$MachineEpsilon"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]0", "[", 
    RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"Im", "[", 
    RowBox[{"z0", "[", 
     RowBox[{"n", ",", "t"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"z0i", "[", 
    RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"1", "/", 
    RowBox[{"z0", "[", 
     RowBox[{"n", ",", "t"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"z0", "[", 
    RowBox[{"_", ",", 
     RowBox[{"t_", "?", "ZeroQ"}]}], "]"}], "=", "\[Infinity]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetScatteringData", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rr_", ",", "ma_", ",", "mc_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"rr1_", ",", "ma1_", ",", "mc1_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"R1", "[", "k_", "]"}], ":=", 
       RowBox[{"rr", "[", "k", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"R2", "[", "k_", "]"}], ":=", 
       RowBox[{"rr1", "[", "k", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[CapitalLambda]1", "=", "ma"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[CapitalLambda]2", "=", "ma1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"c1", "=", "mc"}], ";", "\[IndentingNewLine]", 
      RowBox[{"c2", "=", "mc1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"R", "=", "R2"}], ";", "\[IndentingNewLine]", 
      RowBox[{"c", "=", "c2"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[CapitalLambda]", "=", "\[CapitalLambda]2"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Ri", "[", "k_", "]"}], ":=", 
       RowBox[{"-", 
        RowBox[{"R", "[", 
         RowBox[{"1", "/", "k"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Tau]", "[", "k_", "]"}], ":=", 
       RowBox[{"1", "+", " ", 
        RowBox[{
         RowBox[{"R", "[", "k", "]"}], 
         RowBox[{"Ri", "[", "k", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Tau]", "[", 
        RowBox[{"_", "?", "InfinityQ"}], "]"}], ":=", "1"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Tau]", "[", "k_List", "]"}], ":=", 
       RowBox[{"\[Tau]", "/@", "k"}]}], ";"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GetLastRHP", "[", "]"}], ":=", "lastrhp"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"GetLastSolution", "[", "]"}], ":=", "innersolution"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"SetScatteringData", "[", 
      RowBox[{
      "aa_", ",", "bb_", ",", "rr_", ",", "ma_", ",", "a_", ",", "b_"}], 
      "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"r", "[", "k_", "]"}], ":=", 
         RowBox[{"rr", "[", "k", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ri", "[", "k_", "]"}], ":=", 
         RowBox[{"-", 
          RowBox[{"rr", "[", 
           RowBox[{"1", "/", "k"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"A", "=", "ma"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Tau]", "[", "k_", "]"}], ":=", 
         RowBox[{"1", "+", " ", 
          RowBox[{
           RowBox[{"r", "[", "k", "]"}], 
           RowBox[{"ri", "[", "k", "]"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Tau]", "[", 
          RowBox[{"_", "?", "InfinityQ"}], "]"}], ":=", "1"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Tau]", "[", "k_List", "]"}], ":=", 
         RowBox[{"\[Tau]", "/@", "k"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"c", " ", "=", " ", 
         RowBox[{"Residues", "[", 
          RowBox[{"a", ",", "b", ",", "ma", ","}], "]"}]}], ";"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetParams", "[", 
    RowBox[{"nu_", ",", "rad1_", ",", "tol_", ",", "sN_", ",", "bN_"}], "]"}],
    ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"strip", "=", "nu"}], ";", " ", 
      RowBox[{"(*", 
       RowBox[{
       "parameter", " ", "for", " ", "width", " ", "of", " ", "strip", " ", 
        "of", " ", "analyticity"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"rad", "=", "rad1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"globalTol", "=", "tol"}], ";", "\[IndentingNewLine]", 
      RowBox[{"smallN", "=", "sN"}], ";", "\[IndentingNewLine]", 
      RowBox[{"largeN", "=", "bN"}], ";", "\[IndentingNewLine]", 
      RowBox[{"expconst", "=", 
       RowBox[{"10", "^", 
        RowBox[{"(", "0", ")"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"eps", "=", ".01"}], ";", 
      RowBox[{"(*", 
       RowBox[{"size", " ", "of", " ", "subdivision", " ", "near", " ", "1"}],
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"StartToda", "[", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"TodaInit", "[", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GetScatteringData", "[", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "A", ",", "c"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.63448616168644*^9, 3.6344862617350283`*^9}, {
   3.634486303197608*^9, 3.634486303574624*^9}, {3.634486341053179*^9, 
   3.63448648844144*^9}, {3.63448693886203*^9, 3.634486960891451*^9}, {
   3.634486995018539*^9, 3.63448701774142*^9}, {3.634491712216044*^9, 
   3.634491715350416*^9}, {3.6344918048608932`*^9, 3.634491855586857*^9}, {
   3.6345514397966757`*^9, 3.634551441786002*^9}, {3.634552396940777*^9, 
   3.634552400885116*^9}, {3.6345529323411694`*^9, 3.634552933338171*^9}, {
   3.634554601246314*^9, 3.6345546040293694`*^9}, {3.634563578466707*^9, 
   3.634563597393145*^9}, {3.6345760619767017`*^9, 3.63457606967782*^9}, {
   3.634581613319921*^9, 3.634581633853787*^9}, {3.634649866153047*^9, 
   3.6346498803436127`*^9}, {3.634649967925034*^9, 3.6346500166823463`*^9}, {
   3.6346501511511927`*^9, 3.634650185005364*^9}, {3.634650351905531*^9, 
   3.634650370817458*^9}, {3.634656331731214*^9, 3.634656357202887*^9}, {
   3.634659929324711*^9, 3.634659930729411*^9}, {3.634660105125066*^9, 
   3.6346601124049063`*^9}, {3.645356874394701*^9, 3.6453568887922487`*^9}, {
   3.645465075885545*^9, 3.64546509925277*^9}, {3.645465287371481*^9, 
   3.645465287750392*^9}, 3.645465325592404*^9, {3.6454658032206917`*^9, 
   3.6454658036822443`*^9}, {3.645466777196768*^9, 3.645466780297798*^9}, {
   3.647434427538747*^9, 3.6474344276633244`*^9}, {3.647439731932274*^9, 
   3.6474397323138113`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reflection Coefficient", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5407685463534*^9, 3.5407685478054*^9}, {
  3.5657108306542*^9, 3.5657108348501997`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Normalized", " ", "at"}], " ", "+", "\[Infinity]"}], ",", " ", 
    RowBox[{"behaves", " ", "like", " ", 
     RowBox[{"\[Zeta]", "^", 
      RowBox[{"(", "\[Sigma]n", ")"}]}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Jost", "[", 
      RowBox[{"\[Zeta]_", ",", 
       RowBox[{"+", "1"}], ",", "\[Sigma]_", ",", "nn_", ",", "a_", ",", 
       "b_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Phi]", ",", "n"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Phi]", "[", "nn", "]"}], "=", "1"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Phi]", "[", 
          RowBox[{"nn", "-", "1"}], "]"}], "=", "1"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"n", "=", 
         RowBox[{"nn", "-", "2"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"n", "\[GreaterEqual]", 
           RowBox[{"-", "1"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Phi]", "[", "n", "]"}], "=", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Zeta]", "^", "\[Sigma]"}], "/", 
                RowBox[{"a", "[", "n", "]"}]}], ")"}]}], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"\[Zeta]", "^", "\[Sigma]"}], " ", 
                RowBox[{"a", "[", 
                 RowBox[{"n", "+", "1"}], "]"}], 
                RowBox[{"\[Phi]", "[", 
                 RowBox[{"n", "+", "2"}], "]"}]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"b", "[", 
                   RowBox[{"n", "+", "1"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"\[Zeta]", "+", 
                    RowBox[{"1", "/", "\[Zeta]"}]}], ")"}], "/", "2"}]}], 
                 ")"}], 
                RowBox[{"\[Phi]", "[", 
                 RowBox[{"n", "+", "1"}], "]"}]}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"n", "=", 
            RowBox[{"n", "-", "1"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Phi]", "[", "#", "]"}], 
          RowBox[{"\[Zeta]", "^", 
           RowBox[{"(", 
            RowBox[{"\[Sigma]", " ", "#"}], ")"}]}]}], "&"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"Normalized", " ", "at"}], " ", "-", "\[Infinity]"}], ",", " ", 
     
     RowBox[{"behaves", " ", "like", " ", 
      RowBox[{"\[Zeta]", "^", 
       RowBox[{"(", 
        RowBox[{"-", "\[Sigma]n"}], ")"}]}], " ", "\[IndentingNewLine]", 
      "Maybe", " ", "we", " ", "can", " ", "compile", " ", 
      RowBox[{"these", " ", "?"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Jost", "[", 
      RowBox[{"\[Zeta]_", ",", 
       RowBox[{"-", "1"}], ",", "\[Sigma]_", ",", "nn_", ",", "a_", ",", 
       "b_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Phi]", ",", "n"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Phi]", "[", 
          RowBox[{"-", "nn"}], "]"}], "=", "1"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{"\[Phi]", "[", 
          RowBox[{
           RowBox[{"-", "nn"}], "+", "1"}], "]"}], "=", "1"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"n", "=", 
         RowBox[{
          RowBox[{"-", "nn"}], "+", "2"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"n", "\[LessEqual]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Phi]", "[", "n", "]"}], "=", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Zeta]", "^", "\[Sigma]"}], "/", 
                RowBox[{"a", "[", 
                 RowBox[{"n", "-", "1"}], "]"}]}], ")"}]}], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"\[Zeta]", "^", "\[Sigma]"}], " ", 
                RowBox[{"a", "[", 
                 RowBox[{"n", "-", "2"}], "]"}], 
                RowBox[{"\[Phi]", "[", 
                 RowBox[{"n", "-", "2"}], "]"}]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"b", "[", 
                   RowBox[{"n", "-", "1"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"\[Zeta]", "+", 
                    RowBox[{"1", "/", "\[Zeta]"}]}], ")"}], "/", "2"}]}], 
                 ")"}], 
                RowBox[{"\[Phi]", "[", 
                 RowBox[{"n", "-", "1"}], "]"}]}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"n", "=", 
            RowBox[{"n", "+", "1"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Phi]", "[", "#", "]"}], 
          RowBox[{"\[Zeta]", "^", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[Sigma]"}], " ", "#"}], ")"}]}]}], "&"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"JostP", "=", 
     RowBox[{"Compile", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Zeta]", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Sigma]", ",", "_Integer"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"nn", ",", "_Integer"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"a", ",", "_Complex", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"b", ",", "_Complex", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\[Phi]", "=", "a"}], ",", 
           RowBox[{"n", "=", "nn"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Phi]", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"2", "nn"}], "+", "1"}], "]"}], "]"}], "=", "1"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\[Phi]", "[", 
            RowBox[{"[", 
             RowBox[{"2", "nn"}], "]"}], "]"}], "=", "1"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"n", "=", 
           RowBox[{
            RowBox[{"2", "nn"}], "-", "1"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"n", "\[GreaterEqual]", "nn"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Phi]", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Zeta]", "^", "\[Sigma]"}], "/", 
                  RowBox[{"a", "[", 
                   RowBox[{"[", "n", "]"}], "]"}]}], ")"}]}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"\[Zeta]", "^", "\[Sigma]"}], " ", 
                  RowBox[{"a", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", "+", "1"}], "]"}], "]"}], 
                  RowBox[{"\[Phi]", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", "+", "2"}], "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"b", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", "+", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Zeta]", "+", 
                    RowBox[{"1", "/", "\[Zeta]"}]}], ")"}], "/", "2"}]}], 
                   ")"}], 
                  RowBox[{"\[Phi]", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", "+", "1"}], "]"}], "]"}]}]}], ")"}]}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"n", "=", 
              RowBox[{"n", "-", "1"}]}], ";"}]}], "\[IndentingNewLine]", 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Phi]", "[", 
             RowBox[{"[", 
              RowBox[{"n", "+", "2"}], "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"\[Phi]", "[", 
              RowBox[{"[", 
               RowBox[{"n", "+", "3"}], "]"}], "]"}], 
             RowBox[{"\[Zeta]", "^", 
              RowBox[{"(", "\[Sigma]", ")"}]}]}]}], "}"}]}]}], 
        "\[IndentingNewLine]", "]"}], ",", 
       RowBox[{"CompilationTarget", "\[Rule]", "\"\<C\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"JostM", "=", 
     RowBox[{"Compile", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Zeta]", ",", "_Complex"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Sigma]", ",", "_Integer"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"nn", ",", "_Integer"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"a", ",", "_Complex", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"b", ",", "_Complex", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\[Phi]", "=", "a"}], ",", 
           RowBox[{"n", "=", "nn"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Phi]", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "=", "1"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\[Phi]", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "=", "1"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"n", "=", "3"}], ";", "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"n", "\[LessEqual]", 
             RowBox[{"nn", "+", "2"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Phi]", "[", 
               RowBox[{"[", "n", "]"}], "]"}], "=", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Zeta]", "^", "\[Sigma]"}], "/", 
                  RowBox[{"a", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", "-", "1"}], "]"}], "]"}]}], ")"}]}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"\[Zeta]", "^", "\[Sigma]"}], " ", 
                  RowBox[{"a", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", "-", "2"}], "]"}], "]"}], 
                  RowBox[{"\[Phi]", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", "-", "2"}], "]"}], "]"}]}], "+", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"b", "[", 
                    RowBox[{"[", 
                    RowBox[{"n", "-", "1"}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Zeta]", "+", 
                    RowBox[{"1", "/", "\[Zeta]"}]}], ")"}], "/", "2"}]}], 
                   ")"}], 
                  RowBox[{"\[Phi]", "[", 
                   RowBox[{"[", 
                    RowBox[{"n", "-", "1"}], "]"}], "]"}]}]}], ")"}]}]}], ";",
              "\[IndentingNewLine]", 
             RowBox[{"n", "=", 
              RowBox[{"n", "+", "1"}]}], ";"}]}], "\[IndentingNewLine]", 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\[Phi]", "[", 
             RowBox[{"[", 
              RowBox[{"nn", "+", "1"}], "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"\[Phi]", "[", 
              RowBox[{"[", 
               RowBox[{"nn", "+", "2"}], "]"}], "]"}], 
             RowBox[{"\[Zeta]", "^", 
              RowBox[{"(", 
               RowBox[{"-", "\[Sigma]"}], ")"}]}]}]}], "}"}]}]}], 
        "\[IndentingNewLine]", "]"}], ",", 
       RowBox[{"CompilationTarget", "\[Rule]", "\"\<C\>\""}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Wronski", "[", 
       RowBox[{"a_", ",", "n_"}], "]"}], "[", 
      RowBox[{"f_", ",", "g_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"a", "[", "n", "]"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"f", "[", "n", "]"}], 
         RowBox[{"g", "[", 
          RowBox[{"n", "+", "1"}], "]"}]}], "-", 
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{"n", "+", "1"}], "]"}], 
         RowBox[{"g", "[", "n", "]"}]}]}], ")"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"WronskiC", "[", "a_", "]"}], "[", 
      RowBox[{"f_", ",", "g_"}], "]"}], ":=", 
     RowBox[{"a", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{"[", "1", "]"}], "]"}], 
         RowBox[{"g", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "-", 
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{"[", "2", "]"}], "]"}], 
         RowBox[{"g", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}]}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ScatteringMatrixFiniteToda", "[", 
       RowBox[{"a_", ",", "b_", ",", "nn_"}], "]"}], "[", "\[Zeta]_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\[Beta]", ",", "\[Phi]pm", ",", "\[Phi]pp", ",", "\[Phi]mp", ",", 
         "\[Phi]mm", ",", "\[Alpha]"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Phi]pm", "=", 
         RowBox[{"Jost", "[", 
          RowBox[{"\[Zeta]", ",", "1", ",", 
           RowBox[{"-", "1"}], ",", "nn", ",", "a", ",", "b"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Phi]pp", "=", 
         RowBox[{"Jost", "[", 
          RowBox[{
          "\[Zeta]", ",", "1", ",", "1", ",", "nn", ",", "a", ",", "b"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Phi]mm", "=", 
         RowBox[{"Jost", "[", 
          RowBox[{"\[Zeta]", ",", 
           RowBox[{"-", "1"}], ",", "1", ",", "nn", ",", "a", ",", "b"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Phi]mp", "=", 
         RowBox[{"Jost", "[", 
          RowBox[{"\[Zeta]", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}], ",", "nn", ",", "a", ",", "b"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Beta]", "=", 
         FractionBox[
          RowBox[{"2", " ", 
           RowBox[{
            RowBox[{"Wronski", "[", 
             RowBox[{"a", ",", "0"}], "]"}], "[", 
            RowBox[{"\[Phi]mm", ",", "\[Phi]pm"}], "]"}]}], 
          RowBox[{"\[Zeta]", "-", 
           FractionBox["1", "\[Zeta]"]}]]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Alpha]", "=", 
         FractionBox[
          RowBox[{"2", " ", 
           RowBox[{
            RowBox[{"Wronski", "[", 
             RowBox[{"a", ",", "0"}], "]"}], "[", 
            RowBox[{"\[Phi]pp", ",", "\[Phi]mm"}], "]"}]}], 
          RowBox[{"\[Zeta]", "-", 
           FractionBox["1", "\[Zeta]"]}]]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Conjugate", "[", "\[Alpha]", "]"}], ",", "\[Beta]"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Conjugate", "[", "\[Beta]", "]"}], ",", "\[Alpha]"}], 
           "}"}]}], "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ScatteringMatrixFiniteTodaC", "[", 
       RowBox[{"a_", ",", "b_", ",", "nn_"}], "]"}], "[", "\[Zeta]_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\[Beta]", ",", "\[Phi]pm", ",", "\[Phi]pp", ",", "\[Phi]mp", ",", 
         "\[Phi]mm", ",", "\[Alpha]", ",", "NN", ",", "A", ",", "B"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"NN", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"-", "nn"}], ",", "nn"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"A", "=", 
         RowBox[{"a", "[", "NN", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"B", "=", 
         RowBox[{"b", "[", "NN", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Phi]pm", "=", 
         RowBox[{"JostP", "[", 
          RowBox[{"\[Zeta]", ",", 
           RowBox[{"-", "1"}], ",", "nn", ",", "A", ",", "B"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Phi]pp", "=", 
         RowBox[{"JostP", "[", 
          RowBox[{"\[Zeta]", ",", "1", ",", "nn", ",", "A", ",", "B"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Phi]mm", "=", 
         RowBox[{"JostM", "[", 
          RowBox[{"\[Zeta]", ",", "1", ",", "nn", ",", "A", ",", "B"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Phi]mp", "=", 
         RowBox[{"JostM", "[", 
          RowBox[{"\[Zeta]", ",", 
           RowBox[{"-", "1"}], ",", "nn", ",", "A", ",", "B"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Beta]", "=", 
         FractionBox[
          RowBox[{"2", " ", 
           RowBox[{
            RowBox[{"WronskiC", "[", 
             RowBox[{"a", "[", "0", "]"}], "]"}], "[", 
            RowBox[{"\[Phi]mm", ",", "\[Phi]pm"}], "]"}]}], 
          RowBox[{"\[Zeta]", "-", 
           FractionBox["1", "\[Zeta]"]}]]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Alpha]", "=", 
         FractionBox[
          RowBox[{"2", " ", 
           RowBox[{
            RowBox[{"WronskiC", "[", 
             RowBox[{"a", "[", "0", "]"}], "]"}], "[", 
            RowBox[{"\[Phi]pp", ",", "\[Phi]mm"}], "]"}]}], 
          RowBox[{"\[Zeta]", "-", 
           FractionBox["1", "\[Zeta]"]}]]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Conjugate", "[", "\[Alpha]", "]"}], ",", "\[Beta]"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Conjugate", "[", "\[Beta]", "]"}], ",", "\[Alpha]"}], 
           "}"}]}], "}"}]}]}], "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6067396197140017`*^9, 3.606739619961176*^9}, {
   3.606740457834692*^9, 3.606740462425825*^9}, {3.606756870506476*^9, 
   3.606756896869054*^9}, {3.6067573505697803`*^9, 3.606757361335435*^9}, {
   3.606760000144485*^9, 3.606760059147492*^9}, {3.606822589489613*^9, 
   3.606822593695072*^9}, {3.606823058465664*^9, 3.606823081685204*^9}, 
   3.6068233668196983`*^9, {3.60682371157966*^9, 3.6068237353266773`*^9}, {
   3.606823808337929*^9, 3.60682381412825*^9}, {3.6068241346134567`*^9, 
   3.606824152570056*^9}, 3.607164695630308*^9, {3.634486510019702*^9, 
   3.634486537647871*^9}, {3.63448656800113*^9, 3.6344865940623903`*^9}, {
   3.634486624704208*^9, 3.63448663259018*^9}, {3.634486668901885*^9, 
   3.6344867772236958`*^9}, {3.6344868466213207`*^9, 
   3.6344868925817547`*^9}, {3.634731767909346*^9, 3.634731844896668*^9}, {
   3.6347319041967688`*^9, 3.634731924911006*^9}, {3.63473196255118*^9, 
   3.634732003667055*^9}, {3.634733385207899*^9, 3.634733466780429*^9}, {
   3.6347335938403473`*^9, 3.6347336078221684`*^9}, {3.634733661307457*^9, 
   3.63473374278573*^9}, {3.634733779506756*^9, 3.634733789320516*^9}, {
   3.634733820706918*^9, 3.634733846125525*^9}, {3.634734114534239*^9, 
   3.634734123156098*^9}, {3.634734295900352*^9, 3.634734296236292*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Eigenvalues", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6344867803835382`*^9, 3.634486781638795*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LocatePolesToda", "[", 
     RowBox[{"a_", ",", "b_", ",", "n_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"L", ",", "i"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"L", "=", 
        RowBox[{"ConstantArray", "[", 
         RowBox[{"0.", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"2", "n"}], "+", "1"}], ",", 
            RowBox[{
             RowBox[{"2", "n"}], "+", "1"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", 
          RowBox[{"-", "n"}]}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"n", "-", "1"}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"L", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"i", "+", "n", "+", "1"}], ",", 
              RowBox[{"i", "+", "n", "+", "1"}]}], "]"}], "]"}], "=", 
           RowBox[{"b", "[", "i", "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"L", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"i", "+", "n", "+", "1"}], ",", 
              RowBox[{"i", "+", "n", "+", "2"}]}], "]"}], "]"}], "=", 
           RowBox[{"a", "[", "i", "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"L", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"i", "+", "n", "+", "2"}], ",", 
              RowBox[{"i", "+", "n", "+", "1"}]}], "]"}], "]"}], "=", 
           RowBox[{"a", "[", "i", "]"}]}], ";"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"L", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{
            RowBox[{"2", "n"}], "+", "1"}], ",", 
           RowBox[{
            RowBox[{"2", "n"}], "+", "1"}]}], "]"}], "]"}], "=", 
        RowBox[{"b", "[", "n", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DeleteCases", "[", 
         RowBox[{
          RowBox[{"Eigenvalues", "[", "L", "]"}], ",", 
          RowBox[{"aa_", "/;", 
           RowBox[{
            RowBox[{"Abs", "[", "aa", "]"}], "\[LessEqual]", "1"}]}]}], "]"}],
         "//", "IntervalToInnerCircle"}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "IntervalToInnerCircle", " ", "maps", " ", "eigenvalues", " ", "on", " ", 
    "the", " ", "line", " ", "to", " ", "poles", " ", "for", " ", "the", " ", 
    "cirle", " ", "RHP", " ", "INSIDE", " ", "the", " ", "unit", " ", 
    "circle"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ResiduesToda", "[", 
    RowBox[{"a_", ",", "b_", ",", "\[CapitalLambda]_", ",", "nn_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Zeta]", ",", "i", ",", "norm", ",", "\[Phi]p", ",", "\[Phi]m", ",", 
       "\[Phi]"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"norm", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"\[CapitalLambda]", "\[Equal]", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"Return", "[", "norm", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", 
         RowBox[{"Length", "[", "\[CapitalLambda]", "]"}]}], ",", 
        RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Zeta]", "=", 
          RowBox[{"\[CapitalLambda]", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"\[Phi]p", "=", 
          RowBox[{"Jost", "[", 
           RowBox[{
           "\[Zeta]", ",", "1", ",", "1", ",", "nn", ",", "a", ",", "b"}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"\[Phi]m", "=", 
          RowBox[{"Jost", "[", 
           RowBox[{"\[Zeta]", ",", 
            RowBox[{"-", "1"}], ",", "1", ",", "nn", ",", "a", ",", "b"}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Phi]", "[", "n_", "]"}], ":=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"n", " ", "\[GreaterEqual]", "0"}], ",", 
            RowBox[{"\[Phi]p", "[", "n", "]"}], ",", 
            RowBox[{
             RowBox[{"\[Phi]m", "[", "n", "]"}], 
             RowBox[{
              RowBox[{"\[Phi]p", "[", "0", "]"}], "/", 
              RowBox[{"\[Phi]m", "[", "0", "]"}]}]}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"norm", "=", 
          RowBox[{"norm", "~", "Join", "~", 
           RowBox[{"{", 
            RowBox[{"1", "/", 
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Abs", "[", 
                 RowBox[{"\[Phi]", "[", "n", "]"}], "]"}], "^", "2"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", 
                 RowBox[{"-", "nn"}], ",", "nn"}], "}"}]}], "]"}]}], 
            "}"}]}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", "norm"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6067396197140017`*^9, 3.606739619961176*^9}, {
   3.606740457834692*^9, 3.606740462425825*^9}, {3.606756870506476*^9, 
   3.606756896869054*^9}, {3.6067573505697803`*^9, 3.606757361335435*^9}, {
   3.606760000144485*^9, 3.606760059147492*^9}, {3.606822589489613*^9, 
   3.606822593695072*^9}, {3.606823058465664*^9, 3.606823081685204*^9}, 
   3.6068233668196983`*^9, {3.60682371157966*^9, 3.6068237353266773`*^9}, {
   3.606823808337929*^9, 3.60682381412825*^9}, {3.6068241346134567`*^9, 
   3.606824152570056*^9}, 3.607164695630308*^9, {3.634486510019702*^9, 
   3.634486537647871*^9}, {3.63448656800113*^9, 3.6344865940623903`*^9}, {
   3.634486624704208*^9, 3.63448663259018*^9}, {3.634486668901885*^9, 
   3.6344867772236958`*^9}, {3.6344868135746317`*^9, 3.63448681536017*^9}, {
   3.6344869231359453`*^9, 3.634486925059989*^9}, {3.634487060674389*^9, 
   3.634487065865121*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Jump Functions", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.568128904921782*^9, 3.56812890695053*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "initialize", " ", "functions", " ", "that", " ", "are", " ", "expensive", 
    " ", "to", " ", "evaluate"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"meps", "=", "$MachineEpsilon"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NSqrt", "[", "x_", "]"}], ":=", 
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"-", "x"}], "]"}], 
     RowBox[{"(", "I", ")"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NegReQ", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"Re", "[", "x", "]"}], "\[LessEqual]", "0"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"PosImQ", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"Im", "[", "x", "]"}], "\[GreaterEqual]", "0"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CircSqrt", "[", 
      RowBox[{"a_", "?", "NegReQ"}], "]"}], "[", "z_", "]"}], ":=", 
    TagBox[GridBox[{
       {"\[Piecewise]", GridBox[{
          {
           RowBox[{"NSqrt", "[", 
            RowBox[{"z", "-", "a"}], "]"}], 
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], "\[LessEqual]", "1"}], "&&", 
            RowBox[{
             RowBox[{"Im", "[", "z", "]"}], "\[GreaterEqual]", 
             RowBox[{"Im", "[", "a", "]"}]}]}]},
          {
           RowBox[{"-", 
            RowBox[{"NSqrt", "[", 
             RowBox[{"z", "-", "a"}], "]"}]}], 
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], "\[LessEqual]", "1"}], "&&", 
            RowBox[{
             RowBox[{"Im", "[", "z", "]"}], "<", 
             RowBox[{"Im", "[", "a", "]"}]}]}]},
          {
           RowBox[{"NSqrt", "[", 
            RowBox[{"z", "-", "a"}], "]"}], 
           RowBox[{
            RowBox[{
             RowBox[{"Re", "[", "z", "]"}], ">", "0"}], "&&", 
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], ">", "1"}], "&&", 
            RowBox[{
             RowBox[{"Im", "[", "a", "]"}], "\[LessEqual]", 
             RowBox[{"Im", "[", "z", "]"}], "\[LessEqual]", "0"}]}]},
          {
           RowBox[{"NSqrt", "[", 
            RowBox[{"z", "-", "a"}], "]"}], 
           RowBox[{
            RowBox[{
             RowBox[{"Re", "[", "z", "]"}], ">", "0"}], "&&", 
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], ">", "1"}], "&&", 
            RowBox[{"0", "\[LessEqual]", 
             RowBox[{"Im", "[", "z", "]"}], "\[LessEqual]", 
             RowBox[{"Im", "[", "a", "]"}]}]}]},
          {
           RowBox[{"-", 
            RowBox[{"NSqrt", "[", 
             RowBox[{"z", "-", "a"}], "]"}]}], "True"}
         },
         AllowedDimensions->{2, Automatic},
         Editable->True,
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{1.}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.35]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "Piecewise",
     DeleteWithContents->True,
     Editable->False,
     SelectWithContents->True,
     Selectable->False]}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"CircSqrt", "[", 
      RowBox[{"a_", "?", "PosImQ"}], "]"}], "[", "z_", "]"}], ":=", 
    TagBox[GridBox[{
       {"\[Piecewise]", GridBox[{
          {
           RowBox[{"NSqrt", "[", 
            RowBox[{"z", "-", "a"}], "]"}], 
           RowBox[{
            RowBox[{
             RowBox[{"Re", "[", "z", "]"}], ">", "0"}], "&&", 
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], ">", "1"}], "&&", 
            RowBox[{
             RowBox[{"Im", "[", "a", "]"}], "\[LessEqual]", 
             RowBox[{"Im", "[", "z", "]"}], "\[LessEqual]", "0"}]}]},
          {
           RowBox[{"NSqrt", "[", 
            RowBox[{"z", "-", "a"}], "]"}], 
           RowBox[{
            RowBox[{
             RowBox[{"Re", "[", "z", "]"}], ">", "0"}], "&&", 
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], ">", "1"}], "&&", 
            RowBox[{"0", "\[LessEqual]", 
             RowBox[{"Im", "[", "z", "]"}], "\[LessEqual]", 
             RowBox[{"Im", "[", "a", "]"}]}]}]},
          {
           RowBox[{"-", 
            RowBox[{"NSqrt", "[", 
             RowBox[{"z", "-", "a"}], "]"}]}], "True"}
         },
         AllowedDimensions->{2, Automatic},
         Editable->True,
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{1.}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.35]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "Piecewise",
     DeleteWithContents->True,
     Editable->False,
     SelectWithContents->True,
     Selectable->False]}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"CircSqrt", "[", "a_", "]"}], "[", "z_", "]"}], ":=", 
    TagBox[GridBox[{
       {"\[Piecewise]", GridBox[{
          {
           RowBox[{"NSqrt", "[", 
            RowBox[{"z", "-", "a"}], "]"}], 
           RowBox[{
            RowBox[{
             RowBox[{"Re", "[", "z", "]"}], ">", "0"}], "&&", 
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], ">", "1"}], "&&", 
            RowBox[{
             RowBox[{"Im", "[", "a", "]"}], "\[LessEqual]", 
             RowBox[{"Im", "[", "z", "]"}], "\[LessEqual]", "0"}]}]},
          {
           RowBox[{"NSqrt", "[", 
            RowBox[{"z", "-", "a"}], "]"}], 
           RowBox[{
            RowBox[{
             RowBox[{"Re", "[", "z", "]"}], ">", "0"}], "&&", 
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], ">", "1"}], "&&", 
            RowBox[{"0", "\[LessEqual]", 
             RowBox[{"Im", "[", "z", "]"}], "\[LessEqual]", 
             RowBox[{"Im", "[", "a", "]"}]}]}]},
          {
           RowBox[{"NSqrt", "[", 
            RowBox[{"z", "-", "a"}], "]"}], 
           RowBox[{
            RowBox[{"Abs", "[", "z", "]"}], "<", "1"}]},
          {
           RowBox[{"-", 
            RowBox[{"NSqrt", "[", 
             RowBox[{"z", "-", "a"}], "]"}]}], "True"}
         },
         AllowedDimensions->{2, Automatic},
         Editable->True,
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{1.}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.35]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "Piecewise",
     DeleteWithContents->True,
     Editable->False,
     SelectWithContents->True,
     Selectable->False]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"XX", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"CircSqrt", "[", "a", "]"}], "[", "z", "]"}], 
      RowBox[{
       RowBox[{"CircSqrt", "[", "b", "]"}], "[", "z", "]"}], 
      RowBox[{
       RowBox[{"CircSqrt", "[", 
        RowBox[{"1", "/", "a"}], "]"}], "[", "z", "]"}], 
      RowBox[{
       RowBox[{"CircSqrt", "[", 
        RowBox[{"1", "/", "b"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"H", "[", 
       RowBox[{"\[Theta]a_", ",", "\[Theta]b_"}], "]"}], "[", "ss_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"XX", "[", 
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{"I", " ", "\[Theta]a"}], "]"}], ",", 
           RowBox[{"Exp", "[", 
            RowBox[{"I", " ", "\[Theta]b"}], "]"}]}], "]"}], "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"I", " ", "ss"}], "]"}], 
          RowBox[{"(", 
           RowBox[{"1", "-", "meps"}], ")"}]}], "]"}], "/", 
        RowBox[{"Exp", "[", 
         RowBox[{"2", " ", "I", " ", "ss"}], "]"}]}], "I", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"I", " ", "ss"}], "]"}], "*", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"\[Theta]a", "-", "ss"}], ")"}]}], 
          RowBox[{"(", 
           RowBox[{"\[Theta]b", "-", "ss"}], ")"}]}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Theta]a", "-", "\[Theta]b"}], ")"}], "/", "2"}], 
         ")"}]}]}], "//", "Abs"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"HT", "[", 
       RowBox[{"\[Theta]a_", ",", "\[Theta]b_"}], "]"}], "[", "ss_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"1", "/", "2"}], 
       RowBox[{
        RowBox[{
         RowBox[{"XX", "[", 
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{"I", " ", "\[Theta]a"}], "]"}], ",", 
           RowBox[{"Exp", "[", 
            RowBox[{"I", " ", "\[Theta]b"}], "]"}]}], "]"}], "[", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{"I", " ", "ss"}], "]"}], 
          RowBox[{"(", 
           RowBox[{"1", "-", "meps"}], ")"}]}], "]"}], "/", 
        RowBox[{"Exp", "[", 
         RowBox[{"2", " ", "I", " ", "ss"}], "]"}]}], "I", " ", 
       RowBox[{"Exp", "[", 
        RowBox[{"I", " ", "ss"}], "]"}], "*", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"\[Theta]a", "-", "ss"}], ")"}]}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "Pi"}], "-", "\[Theta]a", "-", "ss"}], ")"}]}], 
         "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "Pi"}], "-", 
            RowBox[{"2", "\[Theta]a"}]}], ")"}], "/", "2"}], ")"}]}]}], "//", 
      "Abs"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Theta]bfun", "[", 
      RowBox[{"\[Theta]a_", ",", "z0_"}], "]"}], ":=", 
     RowBox[{"ArcCos", "[", 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"Re", "[", "z0", "]"}]}], " ", "-", " ", 
       RowBox[{"Cos", "[", "\[Theta]a", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Func", "[", 
      RowBox[{"\[Theta]a_", ",", "z0_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "<", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Re", "[", "z0", "]"}]}], " ", "-", " ", 
         RowBox[{"Cos", "[", "\[Theta]a", "]"}]}], "<", "1"}], ",", 
       RowBox[{
        RowBox[{"SingFun", "[", 
         RowBox[{
          RowBox[{"Fun", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"H", "[", 
               RowBox[{"\[Theta]a", ",", 
                RowBox[{"\[Theta]bfun", "[", 
                 RowBox[{"\[Theta]a", ",", "z0"}], "]"}]}], "]"}], "[", "#", 
              "]"}], "&"}], ",", 
            RowBox[{"Line", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"\[Theta]bfun", "[", 
                RowBox[{"\[Theta]a", ",", "z0"}], "]"}], ",", "\[Theta]a"}], 
              "}"}], "]"}], ",", "40"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "1"}], "/", "2"}], ",", 
            RowBox[{
             RowBox[{"-", "1"}], "/", "2"}]}], "}"}]}], "]"}], "//", 
        "DomainIntegrate"}], ",", "0"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ZeroFun", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"Func", "[", 
       RowBox[{"x", ",", 
        RowBox[{"z0", "[", 
         RowBox[{"n", ",", "t"}], "]"}]}], "]"}], "+", 
      RowBox[{"2", " ", 
       RowBox[{
        RowBox[{"Log", "[", 
         RowBox[{"Im", "[", 
          RowBox[{"z0", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "]"}], "]"}], "/", "t"}]}]}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Func2", "[", 
      RowBox[{"\[Theta]a_", ",", "z0_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "f", "}"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "1"}], "<", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"Re", "[", "z0", "]"}]}], " ", "-", " ", 
           RowBox[{"Cos", "[", "\[Theta]a", "]"}]}], "<", "1"}], ",", 
         RowBox[{
          RowBox[{"f", "=", 
           RowBox[{"SingFun", "[", 
            RowBox[{
             RowBox[{"Fun", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"HT", "[", 
                  RowBox[{"\[Theta]a", ",", 
                   RowBox[{"\[Theta]bfun", "[", 
                    RowBox[{"\[Theta]a", ",", "z0"}], "]"}]}], "]"}], "[", 
                 "#", "]"}], "&"}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{"\[Theta]a", ",", 
                  RowBox[{
                   RowBox[{"2", "Pi"}], "-", "\[Theta]a"}]}], "}"}], "]"}], 
               ",", "40"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"-", "1"}], "/", "2"}], ",", 
               RowBox[{
                RowBox[{"-", "1"}], "/", "2"}]}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"f", "//", "DomainIntegrate"}]}], ",", "0"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"NOTE", ":", " ", 
       RowBox[{"The", " ", "image", " ", "of", " ", "the", " ", "arc", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "z0"}], ")"}], " ", "under", " ", 
        RowBox[{"Func2", "[", 
         RowBox[{"#", ",", "z0"}], "]"}]}]}], "&"}], " ", "always", " ", 
     "contains", " ", 
     RowBox[{"1", "/", "2"}], 
     RowBox[{"\[Rho]0", "^", "3"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"CODE", " ", "TO", " ", "TEST", " ", "THESE", " ", 
       RowBox[{"FUNCTIONS", ":", "\[IndentingNewLine]", "a"}]}], "=", 
      RowBox[{
       RowBox[{"3", 
        RowBox[{"Pi", "/", "4"}]}], "//", "N"}]}], ";", "\[IndentingNewLine]",
      "\t", 
     RowBox[{"b", "=", 
      RowBox[{
       RowBox[{"\[Theta]bfun", "[", 
        RowBox[{"a", ",", "I"}], "]"}], "//", "N"}]}], ";", "\n", "\t", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"NIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"XX", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"I", " ", "a"}], "//", "Exp"}], ",", 
              RowBox[{
               RowBox[{"I", " ", "b"}], "//", "Exp"}]}], "]"}], "[", 
            RowBox[{"Exp", "[", 
             RowBox[{"I", " ", "y"}], "]"}], "]"}], "I", " ", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", "I"}], " ", "y"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", "b", ",", "a"}], "}"}]}], "]"}]}], 
       "\[IndentingNewLine]", "-", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"XX", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"I", " ", "a"}], "//", "Exp"}], ",", 
             RowBox[{
              RowBox[{"I", " ", "b"}], "//", "Exp"}]}], "]"}], "[", 
           RowBox[{"Exp", "[", 
            RowBox[{"I", " ", "y"}], "]"}], "]"}], "I", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "I"}], " ", "y"}], "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", "a", ",", "Pi"}], "}"}]}], "]"}]}], "//", 
      RowBox[{"Im", "\[IndentingNewLine]", 
       RowBox[{"Func", "[", 
        RowBox[{"a", ",", "I"}], "]"}], "\[IndentingNewLine]", 
       RowBox[{"Func2", "[", 
        RowBox[{"a", ",", "I"}], "]"}]}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ZeroFun2", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"Func2", "[", 
       RowBox[{"x", ",", 
        RowBox[{"z0", "[", 
         RowBox[{"n", ",", "t"}], "]"}]}], "]"}], "-", 
      RowBox[{"2", "/", "t"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Bisection", "[", 
      RowBox[{"F_", ",", "a_", ",", "b_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tol", "=", "1"}], ",", 
         RowBox[{"A", "=", "a"}], ",", 
         RowBox[{"B", "=", "b"}], ",", "new", ",", "old", ",", "FA", ",", 
         "FB"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"F", "[", "a", "]"}], 
            RowBox[{"F", "[", "b", "]"}]}], ">", "0"}], ",", 
          RowBox[{"Return", "[", "Null", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FA", " ", "=", 
         RowBox[{"F", "[", "A", "]"}]}], ";", 
        RowBox[{"FB", "=", 
         RowBox[{"F", "[", "B", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"A", "-", "B"}], "]"}], " ", ">", " ", 
           RowBox[{"10", "^", 
            RowBox[{"(", 
             RowBox[{"-", "8"}], ")"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"FB", " ", 
               RowBox[{"F", "[", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"B", "+", "A"}], ")"}], "/", "2"}], "]"}]}], "<", 
              "0"}], ",", " ", 
             RowBox[{"A", " ", "=", " ", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"B", "+", "A"}], ")"}], "/", "2"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"FA", " ", 
               RowBox[{"F", "[", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"B", "+", "A"}], ")"}], "/", "2"}], "]"}]}], "<", 
              "0"}], ",", 
             RowBox[{"B", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"B", "+", "A"}], ")"}], "/", "2"}]}]}], "]"}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "A"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TodaInit", "[", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"LogFun", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"mArg", "[", "z_", "]"}], ":=", 
         RowBox[{"Mod", "[", 
          RowBox[{
           RowBox[{"Arg", "[", "z", "]"}], ",", 
           RowBox[{"2", "Pi"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"LLog", "[", "x_", "]"}], ":=", 
         RowBox[{"Log", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"x", "+", "1"}], ")"}], 
           RowBox[{"(", 
            RowBox[{"1", "-", "x"}], ")"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"LogFun", "[", "a_", "]"}], ":=", 
         RowBox[{
          RowBox[{"LogFun", "[", "a", "]"}], "=", 
          RowBox[{"Fun", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"LLog", "[", "#", "]"}], "&"}], ",", 
            RowBox[{"Line", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", 
               RowBox[{"1", "/", "a"}]}], "}"}], "]"}], ",", "40"}], 
           "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"II2", "[", 
          RowBox[{"s_", ",", "a_", ",", "z_"}], "]"}], ":=", 
         RowBox[{"Cauchy", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"LogFun", "[", "a", "]"}], "}"}], ",", "z"}], "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"This", " ", "improves", " ", "upon", " ", "the", " ", 
            RowBox[{"above", ".", "  ", "It"}], " ", "is", " ", "accurate", 
            " ", "as", " ", "a"}], " ", "\[Rule]", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "1"}], "\[IndentingNewLine]", "Mathematica", " ", 
             "computes", " ", "lint", " ", 
             RowBox[{"(", 
              RowBox[{"logarithmic", " ", "integral"}], ")"}], " ", "as", " ",
              "the", " ", "explicit", " ", "integral", " ", "but", " ", "the",
              " ", "branches", " ", "are", " ", "all", " ", "mixed", " ", 
             RowBox[{"up", ".", "  ", "lintfix"}], " ", "patched", " ", "up", 
             " ", "the", " ", "branch", " ", "issue", " ", "for", " ", 
             RowBox[{"Re", "[", "z0", "]"}]}], "<", "0"}]}], ",", " ", 
          RowBox[{
          "for", " ", "z0", " ", "near", " ", "zero", " ", "we", " ", "use", 
           " ", "the", " ", "old", " ", "function"}], ",", " ", 
          RowBox[{
          "there", " ", "is", " ", "some", " ", "branching", " ", "issue", 
           " ", "here", " ", "for", " ", "lintfix"}]}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"lint", "[", 
           RowBox[{"a1_", ",", "b1_"}], "]"}], "[", "z_", "]"}], ":=", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            RowBox[{"2", " ", "\[Pi]"}]]}], "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              RowBox[{"Log", "[", 
               RowBox[{"1", "+", "a1", "+", 
                RowBox[{"\[ImaginaryI]", " ", "b1"}]}], "]"}]}], " ", 
             RowBox[{"Log", "[", 
              FractionBox[
               RowBox[{
                RowBox[{"-", "a1"}], "-", 
                RowBox[{"\[ImaginaryI]", " ", "b1"}], "+", "z"}], 
               RowBox[{"1", "+", "z"}]], "]"}]}], "+", 
            RowBox[{
             RowBox[{"Log", "[", 
              RowBox[{"1", "+", "a1", "-", 
               RowBox[{"\[ImaginaryI]", " ", "b1"}]}], "]"}], " ", 
             RowBox[{"Log", "[", 
              FractionBox[
               RowBox[{
                RowBox[{"-", "a1"}], "+", 
                RowBox[{"\[ImaginaryI]", " ", "b1"}], "+", "z"}], 
               RowBox[{"1", "+", "z"}]], "]"}]}], "+", 
            RowBox[{"PolyLog", "[", 
             RowBox[{"2", ",", 
              FractionBox[
               RowBox[{"1", "+", "a1", "-", 
                RowBox[{"\[ImaginaryI]", " ", "b1"}]}], 
               RowBox[{"1", "+", "z"}]]}], "]"}], "-", 
            RowBox[{"PolyLog", "[", 
             RowBox[{"2", ",", 
              FractionBox[
               RowBox[{"1", "+", "a1", "+", 
                RowBox[{"\[ImaginaryI]", " ", "b1"}]}], 
               RowBox[{"1", "+", "z"}]]}], "]"}]}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"lintfix", "[", 
           RowBox[{"a1_", ",", "b1_"}], "]"}], "[", "z_", "]"}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "ang", "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ang", "=", " ", 
             RowBox[{
              RowBox[{"a1", "+", 
               RowBox[{"I", " ", "b1"}], "+", "1"}], "//", "Arg"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"-", "ang"}], " ", "<", " ", 
                RowBox[{"Arg", "[", 
                 RowBox[{"z", "+", "1"}], "]"}], "<", "ang"}], " ", "&&", " ", 
               RowBox[{
                RowBox[{"Re", "[", "z", "]"}], "<", " ", "a1"}]}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"lint", "[", 
                 RowBox[{"a1", ",", "b1"}], "]"}], "[", "z", "]"}], "-", 
               RowBox[{"Log", "[", 
                RowBox[{"1", "+", "z"}], "]"}]}], ",", 
              RowBox[{
               RowBox[{"lint", "[", 
                RowBox[{"a1", ",", "b1"}], "]"}], "[", "z", "]"}]}], 
             "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"lint\[Infinity]", "[", 
          RowBox[{"a1_", ",", "b1_"}], "]"}], ":=", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", "b1"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"\[ImaginaryI]", " ", "a1"}], "+", "b1"}], ")"}], " ", 
            RowBox[{"Log", "[", 
             RowBox[{"1", "+", "a1", "-", 
              RowBox[{"\[ImaginaryI]", " ", "b1"}]}], "]"}]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "\[ImaginaryI]"}], "-", 
              RowBox[{"\[ImaginaryI]", " ", "a1"}], "+", "b1"}], ")"}], " ", 
            RowBox[{"Log", "[", 
             RowBox[{"1", "+", "a1", "+", 
              RowBox[{"\[ImaginaryI]", " ", "b1"}]}], "]"}]}]}], 
          RowBox[{"2", " ", "\[Pi]"}]]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"k", "[", "a_", "]"}], "[", "z_", "]"}], ":=", 
         RowBox[{
          RowBox[{"lintfix", "[", 
           RowBox[{
            RowBox[{"Re", "[", "a", "]"}], ",", 
            RowBox[{"Im", "[", "a", "]"}]}], "]"}], "[", 
          RowBox[{"z", "-", "$MachineEpsilon"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"k\[Infinity]", "[", "a_", "]"}], ":=", 
         RowBox[{"lint\[Infinity]", "[", 
          RowBox[{
           RowBox[{"Re", "[", "a", "]"}], ",", 
           RowBox[{"Im", "[", "a", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"llll", "[", "x_", "]"}], ":=", 
         RowBox[{"Log", "[", 
          RowBox[{"(", 
           RowBox[{"1", "-", "x"}], ")"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"LogFunShort", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"LogFunShort", "[", "a_", "]"}], ":=", 
         RowBox[{
          RowBox[{"LogFunShort", "[", "a", "]"}], "=", 
          RowBox[{"Fun", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"llll", "[", "#", "]"}], "&"}], ",", 
            RowBox[{"Line", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", 
               RowBox[{"1", "/", "a"}]}], "}"}], "]"}], ",", "35"}], 
           "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"II", "[", 
          RowBox[{"s_", ",", "a_", ",", "z_"}], "]"}], ":=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"a", "-", "I"}], "]"}], ">", ".1"}], ",", 
           RowBox[{
            RowBox[{"Cauchy", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"LogFunShort", "[", "a", "]"}], "}"}], ",", "z"}], 
             "]"}], "+", 
            RowBox[{
             RowBox[{"k", "[", "a", "]"}], "[", "z", "]"}]}], ",", 
           RowBox[{"II2", "[", 
            RowBox[{"s", ",", "a", ",", "z"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"LLog", "[", "x_", "]"}], ":=", 
           RowBox[{"Log", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"x", "+", "1"}], ")"}], 
             RowBox[{"(", 
              RowBox[{"1", "-", "x"}], ")"}]}], "]"}]}], ";"}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"mLog", "[", "x_", "]"}], ":=", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Log", "[", 
            RowBox[{"-", "x"}], "]"}]}], "+", 
          RowBox[{"I", " ", 
           RowBox[{"Pi", "/", "2"}]}]}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"LogFun2", "//", "Clear"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"mLog", "[", "x_", "]"}], ":=", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"Log", "[", 
              RowBox[{"-", "x"}], "]"}]}], "+", 
            RowBox[{"I", " ", 
             RowBox[{"Pi", "/", "2"}]}]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"LogFun2", "[", "a_", "]"}], ":=", 
           RowBox[{
            RowBox[{"LogFun2", "[", "a", "]"}], "=", 
            RowBox[{"Fun", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"mLog", "[", "#", "]"}], "&"}], ",", 
              RowBox[{"Arc", "[", 
               RowBox[{"0", ",", "1", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Arg", "[", "a", "]"}], ",", 
                  RowBox[{
                   RowBox[{"2", "Pi"}], "-", 
                   RowBox[{"Arg", "[", "a", "]"}]}]}], "}"}]}], "]"}], ",", 
              "largeN"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"II2", "[", 
            RowBox[{"s_", ",", "a_", ",", "z_"}], "]"}], ":=", 
           RowBox[{"Cauchy", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"LogFun2", "[", "a", "]"}], "}"}], ",", "z"}], "]"}]}], 
          ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "this", " ", "should", " ", "be", " ", "simplified", " ", "using", 
          " ", "the", " ", "derivation", " ", "in", " ", "the", " ", 
          "paper"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"sing", "[", 
          RowBox[{"a_", ",", "z_"}], "]"}], ":=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", "z", "]"}], "\[GreaterEqual]", "1."}], " ", "||",
             " ", 
            RowBox[{
             RowBox[{"Re", "[", "z", "]"}], "\[GreaterEqual]", 
             RowBox[{"Re", "[", "a", "]"}]}]}], ",", 
           RowBox[{"II", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "a", ",", "z"}], "]"}], ",", 
           RowBox[{
            RowBox[{"II", "[", 
             RowBox[{
              RowBox[{"+", "1"}], ",", "a", ",", "z"}], "]"}], "+", 
            RowBox[{"LLog", "[", "z", "]"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"sing", "[", 
          RowBox[{"a_", ",", "z_List"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"sing", "[", 
            RowBox[{"a", ",", "#"}], "]"}], "&"}], "/@", "z"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Tau]r", "[", "z_", "]"}], ":=", " ", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"\[Tau]", "[", "z", "]"}]}], "/", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"z", "-", 
               RowBox[{"1", "/", "z"}]}], ")"}], "^", "2"}]}]}], ";"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"ift", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ift", "[", 
          RowBox[{"z0_", ",", "r_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"ift", "[", 
           RowBox[{"z0", ",", "r"}], "]"}], "=", 
          RowBox[{"{", 
           RowBox[{"Fun", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{
                 RowBox[{"-", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{
                    RowBox[{"r", "[", "#", "]"}], 
                    RowBox[{"r", "[", 
                    RowBox[{"1", "/", "#"}], "]"}]}]}], ")"}]}], "/", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"#", "-", 
                    RowBox[{"1", "/", "#"}]}], ")"}], "^", "2"}]}], "]"}], 
               "+", 
               RowBox[{"2", 
                RowBox[{"mLog", "[", "#", "]"}]}]}], "&"}], ",", 
             RowBox[{"Arc", "[", 
              RowBox[{"0", ",", "1", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Arg", "[", "z0", "]"}], ",", 
                 RowBox[{
                  RowBox[{"2", "Pi"}], "-", 
                  RowBox[{"Arg", "[", "z0", "]"}]}]}], "}"}]}], "]"}], ",", 
             RowBox[{
              RowBox[{"2", "largeN"}], "+", "40"}]}], "]"}], "}"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"ift", "[", 
            RowBox[{"z0_", ",", "r_"}], "]"}], ":=", 
           RowBox[{
            RowBox[{"ift", "[", 
             RowBox[{"z0", ",", "r"}], "]"}], "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Fun", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"Log", "[", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{
                    RowBox[{"r", "[", "#", "]"}], 
                    RowBox[{"r", "[", 
                    RowBox[{"1", "/", "#"}], "]"}]}]}], ")"}]}], "/", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#", "-", 
                    RowBox[{"1", "/", "#"}]}], ")"}], "^", "2"}]}], "]"}], 
                  "+", 
                  RowBox[{"2", 
                   RowBox[{"mLog", "[", "#", "]"}]}]}], "&"}], ",", 
                RowBox[{"Arc", "[", 
                 RowBox[{"0", ",", "1", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Arg", "[", "z0", "]"}], ",", 
                    RowBox[{"Pi", "-", "eps"}]}], "}"}]}], "]"}], ",", 
                RowBox[{"40", "+", 
                 RowBox[{"2", "largeN"}]}]}], "]"}], ",", 
              RowBox[{"Fun", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"Log", "[", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{
                    RowBox[{"r", "[", "#", "]"}], 
                    RowBox[{"r", "[", 
                    RowBox[{"1", "/", "#"}], "]"}]}]}], ")"}]}], "/", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#", "-", 
                    RowBox[{"1", "/", "#"}]}], ")"}], "^", "2"}]}], "]"}], 
                  "+", 
                  RowBox[{"2", 
                   RowBox[{"mLog", "[", "#", "]"}]}]}], "&"}], ",", 
                RowBox[{"Arc", "[", 
                 RowBox[{"0", ",", "1", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Pi", "-", "eps"}], ",", 
                    RowBox[{"Pi", "+", "eps"}]}], "}"}]}], "]"}], ",", 
                RowBox[{"20", "+", "smallN"}]}], "]"}], ",", 
              RowBox[{"Fun", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"Log", "[", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{
                    RowBox[{"r", "[", "#", "]"}], 
                    RowBox[{"r", "[", 
                    RowBox[{"1", "/", "#"}], "]"}]}]}], ")"}]}], "/", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#", "-", 
                    RowBox[{"1", "/", "#"}]}], ")"}], "^", "2"}]}], "]"}], 
                  "+", 
                  RowBox[{"2", 
                   RowBox[{"mLog", "[", "#", "]"}]}]}], "&"}], ",", 
                RowBox[{"Arc", "[", 
                 RowBox[{"0", ",", "1", ",", 
                  RowBox[{"{", 
                   RowBox[{"Arg", ",", 
                    RowBox[{
                    RowBox[{"2", "Pi"}], "-", 
                    RowBox[{"Arg", "[", "z0", "]"}]}]}], "}"}]}], "]"}], ",", 
                
                RowBox[{"40", "+", 
                 RowBox[{"2", "largeN"}]}]}], "]"}]}], "}"}]}]}], ";"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"This", " ", "gives", " ", "the", " ", "so"}], "-", 
          RowBox[{"called", " ", "partial", " ", "transmission", " ", 
           RowBox[{"coefficient", "?"}]}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"\[Delta]", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Delta]", "[", 
           RowBox[{"s_", ",", "n_", ",", "t_", ",", "R_"}], "]"}], "[", "z_", 
          "]"}], ":=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Delta]", "[", 
            RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
           "]"}], "=", 
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"Cauchy", "[", 
              RowBox[{
               RowBox[{"ift", "[", 
                RowBox[{
                 RowBox[{"z0", "[", 
                  RowBox[{"n", ",", "t"}], "]"}], ",", "R"}], "]"}], ",", 
               RowBox[{"z", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}]}], 
              "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"sing", "[", 
               RowBox[{
                RowBox[{"z0", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], ",", 
                RowBox[{"z", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}]}], 
               "]"}]}]}], "]"}], 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"z", "-", 
              RowBox[{"z0", "[", 
               RowBox[{"n", ",", "t"}], "]"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"z", "+", "1"}], ")"}]}]}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"Compute", " ", "g"}], ",", " ", 
          RowBox[{
           RowBox[{"the", " ", "g"}], "-", 
           RowBox[{
           "function", " ", "in", " ", "the", " ", "CS", " ", "region"}]}]}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"CSPoints", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"CSPoints", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"CSPoints", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "=", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Theta]a", ",", "\[Theta]b"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\[Theta]a", "=", 
              RowBox[{"Bisection", "[", 
               RowBox[{
                RowBox[{"ZeroFun", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], ",", "Pi", ",", 
                RowBox[{
                 RowBox[{"Arg", "[", 
                  RowBox[{"z0", "[", 
                   RowBox[{"n", ",", "t"}], "]"}], "]"}], "+", 
                 RowBox[{"100", "$MachineEpsilon"}]}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"\[Theta]a", "\[Equal]", "Null"}], ",", 
               RowBox[{"Return", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", 
                  RowBox[{"z0", "[", 
                   RowBox[{"n", ",", "t"}], "]"}]}], "}"}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"\[Theta]b", "=", 
              RowBox[{"\[Theta]bfun", "[", 
               RowBox[{"\[Theta]a", ",", 
                RowBox[{"z0", "[", 
                 RowBox[{"n", ",", "t"}], "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Exp", "[", 
              RowBox[{"I", 
               RowBox[{"{", 
                RowBox[{"\[Theta]a", ",", "\[Theta]b"}], "}"}]}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"iMM", "[", "z_", "]"}], ":=", 
         RowBox[{"I", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"z", "+", "1"}], ")"}], "/", 
           RowBox[{"(", 
            RowBox[{"z", "-", "1"}], ")"}]}]}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{"MM", "[", "x_", "]"}], ":=", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "x"}], ")"}], 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], "+", "x"}]]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Theta]t", "[", 
           RowBox[{"n_", ",", "t_"}], "]"}], "[", "\[Zeta]_", "]"}], ":=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Zeta]", "-", 
            RowBox[{"\[Zeta]", "^", 
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}]}]}], ")"}], "+", " ", 
          RowBox[{"2", "n", " ", 
           RowBox[{
            RowBox[{"Log", "[", "\[Zeta]", "]"}], "/", "t"}]}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"V", "[", 
           RowBox[{"nn_", ",", "T_"}], "]"}], "[", "k_", "]"}], ":=", 
         RowBox[{
          RowBox[{"\[Theta]t", "[", 
           RowBox[{"nn", ",", "T"}], "]"}], "[", 
          RowBox[{"MM", "[", "k", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{"A", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"CSPoints", "[", 
            RowBox[{"n", ",", "t"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "iMM"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"B", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"CSPoints", "[", 
            RowBox[{"n", ",", "t"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "//", "iMM"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Alpha]", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"CSPoints", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Beta]", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"CSPoints", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"iftcs", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"iftcs", "[", 
          RowBox[{"z0_", ",", "r_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"iftcs", "[", 
           RowBox[{"z0", ",", "r"}], "]"}], "=", 
          RowBox[{"{", 
           RowBox[{"Fun", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Log", "[", 
                RowBox[{
                 RowBox[{"-", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{
                    RowBox[{"r", "[", "#", "]"}], 
                    RowBox[{"r", "[", 
                    RowBox[{"1", "/", "#"}], "]"}]}]}], ")"}]}], "/", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"#", "-", 
                    RowBox[{"1", "/", "#"}]}], ")"}], "^", "2"}]}], "]"}], 
               "+", 
               RowBox[{"2", 
                RowBox[{"mLog", "[", "#", "]"}]}]}], "&"}], ",", 
             RowBox[{"Arc", "[", 
              RowBox[{"0", ",", "1", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Arg", "[", "z0", "]"}], ",", 
                 RowBox[{
                  RowBox[{"2", "Pi"}], "-", 
                  RowBox[{"Arg", "[", "z0", "]"}]}]}], "}"}]}], "]"}], ",", 
             RowBox[{"40", "+", 
              RowBox[{"2", "largeN"}]}]}], "]"}], "}"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ci", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ci", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"ci", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "=", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Fun", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"V", "[", 
                   RowBox[{"n", ",", "t"}], "]"}], "'"}], "[", "#", "]"}], 
                "&"}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"B", "[", 
                    RowBox[{"n", ",", "t"}], "]"}]}], ",", 
                  RowBox[{"-", 
                   RowBox[{"A", "[", 
                    RowBox[{"n", ",", "t"}], "]"}]}]}], "}"}], "]"}], ",", 
               "40"}], "]"}], ",", 
             RowBox[{"Fun", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"V", "[", 
                   RowBox[{"n", ",", "t"}], "]"}], "'"}], "[", "#", "]"}], 
                "&"}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"A", "[", 
                   RowBox[{"n", ",", "t"}], "]"}], ",", 
                  RowBox[{"B", "[", 
                   RowBox[{"n", ",", "t"}], "]"}]}], "}"}], "]"}], ",", 
               "40"}], "]"}]}], "}"}], "//", "CauchyInverseCurves"}]}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
         RowBox[{
          RowBox[{"-", "t"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"CauchyInverseIntegral", "[", 
               RowBox[{
                RowBox[{"-", "p"}], ",", "#", ",", 
                RowBox[{"iMM", "[", "z", "]"}]}], "]"}], "&"}], "/@", 
             RowBox[{"ci", "[", 
              RowBox[{"n", ",", "t"}], "]"}]}], "//", "Total"}], ")"}]}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"gg", "[", 
             RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
           RowBox[{
            RowBox[{"-", "t"}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"CauchyInverseIntegral", "[", 
                 RowBox[{
                  RowBox[{"-", "p"}], ",", "#", ",", "z"}], "]"}], "&"}], "/@", 
               RowBox[{"ci", "[", 
                RowBox[{"n", ",", "t"}], "]"}]}], "//", "Total"}], ")"}]}]}], 
          ";"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"d1", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", 
           RowBox[{"-", "1"}], "]"}], "-", 
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", 
           RowBox[{"-", "1"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Delta]d1", "[", 
           RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
         RowBox[{
          RowBox[{"Cauchy", "[", 
           RowBox[{"s", ",", 
            RowBox[{"{", 
             RowBox[{"Fun", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"d1", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], "&"}], ",", 
               RowBox[{"Arc", "[", 
                RowBox[{"0", ",", "1", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[Alpha]", "[", 
                    RowBox[{"n", ",", "t"}], "]"}], "//", "Arg"}], ",", 
                   RowBox[{
                    RowBox[{"2", "Pi"}], "-", 
                    RowBox[{"Arg", "[", 
                    RowBox[{"\[Alpha]", "[", 
                    RowBox[{"n", ",", "t"}], "]"}], "]"}]}]}], "}"}]}], "]"}],
                ",", "2"}], "]"}], "}"}], ",", "z"}], "]"}], "//", "Exp"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"\[Delta]cs", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Delta]cs", "[", 
           RowBox[{"s_", ",", "n_", ",", "t_", ",", "R_"}], "]"}], "[", "z_", 
          "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Delta]cs", "[", 
            RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
           "]"}], "=", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Delta]d1", "[", 
             RowBox[{"s", ",", "n", ",", "t"}], "]"}], "[", 
            RowBox[{"z", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}], "]"}],
            "*", 
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"Cauchy", "[", 
              RowBox[{
               RowBox[{"iftcs", "[", 
                RowBox[{
                 RowBox[{"\[Alpha]", "[", 
                  RowBox[{"n", ",", "t"}], "]"}], ",", "R"}], "]"}], ",", 
               RowBox[{"z", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}]}], 
              "]"}], "+", 
             RowBox[{"2", " ", 
              RowBox[{"sing", "[", 
               RowBox[{
                RowBox[{"\[Alpha]", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], ",", 
                RowBox[{"z", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}]}], 
               "]"}]}]}], "]"}], 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"z", "-", 
              RowBox[{"\[Alpha]", "[", 
               RowBox[{"n", ",", "t"}], "]"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"z", "+", "1"}], ")"}]}]}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"test", "[", 
           RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"Cauchy", "[", 
             RowBox[{
              RowBox[{"iftcs", "[", 
               RowBox[{
                RowBox[{"\[Alpha]", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], ",", "R"}], "]"}], ",", 
              RowBox[{"z", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}]}], 
             "]"}], "+", 
            RowBox[{"2", " ", 
             RowBox[{"sing", "[", 
              RowBox[{
               RowBox[{"\[Alpha]", "[", 
                RowBox[{"n", ",", "t"}], "]"}], ",", 
               RowBox[{"z", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}]}], 
              "]"}]}]}], "]"}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"z", "-", 
             RowBox[{"\[Alpha]", "[", 
              RowBox[{"n", ",", "t"}], "]"}]}], ")"}], "/", 
           RowBox[{"(", 
            RowBox[{"z", "+", "1"}], ")"}]}]}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"compute", " ", "gt"}], ",", " ", 
          RowBox[{
           RowBox[{"the", " ", "g"}], "-", 
           RowBox[{
           "function", " ", "in", " ", "the", " ", "transition", " ", 
            "region"}]}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"TODO", ":", " ", 
          RowBox[{"Does", " ", "TPoints", " ", 
           RowBox[{"work", "?"}]}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TPoints", "//", "Clear"}], ";", 
        RowBox[{
         RowBox[{"TPoints", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"TPoints", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "=", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Theta]a", ",", "\[Theta]b"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\[Theta]a", "=", 
              RowBox[{"Bisection", "[", 
               RowBox[{
                RowBox[{"ZeroFun2", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"Arg", "[", 
                  RowBox[{"z0", "[", 
                   RowBox[{"n", ",", "t"}], "]"}], "]"}], "+", 
                 RowBox[{"100", "$MachineEpsilon"}]}], ",", 
                RowBox[{"Pi", "-", 
                 RowBox[{"10", "$MachineEpsilon"}]}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"\[Theta]a", "\[Equal]", "Null"}], ",", 
               RowBox[{"Return", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", 
                  RowBox[{"z0", "[", 
                   RowBox[{"n", ",", "t"}], "]"}]}], "}"}], "]"}]}], "]"}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"\[Theta]b", "=", 
              RowBox[{"\[Theta]bfun", "[", 
               RowBox[{"\[Theta]a", ",", 
                RowBox[{"z0", "[", 
                 RowBox[{"n", ",", "t"}], "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Exp", "[", 
              RowBox[{"I", 
               RowBox[{"{", 
                RowBox[{"\[Theta]a", ",", "\[Theta]b"}], "}"}]}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"At", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"CSPoints", "[", 
            RowBox[{"n", ",", "t"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "iMM"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Bt", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"CSPoints", "[", 
            RowBox[{"n", ",", "t"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "//", "iMM"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Alpha]t", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"CSPoints", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Beta]t", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"CSPoints", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"cit", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"cit", "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{"cit", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "=", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Fun", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"V", "[", 
                   RowBox[{"n", ",", "t"}], "]"}], "'"}], "[", "#", "]"}], 
                "&"}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", 
                   RowBox[{"Bt", "[", 
                    RowBox[{"n", ",", "t"}], "]"}]}], ",", 
                  RowBox[{"-", 
                   RowBox[{"At", "[", 
                    RowBox[{"n", ",", "t"}], "]"}]}]}], "}"}], "]"}], ",", 
               "30"}], "]"}], ",", 
             RowBox[{"Fun", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"V", "[", 
                   RowBox[{"n", ",", "t"}], "]"}], "'"}], "[", "#", "]"}], 
                "&"}], ",", 
               RowBox[{"Line", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"At", "[", 
                   RowBox[{"n", ",", "t"}], "]"}], ",", 
                  RowBox[{"Bt", "[", 
                   RowBox[{"n", ",", "t"}], "]"}]}], "}"}], "]"}], ",", 
               "30"}], "]"}]}], "}"}], "//", "CauchyInverseCurves"}]}]}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"gt", "[", 
           RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
         RowBox[{
          RowBox[{"-", "t"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"CauchyInverseIntegral", "[", 
               RowBox[{
                RowBox[{"-", "p"}], ",", "#", ",", 
                RowBox[{"iMM", "[", "z", "]"}]}], "]"}], "&"}], "/@", 
             RowBox[{"cit", "[", 
              RowBox[{"n", ",", "t"}], "]"}]}], "//", "Total"}], ")"}]}]}], 
        ";"}]}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"gg", "[", 
           RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
         RowBox[{
          RowBox[{"-", "t"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"CauchyInverseIntegral", "[", 
               RowBox[{
                RowBox[{"-", "p"}], ",", "#", ",", "z"}], "]"}], "&"}], "/@", 
             
             RowBox[{"ci", "[", 
              RowBox[{"n", ",", "t"}], "]"}]}], "//", "Total"}], ")"}]}]}], 
        ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Find", " ", "the", " ", "minimum", " ", "distance", " ", "among", " ", 
     "all", " ", "the", " ", "elements", " ", "of", " ", "x"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MinDist", "[", "x_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"min", ",", "i", ",", "j"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"min", "=", "1000"}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "x", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", 
              RowBox[{"i", "+", "1"}]}], ",", 
             RowBox[{"j", "\[LessEqual]", 
              RowBox[{"Length", "[", "x", "]"}]}], ",", 
             RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Abs", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", 
                   RowBox[{"x", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], "<", "min"}], 
                ",", 
                RowBox[{"min", "=", 
                 RowBox[{"Abs", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", 
                   RowBox[{"x", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}]}], "]"}], 
              ";"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "min"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Determined", " ", "whether", " ", "the", " ", "growth", " ", "at", " ", 
     "a", " ", "eigenvalue", " ", 
     RowBox[{"(", 
      RowBox[{"or", " ", "pole"}], ")"}], " ", "should", " ", "inverted"}], 
    " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"Swit", "[", 
      RowBox[{"n_", ",", "t_", ",", "\[CapitalLambda]_", ",", "c_"}], "]"}], ":=", 
     RowBox[{"DeleteCases", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{
              RowBox[{"\[CapitalLambda]", "[", 
               RowBox[{"[", "i", "]"}], "]"}], " ", 
              RowBox[{"c", "[", 
               RowBox[{"[", "i", "]"}], "]"}], " ", 
              RowBox[{"Exp", "[", 
               RowBox[{
                RowBox[{"\[Theta]", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], "[", 
                RowBox[{"\[CapitalLambda]", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}]}], "]"}], ">", 
            "expconst"}], ",", "i", ",", "0"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "c", "]"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"a_", "/;", 
        RowBox[{"a", "\[Equal]", "0"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "create", " ", "a", " ", "product", " ", "of", " ", "appropriate", " ", 
      "rational", " ", "functions", " ", "over", " ", "the", " ", "index", 
      " ", "set", " ", "from", " ", "Swit"}], ",", " ", 
     RowBox[{
     "just", " ", "one", " ", "function", " ", "for", " ", "each", " ", "n", 
      " ", "and", " ", "t"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"DD", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"s", ",", "f"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"s", "=", 
         RowBox[{"Swit", "[", 
          RowBox[{"n", ",", "t", ",", "\[CapitalLambda]", ",", "c"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"f", "=", 
         RowBox[{"Product", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"z", "-", 
              RowBox[{"\[CapitalLambda]", "[", 
               RowBox[{"[", 
                RowBox[{"s", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"z", " ", 
               RowBox[{"\[CapitalLambda]", "[", 
                RowBox[{"[", 
                 RowBox[{"s", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}]}], "-", "1"}], 
             ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "s", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"f", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"1", "/", "f"}]}], "}"}]}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"DD", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "\[Infinity]", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"s", ",", "f"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"s", "=", 
         RowBox[{"Swit", "[", 
          RowBox[{"n", ",", "t", ",", "\[CapitalLambda]", ",", "c"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"f", "=", 
         RowBox[{"Product", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", "1", ")"}], "/", 
            RowBox[{"(", " ", 
             RowBox[{"\[CapitalLambda]", "[", 
              RowBox[{"[", 
               RowBox[{"s", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "s", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"f", ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"1", "/", "f"}]}], "}"}]}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"DDsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"Lensing", " ", "of", " ", "unit", " ", "circle", " ", 
      RowBox[{"RHP", ":", " ", "L"}]}], ",", " ", "U", ",", " ", "M", ",", 
     " ", "P", ",", " ", "Diag"}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Theta]", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "\[Zeta]_", "]"}], ":=", 
     RowBox[{
      RowBox[{"t", 
       RowBox[{"(", 
        RowBox[{"\[Zeta]", "-", 
         RowBox[{"\[Zeta]", "^", 
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}]}]}], ")"}]}], "+", " ", 
      RowBox[{"2", "n", " ", 
       RowBox[{"Log", "[", "\[Zeta]", "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"L", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", "0"},
        {
         RowBox[{
          FractionBox[
           RowBox[{"R", "[", "k", "]"}], 
           RowBox[{"\[Tau]", "[", "k", "]"}]], 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"\[Theta]", "[", 
             RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}], "]"}]}], "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Lsamp", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", "0"},
        {
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"\[Theta]", "[", 
            RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}], "]"}], "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"U", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", 
         RowBox[{
          FractionBox[
           RowBox[{"Ri", "[", "k", "]"}], 
           RowBox[{"\[Tau]", "[", "k", "]"}]], 
          RowBox[{"Exp", "[", 
           RowBox[{"-", 
            RowBox[{
             RowBox[{"\[Theta]", "[", 
              RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}]}], "]"}]}]},
        {"0", "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Ui", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"Ri", "[", "k", "]"}], 
            RowBox[{"\[Tau]", "[", "k", "]"}]]}], 
          RowBox[{"Exp", "[", 
           RowBox[{"-", 
            RowBox[{
             RowBox[{"\[Theta]", "[", 
              RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}]}], "]"}]}]},
        {"0", "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Usamp", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", 
         RowBox[{"Exp", "[", 
          RowBox[{"-", 
           RowBox[{
            RowBox[{"\[Theta]", "[", 
             RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}]}], "]"}]},
        {"0", "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Ri", "[", "k_", "]"}], ":=", 
     RowBox[{"-", 
      RowBox[{"R", "[", 
       RowBox[{"1", "/", "k"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Diag", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {
         RowBox[{"\[Tau]", "[", "k", "]"}], "0"},
        {"0", 
         RowBox[{"1", "/", 
          RowBox[{"\[Tau]", "[", "k", "]"}]}]}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Diagsamp", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"2", "0"},
        {"0", "2"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Diagi", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {
         RowBox[{"1", "/", 
          RowBox[{"\[Tau]", "[", "k", "]"}]}], "0"},
        {"0", 
         RowBox[{"\[Tau]", "[", "k", "]"}]}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Diagisamp", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"2", "0"},
        {"0", "2"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"M", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", 
         RowBox[{
          RowBox[{"Ri", "[", "k", "]"}], " ", 
          RowBox[{"Exp", "[", 
           RowBox[{"-", 
            RowBox[{
             RowBox[{"\[Theta]", "[", 
              RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}]}], "]"}]}]},
        {"0", "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Msamp", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", 
         RowBox[{"Exp", "[", 
          RowBox[{"-", 
           RowBox[{
            RowBox[{"\[Theta]", "[", 
             RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}]}], "]"}]},
        {"0", "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"P", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", "0"},
        {
         RowBox[{
          RowBox[{"R", "[", "k", "]"}], " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"\[Theta]", "[", 
             RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}], "]"}]}], "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Pin", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", "0"},
        {
         RowBox[{
          RowBox[{"-", 
           RowBox[{"R", "[", "k", "]"}]}], " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"\[Theta]", "[", 
             RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}], "]"}]}], "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Psamp", "[", 
       RowBox[{"x_", ",", "t_"}], "]"}], "[", "k_", "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", "0"},
        {
         RowBox[{" ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"\[Theta]", "[", 
             RowBox[{"x", ",", "t"}], "]"}], "[", "k", "]"}], "]"}]}], "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"J", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "x_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "-", 
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"R", "[", "x", "]"}], "]"}], "^", "2"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Conjugate", "[", 
            RowBox[{"R", "[", "x", "]"}], "]"}]}], 
          RowBox[{"Exp", "[", 
           RowBox[{"-", 
            RowBox[{
             RowBox[{"\[Theta]", "[", 
              RowBox[{"n", ",", "t"}], "]"}], "[", "x", "]"}]}], "]"}]}]}], 
        " ", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"R", "[", "x", "]"}], 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"\[Theta]", "[", 
             RowBox[{"n", ",", "t"}], "]"}], "[", "x", "]"}], "]"}]}], " ", 
         ",", "1"}], "}"}]}], "}"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Jsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "x_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"jumps", " ", "around", " ", "poles"}], ",", " ", 
     RowBox[{
     "T", " ", "is", " ", "the", " ", "original", " ", "deformation"}], ",", 
     " ", 
     RowBox[{
      RowBox[{"+", "1"}], " ", "is", " ", "interior"}], ",", " ", 
     RowBox[{
      RowBox[{"-", "1"}], " ", "is", " ", "exterior"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"+", "1"}], "]"}], "[", 
       RowBox[{"n_", ",", "t_", ",", "a_", ",", "c_"}], "]"}], "[", "z_", 
      "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", "0"},
        {
         RowBox[{"a", " ", "c", " ", 
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"\[Theta]", "[", 
              RowBox[{"n", ",", "t"}], "]"}], "[", "a", "]"}], "]"}], "/", 
           RowBox[{"(", 
            RowBox[{"z", "-", "a"}], ")"}]}]}], "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"-", "1"}], "]"}], "[", 
       RowBox[{"n_", ",", "t_", ",", "a_", ",", "c_"}], "]"}], "[", "z_", 
      "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", 
         RowBox[{" ", 
          RowBox[{"c", " ", "z", " ", 
           RowBox[{
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"\[Theta]", "[", 
               RowBox[{"n", ",", "t"}], "]"}], "[", "a", "]"}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{"z", "-", 
              RowBox[{"1", "/", "a"}]}], ")"}]}]}]}]},
        {
         RowBox[{" ", "0"}], "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"inverting", " ", "the", " ", "exponent"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"+", "1"}], "]"}], "[", 
       RowBox[{"n_", ",", "t_", ",", "a_", ",", "c_"}], "]"}], "[", "z_", 
      "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", 
         RowBox[{
          RowBox[{"(", " ", 
           RowBox[{"z", " ", "-", "a"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"a", " ", "c", " ", 
            RowBox[{"Exp", "[", 
             RowBox[{
              RowBox[{"\[Theta]", "[", 
               RowBox[{"n", ",", "t"}], "]"}], "[", "a", "]"}], "]"}]}], 
           ")"}]}]},
        {"0", "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"-", "1"}], "]"}], "[", 
       RowBox[{"n_", ",", "t_", ",", "a_", ",", "c_"}], "]"}], "[", "z_", 
      "]"}], ":=", 
     RowBox[{"(", GridBox[{
        {"1", "0"},
        {
         RowBox[{" ", 
          RowBox[{
           RowBox[{"(", " ", 
            RowBox[{
             RowBox[{"a", " ", "z"}], "-", "1"}], ")"}], "/", 
           RowBox[{"(", 
            RowBox[{"a", " ", "c", " ", "z", " ", 
             RowBox[{"Exp", "[", 
              RowBox[{
               RowBox[{"\[Theta]", "[", 
                RowBox[{"n", ",", "t"}], "]"}], "[", "a", "]"}], "]"}]}], 
            ")"}]}]}], "1"}
       }], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "create", " ", "circles", " ", "around", " ", "a", " ", "and", " ", 
      RowBox[{"1", "/", "a"}]}], ",", " ", 
     RowBox[{"only", " ", "used", " ", "for", " ", "poles"}], ",", " ", 
     RowBox[{"note", " ", "orientation"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ContourArray", "[", 
      RowBox[{
       RowBox[{"+", "1"}], ",", "r_", ",", "a_"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Arc", "[", 
        RowBox[{"a", ",", "r", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "Pi"}], "}"}]}], "]"}], ",", 
       RowBox[{"Arc", "[", 
        RowBox[{"a", ",", "r", ",", 
         RowBox[{"{", 
          RowBox[{"Pi", ",", 
           RowBox[{"2", "Pi"}]}], "}"}]}], "]"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ContourArray", "[", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "r_", ",", "a_"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Arc", "[", 
        RowBox[{
         RowBox[{"1", "/", "a"}], ",", "r", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "Pi"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"Arc", "[", 
        RowBox[{
         RowBox[{"1", "/", "a"}], ",", "r", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "Pi"}], ",", 
           RowBox[{
            RowBox[{"-", "2"}], "Pi"}]}], "}"}]}], "]"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Delta]", "[", 
           RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
          "]"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"1", "/", 
          RowBox[{
           RowBox[{"\[Delta]", "[", 
            RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
           "]"}]}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]samp", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]i", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{
           RowBox[{"\[Delta]", "[", 
            RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
           "]"}]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{
          RowBox[{"\[Delta]", "[", 
           RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
          "]"}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]isamp", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]PUi", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"P", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Ui", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]PUisamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"Psamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{"Inverse", "[", 
       RowBox[{
        RowBox[{"Usamp", "[", 
         RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]Ui", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Ui", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]Uisamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"Inverse", "[", 
      RowBox[{
       RowBox[{"Usamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]LD", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"L", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Diag", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CapitalDelta]LDsamp", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{"Lsamp", "[", 
      RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]D", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", "z", "]"}], ">", "1."}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalDelta]", "[", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
        ".", 
        RowBox[{
         RowBox[{"Diag", "[", 
          RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}], ",", 
       RowBox[{
        RowBox[{"\[CapitalDelta]", "[", 
         RowBox[{
          RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]Dsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "2"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]cs", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Delta]cs", "[", 
           RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
          "]"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"1", "/", 
          RowBox[{
           RowBox[{"\[Delta]cs", "[", 
            RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
           "]"}]}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]cssamp", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]csi", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{
           RowBox[{"\[Delta]cs", "[", 
            RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
           "]"}]}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{
          RowBox[{"\[Delta]cs", "[", 
           RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", 
          "]"}]}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]csisamp", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"gsamp", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"z", "+", "1"}], "]"}], "<", "4"}], ",", 
       RowBox[{".1", 
        RowBox[{"Abs", "[", "t", "]"}], 
        RowBox[{"Sign", "[", 
         RowBox[{
          RowBox[{"Abs", "[", "z", "]"}], "-", "1"}], "]"}]}], ",", "0"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}], 
        ",", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
         "]"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]i", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}],
        "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]samp", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"2", 
      RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]isamp", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{"1", "/", "2"}], 
      RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]cs", "[", 
        RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]i", "[", 
        RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]i", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]csi", "[", 
        RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]", "[", 
        RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{"\[Phi]isamp", "[", 
       RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]isamp", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{"\[Phi]samp", "[", 
       RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "jumps", " ", "away", " ", "from", " ", "both", " ", "\[Alpha]", " ", 
     "and", " ", "\[Beta]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Jcs", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"J", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]i", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Ucs", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"U", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]i", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Lcs", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"L", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]i", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Pcs", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"P", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]i", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Mcs", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]i", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Jcssamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Jsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]isamp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Ucssamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Usamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]isamp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Lcssamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Lsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]isamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Pcssamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Psamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]isamp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Mcssamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Msamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]isamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"jumps", " ", "near", " ", "\[Beta]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]M\[CapitalDelta]i", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]csi", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]Pi\[CapitalDelta]i", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{
         RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{"Inverse", "[", 
       RowBox[{
        RowBox[{"P", "[", 
         RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}], ".", 
      RowBox[{
       RowBox[{"\[CapitalDelta]csi", "[", 
        RowBox[{
         RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CapitalDelta]\[Phi]M\[CapitalDelta]isamp", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
     RowBox[{
      RowBox[{"Msamp", "[", 
       RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CapitalDelta]\[Phi]Pi\[CapitalDelta]isamp", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
       RowBox[{
        RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
     RowBox[{"Inverse", "[", 
      RowBox[{
       RowBox[{"Psamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"jumps", " ", "near", " ", "\[Alpha]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]L", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"L", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]LD", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"L", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Diag", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]Ui", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]", "[", 
        RowBox[{
         RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Ui", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]D", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", "z", "]"}], ">", "1"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalDelta]\[Phi]", "[", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
        ".", 
        RowBox[{
         RowBox[{"Diag", "[", 
          RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}], ",", 
       RowBox[{
        RowBox[{"\[CapitalDelta]\[Phi]", "[", 
         RowBox[{
          RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]Lsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Lsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]LDsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Lsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Diagsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]Uisamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
        RowBox[{
         RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{"Inverse", "[", 
       RowBox[{
        RowBox[{"Usamp", "[", 
         RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]Dsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{"\[CapitalDelta]\[Phi]samp", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Transition", " ", "Jumps"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"gsamp", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"z", "+", "1"}], "]"}], "<", "4"}], ",", 
       RowBox[{".1", 
        RowBox[{"Abs", "[", "t", "]"}], 
        RowBox[{"Sign", "[", 
         RowBox[{
          RowBox[{"Abs", "[", "z", "]"}], "-", "1"}], "]"}]}], ",", "0"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]t", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"gt", "[", 
           RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}], 
        ",", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{
           RowBox[{"gt", "[", 
            RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
         "]"}]}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]ti", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{
           RowBox[{"gt", "[", 
            RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"gt", "[", 
           RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}],
        "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]tsamp", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"2", 
      RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]tisamp", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{"1", "/", "2"}], 
      RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "jumps", " ", "away", " ", "from", " ", "both", " ", "\[Alpha]", " ", 
     "and", " ", "\[Beta]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Jt", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"J", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]t", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Ut", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"U", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]t", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Lt", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"L", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]t", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Pt", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"P", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]t", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Mt", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]t", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Jtsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]tisamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Jsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]tsamp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Utsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]tisamp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Usamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]tsamp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Ltsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]tisamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Lsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]tsamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Ptsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]tisamp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Psamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]tsamp", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Mtsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]tisamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Msamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"\[Phi]tsamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}]}],
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"jumps", " ", "near", " ", "\[Beta]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]iM", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]iPi", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{
         RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{"Inverse", "[", 
       RowBox[{
        RowBox[{"P", "[", 
         RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Phi]iMsamp", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]tisamp", "[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
     RowBox[{
      RowBox[{"Msamp", "[", 
       RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Phi]iPisamp", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]tisamp", "[", 
       RowBox[{
        RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
     RowBox[{"Inverse", "[", 
      RowBox[{
       RowBox[{"Psamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"jumps", " ", "near", " ", "\[Alpha]"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]iL", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"L", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]iLD", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"L", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Diag", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]iUi", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{
         RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Ui", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]iLsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]tisamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Lsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]iLDsamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]tisamp", "[", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{
       RowBox[{"Lsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], ".", 
      RowBox[{
       RowBox[{"Diagsamp", "[", 
        RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]iUisamp", "[", 
       RowBox[{"n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]tisamp", "[", 
        RowBox[{
         RowBox[{"+", "1"}], ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
      ".", 
      RowBox[{"Inverse", "[", 
       RowBox[{
        RowBox[{"Usamp", "[", 
         RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6071689931105213`*^9, 3.607169078152041*^9}, {
   3.607170645532827*^9, 3.607170646466487*^9}, {3.607172116333726*^9, 
   3.607172119491024*^9}, 3.6076079665847273`*^9, {3.618141424150166*^9, 
   3.618141426834998*^9}, {3.618141480154718*^9, 3.618141501027776*^9}, 
   3.6344916938300447`*^9, {3.634491737609127*^9, 3.63449175544779*^9}, {
   3.634491862342167*^9, 3.634491862620139*^9}, {3.6345509830828867`*^9, 
   3.634550983458352*^9}, {3.634551613268358*^9, 3.634551893870425*^9}, {
   3.634552186348817*^9, 3.634552199603828*^9}, {3.634553559458921*^9, 
   3.634553601206415*^9}, {3.6345548586870003`*^9, 3.6345548798828793`*^9}, {
   3.634554933937973*^9, 3.6345549512934847`*^9}, {3.63455506683391*^9, 
   3.634555088846887*^9}, {3.634555145050317*^9, 3.634555155980653*^9}, {
   3.634558991864202*^9, 3.6345589933334637`*^9}, {3.634559815347904*^9, 
   3.6345598171044073`*^9}, {3.634559882666819*^9, 3.634559889405456*^9}, {
   3.634564178421276*^9, 3.634564178609497*^9}, {3.634564307847579*^9, 
   3.634564312389689*^9}, {3.634598154863648*^9, 3.634598195765523*^9}, {
   3.63459992765644*^9, 3.6345999303582907`*^9}, {3.634656325053665*^9, 
   3.634656325840756*^9}, {3.63465872384347*^9, 3.6346588198311462`*^9}, {
   3.63465896977269*^9, 3.634659028318409*^9}, {3.634659068339799*^9, 
   3.634659080566341*^9}, {3.6346591199279137`*^9, 3.634659121392179*^9}, {
   3.634672143116835*^9, 3.634672154970525*^9}, {3.634672239425901*^9, 
   3.63467232533398*^9}, {3.6346723773513803`*^9, 3.634672379308148*^9}, 
   3.63467241600132*^9, {3.6346725276912527`*^9, 3.634672535457152*^9}, {
   3.6362203046213713`*^9, 3.636220311213279*^9}, {3.636220343779934*^9, 
   3.63622034894951*^9}, {3.63622206199716*^9, 3.6362220822444468`*^9}, {
   3.636320143888297*^9, 3.63632018526755*^9}, 3.636361108215993*^9, 
   3.6363628791155376`*^9, {3.63636786986679*^9, 3.636367877005061*^9}, {
   3.636367934562747*^9, 3.636367952599062*^9}, {3.636367982972468*^9, 
   3.636368151990303*^9}, {3.636368466689913*^9, 3.6363684888005457`*^9}, {
   3.6363685889275312`*^9, 3.636368599677751*^9}, {3.636368632783832*^9, 
   3.636368660262302*^9}, {3.636368848466979*^9, 3.636368850913067*^9}, {
   3.636368888049782*^9, 3.636368891526133*^9}, 3.636369338207079*^9, {
   3.636369431053141*^9, 3.636369499179543*^9}, {3.6363697655300903`*^9, 
   3.636369808692737*^9}, {3.636369887870265*^9, 3.6363698972513*^9}, {
   3.6363699311685543`*^9, 3.636369942083259*^9}, {3.636370104837998*^9, 
   3.636370139939774*^9}, {3.636370207803542*^9, 3.636370208009448*^9}, {
   3.636370454630683*^9, 3.636370521614788*^9}, {3.636370877099491*^9, 
   3.63637095238557*^9}, {3.636371005744194*^9, 3.636371010400638*^9}, {
   3.636374402073764*^9, 3.636374515073805*^9}, {3.636374664146553*^9, 
   3.636374713337446*^9}, {3.63637475434833*^9, 3.6363748245071287`*^9}, {
   3.6363748869937067`*^9, 3.636374973805468*^9}, {3.6363750287457447`*^9, 
   3.6363753629769783`*^9}, 3.636376403592396*^9, {3.636376560184298*^9, 
   3.636376563077669*^9}, {3.6363795993226337`*^9, 3.636379602200613*^9}, {
   3.63638026422773*^9, 3.636380264454433*^9}, {3.636380438462719*^9, 
   3.636380439120425*^9}, {3.63638047360909*^9, 3.636380485659749*^9}, {
   3.636381222743063*^9, 3.6363812349048443`*^9}, {3.63638177182417*^9, 
   3.63638179229055*^9}, {3.636381840169688*^9, 3.636381848624823*^9}, 
   3.636381993121776*^9, 3.636382803146728*^9, {3.636383168632731*^9, 
   3.6363831834623127`*^9}, {3.636383218772501*^9, 3.636383249129526*^9}, {
   3.6363832920468903`*^9, 3.636383321549518*^9}, {3.636383525739629*^9, 
   3.6363835261055593`*^9}, {3.63638617613905*^9, 3.636386221020627*^9}, {
   3.636386292620185*^9, 3.636386293136326*^9}, {3.636386333814624*^9, 
   3.636386334079432*^9}, {3.636388371321517*^9, 3.636388400612602*^9}, {
   3.636388561485347*^9, 3.636388567367432*^9}, {3.636450188371982*^9, 
   3.6364502141528587`*^9}, {3.636450265193533*^9, 3.636450309209702*^9}, {
   3.6364505357871227`*^9, 3.636450542267688*^9}, {3.636451085650099*^9, 
   3.63645108773466*^9}, {3.6364511205891533`*^9, 3.636451120743169*^9}, {
   3.636462562713646*^9, 3.636462565502198*^9}, {3.6364626126327953`*^9, 
   3.6364626345323477`*^9}, {3.636462797668305*^9, 3.636462799575655*^9}, {
   3.6364664416491623`*^9, 3.636466448423964*^9}, {3.636479885438065*^9, 
   3.636479924410139*^9}, {3.636480268192253*^9, 3.6364802689473257`*^9}, {
   3.636480340010582*^9, 3.6364803435563993`*^9}, {3.636483613848462*^9, 
   3.636483617311038*^9}, {3.63648412807261*^9, 3.636484213133762*^9}, {
   3.636542524608358*^9, 3.6365425383963127`*^9}, {3.636544378923595*^9, 
   3.6365443798888083`*^9}, {3.636544415233288*^9, 3.636544416004703*^9}, {
   3.636559411139159*^9, 3.636559426442232*^9}, {3.636560003707209*^9, 
   3.636560016682088*^9}, {3.636560163445641*^9, 3.6365601756753693`*^9}, {
   3.636560376270859*^9, 3.6365603810534153`*^9}, {3.63656107479744*^9, 
   3.636561076246901*^9}, {3.636561150339192*^9, 3.636561177405332*^9}, {
   3.636562758134487*^9, 3.636562777040681*^9}, {3.636562906471078*^9, 
   3.6365629788156137`*^9}, {3.63656587744628*^9, 3.63656588999463*^9}, {
   3.636565939555552*^9, 3.636565940454236*^9}, {3.636565987015448*^9, 
   3.6365659962074823`*^9}, {3.636589702536106*^9, 3.636589715397039*^9}, {
   3.636797042991234*^9, 3.636797059718347*^9}, {3.636797112357424*^9, 
   3.636797284541646*^9}, {3.636797328029023*^9, 3.636797604632744*^9}, {
   3.636813839862981*^9, 3.636813850237658*^9}, {3.636815278622361*^9, 
   3.636815355578155*^9}, {3.6368154611563587`*^9, 3.636815464186715*^9}, {
   3.636815505985469*^9, 3.636815508799457*^9}, 3.6374125034380627`*^9, {
   3.637423800499776*^9, 3.637423814095798*^9}, {3.6452848491846857`*^9, 
   3.64528487612921*^9}, {3.645284949963594*^9, 3.64528495841617*^9}, {
   3.6452852078662558`*^9, 3.645285212429879*^9}, {3.6452857560846043`*^9, 
   3.6452857573939857`*^9}, {3.645286176313714*^9, 3.6452861799959373`*^9}, {
   3.645286315115521*^9, 3.64528631597367*^9}, {3.645286349907998*^9, 
   3.645286350474374*^9}, {3.645289247661312*^9, 3.645289249188918*^9}, {
   3.645289426474312*^9, 3.6452894398700323`*^9}, {3.645290925455635*^9, 
   3.6452909274172773`*^9}, {3.645290964585018*^9, 3.6452909688473577`*^9}, {
   3.645291197469125*^9, 3.6452912396701*^9}, {3.6452912746081123`*^9, 
   3.64529128084942*^9}, {3.6452918976816063`*^9, 3.645291922840826*^9}, {
   3.645292029302532*^9, 3.645292044545331*^9}, 3.645292363095025*^9, {
   3.6453545003996897`*^9, 3.645354533257578*^9}, {3.645354610045906*^9, 
   3.645354610200687*^9}, {3.645354674538875*^9, 3.645354750340337*^9}, {
   3.6453560694439363`*^9, 3.6453560696375933`*^9}, {3.64535643203388*^9, 
   3.645356435250819*^9}, {3.645356510013438*^9, 3.645356510851905*^9}, {
   3.6453568315895452`*^9, 3.645356837103343*^9}, {3.64535691150772*^9, 
   3.645356972119381*^9}, {3.645449801153582*^9, 3.645449804733186*^9}, {
   3.6454667180221*^9, 3.645466736715426*^9}, {3.645467338478924*^9, 
   3.6454674765296173`*^9}, {3.645467516846848*^9, 3.645467517080968*^9}, {
   3.645703637111326*^9, 3.645703638765192*^9}, {3.647436632503497*^9, 
   3.6474366528231277`*^9}, {3.647436691520813*^9, 3.647436695279345*^9}, {
   3.647436762390669*^9, 3.647436765440941*^9}, {3.647439129425103*^9, 
   3.64743913544738*^9}, {3.6474392206610937`*^9, 3.647439275177473*^9}, {
   3.647441095855936*^9, 3.647441131132862*^9}, {3.647441164526877*^9, 
   3.647441165157445*^9}, {3.64745634978858*^9, 3.647456378189742*^9}, {
   3.647456849274228*^9, 3.647456854831203*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Contour functions", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.63455099206208*^9, 3.6345509939328337`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BasicCross", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"Exp", "[", 
         RowBox[{"I", " ", 
          RowBox[{"Pi", "/", "4"}]}], "]"}]}], "}"}], "]"}], ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "3"}], 
          RowBox[{"Pi", "/", "4"}], "I"}], "]"}], ",", "0"}], "}"}], "]"}], 
     ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"3", "I", " ", 
          RowBox[{"Pi", "/", "4"}]}], "]"}], ",", "0"}], "}"}], "]"}], ",", 
     RowBox[{"Line", "[", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "I"}], " ", 
          RowBox[{"Pi", "/", "4"}]}], "]"}]}], "}"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoleCross", "[", "r_", "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{"I", " ", 
            RowBox[{"Pi", "/", "4"}]}], "]"}]}], ",", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"Pi", "/", "4"}]}], "]"}]}], "}"}], "]"}], ",", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", "3"}], 
           RowBox[{"Pi", "/", "4"}], "I"}], "]"}], ",", 
         RowBox[{"r", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "3"}], 
            RowBox[{"Pi", "/", "4"}], "I"}], "]"}]}]}], "}"}], "]"}], ",", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{"3", "I", " ", 
           RowBox[{"Pi", "/", "4"}]}], "]"}], ",", 
         RowBox[{"r", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{"3", "I", " ", 
            RowBox[{"Pi", "/", "4"}]}], "]"}]}]}], "}"}], "]"}], ",", 
      RowBox[{"Line", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"r", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "I"}], " ", 
            RowBox[{"Pi", "/", "4"}]}], "]"}]}], ",", 
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", "I"}], " ", 
           RowBox[{"Pi", "/", "4"}]}], "]"}]}], "}"}], "]"}]}], "}"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"first", " ", "contour", " ", "is", " ", "inside"}], ",", " ", 
    RowBox[{"further", " ", "along", " ", 
     RowBox[{"(", 
      RowBox[{"pos", " ", "orientation"}], ")"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "second", " ", "is", " ", "in", " ", "the", " ", "same", " ", "direction", 
    " ", "as", " ", "the", " ", "first", " ", 
    RowBox[{"(", 
     RowBox[{"outside", " ", "circle"}], ")"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"third", " ", "is", " ", "inside"}], ",", " ", 
    RowBox[{"fourth", " ", "is", " ", "outside"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SmallCross", "[", 
    RowBox[{"z0_", ",", "rad_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"BasicCross", " ", "*", "rad", " ", 
     RowBox[{"Exp", "[", 
      RowBox[{"I", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Arg", "[", "z0", "]"}], "+", 
         RowBox[{"Pi", "/", "2"}]}], ")"}]}], "]"}]}], "+", "z0"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SmallHoleCross", "[", 
     RowBox[{"z0_", ",", "rad_", ",", "f_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"HoleCross", "[", "f", "]"}], " ", "*", "rad", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"I", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Arg", "[", "z0", "]"}], "+", 
          RowBox[{"Pi", "/", "2"}]}], ")"}]}], "]"}]}], "+", "z0"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "ordered", " ", "counterclockwise", " ", "from", " ", "the", " ", 
    "furthest", " ", "right", " ", "intersection", " ", "point", 
    "\[IndentingNewLine]", "with", " ", "the", " ", "real", " ", "axis"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RightLens", "[", 
    RowBox[{"z0_", ",", "rad_", ",", "bool_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "cont", ",", "contc", ",", "a1", ",", "a2", ",", "a3", ",", "a4"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{"bool", ",", 
        RowBox[{
         RowBox[{"cont", "=", 
          RowBox[{"SmallHoleCross", "[", 
           RowBox[{"z0", ",", "rad", ",", "f"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"contc", "=", 
          RowBox[{"SmallHoleCross", "[", 
           RowBox[{
            RowBox[{"1", "/", "z0"}], ",", "rad", ",", "f"}], "]"}]}], ";"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"cont", "=", 
          RowBox[{"SmallCross", "[", 
           RowBox[{"z0", ",", "rad"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"contc", "=", 
          RowBox[{"SmallCross", "[", 
           RowBox[{
            RowBox[{"1", "/", "z0"}], ",", "rad"}], "]"}]}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"a3", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "3", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a2", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a4", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "4", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a2", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"a2", "//", "Arg"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"cont", "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"cont", "[", 
         RowBox[{"[", "3", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a3", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"a3", "//", "Arg"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a3", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"2", "Pi"}], "-", 
             RowBox[{"Arg", "[", "a3", "]"}]}], ",", 
            RowBox[{"2", "Pi"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"contc", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"contc", "[", 
         RowBox[{"[", "4", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a2", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"2", "Pi"}], "-", 
             RowBox[{"Arg", "[", "a2", "]"}]}], ",", 
            RowBox[{"2", "Pi"}]}], "}"}]}], "]"}]}], "}"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RightLensClosed", "[", "z0_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "cont", ",", "contc", ",", "a", ",", "a1", ",", "a2", ",", "a3", ",", 
       "a4"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"a", "=", 
       RowBox[{"1", "+", "strip", "-", "z0"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a1", "=", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "+", "strip"}], ")"}], "^", "2"}], "-", 
           RowBox[{"a", "^", "2"}]}], "]"}]}], "+", 
        RowBox[{"I", " ", "a"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a2", "=", 
       RowBox[{"Conjugate", "[", "a1", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{
        RowBox[{"1", "/", "z0"}], "-", 
        RowBox[{"(", 
         RowBox[{"1", "-", "strip"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a3", " ", "=", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", "strip"}], ")"}], "^", "2"}], "-", 
           RowBox[{"a", "^", "2"}]}], "]"}]}], "+", 
        RowBox[{"I", " ", "a"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a4", " ", "=", 
       RowBox[{"Conjugate", "[", "a3", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"1", "+", "strip"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"Arg", "[", "a1", "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{"a1", ",", 
           RowBox[{"-", "z0"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "z0"}], ",", "a2"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"1", "+", "strip"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Arg", "[", "a2", "]"}], ",", "0"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"1", "-", "strip"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"Arg", "[", "a3", "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{"a3", ",", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "z0"}]}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Line", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "1"}], "/", "z0"}], ",", "a4"}], "}"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"1", "-", "strip"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Arg", "[", "a4", "]"}], ",", "0"}], "}"}]}], "]"}]}], 
       "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LeftLens", "[", 
    RowBox[{"z0_", ",", "rad_", ",", "bool_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "cont", ",", "contc", ",", "a1", ",", "a2", ",", "a3", ",", "a4"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{"bool", ",", 
        RowBox[{
         RowBox[{"cont", "=", 
          RowBox[{"SmallHoleCross", "[", 
           RowBox[{"z0", ",", "rad", ",", "f"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"contc", "=", 
          RowBox[{"SmallHoleCross", "[", 
           RowBox[{
            RowBox[{"1", "/", "z0"}], ",", "rad", ",", "f"}], "]"}]}], ";"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"cont", "=", 
          RowBox[{"SmallCross", "[", 
           RowBox[{"z0", ",", "rad"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"contc", "=", 
          RowBox[{"SmallCross", "[", 
           RowBox[{
            RowBox[{"1", "/", "z0"}], ",", "rad"}], "]"}]}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"a3", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "3", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a2", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a4", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "4", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a1", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"a1", "//", "Arg"}], ",", "Pi"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"cont", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"cont", "[", 
         RowBox[{"[", "4", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a4", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"a4", "//", "Arg"}], ",", "Pi"}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a4", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{"Pi", ",", 
            RowBox[{
             RowBox[{"2", "Pi"}], "-", 
             RowBox[{"Arg", "[", "a4", "]"}]}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"contc", "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"contc", "[", 
         RowBox[{"[", "3", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a1", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{"Pi", ",", 
            RowBox[{
             RowBox[{"2", "Pi"}], "-", 
             RowBox[{"Arg", "[", "a1", "]"}]}]}], "}"}]}], "]"}]}], "}"}]}]}],
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LeftLensCS", "[", 
    RowBox[{"z0_", ",", "rad_", ",", "bool_", ",", "f_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "cont", ",", "contc", ",", "a1", ",", "a2", ",", "a3", ",", "a4"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{"bool", ",", 
        RowBox[{
         RowBox[{"cont", "=", 
          RowBox[{"SmallHoleCross", "[", 
           RowBox[{"z0", ",", "rad", ",", "f"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"contc", "=", 
          RowBox[{"SmallHoleCross", "[", 
           RowBox[{
            RowBox[{"1", "/", "z0"}], ",", "rad", ",", "f"}], "]"}]}], ";"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"cont", "=", 
          RowBox[{"SmallCross", "[", 
           RowBox[{"z0", ",", "rad"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"contc", "=", 
          RowBox[{"SmallCross", "[", 
           RowBox[{
            RowBox[{"1", "/", "z0"}], ",", "rad"}], "]"}]}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"a3", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "3", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a2", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"a4", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"cont", "[", 
          RowBox[{"[", "4", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a1", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"a1", "//", "Arg"}], ",", 
            RowBox[{
             RowBox[{"2", "Pi"}], "-", 
             RowBox[{"Arg", "[", "a1", "]"}]}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"cont", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"cont", "[", 
         RowBox[{"[", "4", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Arc", "[", 
         RowBox[{"0", ",", 
          RowBox[{"a4", "//", "Abs"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"a4", "//", "Arg"}], ",", 
            RowBox[{
             RowBox[{"2", "Pi"}], "-", 
             RowBox[{"Arg", "[", "a4", "]"}]}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"contc", "[", 
         RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"contc", "[", 
         RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}]}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{
      "A", " ", "simplification", " ", "on", " ", "the", " ", "angle"}], 
      "..."}], "*)"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RightSemi", "[", "z0_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "1", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"Arg", "[", "z0", "]"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "1", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"2", "Pi"}], "-", 
          RowBox[{"Arg", "[", "z0", "]"}]}], ",", 
         RowBox[{"2", "Pi"}]}], "}"}]}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LeftSemi", "[", "z0_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "1", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arg", "[", "z0", "]"}], ",", 
         RowBox[{"Pi", "-", "eps"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "1", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Pi", "-", "eps"}], ",", 
         RowBox[{"Pi", "+", "eps"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "1", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Pi", "+", "eps"}], ",", 
         RowBox[{
          RowBox[{"2", "Pi"}], "-", 
          RowBox[{"Arg", "[", "z0", "]"}]}]}], "}"}]}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LeftSemiSmall", "[", "z0_", "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "1", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arg", "[", "z0", "]"}], ",", 
         RowBox[{
          RowBox[{"2", "Pi"}], "-", 
          RowBox[{"Arg", "[", "z0", "]"}]}]}], "}"}]}], "]"}], "}"}]}], ";"}],
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"OuterLens", "[", 
      RowBox[{"z0_", ",", "rad_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"cont", ",", "a1", ",", "a2"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"cont", "=", 
         RowBox[{"SmallCross", "[", 
          RowBox[{"z0", ",", "rad"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"a1", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"cont", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"a2", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"cont", "[", 
            RowBox[{"[", "4", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Arc", "[", 
           RowBox[{"0", ",", 
            RowBox[{"a1", "//", "Abs"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"a1", "//", "Arg"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"Arc", "[", 
           RowBox[{"0", ",", 
            RowBox[{"a1", "//", "Abs"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"2", "Pi"}], "-", 
               RowBox[{"Arg", "[", "a1", "]"}]}], ",", 
              RowBox[{"2", "Pi"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"Arc", "[", 
           RowBox[{"0", ",", 
            RowBox[{"a2", "//", "Abs"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a2", "//", "Arg"}], ",", "Pi"}], "}"}]}], "]"}], ",", 
          RowBox[{"Arc", "[", 
           RowBox[{"0", ",", 
            RowBox[{"a2", "//", "Abs"}], ",", 
            RowBox[{"{", 
             RowBox[{"Pi", " ", ",", 
              RowBox[{
               RowBox[{"2", "Pi"}], "-", " ", 
               RowBox[{"Arg", "[", "a2", "]"}]}]}], "}"}]}], "]"}]}], 
         "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FullCircle", "[", 
    RowBox[{"rad_", ",", "eps_"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "rad", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "eps"}], ",", "eps"}], "}"}]}], "]"}], ",", 
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "rad", ",", 
       RowBox[{"{", 
        RowBox[{"eps", ",", 
         RowBox[{"Pi", "-", "eps"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "rad", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Pi", "-", "eps"}], ",", 
         RowBox[{"Pi", "+", "eps"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Arc", "[", 
      RowBox[{"0", ",", "rad", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Pi", "+", "eps"}], ",", 
         RowBox[{
          RowBox[{"2", "Pi"}], "-", "eps"}]}], "}"}]}], "]"}]}], "}"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.634552791028685*^9, 3.634552816704926*^9}, {
   3.6345528608552227`*^9, 3.634552862374908*^9}, {3.6346552809797993`*^9, 
   3.6346553956479387`*^9}, {3.63473048681213*^9, 3.634730499200387*^9}, {
   3.634750488342793*^9, 3.6347505032926903`*^9}, {3.6347505431666183`*^9, 
   3.634750552915257*^9}, {3.634750586553576*^9, 3.634750660414344*^9}, {
   3.634750726892089*^9, 3.6347509619692373`*^9}, {3.634751785132812*^9, 
   3.634751891041258*^9}, {3.634752612930417*^9, 3.634752645296112*^9}, {
   3.634752711831094*^9, 3.634752741395268*^9}, {3.6347528228359423`*^9, 
   3.634752965238759*^9}, {3.634753223989047*^9, 3.634753224266605*^9}, {
   3.634753299109687*^9, 3.634753301814005*^9}, 3.63475339843456*^9, {
   3.6347542068262453`*^9, 3.6347542409580097`*^9}, {3.634754328219803*^9, 
   3.634754329778392*^9}, {3.6347543937252913`*^9, 3.634754428106956*^9}, {
   3.636225454153943*^9, 3.636225482734275*^9}, {3.636225523600774*^9, 
   3.636225563692945*^9}, {3.6362257986351233`*^9, 3.636225808115334*^9}, {
   3.6362259540356617`*^9, 3.636225956221046*^9}, {3.6362261809089727`*^9, 
   3.636226187156255*^9}, {3.636226237238983*^9, 3.636226269019663*^9}, {
   3.636226340651321*^9, 3.636226362096672*^9}, {3.636543158770617*^9, 
   3.636543159326391*^9}, {3.636543230438758*^9, 3.6365432331588707`*^9}, {
   3.636543284339457*^9, 3.63654328445737*^9}, {3.636543369887328*^9, 
   3.63654337283652*^9}, {3.636543437457806*^9, 3.636543437648601*^9}, {
   3.636543851304448*^9, 3.636543856783122*^9}, {3.6365440149931927`*^9, 
   3.636544015150445*^9}, 3.6474366755521603`*^9, {3.647438875619501*^9, 
   3.647438881314889*^9}, 3.647438938231089*^9, 3.647438968667206*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Region 0: Undeformed", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.634492990416301*^9, 3.6344929952476587`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CircleRHP", "[", "0", "]"}], "[", 
    RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Jumps", ",", "Domain", ",", "Points", ",", "i"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Domain", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arc", "[", 
          RowBox[{"0", ",", "1", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "eps"}], ",", "eps"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{"0", ",", "1", ",", 
           RowBox[{"{", 
            RowBox[{"eps", ",", 
             RowBox[{"Pi", "-", "eps"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{"0", ",", "1.", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Pi", "-", "eps"}], ",", 
             RowBox[{"Pi", "+", "eps"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{"0", ",", "1.", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Pi", "+", "eps"}], ",", 
             RowBox[{
              RowBox[{"2", "Pi"}], "-", "eps"}]}], "}"}]}], "]"}]}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Jumps", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"J", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Points", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"largeN", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Points", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "=", 
       RowBox[{
        RowBox[{"Points", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "*", "4"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Points", "[", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}], "]"}], "=", 
       RowBox[{
        RowBox[{"Points", "[", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}], "]"}], "*", "4"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ConjugateJumps", "[", 
         RowBox[{"Jumps", ",", 
          RowBox[{"DD", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", "Domain", ",", 
        "Points"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CircleRHPsamp", "[", "0", "]"}], "[", 
    RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Jumps", ",", "Domain", ",", "Points", ",", "i"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Domain", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arc", "[", 
          RowBox[{"0", ",", "1", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "eps"}], ",", "eps"}], "}"}]}], "]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{"0", ",", "1", ",", 
           RowBox[{"{", 
            RowBox[{"eps", ",", 
             RowBox[{"Pi", "-", "eps"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{"0", ",", "1.", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Pi", "-", "eps"}], ",", 
             RowBox[{"Pi", "+", "eps"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"Arc", "[", 
          RowBox[{"0", ",", "1.", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Pi", "+", "eps"}], ",", 
             RowBox[{
              RowBox[{"2", "Pi"}], "-", "eps"}]}], "}"}]}], "]"}]}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Jumps", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Jsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Points", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"largeN", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Points", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "=", 
       RowBox[{
        RowBox[{"Points", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "*", "4"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Points", "[", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}], "]"}], "=", 
       RowBox[{
        RowBox[{"Points", "[", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}], "]"}], "*", "4"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Jumps", ",", "Domain", ",", "Points"}], "}"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.634492998366212*^9, 3.634493011911346*^9}, {
  3.6345118796832657`*^9, 3.63451187995889*^9}, {3.63455133862595*^9, 
  3.634551339145527*^9}, {3.634553609981419*^9, 3.634553610426614*^9}, {
  3.634559042634707*^9, 3.634559058457615*^9}, {3.634564043130473*^9, 
  3.634564089358979*^9}, {3.634564340611434*^9, 3.634564341921213*^9}, {
  3.634580264385215*^9, 3.634580269374959*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Region 1: Painleve (no conjugation)", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.634550591869*^9, 3.63455060009131*^9}, {
  3.634551038000371*^9, 3.6345510432457542`*^9}, {3.6346539649091454`*^9, 
  3.634653966188231*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"RHP", " ", "with", " ", "no", " ", "conjugation", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"z0", " ", "near"}], " ", "-", 
      RowBox[{"1", "?"}]}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CircleRHP", "[", "1", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Domain", ",", "Jumps", ",", "NumPts", ",", "z", ",", "i"}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"z", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"t", ">", "0"}], ",", 
           RowBox[{"z0", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", "I"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"RightLens", "[", 
            RowBox[{"z", ",", "strip", ",", "False", ",", 
             RowBox[{"1", "/", "4"}]}], "]"}], ",", 
           RowBox[{"LeftSemiSmall", "[", "z", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Jumps", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"M", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"M", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"P", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"P", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"P", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"P", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"M", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"M", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"J", "[", 
            RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"NumPts", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"largeN", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NumPts", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], "=", 
         RowBox[{"2", " ", "largeN"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ConjugateJumps", "[", 
           RowBox[{"Jumps", ",", 
            RowBox[{"DD", "[", 
             RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", "Domain", ",", 
          "NumPts"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CircleRHPsamp", "[", "1", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Domain", ",", "Jumps", ",", "NumPts", ",", "z", ",", "i"}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"z", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"t", ">", "0"}], ",", 
           RowBox[{"z0", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", "I"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"RightLens", "[", 
            RowBox[{"z", ",", "strip", ",", "False", ",", 
             RowBox[{"1", "/", "4"}]}], "]"}], ",", 
           RowBox[{"LeftSemiSmall", "[", "z", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Jumps", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Msamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Msamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Psamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Psamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Psamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Psamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Msamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Msamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"NumPts", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"largeN", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NumPts", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], "=", 
         RowBox[{"2", " ", "largeN"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Jumps", ",", "Domain", ",", "NumPts"}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.607687740759197*^9, 3.607687752403783*^9}, {
   3.6201286933741827`*^9, 3.620128755470149*^9}, 3.6201290359120617`*^9, 
   3.620129482103833*^9, 3.620129676231625*^9, {3.620129850158442*^9, 
   3.6201298964843197`*^9}, {3.620129957051549*^9, 3.6201299805768433`*^9}, 
   3.620130101004918*^9, {3.620130302638566*^9, 3.620130445138089*^9}, {
   3.6201304894729977`*^9, 3.6201305251515417`*^9}, 3.620130638675427*^9, {
   3.6201307147789516`*^9, 3.620130738632464*^9}, {3.620472648276346*^9, 
   3.6204726533887587`*^9}, {3.620472820252541*^9, 3.620472845547723*^9}, 
   3.620472896168179*^9, {3.6204903968658524`*^9, 3.620490400910372*^9}, {
   3.620492067145582*^9, 3.620492088414727*^9}, {3.620492357578835*^9, 
   3.6204923671121683`*^9}, 3.620492647447353*^9, {3.634550610021647*^9, 
   3.634550644163558*^9}, {3.634550850232502*^9, 3.634550888487487*^9}, {
   3.634550978737112*^9, 3.6345510060236692`*^9}, {3.634551334691854*^9, 
   3.634551334969935*^9}, {3.63455288868609*^9, 3.634552890173073*^9}, {
   3.6345536132427187`*^9, 3.6345536140503883`*^9}, {3.634559066597035*^9, 
   3.634559071664757*^9}, {3.6345591037946978`*^9, 3.634559126509865*^9}, 
   3.634559904034753*^9, {3.6347304666765757`*^9, 3.6347304702647552`*^9}, {
   3.634731247877136*^9, 3.634731254426853*^9}, {3.634833058074844*^9, 
   3.634833071017112*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Region 2: Dispersive", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6345509545279713`*^9, 3.6345509643504047`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CR", "[", "x_", "]"}], ":=", 
   RowBox[{"Conjugate", "[", 
    RowBox[{"Reverse", "[", "x", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CircleRHP", "[", "2", "]"}], "[", 
    RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "Domain", ",", "NumPts", ",", "z", ",", "i", ",", "p1", ",", "p2", ",", 
       "p3", ",", "p4", ",", "UpperDomain", ",", "UpperJumps", ",", 
       "LowerDomain", ",", "Jumps", ",", "LowerJumps", ",", "InnerNumPts", 
       ",", "smallrad"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"smallrad", "=", 
       RowBox[{"Min", "[", 
        RowBox[{".25", "/", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1.", "+", 
            RowBox[{
             RowBox[{"Abs", "[", "t", "]"}], "/", "10"}]}], ")"}], "^", 
          RowBox[{"(", 
           RowBox[{"1", "/", "2"}], ")"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"z", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"t", ">", "0"}], ",", 
         RowBox[{"z0", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", "I"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Domain", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"RightLens", "[", 
          RowBox[{"z", ",", "strip", ",", "True", ",", "smallrad"}], "]"}], 
         ",", 
         RowBox[{"LeftLens", "[", 
          RowBox[{"z", ",", "strip", ",", "True", ",", "smallrad"}], "]"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Jumps", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"M", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"M", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"P", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"P", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"P", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"P", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"M", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"M", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"U", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"U", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"L", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"L", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"L", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"L", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"U", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"U", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Jumps", "=", 
       RowBox[{"ConjugateJumps", "[", 
        RowBox[{"Jumps", ",", 
         RowBox[{"\[CapitalDelta]i", "[", 
          RowBox[{"1", ",", "n", ",", "t"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"NumPts", "=", 
       RowBox[{"{", 
        RowBox[{
        "largeN", ",", "smallN", ",", "smallN", ",", "largeN", ",", "largeN", 
         ",", "smallN", ",", "smallN", ",", "largeN", ",", "largeN", ",", 
         "smallN", ",", "smallN", ",", "largeN", ",", "largeN", ",", "smallN",
          ",", "smallN", ",", "largeN"}], "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"p1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Domain", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p4", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Domain", "[", 
          RowBox[{"[", "3", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p3", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Domain", "[", 
          RowBox[{"[", "10", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "//", "First"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p2", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Domain", "[", 
          RowBox[{"[", "11", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "//", "First"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"UpperDomain", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"p1", ",", "p2"}], "}"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"p2", ",", "p3"}], "}"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"p3", ",", "p4"}], "}"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"p4", ",", "p1"}], "}"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LowerDomain", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p2", ",", "p3"}], "}"}], "//", "CR"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p3", ",", "p4"}], "}"}], "//", "CR"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p4", ",", "p1"}], "}"}], "//", "CR"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p1", ",", "p2"}], "}"}], "//", "CR"}], "]"}]}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"UpperJumps", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[CapitalDelta]LD", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]D", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]Ui", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]PUi", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LowerJumps", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[CapitalDelta]D", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]Ui", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]PUi", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]LD", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"InnerNumPts", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"smallN", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "8"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ConjugateJumps", "[", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{"Jumps", ",", "UpperJumps", ",", "LowerJumps"}], "]"}], 
          ",", 
          RowBox[{"DD", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", 
        RowBox[{"Join", "[", 
         RowBox[{"Domain", ",", "UpperDomain", ",", "LowerDomain"}], "]"}], 
        ",", 
        RowBox[{"Join", "[", 
         RowBox[{"NumPts", ",", "InnerNumPts"}], "]"}]}], "}"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CircleRHPsamp", "[", "2", "]"}], "[", 
    RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "Domain", ",", "NumPts", ",", "z", ",", "i", ",", "p1", ",", "p2", ",", 
       "p3", ",", "p4", ",", "UpperDomain", ",", "UpperJumps", ",", 
       "LowerDomain", ",", "Jumps", ",", "LowerJumps", ",", "InnerNumPts", 
       ",", "smallrad"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"smallrad", "=", 
       RowBox[{"Min", "[", 
        RowBox[{".25", "/", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1.", "+", 
            RowBox[{
             RowBox[{"Abs", "[", "t", "]"}], "/", "10"}]}], ")"}], "^", 
          RowBox[{"(", 
           RowBox[{"1", "/", "2"}], ")"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"z", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"t", ">", "0"}], ",", 
         RowBox[{"z0", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", "I"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Domain", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"RightLens", "[", 
          RowBox[{"z", ",", "strip", ",", "True", ",", "smallrad"}], "]"}], 
         ",", 
         RowBox[{"LeftLens", "[", 
          RowBox[{"z", ",", "strip", ",", "True", ",", "smallrad"}], "]"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Jumps", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Msamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Msamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Psamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Psamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Psamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Psamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Msamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Msamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Usamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Usamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Lsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Lsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Lsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Lsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Usamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"Usamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"NumPts", "=", 
       RowBox[{"{", 
        RowBox[{
        "largeN", ",", "smallN", ",", "smallN", ",", "largeN", ",", "largeN", 
         ",", "smallN", ",", "smallN", ",", "largeN", ",", "largeN", ",", 
         "smallN", ",", "smallN", ",", "largeN", ",", "largeN", ",", "smallN",
          ",", "smallN", ",", "largeN"}], "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"p1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Domain", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p4", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Domain", "[", 
          RowBox[{"[", "3", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p3", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Domain", "[", 
          RowBox[{"[", "10", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "//", "First"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"p2", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Domain", "[", 
          RowBox[{"[", "11", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "//", "First"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"UpperDomain", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"p1", ",", "p2"}], "}"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"p2", ",", "p3"}], "}"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"p3", ",", "p4"}], "}"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{"{", 
           RowBox[{"p4", ",", "p1"}], "}"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LowerDomain", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p2", ",", "p3"}], "}"}], "//", "CR"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p3", ",", "p4"}], "}"}], "//", "CR"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p4", ",", "p1"}], "}"}], "//", "CR"}], "]"}], ",", 
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p1", ",", "p2"}], "}"}], "//", "CR"}], "]"}]}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"UpperJumps", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[CapitalDelta]LDsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]Dsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]Uisamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]PUisamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LowerJumps", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[CapitalDelta]Dsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]Uisamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]PUisamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"\[CapitalDelta]LDsamp", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"InnerNumPts", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"smallN", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", "8"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{"Jumps", ",", "UpperJumps", ",", "LowerJumps"}], "]"}], ",", 
        
        RowBox[{"Join", "[", 
         RowBox[{"Domain", ",", "UpperDomain", ",", "LowerDomain"}], "]"}], 
        ",", 
        RowBox[{"Join", "[", 
         RowBox[{"NumPts", ",", "InnerNumPts"}], "]"}]}], "}"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.634551330246146*^9, {3.6345536177071247`*^9, 3.634553618163981*^9}, {
   3.63455913349597*^9, 3.634559229496114*^9}, {3.634560725840804*^9, 
   3.634560731553033*^9}, {3.634730227990283*^9, 3.634730229301239*^9}, {
   3.6347302634901543`*^9, 3.634730337591712*^9}, {3.634730686905004*^9, 
   3.634730687367144*^9}, {3.634730724676619*^9, 3.634730725066914*^9}, {
   3.634822742427237*^9, 3.634822822545828*^9}, {3.634822986850762*^9, 
   3.6348230027015467`*^9}, {3.6348304061916113`*^9, 3.634830444222484*^9}, {
   3.634830493516945*^9, 3.634830497056528*^9}, {3.634831283934906*^9, 
   3.6348312924185877`*^9}, {3.63483276738453*^9, 3.6348327975865593`*^9}, {
   3.634832844630608*^9, 3.634832848248198*^9}, {3.634833011221834*^9, 
   3.634833027259186*^9}, {3.6474397598167267`*^9, 3.647439769779949*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Region 3: Soliton", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.634550591869*^9, 3.63455060009131*^9}, {
  3.634551038000371*^9, 3.6345510432457542`*^9}, {3.6346539649091454`*^9, 
  3.634653966188231*^9}, {3.634655203118178*^9, 3.63465520886128*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"RHP", " ", "with", " ", "no", " ", "conjugation", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"z0", " ", "near"}], " ", "-", 
      RowBox[{"1", "?"}]}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CircleRHP", "[", "3", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Domain", ",", "Jumps", ",", "NumPts", ",", "z", ",", "i"}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"z", "=", 
         RowBox[{"Abs", "[", 
          RowBox[{"z0", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"z", "\[GreaterEqual]", 
           RowBox[{"strip", "+", "1"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Domain", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"FullCircle", "[", 
               RowBox[{
                RowBox[{"1", "+", "strip"}], ",", "eps"}], "]"}], ",", 
              RowBox[{"FullCircle", "[", 
               RowBox[{
                RowBox[{"1", "-", "strip"}], ",", "eps"}], "]"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"Jumps", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"NumPts", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"largeN", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "+", "strip"}], ">", "z", ">", 
           RowBox[{"1", "+", 
            RowBox[{"strip", "/", "100"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Domain", "=", 
            RowBox[{"RightLensClosed", "[", "z", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Jumps", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"NumPts", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"largeN", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "+", 
            RowBox[{"strip", "/", "100"}]}], "\[GreaterEqual]", "z", 
           "\[GreaterEqual]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Domain", "=", 
            RowBox[{"RightLensClosed", "[", 
             RowBox[{"z", "+", 
              RowBox[{"strip", "/", "100"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Jumps", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"M", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"P", "[", 
               RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"NumPts", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"largeN", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ConjugateJumps", "[", 
           RowBox[{"Jumps", ",", 
            RowBox[{"DD", "[", 
             RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", "Domain", ",", 
          "NumPts"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CircleRHPsamp", "[", "3", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Domain", ",", "Jumps", ",", "NumPts", ",", "z", ",", "i"}], 
        "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"z", "=", 
         RowBox[{"Abs", "[", 
          RowBox[{"z0", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"z", "\[GreaterEqual]", 
           RowBox[{"strip", "+", "1"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Domain", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"FullCircle", "[", 
               RowBox[{
                RowBox[{"1", "+", "strip"}], ",", "eps"}], "]"}], ",", 
              RowBox[{"FullCircle", "[", 
               RowBox[{
                RowBox[{"1", "-", "strip"}], ",", "eps"}], "]"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"Jumps", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"NumPts", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"largeN", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "+", "strip"}], ">", "z", ">", 
           RowBox[{"1", "+", 
            RowBox[{"strip", "/", "100"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Domain", "=", 
            RowBox[{"RightLensClosed", "[", "z", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Jumps", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"NumPts", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"largeN", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"1", "+", 
            RowBox[{"strip", "/", "100"}]}], "\[GreaterEqual]", "z", 
           "\[GreaterEqual]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Domain", "=", 
            RowBox[{"RightLensClosed", "[", 
             RowBox[{"z", "+", 
              RowBox[{"strip", "/", "100"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Jumps", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Msamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}], ",", 
              RowBox[{"Psamp", "[", 
               RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"NumPts", "=", 
            RowBox[{"Table", "[", 
             RowBox[{"largeN", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", "Domain", "]"}]}], "}"}]}], "]"}]}], 
           ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Jumps", ",", "Domain", ",", "NumPts"}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.607687740759197*^9, 3.607687752403783*^9}, {
   3.6201286933741827`*^9, 3.620128755470149*^9}, 3.6201290359120617`*^9, 
   3.620129482103833*^9, 3.620129676231625*^9, {3.620129850158442*^9, 
   3.6201298964843197`*^9}, {3.620129957051549*^9, 3.6201299805768433`*^9}, 
   3.620130101004918*^9, {3.620130302638566*^9, 3.620130445138089*^9}, {
   3.6201304894729977`*^9, 3.6201305251515417`*^9}, 3.620130638675427*^9, {
   3.6201307147789516`*^9, 3.620130738632464*^9}, {3.620472648276346*^9, 
   3.6204726533887587`*^9}, {3.620472820252541*^9, 3.620472845547723*^9}, 
   3.620472896168179*^9, {3.6204903968658524`*^9, 3.620490400910372*^9}, {
   3.620492067145582*^9, 3.620492088414727*^9}, {3.620492357578835*^9, 
   3.6204923671121683`*^9}, 3.620492647447353*^9, {3.634550610021647*^9, 
   3.634550644163558*^9}, {3.634550850232502*^9, 3.634550888487487*^9}, {
   3.634550978737112*^9, 3.6345510060236692`*^9}, {3.634551334691854*^9, 
   3.634551334969935*^9}, {3.63455288868609*^9, 3.634552890173073*^9}, {
   3.6345536132427187`*^9, 3.6345536140503883`*^9}, {3.634559066597035*^9, 
   3.634559071664757*^9}, {3.6345591037946978`*^9, 3.634559126509865*^9}, 
   3.634559904034753*^9, {3.63465541609964*^9, 3.634655520871044*^9}, {
   3.6346556250837097`*^9, 3.6346556251848392`*^9}, {3.634655684906288*^9, 
   3.6346557387091*^9}, {3.634655809862166*^9, 3.63465581225913*^9}, {
   3.6346608255283117`*^9, 3.634660828773013*^9}, 3.63472954396553*^9, 
   3.6347310902523108`*^9, {3.63475035324769*^9, 3.634750429628138*^9}, {
   3.634752976813883*^9, 3.634753081956785*^9}, {3.6347531292392893`*^9, 
   3.634753142112246*^9}, {3.634753694986227*^9, 3.6347537887982473`*^9}, {
   3.634753836097466*^9, 3.634753842592456*^9}, {3.634753878180184*^9, 
   3.6347538975945597`*^9}, {3.634753965946518*^9, 3.634754125509158*^9}, {
   3.634754159458457*^9, 3.6347541607592783`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Region 4: Collisionless Shock", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.636201542809016*^9, 3.636201554863752*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CircleRHP", "[", "4", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Domain", ",", "NumPts", ",", "a", ",", "b", ",", "i", ",", "p1", ",",
          "p2", ",", "p3", ",", "p4", ",", "pa", ",", "pb", ",", 
         "UpperDomain", ",", "UpperJumps", ",", "LowerDomain", ",", "Jumps", 
         ",", "LowerJumps", ",", "InnerNumPts", ",", "smallrada", ",", 
         "smallradb"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"a", ",", "b"}], "}"}], "=", 
         RowBox[{"CSPoints", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"smallradb", "=", 
         RowBox[{"2", 
          RowBox[{"Min", "[", 
           RowBox[{
            RowBox[{"strip", "/", "2"}], ",", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"a", "-", "b"}], "]"}], "/", "2"}]}], "]"}]}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"fix", " ", "this", " ", 
          RowBox[{"scaling", "?"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"smallrada", "=", 
         RowBox[{"Min", "[", 
          RowBox[{
           RowBox[{"8", "smallradb"}], ",", 
           RowBox[{
            RowBox[{"Im", "[", "a", "]"}], "/", "2"}]}], "]"}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"fix", " ", "this", " ", 
          RowBox[{"scaling", "?"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"RightLens", "[", 
            RowBox[{"b", ",", "strip", ",", "True", ",", "smallradb"}], "]"}],
            ",", 
           RowBox[{"LeftLensCS", "[", 
            RowBox[{"a", ",", 
             RowBox[{"Min", "[", 
              RowBox[{"strip", ",", 
               RowBox[{
                RowBox[{"Im", "[", "a", "]"}], "/", "2"}]}], "]"}], ",", 
             "True", ",", "smallrada"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p1", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p4", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "3", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p3", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "10", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "First"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p2", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "11", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "First"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pa", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "a", "]"}], "-", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallrada", "/", "2"}], "]"}], "/", "8"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"pb", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "b", "]"}], "+", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallradb", "/", "2"}], "]"}], "/", "4"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"p2", ",", 
          RowBox[{
          "p3", " ", "have", " ", "more", " ", "negative", " ", "real", " ", 
           "parts"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"UpperDomain", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p4", ",", "p1"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pb", ",", "p4"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p1", ",", "pb"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p2", ",", "p3"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pa", ",", "p2"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p3", ",", "pa"}], "}"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"LowerDomain", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p4", ",", "p1"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pb", ",", "p4"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p1", ",", "pb"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p2", ",", "p3"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pa", ",", "p2"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p3", ",", "pa"}], "}"}], "//", "CR"}], "]"}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Jumps", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Mcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ucs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ucs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Lcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Lcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Lcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ucs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]i", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Pi\[CapitalDelta]i", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]M\[CapitalDelta]i", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]D", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]LD", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Ui", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]i", "[", 
            RowBox[{"1", ",", "n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Pi\[CapitalDelta]i", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]M\[CapitalDelta]i", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]D", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]LD", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Ui", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jcs", "[", 
            RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"NumPts", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{"smallN", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "18"}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"largeN", ",", "largeN"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"smallN", ",", "smallN", ",", "smallN", ",", "smallN"}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"largeN", ",", "largeN", ",", "smallN", ",", "smallN"}], 
            "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"Domain", ",", "UpperDomain", ",", "LowerDomain", ",", 
           RowBox[{"{", 
            RowBox[{"Arc", "[", 
             RowBox[{"0", ",", "1", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Arg", "[", "pb", "]"}], ",", 
                RowBox[{"Arg", "[", "pa", "]"}]}], "}"}]}], "]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Arc", "[", 
             RowBox[{"0", ",", "1", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"Arg", "[", "pa", "]"}]}], ",", 
                RowBox[{"-", 
                 RowBox[{"Arg", "[", "pb", "]"}]}]}], "}"}]}], "]"}], "}"}]}],
           "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ConjugateJumps", "[", 
           RowBox[{"Jumps", ",", 
            RowBox[{"DD", "[", 
             RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", "Domain", ",", 
          "NumPts"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CircleRHPsamp", "[", "4", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Domain", ",", "NumPts", ",", "a", ",", "b", ",", "i", ",", "p1", ",",
          "p2", ",", "p3", ",", "p4", ",", "pa", ",", "pb", ",", 
         "UpperDomain", ",", "UpperJumps", ",", "LowerDomain", ",", "Jumps", 
         ",", "LowerJumps", ",", "InnerNumPts", ",", "smallrada", ",", 
         "smallradb"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"a", ",", "b"}], "}"}], "=", 
         RowBox[{"CSPoints", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"smallradb", "=", 
         RowBox[{"2", 
          RowBox[{"Min", "[", 
           RowBox[{
            RowBox[{"strip", "/", "2"}], ",", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"a", "-", "b"}], "]"}], "/", "2"}]}], "]"}]}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"fix", " ", "this", " ", 
          RowBox[{"scaling", "?"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"smallrada", "=", 
         RowBox[{"Min", "[", 
          RowBox[{
           RowBox[{"8", "smallradb"}], ",", 
           RowBox[{
            RowBox[{"Im", "[", "a", "]"}], "/", "2"}]}], "]"}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"fix", " ", "this", " ", 
          RowBox[{"scaling", "?"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"RightLens", "[", 
            RowBox[{"b", ",", "strip", ",", "True", ",", "smallradb"}], "]"}],
            ",", 
           RowBox[{"LeftLensCS", "[", 
            RowBox[{"a", ",", 
             RowBox[{"Min", "[", 
              RowBox[{"strip", ",", 
               RowBox[{
                RowBox[{"Im", "[", "a", "]"}], "/", "2"}]}], "]"}], ",", 
             "True", ",", "smallrada"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p1", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p4", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "3", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p3", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "10", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "First"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p2", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "11", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "First"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pa", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "a", "]"}], "-", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallrada", "/", "2"}], "]"}], "/", "8"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"pb", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "b", "]"}], "+", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallradb", "/", "2"}], "]"}], "/", "4"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"p2", ",", 
          RowBox[{
          "p3", " ", "have", " ", "more", " ", "negative", " ", "real", " ", 
           "parts"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"UpperDomain", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p4", ",", "p1"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pb", ",", "p4"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p1", ",", "pb"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p2", ",", "p3"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pa", ",", "p2"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p3", ",", "pa"}], "}"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"LowerDomain", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p4", ",", "p1"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pb", ",", "p4"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p1", ",", "pb"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p2", ",", "p3"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pa", ",", "p2"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p3", ",", "pa"}], "}"}], "//", "CR"}], "]"}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Jumps", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Mcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ucssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ucssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Lcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Lcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Lcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ucssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]isamp", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Pi\[CapitalDelta]isamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]M\[CapitalDelta]isamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Dsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]LDsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Uisamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]isamp", "[", 
            RowBox[{"1", ",", "n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Pi\[CapitalDelta]isamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]M\[CapitalDelta]isamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Dsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]LDsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[CapitalDelta]\[Phi]Uisamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jcssamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"NumPts", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{"smallN", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", "18"}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"largeN", ",", "largeN"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"smallN", ",", "smallN", ",", "smallN", ",", "smallN"}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"largeN", ",", "largeN", ",", "smallN", ",", "smallN"}], 
            "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"Domain", ",", "UpperDomain", ",", "LowerDomain", ",", 
           RowBox[{"{", 
            RowBox[{"Arc", "[", 
             RowBox[{"0", ",", "1", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Arg", "[", "pb", "]"}], ",", 
                RowBox[{"Arg", "[", "pa", "]"}]}], "}"}]}], "]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Arc", "[", 
             RowBox[{"0", ",", "1", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"Arg", "[", "pa", "]"}]}], ",", 
                RowBox[{"-", 
                 RowBox[{"Arg", "[", "pb", "]"}]}]}], "}"}]}], "]"}], "}"}]}],
           "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Jumps", ",", "Domain", ",", "NumPts"}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.636201572980337*^9, 3.6362015789035673`*^9}, {
   3.6362019048960047`*^9, 3.636201919592216*^9}, {3.6362196917518682`*^9, 
   3.636219741544435*^9}, {3.636219775175325*^9, 3.636219775393998*^9}, {
   3.636220192081518*^9, 3.636220195528192*^9}, 3.636220331469677*^9, {
   3.636221385019986*^9, 3.63622141236242*^9}, {3.636221582161786*^9, 
   3.636221599456367*^9}, {3.636221708780266*^9, 3.636221733564042*^9}, {
   3.636221766546955*^9, 3.636221791333222*^9}, {3.636221839104341*^9, 
   3.636221847706732*^9}, {3.636222350720592*^9, 3.636222363214019*^9}, {
   3.6362225548003817`*^9, 3.636222576412488*^9}, {3.636222616052629*^9, 
   3.636222617980197*^9}, {3.636222713887885*^9, 3.636222770462626*^9}, {
   3.6362228221522083`*^9, 3.636222849117713*^9}, {3.636222896071619*^9, 
   3.6362229204352407`*^9}, 3.636223013102254*^9, {3.636223068112296*^9, 
   3.636223160416238*^9}, {3.636223342151009*^9, 3.63622334231057*^9}, {
   3.636223388282506*^9, 3.63622372534485*^9}, {3.636223763120195*^9, 
   3.636223770525453*^9}, {3.636223817819008*^9, 3.636223885416689*^9}, {
   3.636226387353339*^9, 3.636226387559642*^9}, {3.636226418771893*^9, 
   3.636226507702475*^9}, {3.636226676466604*^9, 3.636226676712167*^9}, {
   3.636374369924799*^9, 3.636374395550934*^9}, {3.636452875526676*^9, 
   3.636452880324548*^9}, {3.636452914819817*^9, 3.636452928738854*^9}, {
   3.6364530053691177`*^9, 3.636453008681181*^9}, {3.63645315002617*^9, 
   3.636453182068551*^9}, {3.636453214573327*^9, 3.6364532151077843`*^9}, {
   3.6364532472836*^9, 3.636453248243046*^9}, {3.636460916263153*^9, 
   3.6364609625889053`*^9}, {3.636461313336707*^9, 3.636461359608637*^9}, {
   3.636461576536427*^9, 3.636461594123372*^9}, {3.636461637747621*^9, 
   3.6364616387850733`*^9}, {3.6364617645617027`*^9, 3.636461764964656*^9}, {
   3.6364618206499853`*^9, 3.636461833547638*^9}, {3.636461890876925*^9, 
   3.636461891058457*^9}, {3.636461933567834*^9, 3.6364619338249893`*^9}, 
   3.63646203359122*^9, {3.6364628603538437`*^9, 3.636462868855163*^9}, {
   3.6364629133925333`*^9, 3.636462946444022*^9}, {3.636463013996997*^9, 
   3.636463088336864*^9}, {3.6364631253148108`*^9, 3.636463145095695*^9}, 
   3.636463200467057*^9, {3.636466326525714*^9, 3.636466376939633*^9}, {
   3.636466455025983*^9, 3.6364664589213953`*^9}, {3.636466607059207*^9, 
   3.636466619083959*^9}, 3.6364666550240307`*^9, {3.636479117421207*^9, 
   3.636479129929085*^9}, {3.6364792191802998`*^9, 3.636479246329547*^9}, {
   3.636479286966695*^9, 3.636479296633861*^9}, {3.636479371181039*^9, 
   3.636479401933441*^9}, {3.6364795026596737`*^9, 3.636479527456572*^9}, {
   3.636479587064666*^9, 3.636479587569758*^9}, {3.636480515687701*^9, 
   3.636480534404058*^9}, {3.636480567716691*^9, 3.636480593233629*^9}, 
   3.636482137554582*^9, 3.636482183583953*^9, 3.636482637413197*^9, {
   3.636484022005486*^9, 3.636484110940015*^9}, {3.636543925602312*^9, 
   3.636543933752061*^9}, {3.636544150217883*^9, 3.636544159395295*^9}, {
   3.636544277617594*^9, 3.6365442941070633`*^9}, {3.6365445068426323`*^9, 
   3.636544520557062*^9}, {3.636544575619542*^9, 3.636544579061763*^9}, {
   3.636544688425199*^9, 3.636544805605857*^9}, {3.6365448878573914`*^9, 
   3.6365448880246162`*^9}, {3.6365449854758472`*^9, 3.636544994229361*^9}, {
   3.636545342037558*^9, 3.6365453507500153`*^9}, {3.6365454489949627`*^9, 
   3.6365454826588*^9}, {3.636545543677168*^9, 3.6365455575842133`*^9}, {
   3.636545619105255*^9, 3.6365456470160513`*^9}, {3.636545690753193*^9, 
   3.636545711165778*^9}, {3.6365496316682262`*^9, 3.636549720572301*^9}, {
   3.636549760287122*^9, 3.636549776299157*^9}, {3.6365499580725727`*^9, 
   3.636549965045763*^9}, {3.636550048354533*^9, 3.6365500536232653`*^9}, {
   3.636551695297324*^9, 3.636551700348634*^9}, {3.636551758607852*^9, 
   3.6365517628642483`*^9}, {3.636552062245387*^9, 3.636552128433041*^9}, {
   3.63655218933877*^9, 3.636552211164792*^9}, 3.636565813685686*^9, {
   3.6365685185376472`*^9, 3.63656851890486*^9}, {3.645619191356703*^9, 
   3.645619197100439*^9}, {3.645619268623569*^9, 3.645619276278812*^9}, {
   3.645619420939032*^9, 3.645619505613453*^9}, {3.645619640741993*^9, 
   3.6456196601974277`*^9}, {3.645619765182375*^9, 3.645619792769154*^9}, {
   3.6456198711921864`*^9, 3.645619892651888*^9}, {3.645622305774251*^9, 
   3.645622314865366*^9}, 3.6474389055064783`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Region 5: Transition", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.636201542809016*^9, 3.636201554863752*^9}, {
  3.636797010094925*^9, 3.636797015181411*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CircleRHP", "[", "5", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Domain", ",", "NumPts", ",", "a", ",", "b", ",", "i", ",", "p1", ",",
          "p4", ",", "pa", ",", "pb", ",", "UpperDomain", ",", "UpperJumps", 
         ",", "LowerDomain", ",", "Jumps", ",", "LowerJumps", ",", 
         "InnerNumPts", ",", "smallrada", ",", "smallradb", ",", "pam", ",", 
         "pao", ",", "pai", ",", "Arcs"}], "}"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"a", ",", "b"}], "}"}], "=", 
         RowBox[{"TPoints", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"smallradb", "=", 
         RowBox[{"2", 
          RowBox[{"Min", "[", 
           RowBox[{
            RowBox[{"strip", "/", "2"}], ",", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"a", "-", "b"}], "]"}], "/", "2"}], ",", 
            RowBox[{
             RowBox[{"Im", "[", "a", "]"}], "/", "2"}]}], "]"}]}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"fix", " ", "this", " ", 
          RowBox[{"scaling", "?"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"smallrada", "=", 
         RowBox[{"Min", "[", 
          RowBox[{
           RowBox[{"strip", "/", "2"}], ",", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"a", "-", "b"}], "]"}], "/", "2"}], ",", 
           RowBox[{
            RowBox[{"Im", "[", "a", "]"}], "/", "2"}]}], "]"}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"fix", " ", "this", " ", 
          RowBox[{"scaling", "?"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"RightLens", "[", 
          RowBox[{"b", ",", "strip", ",", "True", ",", "smallradb"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"p1", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p4", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "3", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pa", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "a", "]"}], "-", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallrada", "/", "2"}], "]"}], "/", "2"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"pam", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "a", "]"}], "+", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallrada", "/", "2"}], "]"}], "/", "2"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"pao", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"smallrada", "/", "2"}]}], ")"}], "a"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pai", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"smallrada", "/", "2"}]}], ")"}], "a"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pb", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "b", "]"}], "+", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallradb", "/", "2"}], "]"}], "/", "4"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"UpperDomain", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p4", ",", "p1"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pb", ",", "p4"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p1", ",", "pb"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pa", ",", "pao"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pao", ",", "pam"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pam", ",", "pai"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pai", ",", "pa"}], "}"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"LowerDomain", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p4", ",", "p1"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pb", ",", "p4"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p1", ",", "pb"}], "}"}], "//", "CR"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pa", ",", "pao"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pao", ",", "pam"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pam", ",", "pai"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pai", ",", "pa"}], "}"}], "//", "CR"}], "]"}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Arcs", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Arc", "[", 
            RowBox[{"0", ",", "1", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Arg", "[", "pb", "]"}], ",", 
               RowBox[{"Arg", "[", "pa", "]"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Arc", "[", 
            RowBox[{"0", ",", "1", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"Arg", "[", "pa", "]"}]}], ",", 
               RowBox[{"-", 
                RowBox[{"Arg", "[", "pb", "]"}]}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Arc", "[", 
            RowBox[{"0", ",", "1", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Arg", "[", "pam", "]"}], ",", 
               RowBox[{
                RowBox[{"2", "Pi"}], "-", 
                RowBox[{"Arg", "[", "pam", "]"}]}]}], "}"}]}], "]"}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Jumps", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Mt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Pt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]ti", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iPi", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iM", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iM", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iM", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iPi", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iPi", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]ti", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iPi", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iM", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iM", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iM", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iPi", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iPi", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jt", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jt", "[", 
            RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Jumps", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Mt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Mt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Pt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Pt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Pt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Pt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Mt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Mt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]ti", "[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iPi", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iM", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iLD", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iLD", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iUi", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iUi", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]ti", "[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iPi", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iM", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iLD", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iLD", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iUi", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"\[Phi]iUi", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Jt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Jt", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"Jt", "[", 
              RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"Optimize", " ", 
          RowBox[{"this", "!"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"NumPts", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"largeN", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "25"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
          "Domain", ",", "UpperDomain", ",", "LowerDomain", ",", "Arcs"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ConjugateJumps", "[", 
           RowBox[{"Jumps", ",", 
            RowBox[{"DD", "[", 
             RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", "Domain", ",", 
          "NumPts"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"CircleRHPsamp", "[", "5", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "Domain", ",", "NumPts", ",", "a", ",", "b", ",", "i", ",", "p1", ",",
          "p4", ",", "pa", ",", "pb", ",", "UpperDomain", ",", "UpperJumps", 
         ",", "LowerDomain", ",", "Jumps", ",", "LowerJumps", ",", 
         "InnerNumPts", ",", "smallrada", ",", "smallradb", ",", "pam", ",", 
         "pao", ",", "pai", ",", "Arcs"}], "}"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"a", ",", "b"}], "}"}], "=", 
         RowBox[{"TPoints", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"smallradb", "=", 
         RowBox[{"2", 
          RowBox[{"Min", "[", 
           RowBox[{
            RowBox[{"strip", "/", "2"}], ",", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"a", "-", "b"}], "]"}], "/", "2"}], ",", 
            RowBox[{
             RowBox[{"Im", "[", "a", "]"}], "/", "2"}]}], "]"}]}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"fix", " ", "this", " ", 
          RowBox[{"scaling", "?"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"smallrada", "=", 
         RowBox[{"Min", "[", 
          RowBox[{
           RowBox[{"strip", "/", "2"}], ",", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"a", "-", "b"}], "]"}], "/", "2"}], ",", 
           RowBox[{
            RowBox[{"Im", "[", "a", "]"}], "/", "2"}]}], "]"}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"fix", " ", "this", " ", 
          RowBox[{"scaling", "?"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"RightLens", "[", 
          RowBox[{"b", ",", "strip", ",", "True", ",", "smallradb"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"p1", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"p4", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Domain", "[", 
            RowBox[{"[", "3", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Last"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pa", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "a", "]"}], "-", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallrada", "/", "2"}], "]"}], "/", "2"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"pam", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "a", "]"}], "+", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallrada", "/", "2"}], "]"}], "/", "2"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"pao", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"smallrada", "/", "2"}]}], ")"}], "a"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pai", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"smallrada", "/", "2"}]}], ")"}], "a"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pb", "=", 
         RowBox[{"Exp", "[", 
          RowBox[{"I", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Arg", "[", "b", "]"}], "+", " ", 
             RowBox[{
              RowBox[{"ArcSin", "[", 
               RowBox[{"smallradb", "/", "2"}], "]"}], "/", "4"}]}], ")"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"UpperDomain", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p4", ",", "p1"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pb", ",", "p4"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"p1", ",", "pb"}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pa", ",", "pao"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pao", ",", "pam"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pam", ",", "pai"}], "}"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{"{", 
             RowBox[{"pai", ",", "pa"}], "}"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"LowerDomain", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p4", ",", "p1"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pb", ",", "p4"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"p1", ",", "pb"}], "}"}], "//", "CR"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pa", ",", "pao"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pao", ",", "pam"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pam", ",", "pai"}], "}"}], "//", "CR"}], "]"}], ",", 
           RowBox[{"Line", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"pai", ",", "pa"}], "}"}], "//", "CR"}], "]"}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Arcs", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Arc", "[", 
            RowBox[{"0", ",", "1", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Arg", "[", "pb", "]"}], ",", 
               RowBox[{"Arg", "[", "pa", "]"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Arc", "[", 
            RowBox[{"0", ",", "1", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"Arg", "[", "pa", "]"}]}], ",", 
               RowBox[{"-", 
                RowBox[{"Arg", "[", "pb", "]"}]}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Arc", "[", 
            RowBox[{"0", ",", "1", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Arg", "[", "pam", "]"}], ",", 
               RowBox[{
                RowBox[{"2", "Pi"}], "-", 
                RowBox[{"Arg", "[", "pam", "]"}]}]}], "}"}]}], "]"}]}], 
          "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Jumps", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Mtsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mtsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ptsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ptsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ptsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Ptsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mtsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Mtsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]tisamp", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iPisamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iMsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iLDsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iLDsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iUisamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iUisamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]tisamp", "[", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iPisamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iMsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iLDsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iLDsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iUisamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"\[Phi]iUisamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jtsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jtsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}], ",", 
           RowBox[{"Jtsamp", "[", 
            RowBox[{"n", ",", "t"}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"TODO", ":", " ", 
          RowBox[{"Optimize", " ", 
           RowBox[{"this", "?"}]}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"NumPts", "=", 
         RowBox[{"Table", "[", 
          RowBox[{"largeN", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "25"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Domain", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
          "Domain", ",", "UpperDomain", ",", "LowerDomain", ",", "Arcs"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Jumps", ",", "Domain", ",", "NumPts"}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.636201572980337*^9, 3.6362015789035673`*^9}, {
   3.6362019048960047`*^9, 3.636201919592216*^9}, {3.6362196917518682`*^9, 
   3.636219741544435*^9}, {3.636219775175325*^9, 3.636219775393998*^9}, {
   3.636220192081518*^9, 3.636220195528192*^9}, 3.636220331469677*^9, {
   3.636221385019986*^9, 3.63622141236242*^9}, {3.636221582161786*^9, 
   3.636221599456367*^9}, {3.636221708780266*^9, 3.636221733564042*^9}, {
   3.636221766546955*^9, 3.636221791333222*^9}, {3.636221839104341*^9, 
   3.636221847706732*^9}, {3.636222350720592*^9, 3.636222363214019*^9}, {
   3.6362225548003817`*^9, 3.636222576412488*^9}, {3.636222616052629*^9, 
   3.636222617980197*^9}, {3.636222713887885*^9, 3.636222770462626*^9}, {
   3.6362228221522083`*^9, 3.636222849117713*^9}, {3.636222896071619*^9, 
   3.6362229204352407`*^9}, 3.636223013102254*^9, {3.636223068112296*^9, 
   3.636223160416238*^9}, {3.636223342151009*^9, 3.63622334231057*^9}, {
   3.636223388282506*^9, 3.63622372534485*^9}, {3.636223763120195*^9, 
   3.636223770525453*^9}, {3.636223817819008*^9, 3.636223885416689*^9}, {
   3.636226387353339*^9, 3.636226387559642*^9}, {3.636226418771893*^9, 
   3.636226507702475*^9}, {3.636226676466604*^9, 3.636226676712167*^9}, {
   3.636374369924799*^9, 3.636374395550934*^9}, {3.636452875526676*^9, 
   3.636452880324548*^9}, {3.636452914819817*^9, 3.636452928738854*^9}, {
   3.6364530053691177`*^9, 3.636453008681181*^9}, {3.63645315002617*^9, 
   3.636453182068551*^9}, {3.636453214573327*^9, 3.6364532151077843`*^9}, {
   3.6364532472836*^9, 3.636453248243046*^9}, {3.636460916263153*^9, 
   3.6364609625889053`*^9}, {3.636461313336707*^9, 3.636461359608637*^9}, {
   3.636461576536427*^9, 3.636461594123372*^9}, {3.636461637747621*^9, 
   3.6364616387850733`*^9}, {3.6364617645617027`*^9, 3.636461764964656*^9}, {
   3.6364618206499853`*^9, 3.636461833547638*^9}, {3.636461890876925*^9, 
   3.636461891058457*^9}, {3.636461933567834*^9, 3.6364619338249893`*^9}, 
   3.63646203359122*^9, {3.6364628603538437`*^9, 3.636462868855163*^9}, {
   3.6364629133925333`*^9, 3.636462946444022*^9}, {3.636463013996997*^9, 
   3.636463088336864*^9}, {3.6364631253148108`*^9, 3.636463145095695*^9}, 
   3.636463200467057*^9, {3.636466326525714*^9, 3.636466376939633*^9}, {
   3.636466455025983*^9, 3.6364664589213953`*^9}, {3.636466607059207*^9, 
   3.636466619083959*^9}, 3.6364666550240307`*^9, {3.636479117421207*^9, 
   3.636479129929085*^9}, {3.6364792191802998`*^9, 3.636479246329547*^9}, {
   3.636479286966695*^9, 3.636479296633861*^9}, {3.636479371181039*^9, 
   3.636479401933441*^9}, {3.6364795026596737`*^9, 3.636479527456572*^9}, {
   3.636479587064666*^9, 3.636479587569758*^9}, {3.636480515687701*^9, 
   3.636480534404058*^9}, {3.636480567716691*^9, 3.636480593233629*^9}, 
   3.636482137554582*^9, 3.636482183583953*^9, 3.636482637413197*^9, {
   3.636484022005486*^9, 3.636484110940015*^9}, {3.636543925602312*^9, 
   3.636543933752061*^9}, {3.636544150217883*^9, 3.636544159395295*^9}, {
   3.636544277617594*^9, 3.6365442941070633`*^9}, {3.6365445068426323`*^9, 
   3.636544520557062*^9}, {3.636544575619542*^9, 3.636544579061763*^9}, {
   3.636544688425199*^9, 3.636544805605857*^9}, {3.6365448878573914`*^9, 
   3.6365448880246162`*^9}, {3.6365449854758472`*^9, 3.636544994229361*^9}, {
   3.636545342037558*^9, 3.6365453507500153`*^9}, {3.6365454489949627`*^9, 
   3.6365454826588*^9}, {3.636545543677168*^9, 3.6365455575842133`*^9}, {
   3.636545619105255*^9, 3.6365456470160513`*^9}, {3.636545690753193*^9, 
   3.636545711165778*^9}, {3.6365496316682262`*^9, 3.636549720572301*^9}, {
   3.636549760287122*^9, 3.636549776299157*^9}, {3.6365499580725727`*^9, 
   3.636549965045763*^9}, {3.636550048354533*^9, 3.6365500536232653`*^9}, {
   3.636551695297324*^9, 3.636551700348634*^9}, {3.636551758607852*^9, 
   3.6365517628642483`*^9}, {3.636552062245387*^9, 3.636552128433041*^9}, {
   3.63655218933877*^9, 3.636552211164792*^9}, 3.636565813685686*^9, {
   3.6365685185376472`*^9, 3.63656851890486*^9}, {3.6367970197333307`*^9, 
   3.636797023929084*^9}, {3.6367976334973993`*^9, 3.636797634775642*^9}, {
   3.636812227971919*^9, 3.6368126005220537`*^9}, {3.636812630922122*^9, 
   3.636812636738265*^9}, {3.6368126826516123`*^9, 3.63681269368436*^9}, {
   3.636812724055056*^9, 3.6368128480612392`*^9}, {3.63681287989027*^9, 
   3.636812887435917*^9}, {3.6368130881042643`*^9, 3.636813090670396*^9}, {
   3.636813139947751*^9, 3.636813166392666*^9}, {3.6368134095786*^9, 
   3.636813477249617*^9}, {3.6368135084061527`*^9, 3.636813514463162*^9}, 
   3.636813577714259*^9, {3.6368137269597683`*^9, 3.636813727861211*^9}, {
   3.6368151480425997`*^9, 3.6368151732746773`*^9}, {3.63681524214429*^9, 
   3.636815248045978*^9}, {3.645619375147244*^9, 3.645619401311405*^9}, {
   3.645619513950983*^9, 3.6456195294265623`*^9}, {3.645619608414983*^9, 
   3.6456196241322947`*^9}, {3.645620829205934*^9, 3.645620833050212*^9}, {
   3.647436944086646*^9, 3.647436982160966*^9}, {3.647438896141489*^9, 
   3.6474389014191093`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Soliton Contours", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6344927427099447`*^9, 3.6344927468374023`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"give", " ", "n"}], ",", "t", ",", 
    RowBox[{"\[CapitalLambda]", " ", 
     RowBox[{"(", "eigenvalues", ")"}]}], ",", " ", 
    RowBox[{"c", " ", 
     RowBox[{"(", 
      RowBox[{"norming", " ", "constants"}], ")"}], " ", "and", " ", 
     "returns"}], ",", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Jumps", ",", "Domain", ",", "Points"}], "}"}], " ", "for", " ",
      "the", " ", "soliton", " ", "circles"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"PoleList", "[", 
     RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"rad", ",", "Domain", ",", "Jumps", ",", "Points", ",", "i"}], 
       "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"rad", "=", 
        RowBox[{
         RowBox[{"MinDist", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "1"}], "+", "strip"}], ",", "\[CapitalLambda]", 
             ",", "0", ",", 
             RowBox[{"1", "-", "strip"}]}], "}"}], "//", "Flatten"}], "]"}], 
         "/", "3"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Domain", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Jumps", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Points", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "\[CapitalLambda]", "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{
               RowBox[{"\[CapitalLambda]", "[", 
                RowBox[{"[", "i", "]"}], "]"}], " ", 
               RowBox[{"c", "[", 
                RowBox[{"[", "i", "]"}], "]"}], " ", 
               RowBox[{"Exp", "[", 
                RowBox[{
                 RowBox[{"\[Theta]", "[", 
                  RowBox[{"n", ",", "t"}], "]"}], "[", 
                 RowBox[{"\[CapitalLambda]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}]}], "]"}], ">", 
             "expconst"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Jumps", " ", "=", " ", 
              RowBox[{"Join", "[", 
               RowBox[{"Jumps", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"S", "[", 
                    RowBox[{"+", "1"}], "]"}], "[", 
                   RowBox[{"n", ",", "t", ",", 
                    RowBox[{"\[CapitalLambda]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"S", "[", 
                    RowBox[{"+", "1"}], "]"}], "[", 
                   RowBox[{"n", ",", "t", ",", 
                    RowBox[{"\[CapitalLambda]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "}"}]}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"Jumps", " ", "=", " ", 
              RowBox[{"Join", "[", 
               RowBox[{"Jumps", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"S", "[", 
                    RowBox[{"-", "1"}], "]"}], "[", 
                   RowBox[{"n", ",", "t", ",", 
                    RowBox[{"\[CapitalLambda]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"S", "[", 
                    RowBox[{"-", "1"}], "]"}], "[", 
                   RowBox[{"n", ",", "t", ",", 
                    RowBox[{"\[CapitalLambda]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "}"}]}], 
               "]"}]}], ";"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Jumps", " ", "=", " ", 
              RowBox[{"Join", "[", 
               RowBox[{"Jumps", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"T", "[", 
                    RowBox[{"+", "1"}], "]"}], "[", 
                   RowBox[{"n", ",", "t", ",", 
                    RowBox[{"\[CapitalLambda]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"T", "[", 
                    RowBox[{"+", "1"}], "]"}], "[", 
                   RowBox[{"n", ",", "t", ",", 
                    RowBox[{"\[CapitalLambda]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "}"}]}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"Jumps", " ", "=", " ", 
              RowBox[{"Join", "[", 
               RowBox[{"Jumps", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"T", "[", 
                    RowBox[{"-", "1"}], "]"}], "[", 
                   RowBox[{"n", ",", "t", ",", 
                    RowBox[{"\[CapitalLambda]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"T", "[", 
                    RowBox[{"-", "1"}], "]"}], "[", 
                   RowBox[{"n", ",", "t", ",", 
                    RowBox[{"\[CapitalLambda]", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"c", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "}"}]}], 
               "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Domain", "=", " ", 
           RowBox[{"Join", "[", 
            RowBox[{"Domain", ",", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"ContourArray", "[", 
                RowBox[{
                 RowBox[{"+", "1"}], ",", "rad", ",", 
                 RowBox[{"\[CapitalLambda]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"ContourArray", "[", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "rad", ",", 
                 RowBox[{"\[CapitalLambda]", "[", 
                  RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "]"}]}], "]"}]}],
           ";", "\[IndentingNewLine]", 
          RowBox[{"Points", "=", 
           RowBox[{"Join", "[", 
            RowBox[{"Points", ",", 
             RowBox[{"{", 
              RowBox[{"smallN", ",", "smallN", ",", "smallN", ",", "smallN"}],
               "}"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ConjugateJumps", "[", 
          RowBox[{"Jumps", ",", 
           RowBox[{"DD", "[", 
            RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", "Domain", ",", 
         "Points"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.606733449570198*^9, 3.606733551253655*^9}, {
   3.6067336632116117`*^9, 3.6067336905873823`*^9}, {3.6067341982394238`*^9, 
   3.606734198565977*^9}, {3.606735076921289*^9, 3.606735190175311*^9}, {
   3.6068245723496113`*^9, 3.6068245733223963`*^9}, {3.606840841826524*^9, 
   3.606840849743154*^9}, {3.6068410582870703`*^9, 3.6068410662203417`*^9}, {
   3.6070814298741093`*^9, 3.607081460277204*^9}, {3.6070815965845327`*^9, 
   3.607081596871505*^9}, {3.607081701849297*^9, 3.60708170254669*^9}, {
   3.607095006002584*^9, 3.6070950808625803`*^9}, {3.607096159669774*^9, 
   3.6070962478123713`*^9}, {3.6071038263028507`*^9, 
   3.6071038320531483`*^9}, {3.607107741210799*^9, 3.607107763549604*^9}, {
   3.607107806823991*^9, 3.607107813243987*^9}, {3.607107897459745*^9, 
   3.607107907220434*^9}, {3.6071667804136744`*^9, 3.6071667815101223`*^9}, {
   3.607167331766487*^9, 3.607167360878427*^9}, {3.607167456078627*^9, 
   3.607167465275872*^9}, {3.6071680721726103`*^9, 3.607168085015952*^9}, {
   3.607168225716888*^9, 3.607168238056736*^9}, {3.607168793695465*^9, 
   3.607168800117456*^9}, {3.607168855454011*^9, 3.6071688725898943`*^9}, {
   3.607169101916469*^9, 3.607169252794587*^9}, {3.607169292734501*^9, 
   3.607169330477306*^9}, {3.6071693613285437`*^9, 3.607169536707952*^9}, {
   3.6071697178704643`*^9, 3.607169722796816*^9}, {3.6071697985247917`*^9, 
   3.60716983106391*^9}, {3.6071698984733887`*^9, 3.6071699152045116`*^9}, {
   3.6071699681564703`*^9, 3.6071699683620777`*^9}, {3.607170100197331*^9, 
   3.607170113135777*^9}, 3.6071701718658133`*^9, {3.607170518628388*^9, 
   3.607170563970374*^9}, {3.607170858174271*^9, 3.607170870368799*^9}, {
   3.607181512606913*^9, 3.60718153439281*^9}, 3.607181848659523*^9, {
   3.607182121531664*^9, 3.607182123988826*^9}, {3.607182297026709*^9, 
   3.60718229721037*^9}, {3.607182890476677*^9, 3.607182891584895*^9}, 
   3.607183004255433*^9, {3.607184657425455*^9, 3.6071846583894*^9}, {
   3.607187556052606*^9, 3.607187559624845*^9}, {3.607187680450625*^9, 
   3.607187680690113*^9}, {3.6076863873697987`*^9, 3.607686387680025*^9}, {
   3.618143507270739*^9, 3.618143560789521*^9}, {3.618143606520234*^9, 
   3.618143608599997*^9}, {3.6345599554009523`*^9, 3.634559962497096*^9}, {
   3.6345834759513493`*^9, 3.6345834824466963`*^9}, {3.636570194796419*^9, 
   3.636570195179977*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Add Solitons and Choose Region", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6345604727271433`*^9, 3.634560480293921*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Delta]cs", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_", ",", "R_"}], "]"}], "[", "z_", 
      "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Delta]cs", "[", 
        RowBox[{"s", ",", "n", ",", "t", ",", "R"}], "]"}], "[", "z", "]"}], 
      "=", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Delta]d1", "[", 
         RowBox[{"s", ",", "n", ",", "t"}], "]"}], "[", 
        RowBox[{"z", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}], "]"}], 
       "*", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"Cauchy", "[", 
          RowBox[{
           RowBox[{"iftcs", "[", 
            RowBox[{
             RowBox[{"\[Alpha]", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", "R"}], "]"}], ",", 
           RowBox[{"z", 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}]}], 
          "]"}], "+", 
         RowBox[{"2", " ", 
          RowBox[{"sing", "[", 
           RowBox[{
            RowBox[{"\[Alpha]", "[", 
             RowBox[{"n", ",", "t"}], "]"}], ",", 
            RowBox[{"z", 
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"100", "s", " ", "$MachineEpsilon"}]}], ")"}]}]}], 
           "]"}]}]}], "]"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"z", "-", 
          RowBox[{"\[Alpha]", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"z", "+", "1"}], ")"}]}]}]}]}], ";"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "z_", "]"}], ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"g", "[", 
           RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}], 
        ",", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{"p", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], 
         "]"}]}], "}"}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"DomainPlot", "[", 
      RowBox[{"{", "}"}], "]"}], "=", "Null"}], ";"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"\[Delta]1", "[", 
      RowBox[{"n_", ",", "t_", ",", "r_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "/", 
        RowBox[{"(", 
         RowBox[{"2", "Pi", " ", "I"}], ")"}]}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"DomainIntegrate", "[", 
          RowBox[{"ift", "[", 
           RowBox[{
            RowBox[{"z0", "[", 
             RowBox[{"n", ",", "t"}], "]"}], ",", "r"}], "]"}], "]"}], "+", 
         RowBox[{"2", 
          RowBox[{"DomainIntegrate", "[", 
           RowBox[{"LogFunShort", "[", 
            RowBox[{"z0", "[", 
             RowBox[{"n", ",", "t"}], "]"}], "]"}], "]"}]}]}], ")"}]}], " ", 
      "-", "1", "-", 
      RowBox[{"z0", "[", 
       RowBox[{"n", ",", "t"}], "]"}], "+", 
      RowBox[{"2", 
       RowBox[{"k\[Infinity]", "[", 
        RowBox[{"z0", "[", 
         RowBox[{"n", ",", "t"}], "]"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Delta]cs1", "[", 
      RowBox[{"n_", ",", "t_", ",", "r_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "/", 
        RowBox[{"(", 
         RowBox[{"2", "Pi", " ", "I"}], ")"}]}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"DomainIntegrate", "[", 
          RowBox[{"iftcs", "[", 
           RowBox[{
            RowBox[{"\[Alpha]", "[", 
             RowBox[{"n", ",", "t"}], "]"}], ",", "r"}], "]"}], "]"}], "+", 
         RowBox[{"2", 
          RowBox[{"DomainIntegrate", "[", 
           RowBox[{"LogFunShort", "[", 
            RowBox[{"\[Alpha]", "[", 
             RowBox[{"n", ",", "t"}], "]"}], "]"}], "]"}]}]}], ")"}]}], " ", 
      "-", "1", "-", 
      RowBox[{"\[Alpha]", "[", 
       RowBox[{"n", ",", "t"}], "]"}], "-", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"2", " ", "Pi", " ", "I"}], ")"}]}], 
       RowBox[{"DomainIntegrate", "[", 
        RowBox[{"Fun", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"d1", "[", 
            RowBox[{"n", ",", "t"}], "]"}], "&"}], ",", 
          RowBox[{"Arc", "[", 
           RowBox[{"0", ",", "1", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Arg", "[", 
               RowBox[{"\[Alpha]", "[", 
                RowBox[{"n", ",", "t"}], "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"2", "Pi"}], "-", 
               RowBox[{"Arg", "[", 
                RowBox[{"\[Alpha]", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], "]"}]}]}], "}"}]}], "]"}], 
          ",", "10"}], "]"}], "]"}]}], "+", 
      RowBox[{"2", 
       RowBox[{"k\[Infinity]", "[", 
        RowBox[{"\[Alpha]", "[", 
         RowBox[{"n", ",", "t"}], "]"}], "]"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"temp", " ", 
     RowBox[{"fix", ".", "  ", "Need"}], " ", "to", " ", "figure", " ", "out",
      " ", 
     RowBox[{"what", "'"}], "s", " ", "wrong", " ", "with", " ", "the", " ", 
     "above", " ", "\[Delta]cs1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Delta]cs1", "[", 
       RowBox[{"n_", ",", "t_", ",", "r_"}], "]"}], ":=", 
      RowBox[{"100000", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Delta]cs", "[", 
           RowBox[{"1", ",", "n", ",", "t", ",", "r"}], "]"}], "[", "100000", 
          "]"}], "-", "1"}], ")"}]}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{
     RowBox[{"g1", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"-", "2"}], "I", " ", "t", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"CauchyInverse", "[", 
           RowBox[{"#", ",", "I"}], "]"}], "&"}], "/@", 
         RowBox[{"ci", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "//", "Total"}], ")"}]}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"g\[Infinity]", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"-", "t"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"CauchyInverseIntegral", "[", 
           RowBox[{"#", ",", "I"}], "]"}], "&"}], "/@", 
         RowBox[{"ci", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "//", "Total"}], ")"}]}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "\[Infinity]", "]"}],
      ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"g\[Infinity]", "[", 
          RowBox[{"n", ",", "t"}], "]"}], "]"}], ",", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{"g\[Infinity]", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], "]"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]i", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "\[Infinity]", "]"}],
      ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{"g\[Infinity]", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", 
        RowBox[{"Exp", "[", 
         RowBox[{"g\[Infinity]", "[", 
          RowBox[{"n", ",", "t"}], "]"}], "]"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Phi]1", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "\[Infinity]", "]"}], 
      ".", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"g1", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"g1", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}]}], "}"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Phi]i1", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]i", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "\[Infinity]", "]"}], 
      ".", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"g1", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], ",", 
         RowBox[{"g1", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "}"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"gt1", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"-", "2"}], "I", " ", "t", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"CauchyInverse", "[", 
           RowBox[{"#", ",", "I"}], "]"}], "&"}], "/@", 
         RowBox[{"cit", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "//", "Total"}], ")"}]}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"gt\[Infinity]", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"-", "t"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"CauchyInverseIntegral", "[", 
           RowBox[{"#", ",", "I"}], "]"}], "&"}], "/@", 
         RowBox[{"cit", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "//", "Total"}], ")"}]}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]t", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "\[Infinity]", "]"}],
      ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"gt\[Infinity]", "[", 
          RowBox[{"n", ",", "t"}], "]"}], "]"}], ",", 
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{"gt\[Infinity]", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], "]"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]ti", "[", 
       RowBox[{"p_", ",", "n_", ",", "t_"}], "]"}], "[", "\[Infinity]", "]"}],
      ":=", 
     RowBox[{"DiagonalMatrix", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{"-", 
          RowBox[{"gt\[Infinity]", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], "]"}], ",", 
        RowBox[{"Exp", "[", 
         RowBox[{"gt\[Infinity]", "[", 
          RowBox[{"n", ",", "t"}], "]"}], "]"}]}], "}"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Phi]t1", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]t", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "\[Infinity]", "]"}], 
      ".", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"gt1", "[", 
          RowBox[{"n", ",", "t"}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"gt1", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}]}], "}"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Phi]ti1", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Phi]ti", "[", 
        RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "\[Infinity]", "]"}], 
      ".", 
      RowBox[{"DiagonalMatrix", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"gt1", "[", 
           RowBox[{"n", ",", "t"}], "]"}]}], ",", 
         RowBox[{"gt1", "[", 
          RowBox[{"n", ",", "t"}], "]"}]}], "}"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"Better\[Delta]1", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"CircleNIntegrate", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Delta]", "[", 
            RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", "0", ",", "2"}], "}"}]}], "]"}]}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], " ", "Pi", " ", "I"}], ")"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Better\[Delta]i1", "[", 
       RowBox[{"s_", ",", "n_", ",", "t_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"CircleNIntegrate", "[", 
         RowBox[{
          RowBox[{"1", "/", 
           RowBox[{
            RowBox[{"\[Delta]", "[", 
             RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"z", ",", "0", ",", "2"}], "}"}]}], "]"}]}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], " ", "Pi", " ", "I"}], ")"}]}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CapitalDelta]1", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Delta]1", "[", 
          RowBox[{"n", ",", "t", ",", "R"}], "]"}], ",", " ", "0"}], "}"}], 
       ",", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          RowBox[{"\[Delta]1", "[", 
           RowBox[{"n", ",", "t", ",", "R"}], "]"}]}]}], "}"}]}], "}"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CapitalDelta]cs1", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Delta]cs1", "[", 
          RowBox[{"n", ",", "t", ",", "R"}], "]"}], ",", " ", "0"}], "}"}], 
       ",", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", 
          RowBox[{"\[Delta]cs1", "[", 
           RowBox[{"n", ",", "t", ",", "R"}], "]"}]}]}], "}"}]}], "}"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"mSeriesCoefficient", "[", "0", "]"}], "=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"mSeriesCoefficient", "[", "1", "]"}], "=", "0"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"mSeriesCoefficient", "[", "x_", "]"}], ":=", 
     RowBox[{"SeriesCoefficient", "[", 
      RowBox[{"x", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CapitalPhi]", "[", 
      RowBox[{"s_", ",", "z_", ",", "solve_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"IdentityMatrix", "[", "2", "]"}], " ", "+", " ", 
      RowBox[{"Cauchy", "[", 
       RowBox[{"s", ",", "solve", ",", 
        RowBox[{"z", "+", 
         RowBox[{"s", " ", "$MachineEpsilon", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{"I", " ", 
            RowBox[{"Arg", "[", "z", "]"}]}], "]"}]}]}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CapitalPhi]", "[", 
      RowBox[{"s_", ",", "z_", ",", 
       RowBox[{"{", "}"}]}], "]"}], ":=", 
     RowBox[{"IdentityMatrix", "[", "2", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DotVect", "[", 
      RowBox[{"solve_", ",", "n_", ",", "t_", ",", "i_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "A", ",", "L", ",", "V", ",", "out", ",", "D\[Infinity]", ",", 
         "\[Phi]\[Infinity]", ",", "D0", ",", "\[Phi]0"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"D\[Infinity]", "=", 
         RowBox[{
          RowBox[{"DD", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "[", "\[Infinity]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Phi]\[Infinity]", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "4"}], ",", 
           RowBox[{
            RowBox[{"\[Phi]", "[", 
             RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "\[Infinity]", 
            "]"}], ",", 
           RowBox[{"IdentityMatrix", "[", "2", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"adjust", " ", "if", " ", "transition", " ", "region"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"i", "\[Equal]", "5"}], ",", 
          RowBox[{"\[Phi]\[Infinity]", "=", 
           RowBox[{
            RowBox[{"\[Phi]t", "[", 
             RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "\[Infinity]", 
            "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"D0", "=", 
         RowBox[{
          RowBox[{"DD", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "[", "0", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
          "this", " ", "should", " ", "be", " ", "the", " ", "solution", " ", 
           "of", " ", "the", " ", "RHP", " ", "at", " ", "zero"}], ",", " ", 
          RowBox[{
          "after", " ", "reversing", " ", "all", " ", "conjugations"}]}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"A", "=", 
         RowBox[{"D\[Infinity]", ".", "\[Phi]\[Infinity]", ".", 
          RowBox[{"\[CapitalPhi]", "[", 
           RowBox[{"1", ",", "0", ",", "solve"}], "]"}], ".", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", "2"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalDelta]", "[", 
                RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "0", "]"}], 
              ",", 
              RowBox[{"IdentityMatrix", "[", "2", "]"}]}], "]"}], ".", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", "4"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalDelta]cs", "[", 
                 RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "0", "]"}], 
               ".", 
               RowBox[{
                RowBox[{"\[Phi]i", "[", 
                 RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "0", "]"}]}], 
              ",", 
              RowBox[{"IdentityMatrix", "[", "2", "]"}]}], "]"}], ".", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "\[Equal]", "5"}], ",", 
              RowBox[{
               RowBox[{"\[Phi]ti", "[", 
                RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "0", "]"}], 
              ",", 
              RowBox[{"IdentityMatrix", "[", "2", "]"}]}], "]"}]}], ")"}], 
          ".", 
          RowBox[{"Inverse", "[", "D0", "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"A", "=", 
         RowBox[{
          RowBox[{"A", "-", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}], "//", 
          "Transpose"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"L", ",", "V"}], "}"}], "=", 
         RowBox[{"Eigensystem", "[", 
          RowBox[{"A", ",", 
           RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"L", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}], ">", ".00001"}], ",", 
          RowBox[{"Print", "[", 
           RowBox[{"\"\<Error estimate: \>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Abs", "[", 
              RowBox[{"L", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}]}], "]"}]}], "]"}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"out", "=", 
         RowBox[{"V", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{
           RowBox[{"-", "I"}], " ", 
           RowBox[{"Arg", "[", 
            RowBox[{"out", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], 
         RowBox[{"out", "/", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"Abs", "[", 
            RowBox[{
             RowBox[{"out", "[", 
              RowBox[{"[", "1", "]"}], "]"}], 
             RowBox[{"out", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}]}]}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "overload", " ", "so", " ", "that", " ", "null", " ", "RHPs", " ", "can", 
     " ", "be", " ", "treated"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"RHSolve", "[", 
      RowBox[{"{", "}"}], "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DomainIntegrate", "[", 
      RowBox[{"{", "}"}], "]"}], "=", 
     RowBox[{"0", "*", 
      RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DomainPlot", "[", 
      RowBox[{"{", "}"}], "]"}], "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ExtractSolution", "[", "i_", "]"}], "[", 
      RowBox[{"solved_", ",", "n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "AA", ",", "BB", ",", "m0", ",", "m1", ",", "v", ",", "D\[Infinity]", 
         ",", "\[Phi]\[Infinity]"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"v", "=", 
         RowBox[{"DotVect", "[", 
          RowBox[{"solved", ",", "n", ",", "t", ",", "i"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"m0", "=", " ", 
         RowBox[{"v", ".", 
          RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"D\[Infinity]", "=", 
         RowBox[{
          RowBox[{"DD", "[", 
           RowBox[{"n", ",", "t"}], "]"}], "[", "\[Infinity]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Phi]\[Infinity]", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "4"}], ",", 
           RowBox[{
            RowBox[{"\[Phi]", "[", 
             RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "\[Infinity]", 
            "]"}], ",", 
           RowBox[{"IdentityMatrix", "[", "2", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"adjust", " ", "if", " ", "transition", " ", "region"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"i", "\[Equal]", "5"}], ",", 
          RowBox[{"\[Phi]\[Infinity]", "=", 
           RowBox[{
            RowBox[{"\[Phi]t", "[", 
             RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "\[Infinity]", 
            "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"m1", "=", 
         RowBox[{
          RowBox[{"v", ".", "D\[Infinity]", ".", "\[Phi]\[Infinity]", ".", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"DomainIntegrate", "[", "solved", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "2"}], "Pi", " ", "I"}], ")"}]}], "+", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", "2"}], ",", 
               RowBox[{"\[CapitalDelta]1", "[", 
                RowBox[{"n", ",", "t"}], "]"}], ",", "0"}], "]"}], "+", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "\[Equal]", "4"}], ",", 
               RowBox[{"\[CapitalDelta]cs1", "[", 
                RowBox[{"n", ",", "t"}], "]"}], ",", "0"}], "]"}]}], ")"}], 
           ".", 
           RowBox[{"Inverse", "[", 
            RowBox[{"D\[Infinity]", ".", "\[Phi]\[Infinity]"}], "]"}]}], "+", 
          
          RowBox[{"v", ".", "D\[Infinity]", ".", "\[Phi]\[Infinity]", ".", 
           RowBox[{"Map", "[", 
            RowBox[{"mSeriesCoefficient", ",", 
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{"Inverse", "[", 
                RowBox[{
                 RowBox[{"DD", "[", 
                  RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"z", ",", "\[Infinity]", ",", "1"}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"{", "2", "}"}]}], "]"}], ".", 
           RowBox[{"Inverse", "[", "\[Phi]\[Infinity]", "]"}]}], "+", 
          RowBox[{"v", ".", "D\[Infinity]", ".", "\[Phi]\[Infinity]", ".", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"i", "\[Equal]", "4"}], ",", 
             RowBox[{"\[Phi]i1", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"0", 
              RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], "]"}], ".", 
           RowBox[{"Inverse", "[", "D\[Infinity]", "]"}]}], "+", 
          RowBox[{"v", ".", "D\[Infinity]", ".", "\[Phi]\[Infinity]", ".", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"i", "\[Equal]", "5"}], ",", 
             RowBox[{"\[Phi]ti1", "[", 
              RowBox[{"n", ",", "t"}], "]"}], ",", 
             RowBox[{"0", 
              RowBox[{"IdentityMatrix", "[", "2", "]"}]}]}], "]"}], ".", 
           RowBox[{"Inverse", "[", "D\[Infinity]", "]"}]}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AA", "=", " ", 
         RowBox[{"m0", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"AA", ",", 
          RowBox[{
           RowBox[{"m1", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "/", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "2"}], " ", "AA"}], ")"}]}], ",", 
          RowBox[{
           RowBox[{"m1", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "*", 
           RowBox[{"(", 
            RowBox[{"AA", "/", "2"}], ")"}]}]}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"StartToda", "[", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TodaAB", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{"TodaABOld", "//", "Clear"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"TodaABFlip", "[", 
           RowBox[{"i_", ",", 
            RowBox[{"{", 
             RowBox[{"rrr_", ",", "lll_", ",", "ccc_"}], "}"}]}], "]"}], "[", 
          
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"rhp1", ",", "rhp2", ",", "rhp"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"R", "=", "rrr"}], ";", "\[IndentingNewLine]", 
            RowBox[{"c", "=", "ccc"}], ";", "\[IndentingNewLine]", 
            RowBox[{"\[CapitalLambda]", "=", "lll"}], ";", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"rhp1", "=", 
             RowBox[{
              RowBox[{"AdaptArcsLines", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"CircleRHPsamp", "[", "i", "]"}], "[", 
                 RowBox[{"n", ",", "t"}], "]"}], ",", "globalTol"}], "]"}], 
              "[", 
              RowBox[{
               RowBox[{"CircleRHP", "[", "i", "]"}], "[", 
               RowBox[{"n", ",", "t"}], "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"rhp2", "=", 
             RowBox[{
              RowBox[{"AdaptArcsLines", "[", 
               RowBox[{
                RowBox[{"PoleList", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], ",", "globalTol"}], "]"}], 
              "[", 
              RowBox[{"PoleList", "[", 
               RowBox[{"n", ",", "t"}], "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"i", "\[Equal]", "2"}], "&&", 
               RowBox[{"rhp2", "\[NotEqual]", 
                RowBox[{"{", 
                 RowBox[{"{", "}"}], "}"}]}]}], ",", 
              RowBox[{"rhp2", "=", 
               RowBox[{"ConjugateList", "[", 
                RowBox[{"rhp2", ",", 
                 RowBox[{"\[CapitalDelta]i", "[", 
                  RowBox[{"1", ",", "n", ",", "t"}], "]"}]}], "]"}]}]}], 
             "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"i", "\[Equal]", "4"}], "&&", 
               RowBox[{"rhp2", "\[NotEqual]", 
                RowBox[{"{", 
                 RowBox[{"{", "}"}], "}"}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"rhp2", "=", 
                RowBox[{"ConjugateList", "[", 
                 RowBox[{"rhp2", ",", 
                  RowBox[{"\[CapitalDelta]csi", "[", 
                   RowBox[{"1", ",", "n", ",", "t"}], "]"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"rhp2", "=", 
                RowBox[{"ConjugateList", "[", 
                 RowBox[{"rhp2", ",", 
                  RowBox[{"\[Phi]", "[", 
                   RowBox[{"1", ",", "n", ",", "t"}], "]"}]}], "]"}]}], 
               ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"i", "\[Equal]", "5"}], "&&", 
               RowBox[{"rhp2", "\[NotEqual]", 
                RowBox[{"{", 
                 RowBox[{"{", "}"}], "}"}]}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"rhp2", "=", 
                RowBox[{"ConjugateList", "[", 
                 RowBox[{"rhp2", ",", 
                  RowBox[{"\[Phi]t", "[", 
                   RowBox[{"1", ",", "n", ",", "t"}], "]"}]}], "]"}]}], 
               ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"rhp", "=", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"rhp1", "//", "MakeListFun"}], ",", 
               RowBox[{"rhp2", "//", "MakeListFun"}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"lastrhp", "=", "rhp"}], ";", "\[IndentingNewLine]", 
            RowBox[{"rhp", "=", 
             RowBox[{"RHSolve", "[", "rhp", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"lastrhpsol", "=", "rhp"}], ";", "\[IndentingNewLine]", 
            RowBox[{"contours", "=", 
             RowBox[{"Show", "[", 
              RowBox[{
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"Graphics", "[", 
                   RowBox[{"{", "}"}], "]"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"DomainPlot", "[", "rhp", "]"}], "}"}]}], "]"}], 
               ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"2", "*", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}]}], ",", 
               RowBox[{"Axes", "\[Rule]", "True"}], ",", 
               RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"innersolution", "[", "z_", "]"}], ":=", 
             RowBox[{
              RowBox[{
               RowBox[{"DD", "[", 
                RowBox[{"n", ",", "t"}], "]"}], "[", "\[Infinity]", "]"}], 
              ".", 
              RowBox[{"\[CapitalPhi]", "[", 
               RowBox[{"1", ",", "z", ",", "lastrhpsol"}], "]"}], ".", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", "\[Equal]", "2"}], ",", 
                RowBox[{
                 RowBox[{"\[CapitalDelta]", "[", 
                  RowBox[{"1", ",", "n", ",", "t"}], "]"}], "[", "z", "]"}], 
                ",", 
                RowBox[{"IdentityMatrix", "[", "2", "]"}]}], "]"}], ".", 
              RowBox[{"Inverse", "[", 
               RowBox[{
                RowBox[{"DD", "[", 
                 RowBox[{"n", ",", "t"}], "]"}], "[", "z", "]"}], "]"}]}]}], 
            ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ExtractSolution", "[", "i", "]"}], "[", 
             RowBox[{"rhp", ",", "n", ",", "t"}], "]"}]}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"TodaAB", "[", "i_", "]"}], "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"TodaAB", "[", "i", "]"}], "[", 
           RowBox[{"n", ",", "t"}], "]"}], "=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"n", " ", "<", "0"}], ",", 
            RowBox[{
             RowBox[{"TodaABFlip", "[", 
              RowBox[{"i", ",", 
               RowBox[{"{", 
                RowBox[{"R2", ",", "\[CapitalLambda]2", ",", "c2"}], "}"}]}], 
              "]"}], "[", 
             RowBox[{
              RowBox[{"-", "n"}], ",", "t"}], "]"}], ",", 
            RowBox[{
             RowBox[{"TodaABFlip", "[", 
              RowBox[{"i", ",", 
               RowBox[{"{", 
                RowBox[{"R1", ",", "\[CapitalLambda]1", ",", "c1"}], "}"}]}], 
              "]"}], "[", 
             RowBox[{"n", ",", "t"}], "]"}]}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"TodaABOld", "[", "i_", "]"}], "[", 
          RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"TodaABOld", "[", "i", "]"}], "[", 
           RowBox[{"n", ",", "t"}], "]"}], "=", 
          RowBox[{
           RowBox[{"TodaABFlip", "[", 
            RowBox[{"i", ",", 
             RowBox[{"{", 
              RowBox[{"R1", ",", "\[CapitalLambda]1", ",", "c1"}], "}"}]}], 
            "]"}], "[", 
           RowBox[{"n", ",", "t"}], "]"}]}]}], ";"}]}], "\[IndentingNewLine]",
       "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"StartToda", "[", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"TODO", ":", " ", 
     RowBox[{"Does", " ", "this", " ", 
      RowBox[{"work", "?"}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TodaChoosePos", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{"{", 
             RowBox[{"n", ",", 
              RowBox[{"2", "t"}]}], "}"}], "]"}], "<", "3"}], " ", ",", 
          RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";", 
        RowBox[{"(*", 
         RowBox[{"no", " ", "deformation"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"NZeroQ", "[", "t", "]"}], "||", " ", 
           RowBox[{
            RowBox[{"Abs", "[", 
             RowBox[{"n", "/", "t"}], "]"}], "\[GreaterEqual]", "1"}]}], ",", 
          
          RowBox[{"Return", "[", "3", "]"}]}], "]"}], ";", 
        RowBox[{"(*", "soliton", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"n", "-", "t"}], "]"}], "\[LessEqual]", 
           RowBox[{"1.5", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"t", "^", 
               RowBox[{"(", 
                RowBox[{"1", "/", "3"}], ")"}]}], "+", "1"}], ")"}]}]}], ",", 
          
          RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", 
        RowBox[{"(*", "Painleve", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"n", "/", "t"}], "]"}], "\[LessEqual]", ".96"}], ",", 
          RowBox[{"Return", "[", "2", "]"}]}], "]"}], ";", 
        RowBox[{"(*", "dispersive", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"0.", "\[LessEqual]", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"Log", "[", 
              RowBox[{
               RowBox[{"\[Rho]0", "[", 
                RowBox[{"n", ",", "t"}], "]"}], "^", "2"}], "]"}]}], "/", 
            RowBox[{"(", 
             RowBox[{"t", " ", 
              RowBox[{
               RowBox[{"\[Rho]0", "[", 
                RowBox[{"n", ",", "t"}], "]"}], "^", "3"}]}], ")"}]}], 
           "\[LessEqual]", ".2"}], ",", 
          RowBox[{"Return", "[", "4", "]"}]}], "]"}], ";", 
        RowBox[{"(*", 
         RowBox[{"collisionless", " ", "shock"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               RowBox[{"Log", "[", 
                RowBox[{
                 RowBox[{"\[Rho]0", "[", 
                  RowBox[{"n", ",", "t"}], "]"}], "^", "2"}], "]"}]}], "/", 
              ".9"}], "\[LessEqual]", 
             RowBox[{"t", " ", 
              RowBox[{
               RowBox[{"\[Rho]0", "[", 
                RowBox[{"n", ",", "t"}], "]"}], "^", "3"}]}], "\[LessEqual]", 
             " ", "4"}], ",", " ", 
            RowBox[{"Return", "[", "5", "]"}]}], "]"}], ";"}], "*)"}], 
        RowBox[{"(*", 
         RowBox[{"transition", ",", " ", 
          RowBox[{
          "ensure", " ", "TPoints", " ", "gives", " ", "a", " ", 
           "solution"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Return", "[", "5", "]"}], ";"}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TodaChoose", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"TodaChoosePos", "[", 
      RowBox[{
       RowBox[{"Abs", "[", "n", "]"}], ",", "t"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TodaABAuto", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"\"\<Region: \>\"", " ", "<>", " ", 
           RowBox[{"ToString", "[", 
            RowBox[{"TodaChoose", "[", 
             RowBox[{"n", ",", "t"}], "]"}], "]"}]}], "]"}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TodaAB", "[", 
         RowBox[{"TodaChoose", "[", 
          RowBox[{"n", ",", "t"}], "]"}], "]"}], "[", 
        RowBox[{"n", ",", "t"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Todaab", "[", "i_", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"n", "\[GreaterEqual]", "0"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"TodaAB", "[", "i", "]"}], "[", 
             RowBox[{"n", ",", "t"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "/", 
           RowBox[{
            RowBox[{
             RowBox[{"TodaAB", "[", "i", "]"}], "[", 
             RowBox[{
              RowBox[{"n", "+", "1"}], ",", "t"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "/", "2"}], ",", 
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"TodaAB", "[", "i", "]"}], "[", 
              RowBox[{"n", ",", "t"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "-", 
            RowBox[{
             RowBox[{
              RowBox[{"TodaAB", "[", "i", "]"}], "[", 
              RowBox[{
               RowBox[{"n", "+", "1"}], ",", "t"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"TodaAB", "[", "i", "]"}], "[", 
             RowBox[{"n", ",", "t"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "/", 
           RowBox[{
            RowBox[{
             RowBox[{"TodaAB", "[", "i", "]"}], "[", 
             RowBox[{
              RowBox[{"n", "-", "1"}], ",", "t"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "/", "2"}], ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"TodaAB", "[", "i", "]"}], "[", 
             RowBox[{
              RowBox[{"n", "-", "1"}], ",", "t"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "-", 
           RowBox[{
            RowBox[{
             RowBox[{"TodaAB", "[", "i", "]"}], "[", 
             RowBox[{
              RowBox[{"n", "-", "2"}], ",", "t"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], "}"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TodaabAuto", "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"n", "\[GreaterEqual]", "0"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"TodaABAuto", "[", 
             RowBox[{"n", ",", "t"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "/", 
           RowBox[{
            RowBox[{"TodaABAuto", "[", 
             RowBox[{
              RowBox[{"n", "+", "1"}], ",", "t"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "/", "2"}], ",", 
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"TodaABAuto", "[", 
              RowBox[{"n", ",", "t"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "-", 
            RowBox[{
             RowBox[{"TodaABAuto", "[", 
              RowBox[{
               RowBox[{"n", "+", "1"}], ",", "t"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"TodaABAuto", "[", 
             RowBox[{"n", ",", "t"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "/", 
           RowBox[{
            RowBox[{"TodaABAuto", "[", 
             RowBox[{
              RowBox[{"n", "-", "1"}], ",", "t"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "/", "2"}], ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"TodaABAuto", "[", 
             RowBox[{
              RowBox[{"n", "-", "1"}], ",", "t"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "-", 
           RowBox[{
            RowBox[{"TodaABAuto", "[", 
             RowBox[{
              RowBox[{"n", "-", "2"}], ",", "t"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], "}"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"TodaabOld", "[", "i_", "]"}], "[", 
      RowBox[{"n_", ",", "t_"}], "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"TodaABOld", "[", "i", "]"}], "[", 
           RowBox[{"n", ",", "t"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "/", 
         RowBox[{
          RowBox[{
           RowBox[{"TodaABOld", "[", "i", "]"}], "[", 
           RowBox[{
            RowBox[{"n", "+", "1"}], ",", "t"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "/", "2"}], ",", 
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"TodaABOld", "[", "i", "]"}], "[", 
            RowBox[{"n", ",", "t"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "-", 
          RowBox[{
           RowBox[{
            RowBox[{"TodaABOld", "[", "i", "]"}], "[", 
            RowBox[{
             RowBox[{"n", "+", "1"}], ",", "t"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.634560483194956*^9, 3.634560611891526*^9}, {
   3.634560646880207*^9, 3.634560704902123*^9}, {3.634560785365591*^9, 
   3.634560867167791*^9}, {3.634561236388488*^9, 3.634561236643362*^9}, {
   3.634561272028471*^9, 3.634561275337882*^9}, {3.63456185060233*^9, 
   3.634561976293207*^9}, {3.6345620607724657`*^9, 3.634562064348456*^9}, {
   3.63456229558395*^9, 3.634562303457508*^9}, {3.634562341324134*^9, 
   3.634562351317636*^9}, {3.634562721495947*^9, 3.634562722524818*^9}, {
   3.634562919274173*^9, 3.63456293506411*^9}, {3.634563303118513*^9, 
   3.634563470311481*^9}, {3.6345635024685717`*^9, 3.634563565017159*^9}, {
   3.6345643929943743`*^9, 3.634564395023679*^9}, {3.6345649651607437`*^9, 
   3.634564975414689*^9}, {3.634568342595903*^9, 3.634568348193631*^9}, {
   3.634568419494959*^9, 3.6345684296725893`*^9}, {3.6345684636414843`*^9, 
   3.6345684672667513`*^9}, {3.634568588374165*^9, 3.6345685885886803`*^9}, {
   3.6345760424325953`*^9, 3.634576051927376*^9}, {3.6345772662818832`*^9, 
   3.634577283830473*^9}, {3.634578076108973*^9, 3.634578081037066*^9}, {
   3.634578553523032*^9, 3.634578657407813*^9}, 3.634578704044817*^9, {
   3.6345790268114567`*^9, 3.6345790680793457`*^9}, {3.634579150813766*^9, 
   3.634579164411447*^9}, 3.6345792327127867`*^9, {3.634579315715239*^9, 
   3.634579319217306*^9}, {3.6345793548888617`*^9, 3.634579362790874*^9}, {
   3.634579432556489*^9, 3.634579436771285*^9}, {3.634579481835003*^9, 
   3.6345794829123096`*^9}, {3.634579666113502*^9, 3.634579666350491*^9}, {
   3.634579708294855*^9, 3.6345797220371103`*^9}, {3.634579770739702*^9, 
   3.634579772273106*^9}, {3.6345798863652973`*^9, 3.634579890018852*^9}, {
   3.634580127160192*^9, 3.634580157014147*^9}, {3.634580380603627*^9, 
   3.634580380864534*^9}, {3.634580615942938*^9, 3.6345806161670027`*^9}, {
   3.634580700467003*^9, 3.6345807069281797`*^9}, {3.63458093428384*^9, 
   3.6345809407062817`*^9}, {3.6345810614896708`*^9, 3.634581065276539*^9}, {
   3.634581107411038*^9, 3.6345811076971416`*^9}, {3.6345811657616653`*^9, 
   3.63458120472543*^9}, {3.634581544892022*^9, 3.634581605568049*^9}, {
   3.634581683079213*^9, 3.634581684637085*^9}, 3.634581926433077*^9, 
   3.6345820256859627`*^9, 3.634582343059495*^9, 3.634582519922406*^9, {
   3.6345834894929743`*^9, 3.634583504500791*^9}, {3.634583637431099*^9, 
   3.634583654748866*^9}, {3.634583811733509*^9, 3.634583837881913*^9}, {
   3.634585652399419*^9, 3.634585654762856*^9}, {3.634587199475568*^9, 
   3.634587204898247*^9}, {3.63458730475065*^9, 3.634587328573262*^9}, 
   3.634587949230011*^9, {3.634598042586619*^9, 3.634598042849791*^9}, {
   3.634599660629517*^9, 3.6345996611632338`*^9}, {3.634650197549931*^9, 
   3.634650366281405*^9}, {3.634651211263385*^9, 3.634651417600774*^9}, {
   3.634651462286758*^9, 3.634651533194285*^9}, {3.6346516059143667`*^9, 
   3.634651680855385*^9}, {3.634651853842292*^9, 3.634651889111309*^9}, {
   3.6346520426059437`*^9, 3.634652102944253*^9}, {3.634652188535915*^9, 
   3.6346521905018053`*^9}, {3.634652268454338*^9, 3.634652273595868*^9}, {
   3.634652604322887*^9, 3.6346526244496317`*^9}, {3.6346527684320087`*^9, 
   3.6346527717076902`*^9}, {3.634652810134734*^9, 3.63465283552316*^9}, {
   3.634652906698559*^9, 3.634652920088694*^9}, {3.634652988631968*^9, 
   3.634653060263747*^9}, {3.634653104285246*^9, 3.6346531177775393`*^9}, {
   3.634656075989567*^9, 3.634656102444387*^9}, {3.634656153434305*^9, 
   3.634656174192987*^9}, {3.634656204671583*^9, 3.634656206340309*^9}, {
   3.634656247703989*^9, 3.6346562604058657`*^9}, {3.63465638004602*^9, 
   3.634656409185708*^9}, {3.6346564429068327`*^9, 3.634656487303483*^9}, {
   3.6346565235585737`*^9, 3.634656656269557*^9}, {3.634656688074585*^9, 
   3.634656750039487*^9}, {3.6346567801441107`*^9, 3.634656889147093*^9}, {
   3.634657152941585*^9, 3.634657201629409*^9}, {3.634657242168744*^9, 
   3.63465724281493*^9}, {3.63465862534221*^9, 3.6346586898361397`*^9}, {
   3.6346591646709547`*^9, 3.63465920325834*^9}, {3.634659520840559*^9, 
   3.634659548157937*^9}, {3.634659584597443*^9, 3.634659590134613*^9}, {
   3.634659647354459*^9, 3.634659648597537*^9}, {3.634659809744281*^9, 
   3.634659821398827*^9}, {3.634660082385764*^9, 3.634660094080895*^9}, {
   3.6346602077908487`*^9, 3.6346602515663433`*^9}, {3.6346727360254517`*^9, 
   3.6346727634788713`*^9}, {3.6347294471969423`*^9, 3.634729482631103*^9}, {
   3.634730897609326*^9, 3.634730940409443*^9}, {3.634739760070582*^9, 
   3.634739763657222*^9}, {3.634742770346764*^9, 3.634742805403718*^9}, {
   3.634742886268407*^9, 3.634742933454543*^9}, {3.6347433707373877`*^9, 
   3.634743372286437*^9}, {3.634743551470455*^9, 3.63474355155118*^9}, {
   3.6347441114715157`*^9, 3.6347441404842787`*^9}, {3.634744189191224*^9, 
   3.634744194677638*^9}, {3.634744263300742*^9, 3.63474430110672*^9}, {
   3.6347449110860558`*^9, 3.634744915762319*^9}, {3.634745238533742*^9, 
   3.634745260178526*^9}, {3.6347454361422253`*^9, 3.634745437611127*^9}, 
   3.634832934250198*^9, {3.6365616067507763`*^9, 3.6365616398650084`*^9}, {
   3.6365616877571287`*^9, 3.636562009240925*^9}, {3.636562384377234*^9, 
   3.636562466102418*^9}, {3.636562797633852*^9, 3.636562801195719*^9}, {
   3.636562993747631*^9, 3.6365630008670263`*^9}, {3.636563073333972*^9, 
   3.636563073546001*^9}, {3.636563152218719*^9, 3.636563198649695*^9}, {
   3.636563273021309*^9, 3.636563273224619*^9}, {3.636563304347324*^9, 
   3.636563314881446*^9}, {3.636563497014625*^9, 3.636563520282777*^9}, {
   3.63656361709548*^9, 3.636563762799232*^9}, {3.636563806072364*^9, 
   3.636563831152988*^9}, 3.636564001952948*^9, {3.636564100728304*^9, 
   3.636564109282097*^9}, {3.6365646305418367`*^9, 3.63656464517955*^9}, {
   3.636564684392089*^9, 3.636564736343651*^9}, {3.636565092185192*^9, 
   3.636565097401516*^9}, {3.636565157607135*^9, 3.636565176193153*^9}, {
   3.63656529135006*^9, 3.636565295484823*^9}, {3.636565955781148*^9, 
   3.636565961253518*^9}, {3.636566007591065*^9, 3.63656608974935*^9}, {
   3.636566184058514*^9, 3.636566394811839*^9}, {3.636566451470806*^9, 
   3.636566479390648*^9}, {3.6365671292946177`*^9, 3.636567133755419*^9}, 
   3.636567438886438*^9, {3.63656755658578*^9, 3.636567557334688*^9}, {
   3.6365675962424994`*^9, 3.636567622240799*^9}, {3.636567701365089*^9, 
   3.6365677043553047`*^9}, {3.6365683217832613`*^9, 3.636568324351182*^9}, {
   3.636568959271693*^9, 3.636568970331182*^9}, {3.636569840170066*^9, 
   3.636569870868836*^9}, {3.63656991639305*^9, 3.636569932871416*^9}, {
   3.636569981757703*^9, 3.636569981881577*^9}, {3.636570092206709*^9, 
   3.636570103964509*^9}, {3.636570376742579*^9, 3.636570377092277*^9}, {
   3.636589628922817*^9, 3.636589647998879*^9}, {3.636589781017037*^9, 
   3.636589781303129*^9}, {3.6365898350129223`*^9, 3.636589839501389*^9}, {
   3.636589874827755*^9, 3.6365898773263903`*^9}, {3.636814007062714*^9, 
   3.636814093539439*^9}, {3.636814135365705*^9, 3.6368141525155287`*^9}, {
   3.636814201285482*^9, 3.63681422626834*^9}, {3.6368142833421993`*^9, 
   3.6368142884745626`*^9}, {3.6368145765838823`*^9, 3.636814599654634*^9}, {
   3.636814741720911*^9, 3.636814750030595*^9}, {3.636815187143985*^9, 
   3.636815225782667*^9}, {3.637437622546438*^9, 3.637437622840535*^9}, {
   3.645357001223503*^9, 3.645357006736354*^9}, {3.64535726664028*^9, 
   3.64535741855541*^9}, {3.645444170552971*^9, 3.645444207220462*^9}, {
   3.645444243129755*^9, 3.6454443012620573`*^9}, {3.6454443657938433`*^9, 
   3.645444366984427*^9}, {3.645444536016448*^9, 3.6454445753474407`*^9}, {
   3.64544507752201*^9, 3.645445111806576*^9}, {3.6454451862054033`*^9, 
   3.645445210747316*^9}, {3.645445343055184*^9, 3.6454453553556547`*^9}, {
   3.6454454217285013`*^9, 3.645445451257104*^9}, {3.645445565333611*^9, 
   3.645445589033338*^9}, {3.645445672805513*^9, 3.645445675929564*^9}, {
   3.645445721202126*^9, 3.645445721301837*^9}, {3.645445751932325*^9, 
   3.645445761048923*^9}, {3.64544587476565*^9, 3.645445875787539*^9}, {
   3.645445917972509*^9, 3.645445935640225*^9}, {3.6454460134898376`*^9, 
   3.6454460135897303`*^9}, {3.645446488521924*^9, 3.6454465321893187`*^9}, {
   3.645446709410614*^9, 3.645446710973196*^9}, {3.645447231338748*^9, 
   3.645447238591353*^9}, {3.645447283568082*^9, 3.6454473116532707`*^9}, {
   3.645447365982778*^9, 3.645447386834735*^9}, {3.6454476146689253`*^9, 
   3.645447617334107*^9}, {3.645447711299316*^9, 3.6454477126731243`*^9}, {
   3.645447913521351*^9, 3.645447913669454*^9}, {3.645448601937826*^9, 
   3.645448657276339*^9}, {3.645463926640049*^9, 3.6454639271318007`*^9}, {
   3.645464018020424*^9, 3.645464039634934*^9}, {3.645464240894885*^9, 
   3.645464247524185*^9}, {3.645484881806984*^9, 3.645484882138562*^9}, {
   3.645702477595439*^9, 3.645702477839047*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Finish", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5463644907164*^9, 3.5463644913004*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5463644931024*^9, 3.5463644945224*^9}}]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{960, 1035},
WindowMargins->{{Automatic, -239}, {896, Automatic}},
ShowSelection->True,
FrontEndVersion->"10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (December 4, \
2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 548, 12, 46, "Input"],
Cell[CellGroupData[{
Cell[1130, 36, 125, 2, 64, "Section",
 InitializationGroup->True],
Cell[1258, 40, 6072, 98, 692, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7367, 143, 162, 3, 64, "Section",
 InitializationCell->True],
Cell[7532, 148, 7415, 180, 726, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[14984, 333, 179, 3, 64, "Section",
 InitializationCell->True],
Cell[15166, 338, 20577, 525, 1355, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[35780, 868, 125, 2, 50, "Section",
 InitializationCell->True],
Cell[35908, 872, 6405, 154, 420, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[42350, 1031, 125, 2, 50, "Section",
 InitializationCell->True],
Cell[42478, 1035, 128791, 3520, 6166, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[171306, 4560, 130, 2, 64, "Section",
 InitializationCell->True],
Cell[171439, 4564, 25789, 704, 1593, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[197265, 5273, 134, 2, 50, "Section",
 InitializationCell->True],
Cell[197402, 5277, 5650, 158, 284, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[203089, 5440, 245, 4, 50, "Section",
 InitializationCell->True],
Cell[203337, 5446, 6652, 159, 318, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[210026, 5610, 136, 2, 50, "Section",
 InitializationCell->True],
Cell[210165, 5614, 15607, 406, 828, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[225809, 6025, 272, 4, 64, "Section",
 InitializationCell->True],
Cell[226084, 6031, 13690, 320, 777, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[239811, 6356, 141, 2, 50, "Section",
 InitializationCell->True],
Cell[239955, 6360, 25522, 581, 862, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[265514, 6946, 181, 3, 50, "Section",
 InitializationCell->True],
Cell[265698, 6951, 28807, 665, 1151, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[294542, 7621, 132, 2, 50, "Section",
 InitializationCell->True],
Cell[294677, 7625, 10283, 221, 420, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[304997, 7851, 144, 2, 50, "Section",
 InitializationCell->True],
Cell[305144, 7855, 54759, 1375, 2222, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[359940, 9235, 114, 2, 64, "Section",
 InitializationCell->True],
Cell[360057, 9239, 158, 4, 30, "Input",
 InitializationCell->True]
}, Closed]]
}
]
*)

(* End of internal cache information *)
