(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     70562,       1651]
NotebookOptionsPosition[     68222,       1568]
NotebookOutlinePosition[     68598,       1585]
CellTagsIndexPosition[     68555,       1582]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Copyright", " ", "2013", " ", "Thomas", " ", "Trogdon"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "This", " ", "software", " ", "is", " ", "distributed", " ", "under", " ", 
    "the", " ", "terms", " ", "of", " ", "the", " ", "GNU", " ", "General", 
    " ", "Public", " ", "License"}], " ", "*)"}]}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", 
    RowBox[{"NotebookDirectory", "[", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", "\"\<~/RHPackage\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"<<", "RiemannHilbert`"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"<<", "ISTPackage`"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"<<", "ISTPackage`NLS`"}], ";"}]}], "Input",
 CellChangeTimes->{{3.546363439855007*^9, 3.546363465995051*^9}, {
  3.5463639894449663`*^9, 3.5463639914930773`*^9}, {3.546364071109374*^9, 
  3.546364072165447*^9}, {3.5463643967110863`*^9, 3.546364399958705*^9}, {
  3.5463653252374*^9, 3.5463653319000673`*^9}, {3.54636538398006*^9, 
  3.546365384914282*^9}, {3.546365713693804*^9, 3.546365728250949*^9}, {
  3.5655721759722*^9, 3.5655721763282003`*^9}, {3.5655722144992*^9, 
  3.5655722153002*^9}, {3.5656137763032*^9, 3.5656137817992*^9}, {
  3.5656647221602*^9, 3.5656647225702*^9}, {3.5657111623262*^9, 
  3.5657111625192003`*^9}, {3.56877791446497*^9, 3.568777939995187*^9}, {
  3.636996491226109*^9, 3.636996507944421*^9}}],

Cell[CellGroupData[{

Cell["Normal Reflection Coefficient", "Section",
 CellChangeTimes->{{3.5656372698241997`*^9, 3.5656372715712*^9}, {
  3.5657134538622*^9, 3.5657134683182*^9}, {3.5657136349432*^9, 
  3.5657136356632*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"q", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "+", "x"}], ")"}], 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"I", " ", "x"}], "-", 
        RowBox[{".7", 
         RowBox[{"x", "^", "2"}]}]}], "]"}]}], "/.", 
     RowBox[{
      RowBox[{"Underflow", "[", "]"}], "\[Rule]", "0"}]}], "/.", 
    RowBox[{"Indeterminate", "\[Rule]", "0."}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"q", "[", 
    RowBox[{"_", "?", "InfinityQ"}], "]"}], ":=", "0."}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Focusing", "[", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LL", "=", "7"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"ScateringMatrixFiniteNLS", ":", "\[IndentingNewLine]", "\t", 
    RowBox[{"2", "nd", " ", "argument"}], ":", " ", 
    RowBox[{"grid", " ", "points", " ", 
     RowBox[{"(", 
      RowBox[{
      "lower", " ", "for", " ", "much", " ", "faster", " ", "computation"}], 
      ")"}], " ", "3", "rd", " ", "argument", " ", "is", " ", "the", " ", 
     "computation", " ", "domain", " ", 
     RowBox[{"(", 
      RowBox[{"numerical", " ", "support", " ", "of", " ", "q"}], ")"}]}]}], 
   " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"H", "=", 
   RowBox[{"ScatteringMatrixFiniteNLS", "[", 
    RowBox[{"q", ",", "60", ",", "LL"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"H", "[", 
    RowBox[{"_", "?", "InfinityQ"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"aa", "//", "Clear"}], ";", 
  RowBox[{"bb", "//", "Clear"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"aa", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"aa", "[", "k", "]"}], "=", 
    RowBox[{
     RowBox[{"H", "[", "k", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"bb", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"bb", "[", "k", "]"}], "=", 
    RowBox[{
     RowBox[{"H", "[", "k", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "1"}], "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LocatePolesNLS", "[", 
  RowBox[{"q", ",", "50"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{" ", 
        RowBox[{"This", " ", "output", " ", "shows", " ", "1"}], ")"}], " ", 
       "the", " ", "the", " ", "IC", " ", "evaluated", " ", "at"}], " ", "+", 
      " ", "or", " ", "-", " ", 
      RowBox[{"L", " ", "and", " ", "2"}]}], ")"}], " ", "the", " ", "DCT", 
    " ", "plot", " ", "of", " ", "the", " ", "Chebyshev", " ", 
    "representative", " ", "of", " ", "the", " ", "IC", " ", 
    RowBox[{"on", " ", "[", 
     RowBox[{"0", ",", "L"}], "]"}]}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.546363773993989*^9, 3.5463638517712603`*^9}, {
   3.546365998210053*^9, 3.546366000681183*^9}, {3.5463683576177263`*^9, 
   3.546368361648726*^9}, {3.5656146077152*^9, 3.5656146126152*^9}, {
   3.5656148652602*^9, 3.5656149007992*^9}, {3.5656150646152*^9, 
   3.5656150777632*^9}, 3.5656152032282*^9, 3.5656152472902*^9, {
   3.5656153478392*^9, 3.5656153573372*^9}, {3.5656169737251997`*^9, 
   3.5656169740411997`*^9}, {3.5656173247132*^9, 3.5656173725262003`*^9}, {
   3.5656178219032*^9, 3.5656178421102*^9}, {3.5656197095942*^9, 
   3.5656197456212*^9}, {3.5656197862122*^9, 3.5656198035671997`*^9}, {
   3.5656200817692003`*^9, 3.5656200862841997`*^9}, {3.5656208628712*^9, 
   3.5656208637612*^9}, {3.5656290762952003`*^9, 3.5656290764912*^9}, {
   3.5656292861182003`*^9, 3.5656292862452*^9}, {3.5656327288402*^9, 
   3.5656327294072*^9}, {3.5656338656822*^9, 3.5656338740582*^9}, {
   3.5656341779002*^9, 3.5656342250172*^9}, {3.5656430375142*^9, 
   3.5656430379231997`*^9}, {3.5656564818132*^9, 3.5656564821302*^9}, {
   3.5657128272052*^9, 3.5657128273492002`*^9}, {3.6369962631586027`*^9, 
   3.6369962777721977`*^9}, {3.636996350168233*^9, 3.6369963509836683`*^9}, {
   3.63699652640231*^9, 3.636996560735104*^9}, 3.636996737489027*^9, {
   3.666014264269064*^9, 3.666014365080627*^9}, {3.666014396293182*^9, 
   3.6660144678384447`*^9}, {3.671212040453336*^9, 3.6712120415282717`*^9}, {
   3.6712169487503777`*^9, 3.671216949485662*^9}, {3.671217283553626*^9, 
   3.671217283880226*^9}, {3.6712176106250467`*^9, 3.671217613174664*^9}, {
   3.671220071457479*^9, 3.671220124943637*^9}, {3.671220399230218*^9, 
   3.671220406202117*^9}, {3.671220710007901*^9, 3.671220715526739*^9}, 
   3.671220942930204*^9, {3.67122129275648*^9, 3.671221326715207*^9}, {
   3.6712213570950212`*^9, 3.671221385788403*^9}, {3.671221424028438*^9, 
   3.6712214351320457`*^9}, {3.671276032842205*^9, 3.671276091858405*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"7.61816756799811`*^-15", ",", 
   GraphicsBox[{{}, {{}, {}, 
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.016666666666666666`], AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw9y1tI02EYx/E/KmUpS/NQI81Dw8PUHdRt6qb+tul0bvNiF1KWAwUvQkMF
sRVrzoVYodEBM5Wy0ugiC00jTPNwUYmEFhVhsXJhHss0bVKKVvisFx5ePu/3
eUMKSvSFLgzDyP7Ov3vrLKb2uJSM5+k2BugBMSW20SP+K2R38N0Mkr52B9kL
MePSkyOsNbIvEhxPhcsvmMEt78WaP1/KsruRAzBddEpRfWs7ORib9ZMVfNcd
5FC4wvEp3+xB5sCP/Usvk+8ih6Ez/WPTXZM3OQLvu38USiJ9yFyIJGa1LsKP
HA1jVH9BbPEeMg/fg4yFra1ssgAHZRPPrjv2kYVQ+i+X3bbuJ8ci9Mvw+M/a
YHIclte1uWZ7CDkeHENUhznrAFkEL83IpaVeDlkMW5lAYRCHkSVgs/xrsgbD
yQn4rJw/2qiPJCfig7ZclL3AJSfhxgMBz3AlmizFaGf3b7WKR5YhbuZ4yP1N
PjkZLbkr1ga7gJyChRTuJPu5kJwK25RuKKYzlgy0ha2qTC1xW7YAszn2ZtPF
eOpynLW83P2oRkRdjsWHxvPXqsTUFfDVmC5wKyXUFQiINntZLQnUlWi21K7H
VydSVyIxf1ZUWpdEPQ3jTYNcz0Yp9TRUV7x5/O6OjHo6Di009s32JFNPR3te
0dDOsRTqKqzmtAkDp1Opq6CIdA+SVIF6BhrE4T6e3nLqGTg3PKBuuElmMiGZ
K2qu5CmoZyJho+PYttdkRo3603UTVyeU1NWom+dY4UFmsrBoMIrWFM6ehbn5
MeZrhrNrcEbvFliuc3YNTlwemNrodXYtZLZXXf0mZ9fibWmP0VeeRl2Hpa57
LPc4Z9fhW82T4sMzzv/Z//f/APcuFvs=
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, -43.44856575260458},
    CoordinatesToolOptions:>{"DisplayFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& )},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{
       Charting`ScaledTicks[{Log, Exp}], 
       Charting`ScaledFrameTicks[{Log, Exp}]}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    Method->{},
    PlotRange->{{0., 60}, {-42.75890597875371, 0}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.05]}},
    Ticks->FrontEndValueCache[{Automatic, 
       Charting`ScaledTicks[{Log, Exp}]}, {Automatic, {{-41.44653167389282, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "18"}]}, "Superscript", SyntaxForm -> 
           SuperscriptBox], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-32.23619130191664, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "14"}]}, "Superscript", SyntaxForm -> 
           SuperscriptBox], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-23.025850929940457`, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "10"}]}, "Superscript", SyntaxForm -> 
           SuperscriptBox], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-13.815510557964274`, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "6"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
           TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.605170185988091, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "2"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
           TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-36.841361487904734`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-27.631021115928547`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-18.420680743952367`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-9.210340371976182, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {0., 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}}}]]}], "}"}]], "Print",
 CellChangeTimes->{
  3.5656340855931997`*^9, {3.5656341379082003`*^9, 3.5656342260062*^9}, 
   3.5656343490162*^9, 3.5656345343241997`*^9, 3.5656365153352003`*^9, 
   3.5656430393942003`*^9, 3.5656550545792*^9, 3.5656564839862003`*^9, 
   3.5657072682321997`*^9, 3.5657096257022*^9, 3.5657096949231997`*^9, 
   3.5657111651921997`*^9, 3.5657128283962*^9, 3.5657135384231997`*^9, 
   3.5657136525872*^9, 3.5657139016722*^9, 3.5657213802282*^9, 
   3.5657214195902*^9, 3.5657215055802*^9, 3.5657281130892*^9, {
   3.636996266506144*^9, 3.636996280293977*^9}, 3.636996353495039*^9, {
   3.6369965141898947`*^9, 3.636996561369244*^9}, 3.636996738117363*^9, 
   3.636997439519514*^9, 3.66601354290528*^9, 3.6660136416201487`*^9, 
   3.6660136865286694`*^9, 3.666013794100236*^9, {3.666013901979781*^9, 
   3.6660139442851133`*^9}, 3.6660139985263233`*^9, {3.666014053717902*^9, 
   3.6660140653096123`*^9}, 3.666014096178226*^9, {3.666014134512639*^9, 
   3.666014142894103*^9}, 3.666014472770233*^9, 3.6683485752502737`*^9, 
   3.668348648396975*^9, {3.67121203637728*^9, 3.671212042308535*^9}, {
   3.6712169279032173`*^9, 3.671216950450327*^9}, 3.671217215722617*^9, 
   3.671217290536818*^9, 3.671217617319223*^9, 3.671217704883279*^9, 
   3.671217745543145*^9, 3.6712179779557943`*^9, 3.671218068445386*^9, 
   3.671218358077958*^9, 3.671218411749016*^9, 3.6712186984760103`*^9, 
   3.671218738802904*^9, 3.671219081091283*^9, 3.671219564460515*^9, 
   3.671219620845436*^9, 3.6712197477446404`*^9, 3.6712199431350327`*^9, {
   3.6712200734781857`*^9, 3.671220131162232*^9}, {3.671220399759058*^9, 
   3.671220406552783*^9}, {3.671220710748539*^9, 3.6712207159105883`*^9}, 
   3.6712209436392927`*^9, {3.6712213027098103`*^9, 3.671221327273114*^9}, {
   3.6712213681436243`*^9, 3.671221386290184*^9}, {3.6712214258005247`*^9, 
   3.671221435502707*^9}, {3.671276039360712*^9, 3.671276092253169*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.5000018470030707`"}], "+", 
   RowBox[{"0.412334441297523`", " ", "\[ImaginaryI]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.671221353199692*^9, 3.671221387918646*^9}, {
  3.671221427165387*^9, 3.671221437153894*^9}, {3.671276040996941*^9, 
  3.671276093068774*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Nu]", "=", 
   RowBox[{"Getnu", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"bb", "[", "k", "]"}], "/", 
    RowBox[{"aa", "[", "k", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", "k_", "]"}], ":=", 
   RowBox[{"5", 
    RowBox[{"Sech", "[", 
     RowBox[{"Abs", "[", 
      RowBox[{"3.", "k"}], "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Setrsamp", "[", "h", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetParams", "[", 
    RowBox[{".4", ",", ".1", ",", 
     RowBox[{"10.", "^", 
      RowBox[{"(", 
       RowBox[{"-", "9"}], ")"}]}], ",", "32", ",", "40"}], "]"}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "dom", " ", "is", " ", "an", " ", "estimate", " ", "of", " ", "the", " ", 
    "support", " ", "of", " ", "the", " ", "reflection", " ", "coefficient", 
    " ", "based", " ", "on", " ", "the", " ", "envelope", " ", "function", 
    " ", "h"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"TableLogPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Abs", "[", 
      RowBox[{"\[Rho]", "[", "k", "]"}], "]"}], ",", 
     RowBox[{"h", "[", "k", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"k", ",", 
     RowBox[{"-", "20"}], ",", "20", ",", "1."}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5657119018442*^9, 3.5657119066071997`*^9}, {
   3.5657119474212*^9, 3.5657119655842*^9}, {3.5657120038452*^9, 
   3.5657121192312*^9}, {3.5657121823532*^9, 3.5657122117612*^9}, {
   3.5657122499892*^9, 3.5657124301472*^9}, 3.5657131869132*^9, 
   3.5657134749372*^9, {3.666014162278687*^9, 3.66601423780202*^9}, {
   3.666014482935748*^9, 3.666014523456957*^9}, {3.668348659980116*^9, 
   3.6683486602393103`*^9}, {3.671218017371706*^9, 3.67121801770159*^9}, {
   3.671218196574203*^9, 3.6712181982776423`*^9}, {3.67121878685605*^9, 
   3.671218788477605*^9}, {3.671218833270879*^9, 3.671218834885786*^9}, {
   3.671219662776984*^9, 3.671219665024563*^9}, {3.6712198160847797`*^9, 
   3.671219816218273*^9}, {3.671220247450706*^9, 3.671220252881322*^9}, {
   3.67122031547436*^9, 3.671220316211051*^9}, {3.671220427734881*^9, 
   3.671220619473456*^9}, {3.6712208584569063`*^9, 3.6712208667898293`*^9}, {
   3.67122109808921*^9, 3.671221098953514*^9}, {3.671221195229244*^9, 
   3.67122119656549*^9}, {3.671221469213648*^9, 3.671221469364729*^9}, {
   3.6712215926663427`*^9, 3.6712215935208387`*^9}, {3.671221922847927*^9, 
   3.671221923776321*^9}, {3.671275660354248*^9, 3.671275660841846*^9}, {
   3.671276107396179*^9, 3.671276211109749*^9}, 3.671276245139246*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.016666666666666666`],
      AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQDQEmB+6+qt9bL+d4AMI3PuDLWecVNc8Byjc6MOvT
uuuay2F8wwM/Nwuf6d0C4xscEPe6x7OsC8bXO9Bp+Yzp7EsYX+cA77NpBg5v
YXytA3p3cxSs78L4GgcOfDisuLMIxlc7MFtNr/3ZdHsoX+UAv4PzfIsN1lC+
0gHruddY1j4xh/IVDngYF4ZNaDWB8mUOPLwXWFFjbAjlSxwQZLyxeQOPNpQv
cuD2F7mW1+qqUL7AAenQP5I8V+SgfI4DAt6KJ5iDBaF8hgM32D4/z1RlhvI/
7L/Adn4dc8Sp/bAQjGRH5n+w/4CinsHhhSeyeRwOKa7I9gk4yBTKI7lHxOFz
1h0k90o4LLU4Vonwj4yDcu9cZ4R/FRz8LO9mbYSHh5JDkIE7aw08vFQcOhMl
Vs9IhoWnmsMm3fmKdevh4e9QId6xIpAdFv9aDsHGkQG8cfD4c1hkvrP15Ux4
/Dq0qZ2/fy8VHv8OJ8Ls3WYehacPB6E9Gz3Y4OqNHGbnSoS2J8LTl8OO6XEL
OAph8iYORkv6jFUfOBwAAFMFuDg=
      "]]}, 
    {RGBColor[0.880722, 0.611041, 0.142051], PointSize[0.016666666666666666`],
      AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQDQEmB9avcnnictPnAIRvDOFHekP5RlB5TyjfECrv
AeUbQOXdoHw9qLwrlK8DlXeG8rWg8k5QvgZU3gHKVzsQG9p5onOTHZSvAuVb
Q/lKUL4FlK8A5ZtC+TJQvhGUL3Fg9yqhicKp+lC+yIH3YL4mlC9wYP9fEF8Z
yuc4MO+3lrL6KSkon+GAd8/nmsApvFD+h/2xCo1fGlKf7YeFoHHv2++OB37a
Q+Xt0eQdUPVzOKCaL+CAar+IA6r7JBxQ3S/jgOo/BQdU/ys5oIaPigNq+Kk5
oIavhgNq+Gs5oMaPjgNq/Ok5oMavgQNq/Bs6oKYPIwfU9GPsgJq+TBxg6Q8A
qEXJNA==
      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, -62.00194454712662},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Part[#, 1], 
      Exp[
       Part[#, 2]]}& )},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{
     Charting`ScaledTicks[{Log, Exp}], 
     Charting`ScaledFrameTicks[{Log, Exp}]}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{},
  PlotRange->{{-20., 20.}, {-60.99224006364152, 1.6094379124341003`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->FrontEndValueCache[{Automatic, 
     Charting`ScaledTicks[{Log, Exp}]}, {Automatic, {{-62.16979751083923, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "27"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-50.65687204586901, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "22"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-39.14394658089878, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "17"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-27.631021115928547`, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "12"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-16.11809565095832, 
       FormBox[
        TemplateBox[{"10", 
          RowBox[{"-", "7"}]}, "Superscript", SyntaxForm -> SuperscriptBox], 
        TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-4.605170185988091, 
       FormBox["0.01`", TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {6.907755278982137, 
       FormBox[
        TagBox[
         InterpretationBox["\"1000.00\"", 1000., AutoDelete -> True], 
         NumberForm[#, {
           DirectedInfinity[1], 2.}]& ], TraditionalForm], {0.01, 0.}, {
        AbsoluteThickness[0.1]}}, {-59.86721241784519, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-57.564627324851145`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-55.262042231857095`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-52.95945713886305, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-48.35428695287496, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-46.051701859880914`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-43.74911676688687, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-41.44653167389282, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-36.841361487904734`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-34.538776394910684`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-32.23619130191664, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-29.933606208922594`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-25.328436022934504`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-23.025850929940457`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-20.72326583694641, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-18.420680743952367`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-13.815510557964274`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-11.512925464970229`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-9.210340371976182, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-6.907755278982137, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {0., 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {2.302585092994046, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}, {4.605170185988092, 
       FormBox[
        InterpretationBox[
         StyleBox[
          
          GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
           Baseline], "CacheGraphics" -> False], 
         Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
        AbsoluteThickness[0.1]}}}}]]], "Output",
 CellChangeTimes->{
  3.6660141990111237`*^9, 3.666014238170309*^9, {3.66601447547425*^9, 
   3.66601452806703*^9}, 3.668348577290223*^9, 3.668348650794807*^9, 
   3.6683487187213984`*^9, 3.671212051309021*^9, {3.67121693620779*^9, 
   3.671216958721444*^9}, 3.6712172270689173`*^9, 3.6712172985581713`*^9, 
   3.671217625263562*^9, 3.6712177127647867`*^9, 3.671217752980216*^9, 
   3.671217986963284*^9, 3.671218018378942*^9, 3.671218077979802*^9, 
   3.67121819943804*^9, 3.671218368426732*^9, 3.6712184202214003`*^9, 
   3.671218705690826*^9, 3.671218745510569*^9, 3.671218789321699*^9, 
   3.671218835445372*^9, 3.671219088100865*^9, 3.671219571556025*^9, 
   3.671219628163439*^9, 3.671219665596304*^9, 3.671219755079268*^9, 
   3.671219816790412*^9, 3.6712199505153637`*^9, 3.6712201417180147`*^9, 
   3.671220253344552*^9, {3.6712204240440187`*^9, 3.67122061979101*^9}, 
   3.671220730792769*^9, {3.671220859095202*^9, 3.6712208670979137`*^9}, 
   3.671220956212859*^9, 3.6712211060441017`*^9, 3.671221197020548*^9, 
   3.671221407535247*^9, {3.671221451876478*^9, 3.671221470026558*^9}, 
   3.671221595262857*^9, 3.671221924331526*^9, 3.6712756612100697`*^9, {
   3.671276100970413*^9, 3.6712762115681133`*^9}, 3.671276246133048*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"poles", "=", 
  RowBox[{"LocatePolesNLS", "[", 
   RowBox[{"q", ",", "200"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetScatteringData", "[", 
  RowBox[{"aa", ",", "bb", ",", "\[Rho]", ",", "poles"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Settimeflag", "[", "True", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.546363773993989*^9, 3.5463638517712603`*^9}, {
   3.546365998210053*^9, 3.546366000681183*^9}, {3.5463683576177263`*^9, 
   3.546368361648726*^9}, {3.5656146077152*^9, 3.5656146126152*^9}, {
   3.5656148652602*^9, 3.5656149007992*^9}, {3.5656150646152*^9, 
   3.5656150777632*^9}, 3.5656152032282*^9, 3.5656152472902*^9, {
   3.5656153478392*^9, 3.5656153573372*^9}, {3.5656169737251997`*^9, 
   3.5656169740411997`*^9}, {3.5656173247132*^9, 3.5656173725262003`*^9}, {
   3.5656178219032*^9, 3.5656178421102*^9}, {3.5656197095942*^9, 
   3.5656197456212*^9}, {3.5656197862122*^9, 3.5656198913492002`*^9}, {
   3.5656202684032*^9, 3.5656202684862003`*^9}, {3.5656209747862*^9, 
   3.5656209890512*^9}, {3.5656341843532*^9, 3.5656341859052*^9}, {
   3.5656343426842003`*^9, 3.5656343661312*^9}, {3.5656550602282*^9, 
   3.5656550635132*^9}, {3.5656564863722*^9, 3.5656564895882*^9}, {
   3.5656566530882*^9, 3.5656566657122*^9}, {3.5656611089812*^9, 
   3.5656611091212*^9}, {3.5656612608652*^9, 3.5656612612552*^9}, {
   3.5656628378702*^9, 3.5656628381902*^9}, {3.5656628957822*^9, 
   3.5656628962722*^9}, {3.5657107598352003`*^9, 3.5657107606142*^9}, {
   3.5657131086071997`*^9, 3.5657131106191998`*^9}, 3.5657133041591997`*^9, {
   3.5657133726162*^9, 3.5657133765112*^9}, {3.5657135069482*^9, 
   3.5657135118302*^9}, 3.5657136476921997`*^9, {3.5657139191982*^9, 
   3.5657139193612003`*^9}, {3.5657280883972*^9, 3.5657280919762*^9}, {
   3.6369965685830793`*^9, 3.636996586767593*^9}, {3.6660137175312967`*^9, 
   3.66601371785856*^9}, {3.666013851042342*^9, 3.666013855068162*^9}, {
   3.6660141663221073`*^9, 3.666014167432418*^9}, {3.6683486735964737`*^9, 
   3.668348681775393*^9}, {3.67121729468298*^9, 3.6712172964503727`*^9}, {
   3.6712180290022907`*^9, 3.6712180293515244`*^9}, {3.6712201425856047`*^9, 
   3.67122015135236*^9}, {3.671221058209133*^9, 3.6712210585274343`*^9}, {
   3.671221459381384*^9, 3.671221460795491*^9}, {3.671221892085565*^9, 
   3.671221892205727*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.5000000000298616`"}], "+", 
   RowBox[{"0.4123318948838133`", " ", "\[ImaginaryI]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.671220152188097*^9, 3.671220257968162*^9, {3.671220609347377*^9, 
   3.671220621541556*^9}, 3.671220744028504*^9, 3.671221087138624*^9, 
   3.671221132746653*^9, {3.671221464965043*^9, 3.671221474646812*^9}, 
   3.671221599633513*^9, 3.671221918178932*^9, 3.6712219524897423`*^9, 
   3.671275687937358*^9, 3.6712762065377893`*^9, 3.671276237785861*^9, 
   3.671276271815524*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"qNLS", "//", "Clear"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"qNLS", "[", 
    RowBox[{"x_", ",", "t_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"qNLS", "[", 
     RowBox[{"x", ",", "t"}], "]"}], "=", 
    RowBox[{"NLSAuto", "[", 
     RowBox[{"x", ",", "t"}], "]"}]}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"qNLS", "[", 
  RowBox[{"0", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.67121724560981*^9, 3.6712172478729477`*^9}}],

Cell[BoxData["\<\"Region: 0 (0,0) 1) Construct: 49.703024  1) Solve: 2.037502 \
 2) Construct: 2.183749  2) Solve: 2.172629\"\>"], "Print",
 CellChangeTimes->{
  3.67121726255873*^9, 3.67121733175602*^9, 3.671218140227558*^9, 
   3.671218228208584*^9, 3.6712183932437162`*^9, 3.6712184476137953`*^9, 
   3.671218772516223*^9, {3.671218827443738*^9, 3.671218841795927*^9}, 
   3.6712196551637907`*^9, 3.671219703376123*^9, 3.671219808396649*^9, 
   3.671219871081058*^9, 3.6712200481446753`*^9, 3.671220327066311*^9, 
   3.671220685657523*^9, 3.6712211864088173`*^9, 3.671221269088871*^9, 
   3.6712215783531446`*^9, 3.6712218190432577`*^9, 3.6712219579855433`*^9, 
   3.6712760151176453`*^9, 3.671276299038129*^9}],

Cell[BoxData[
 RowBox[{"1.0000000002939289`", "\[VeryThinSpace]", "-", 
  RowBox[{"2.654760304927867`*^-10", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{
  3.67121726256645*^9, 3.671217331767413*^9, 3.671218144559218*^9, 
   3.671218229916404*^9, 3.67121839491078*^9, 3.671218447624264*^9, 
   3.671218772526833*^9, {3.671218827454159*^9, 3.671218841806403*^9}, 
   3.671219655174348*^9, 3.671219703386539*^9, 3.6712198084144783`*^9, 
   3.67121987109175*^9, 3.671220048155205*^9, 3.6712203270757113`*^9, 
   3.671220685669036*^9, 3.671221186419232*^9, 3.671221269099308*^9, 
   3.671221578363573*^9, 3.6712218190536213`*^9, 3.671221957995813*^9, 
   3.671276015129272*^9, 3.6712762990486298`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"q", "[", "0", "]"}]], "Input",
 CellChangeTimes->{{3.671221585082725*^9, 3.671221586626437*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.671221587014731*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Cauchy Integral Reflection Coefficient", "Section",
 CellChangeTimes->{{3.5656372698241997`*^9, 3.5656372715712*^9}, {
  3.5657134538622*^9, 3.5657134683182*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"q", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"x", " ", 
      RowBox[{"Sech", "[", "x", "]"}]}], "/.", 
     RowBox[{
      RowBox[{"Underflow", "[", "]"}], "\[Rule]", "0"}]}], "/.", 
    RowBox[{"Indeterminate", "\[Rule]", "0."}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q", "[", 
   RowBox[{"_", "?", "InfinityQ"}], "]"}], ":=", "0."}], "\n", 
 RowBox[{
  RowBox[{"Focusing", "[", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"LocatePolesNLS", "[", 
   RowBox[{"q", ",", "40"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"H", "=", 
   RowBox[{"ScatteringMatrixFiniteNLS", "[", 
    RowBox[{"q", ",", "80", ",", "25"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"aa", "//", "Clear"}], ";", 
  RowBox[{"bb", "//", "Clear"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"aa", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"aa", "[", "k", "]"}], "=", 
    RowBox[{
     RowBox[{"H", "[", "k", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"bb", "[", "k_", "]"}], ":=", 
    RowBox[{
     RowBox[{"bb", "[", "k", "]"}], "=", 
     RowBox[{
      RowBox[{"H", "[", "k", "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", "1"}], "]"}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"SetParams", "[", 
   RowBox[{".6", ",", ".1", ",", 
    RowBox[{"10.", "^", 
     RowBox[{"(", 
      RowBox[{"-", "9"}], ")"}]}], ",", "10", ",", "20"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"h", "[", "k_", "]"}], ":=", 
   RowBox[{"3", "/", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{
       RowBox[{"Abs", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"k", "^", "2"}], "/", "2"}], "+", 
         RowBox[{"1", "/", "3.2"}]}], "]"}], "^", "4"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Setrsamp", "[", "h", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Settimeflag", "[", "False", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Nu]", "=", 
   RowBox[{"Getnu", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"bb", "[", "k", "]"}], "/", 
    RowBox[{"aa", "[", "k", "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.546363773993989*^9, 3.5463638517712603`*^9}, {
   3.546365998210053*^9, 3.546366000681183*^9}, {3.5463683576177263`*^9, 
   3.546368361648726*^9}, {3.5656146077152*^9, 3.5656146126152*^9}, {
   3.5656148652602*^9, 3.5656149007992*^9}, {3.5656150646152*^9, 
   3.5656150777632*^9}, 3.5656152032282*^9, 3.5656152472902*^9, {
   3.5656153478392*^9, 3.5656153573372*^9}, {3.5656169737251997`*^9, 
   3.5656169740411997`*^9}, {3.5656173247132*^9, 3.5656173725262003`*^9}, {
   3.5656178219032*^9, 3.5656178421102*^9}, {3.5656197095942*^9, 
   3.5656197456212*^9}, {3.5656197862122*^9, 3.5656198035671997`*^9}, {
   3.5656200817692003`*^9, 3.5656200862841997`*^9}, {3.5656208628712*^9, 
   3.5656208637612*^9}, {3.5656290762952003`*^9, 3.5656290764912*^9}, {
   3.5656292861182003`*^9, 3.5656292862452*^9}, {3.5656327288402*^9, 
   3.5656327294072*^9}, {3.5656338656822*^9, 3.5656338740582*^9}, {
   3.5656341779002*^9, 3.5656342250172*^9}, {3.5656430375142*^9, 
   3.5656430379231997`*^9}, {3.5656564818132*^9, 3.5656564821302*^9}, {
   3.5657128272052*^9, 3.5657128273492002`*^9}, {3.5657140208742*^9, 
   3.5657140224982*^9}, {3.5657201706792*^9, 3.5657202092981997`*^9}, {
   3.5657281330552*^9, 3.5657281385492*^9}, {3.5657292000912*^9, 
   3.5657292041202*^9}, {3.5657314722771997`*^9, 3.5657314737702*^9}, {
   3.5657325249922*^9, 3.5657325255222*^9}, {3.5657423232473783`*^9, 
   3.565742338729776*^9}, {3.5657432727097883`*^9, 3.565743318406247*^9}, {
   3.565746332487253*^9, 3.5657463550521383`*^9}, {3.565746433908359*^9, 
   3.5657464347901363`*^9}, {3.565746487131394*^9, 3.565746491146474*^9}, {
   3.565746910189403*^9, 3.56574691178651*^9}, {3.565747259510936*^9, 
   3.5657472636541157`*^9}, {3.5657534678509207`*^9, 3.565753468647086*^9}, {
   3.56575480417185*^9, 3.565754831345348*^9}, {3.565756857057745*^9, 
   3.565756864519175*^9}, {3.568777950625959*^9, 3.568777950849099*^9}, {
   3.5687794482537127`*^9, 3.5687794549598713`*^9}, {3.6660145719608803`*^9, 
   3.666014572159794*^9}, {3.671217077950511*^9, 3.671217078996772*^9}, {
   3.671217118479212*^9, 3.671217150967914*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.943971932482009`*^-10", ",", 
   GraphicsBox[{{}, {{}, {}, 
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.016666666666666666`], AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJw1zwtMU2cYxvFDJxZvoxgEnJOWwihWyq0UKIXyFGm5Qy9MhwpOSc0EJmHQ
3SHHuWRjEiMrMOwWDXXDIIhR0aEus87LNp3CxOsY6ZJCumgkJs2Iq4Fdwvud
5OTkd/7fm/ecqB0NZquA4zjjf/f/z4XraU5zh+CL2o0CF71A5fEzya3Tzy8u
MAiJowGFvUtZF+EfzeJVzu3B5FDsWts5u/aakByBmlec3R7FC+SXMTk76Y63
s3kJNHuy13tmWZcipPa3oX3exeQYnFZJFftty8ix0HN1jYasEHIcotc88Y7Y
V5PlGMnqSCp2ryLH4zP/m9/5t4SSE/DLGZtw9BPmJKRedaSWNLHzyQiv2Hrw
5nQYOQVlF8SRjx5GkJWo2lQROGZbQ07F2QPZdxe9KiarYK76YG6iPZachj/e
KvTVF0SR03HboQ4UnpCQMzD6d2ln9E/Majx0joX51Ox8JsKeBOnSZ5g18AZK
xrdOSclZ6BEEWz9PiiFno+bnL62zUrZfi7RDj63C4ARyDlzjw6c1gzIyUO6u
2zsfQeYBv4QfUKhY1+HDS3c83f2s63DuZG3/vtfjqOeiuXNweKZyHfVcGLpb
ppYPyKlvgDdaG9nQH099A1zz1qHYeynU86A8deqpfAl9H5+H8c7w/Od7FNT1
cOvrtI+dZF6P9mndzBsvsf8xIFOWs2L5HTZvQIuiQfDOWCL1fKzuLXWI7UnU
83Gj3uer7kmmXgDldcvw5oup1AtwqEg051ay7ytE5UTksct/0Xm+EKqr7SJb
EOtFODw8tfK4nswXwTPi9N06wnoxuG03GtuildSLMaDYqfl1jMyVAAGGKy2/
s/0lEK8YSo6qT6deilBNX0hHjYp6KfzaY44+OZkrg62rdffHOayXIa7pendK
K+vlaJqQH/1mkvVytCcMyh5Vp1E3QqcMeK/vRdoHI3plItm6qAw6b8S7Qu2z
xOLMBbuM2P3+ff/XduqcCXMFGYePbCPDhKMn9zq63mbzJoj155u/Okt2mfDg
wXRgTLia5s3IqL50bvtBMsxYJp0/ICqifbwZ/Mrzrz2r0tC8GXk/OHOrbNk0
b8G3GxXf/3mNOiy4v1/y4642Mm9Bo7pL6v2UzVvQduL2R+E9ZK4CzZl2T4sp
y/Uvpr1sPA==
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{None, None},
    AxesOrigin->{0, -31.59656790694802},
    CoordinatesToolOptions:>{"DisplayFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& )},
    DisplayFunction->Identity,
    Frame->{{False, False}, {False, False}},
    FrameLabel->{{None, None}, {None, None}},
    FrameTicks->{{
       Charting`ScaledTicks[{Log, Exp}], 
       Charting`ScaledFrameTicks[{Log, Exp}]}, {Automatic, Automatic}},
    GridLines->{None, None},
    GridLinesStyle->Directive[
      GrayLevel[0.5, 0.4]],
    Method->{},
    PlotRange->{{0., 80}, {-31.095035083028208`, 0}},
    PlotRangeClipping->True,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.05]}},
    Ticks->FrontEndValueCache[{Automatic, 
       Charting`ScaledTicks[{Log, Exp}]}, {
      Automatic, {{-25.328436022934504`, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "11"}]}, "Superscript", SyntaxForm -> 
           SuperscriptBox], TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-18.420680743952367`, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "8"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
           TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-11.512925464970229`, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
           TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-4.605170185988091, 
         FormBox[
          TemplateBox[{"10", 
            RowBox[{"-", "2"}]}, "Superscript", SyntaxForm -> SuperscriptBox],
           TraditionalForm], {0.01, 0.}, {
          AbsoluteThickness[0.1]}}, {-32.23619130191664, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-29.933606208922594`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-23.025850929940457`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-16.11809565095832, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-9.210340371976182, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {-2.3025850929940455`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.302585092994046, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.3978952727983707`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.4849066497880004`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.5649493574615367`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.6390573296152584`, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.70805020110221, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.772588722239781, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}, {2.833213344056216, 
         FormBox[
          InterpretationBox[
           StyleBox[
            
            GraphicsBox[{}, ImageSize -> {0., 0.}, BaselinePosition -> 
             Baseline], "CacheGraphics" -> False], 
           Spacer[{0., 0.}]], TraditionalForm], {0.005, 0.}, {
          AbsoluteThickness[0.1]}}}}]]}], "}"}]], "Print",
 CellChangeTimes->{
  3.5657140246322002`*^9, 3.5657193173462*^9, 3.5657200908472*^9, 
   3.5657201278302*^9, {3.5657201843761997`*^9, 3.5657202104832*^9}, 
   3.5657216134932003`*^9, 3.5657268715322*^9, {3.5657281317902*^9, 
   3.5657281406552*^9}, 3.5657292059072*^9, 3.5657306769952*^9, 
   3.5657309934972*^9, {3.5657314602762003`*^9, 3.5657314750692*^9}, 
   3.5657325290732*^9, 3.565733121163211*^9, {3.565742327367516*^9, 
   3.5657423395690603`*^9}, 3.565743318725713*^9, 3.565746193907346*^9, 
   3.5657462545087233`*^9, 3.56574635759175*^9, 3.565746435145156*^9, {
   3.565746491945051*^9, 3.565746497767868*^9}, 3.565746577978385*^9, 
   3.5657466615230637`*^9, 3.565746912661324*^9, 3.565747264553968*^9, 
   3.565753469381509*^9, 3.565753796271229*^9, 3.565754425527398*^9, 
   3.5657545252819147`*^9, {3.565754809963161*^9, 3.565754832364916*^9}, 
   3.565755562350252*^9, 3.565756865516081*^9, {3.568777944852035*^9, 
   3.5687779523036537`*^9}, 3.568778682952198*^9, 3.666014576602271*^9, 
   3.671217046437821*^9, 3.671217080041233*^9, {3.6712171238027*^9, 
   3.671217151695904*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"up", "=", 
   RowBox[{"I", 
    RowBox[{"(", 
     RowBox[{"\[Nu]", "+", ".0001"}], ")"}]}]}], ";", 
  RowBox[{"m", "=", "50"}], ";", 
  RowBox[{"el", "=", "8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Fun", "[", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"Line", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "el"}], ",", "0"}], "}"}], "-", "up"}], "]"}], ",", 
       "m"}], "]"}], ",", 
     RowBox[{"Fun", "[", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"Line", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "el"}], "}"}], "-", "up"}], "]"}], ",", "m"}], 
      "]"}], ",", 
     RowBox[{"Fun", "[", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"Line", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"el", ",", "0"}], "}"}], "+", "up"}], "]"}], ",", "m"}], 
      "]"}], ",", 
     RowBox[{"Fun", "[", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"Line", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "el"}]}], "}"}], "+", "up"}], "]"}], ",", "m"}], 
      "]"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5657124604242*^9, 3.5657125614941998`*^9}, {
   3.5657125934751997`*^9, 3.5657126645741997`*^9}, {3.5657127003992*^9, 
   3.5657127008672*^9}, 3.5657127756352*^9, {3.5657128089702*^9, 
   3.5657128091222*^9}, {3.5657128670271997`*^9, 3.5657128671422*^9}, {
   3.5657129136872*^9, 3.5657129139821997`*^9}, {3.5657131355072002`*^9, 
   3.5657131363422003`*^9}, {3.5657138429712*^9, 3.5657138440622*^9}, {
   3.5657200497142*^9, 3.5657200715752*^9}, {3.5657216844132*^9, 
   3.5657216851672*^9}, {3.5657281478272*^9, 3.5657281481482*^9}, {
   3.5657462004962893`*^9, 3.565746200922305*^9}, {3.565746581933074*^9, 
   3.56574658238769*^9}, {3.565746917651032*^9, 3.565746917865644*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"LinearSolve", "::", "luc"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Result for \[NoBreak]\\!\\(LinearSolve\\)\[NoBreak] of \
badly conditioned matrix \[NoBreak]\\!\\({\\(\\({\\(\\(\\(\\(1.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\[LeftSkeleton] 27 \[RightSkeleton]\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\
\[LeftSkeleton] 110 \[RightSkeleton]\\)\\)}\\)\\), \\(\\(\[LeftSkeleton] 49 \
\[RightSkeleton]\\)\\), \\(\\(\[LeftSkeleton] 110 \[RightSkeleton]\\)\\)}\\)\
\[NoBreak] may contain significant numerical errors. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/luc\\\", ButtonNote -> \
\\\"LinearSolve::luc\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.671217159133973*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"LinearSolve", "::", "luc"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Result for \[NoBreak]\\!\\(LinearSolve\\)\[NoBreak] of \
badly conditioned matrix \[NoBreak]\\!\\({\\(\\({\\(\\(\\(\\(1.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\[LeftSkeleton] 27 \[RightSkeleton]\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\
\[LeftSkeleton] 110 \[RightSkeleton]\\)\\)}\\)\\), \\(\\(\[LeftSkeleton] 49 \
\[RightSkeleton]\\)\\), \\(\\(\[LeftSkeleton] 110 \[RightSkeleton]\\)\\)}\\)\
\[NoBreak] may contain significant numerical errors. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/luc\\\", ButtonNote -> \
\\\"LinearSolve::luc\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.671217159272799*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"LinearSolve", "::", "luc"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Result for \[NoBreak]\\!\\(LinearSolve\\)\[NoBreak] of \
badly conditioned matrix \[NoBreak]\\!\\({\\(\\({\\(\\(\\(\\(1.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\[LeftSkeleton] 27 \[RightSkeleton]\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \
\\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\
\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \
\[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \\(\\(0.`\
\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \[VeryThinSpace]\\)\\) + \
\\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\\(\\(0.` \
\[VeryThinSpace]\\)\\) + \\(\\(0.`\\\\ \[ImaginaryI]\\)\\)\\)\\), \\(\\(\
\[LeftSkeleton] 110 \[RightSkeleton]\\)\\)}\\)\\), \\(\\(\[LeftSkeleton] 49 \
\[RightSkeleton]\\)\\), \\(\\(\[LeftSkeleton] 110 \[RightSkeleton]\\)\\)}\\)\
\[NoBreak] may contain significant numerical errors. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/luc\\\", ButtonNote -> \
\\\"LinearSolve::luc\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.671217159407733*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \
\[NoBreak]\\!\\(\\*StyleBox[\\(LinearSolve :: luc\\), \\\"MessageName\\\"]\\)\
\[NoBreak] will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.671217159462256*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"m\[Rho]", "//", "Clear"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"m\[Rho]", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"m\[Rho]", "[", "k", "]"}], "=", 
    RowBox[{"\[Piecewise]", GridBox[{
       {
        RowBox[{"Cauchy", "[", 
         RowBox[{"f", ",", "k"}], "]"}], 
        RowBox[{
         RowBox[{"Im", "[", "k", "]"}], "<", " ", 
         RowBox[{"Im", "[", "up", "]"}]}]},
       {
        RowBox[{"\[Rho]", "[", "k", "]"}], "True"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"qNLS", "//", "Clear"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"qNLS", "[", 
    RowBox[{"x_", ",", "t_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"qNLS", "[", 
     RowBox[{"x", ",", "t"}], "]"}], "=", 
    RowBox[{"NLSAuto", "[", 
     RowBox[{"x", ",", "t"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5657132310212*^9, 3.5657132954642*^9}, {
  3.5657140632892*^9, 3.5657140646062*^9}, {3.5657192203482*^9, 
  3.5657192849662*^9}, {3.5657194209561996`*^9, 3.5657194272672*^9}, {
  3.5657292666851997`*^9, 3.5657292822352*^9}, {3.5657309648372*^9, 
  3.5657309735282*^9}}],

Cell[BoxData[
 RowBox[{"SetScatteringData", "[", 
  RowBox[{"aa", ",", "bb", ",", "m\[Rho]", ",", 
   RowBox[{"LocatePolesNLS", "[", 
    RowBox[{"q", ",", "40"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.546363773993989*^9, 3.5463638517712603`*^9}, {
   3.546365998210053*^9, 3.546366000681183*^9}, {3.5463683576177263`*^9, 
   3.546368361648726*^9}, {3.5656146077152*^9, 3.5656146126152*^9}, {
   3.5656148652602*^9, 3.5656149007992*^9}, {3.5656150646152*^9, 
   3.5656150777632*^9}, 3.5656152032282*^9, 3.5656152472902*^9, {
   3.5656153478392*^9, 3.5656153573372*^9}, {3.5656169737251997`*^9, 
   3.5656169740411997`*^9}, {3.5656173247132*^9, 3.5656173725262003`*^9}, {
   3.5656178219032*^9, 3.5656178421102*^9}, {3.5656197095942*^9, 
   3.5656197456212*^9}, {3.5656197862122*^9, 3.5656198913492002`*^9}, {
   3.5656202684032*^9, 3.5656202684862003`*^9}, {3.5656209747862*^9, 
   3.5656209890512*^9}, {3.5656341843532*^9, 3.5656341859052*^9}, {
   3.5656343426842003`*^9, 3.5656343661312*^9}, {3.5656550602282*^9, 
   3.5656550635132*^9}, {3.5656564863722*^9, 3.5656564895882*^9}, {
   3.5656566530882*^9, 3.5656566657122*^9}, {3.5656611089812*^9, 
   3.5656611091212*^9}, {3.5656612608652*^9, 3.5656612612552*^9}, {
   3.5656628378702*^9, 3.5656628381902*^9}, {3.5656628957822*^9, 
   3.5656628962722*^9}, {3.5657107598352003`*^9, 3.5657107606142*^9}, {
   3.5657131086071997`*^9, 3.5657131106191998`*^9}, 3.5657133041591997`*^9, {
   3.5657133726162*^9, 3.5657133765112*^9}, {3.5657135069482*^9, 
   3.5657135118302*^9}, {3.5657137550902*^9, 3.5657137561921997`*^9}, {
   3.5657314282152*^9, 3.5657314285592003`*^9}, 3.5657547120520887`*^9, {
   3.565754864432117*^9, 3.5657548656450157`*^9}, {3.5687780077213*^9, 
   3.5687780079645033`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LocatePolesNLS", "[", 
  RowBox[{"q", ",", "40"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "0.27985152211394`"}], "+", 
    RowBox[{"0.16503378635017543`", " ", "\[ImaginaryI]"}]}], ",", 
   RowBox[{"0.27985152211394326`", "\[VeryThinSpace]", "+", 
    RowBox[{"0.16503378635016872`", " ", "\[ImaginaryI]"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.671217108028924*^9, 3.671217188815489*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"qNLS", "[", 
  RowBox[{"0", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.671217060879665*^9, 3.671217063544457*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"LinearSolve", "::", "luc"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Result for \[NoBreak]\\!\\(LinearSolve\\)\[NoBreak] of \
badly conditioned matrix \[NoBreak]\\!\\({\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)}\\)\[NoBreak] may contain significant numerical errors. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/luc\\\", \
ButtonNote -> \\\"LinearSolve::luc\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.671217191767733*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "16.311056628400262`"}], "-", 
  RowBox[{"0.000028477778240098665`", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.671217065347546*^9, 3.671217094330326*^9}, 
   3.671217191815146*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"q", "[", "0", "]"}]], "Input",
 CellChangeTimes->{{3.671217097961684*^9, 3.671217099009522*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.671217099401966*^9, 3.671217197230275*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Plotting: timestring outputs relevant computation times and region information\
\>", "Section",
 CellChangeTimes->{{3.568128552150757*^9, 3.5681285546225033`*^9}, 
   3.568737713029443*^9, {3.568764100658587*^9, 3.5687641281772633`*^9}, {
   3.568779410815009*^9, 3.568779414879402*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Defocusing", ":", "  ", 
    RowBox[{"Run", " ", 
     RowBox[{"Defocusing", "[", "]"}], " ", "above"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Monitor", "[", 
   RowBox[{
    RowBox[{"ReImTablePlot", "[", 
     RowBox[{
      RowBox[{"qNLS", "[", 
       RowBox[{"x", ",", "1."}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "20"}], ",", "10", ",", ".25"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "1"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", "Thick"}]}], "]"}], ",", "timestring"}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.568736342776311*^9, 3.568736391911895*^9}, {
   3.5687370354381857`*^9, 3.5687370358930483`*^9}, {3.5687371300419397`*^9, 
   3.5687371344871483`*^9}, {3.568737316085844*^9, 3.568737316681559*^9}, 
   3.5687377132134523`*^9, {3.568742980436249*^9, 3.568742991750758*^9}, {
   3.5687641060069103`*^9, 3.568764106365384*^9}, {3.5687647977927923`*^9, 
   3.568764830039072*^9}, 3.568764934433239*^9, {3.5687670130818157`*^9, 
   3.56876701313647*^9}, {3.568771314846525*^9, 3.568771355332436*^9}, {
   3.5687756798206463`*^9, 3.568775683954124*^9}, {3.5687757255848007`*^9, 
   3.568775726633548*^9}, {3.568775868777995*^9, 3.568775869689313*^9}, {
   3.56877594062497*^9, 3.5687759538784733`*^9}, {3.568776111948331*^9, 
   3.568776134472105*^9}, {3.568776864855793*^9, 3.568776872415304*^9}, {
   3.568777397250198*^9, 3.568777425497768*^9}, {3.568779398505507*^9, 
   3.568779408761155*^9}, {3.56878058102162*^9, 3.5687805865965014`*^9}, {
   3.6660156139185266`*^9, 3.66601561956504*^9}}],

Cell[BoxData[
 DynamicBox[ToBoxes[$CellContext`timestring, StandardForm],
  Evaluator->"Local2",
  ImageSizeCache->{72., {3., 8.}}]], "PrintTemporary",
 CellChangeTimes->{3.66601558405226*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Focusing", " ", "Run", " ", 
    RowBox[{"Focusing", "[", "]"}], " ", "above"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Monitor", "[", 
   RowBox[{
    RowBox[{"TablePlot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"qNLS", "[", 
        RowBox[{"x", ",", "1."}], "]"}], "//", "Re"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"-", "20"}], ",", "10", ",", ".25"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"InterpolationOrder", "\[Rule]", "1"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", "Thick"}]}], "]"}], ",", "timestring"}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.5687774747191677`*^9, 3.568777483727429*^9}, {
  3.568780269111828*^9, 3.568780271573983*^9}, {3.568780595378986*^9, 
  3.5687805963413*^9}, {3.66601562359735*^9, 3.6660156255404778`*^9}}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.56877779728918*^9}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.666013775199511*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{719, 851},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (December 4, \
2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 408, 9, 63, "Input"],
Cell[968, 31, 1195, 25, 97, "Input"],
Cell[CellGroupData[{
Cell[2188, 60, 204, 3, 64, "Section"],
Cell[CellGroupData[{
Cell[2417, 67, 4995, 118, 267, "Input"],
Cell[7415, 187, 6854, 143, 119, "Print"],
Cell[14272, 332, 327, 7, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14636, 344, 2806, 61, 148, "Input"],
Cell[17445, 407, 12438, 297, 252, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29920, 709, 2351, 37, 63, "Input"],
Cell[32274, 748, 567, 11, 28, "Output"]
}, Open  ]],
Cell[32856, 762, 350, 11, 46, "Input"],
Cell[CellGroupData[{
Cell[33231, 777, 147, 3, 28, "Input"],
Cell[33381, 782, 714, 10, 38, "Print"],
Cell[34098, 794, 709, 11, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34844, 810, 120, 2, 28, "Input"],
Cell[34967, 814, 70, 1, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[35086, 821, 168, 2, 64, "Section"],
Cell[CellGroupData[{
Cell[35279, 827, 4572, 110, 267, "Input"],
Cell[39854, 939, 9069, 206, 119, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48960, 1150, 1953, 51, 63, "Input"],
Cell[50916, 1203, 2698, 41, 75, "Message"],
Cell[53617, 1246, 2698, 41, 75, "Message"],
Cell[56318, 1289, 2698, 41, 75, "Message"],
Cell[59019, 1332, 533, 11, 24, "Message"]
}, Open  ]],
Cell[59567, 1346, 1740, 47, 99, "Input"],
Cell[61310, 1395, 1757, 27, 28, "Input"],
Cell[CellGroupData[{
Cell[63092, 1426, 91, 2, 28, "Input"],
Cell[63186, 1430, 375, 9, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63598, 1444, 146, 3, 28, "Input"],
Cell[63747, 1449, 582, 11, 41, "Message"],
Cell[64332, 1462, 236, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64605, 1472, 120, 2, 28, "Input"],
Cell[64728, 1476, 92, 1, 28, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[64869, 1483, 297, 5, 85, "Section"],
Cell[CellGroupData[{
Cell[65191, 1492, 1706, 33, 63, "Input"],
Cell[66900, 1527, 192, 4, 22, "PrintTemporary"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67129, 1536, 906, 22, 63, "Input"],
Cell[68038, 1560, 76, 1, 28, "Output"],
Cell[68117, 1563, 77, 1, 28, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
