(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    371968,       6497]
NotebookOptionsPosition[    369895,       6421]
NotebookOutlinePosition[    370271,       6438]
CellTagsIndexPosition[    370228,       6435]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Copyright", " ", "2015", " ", "Thomas", " ", "Trogdon"}], " ", 
     "&"}], " ", "Deniz", " ", "Bilman"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "This", " ", "software", " ", "is", " ", "distributed", " ", "under", " ", 
    "the", " ", "terms", " ", "of", " ", "the", " ", "GNU", " ", "General", 
    " ", "Public", " ", "License"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.634487098998006*^9, 3.634487103574916*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", 
    RowBox[{"NotebookDirectory", "[", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AppendTo", "[", 
   RowBox[{"$Path", ",", "\"\<~/RHPackage\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"<<", "RiemannHilbert`"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"<<", "ISTPackage`"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"<<", "ISTPackage`Toda`"}], ";"}]}], "Input",
 CellChangeTimes->{{3.568127731235124*^9, 3.5681277321837473`*^9}, {
   3.5681277635170107`*^9, 3.568127768420763*^9}, {3.5681278731577663`*^9, 
   3.568127878261003*^9}, {3.568127909717389*^9, 3.568127911235106*^9}, {
   3.5683801532743464`*^9, 3.568380154503632*^9}, {3.568397641432334*^9, 
   3.568397642286002*^9}, {3.56876310866968*^9, 3.568763115868435*^9}, {
   3.5687631957518597`*^9, 3.5687631994379807`*^9}, {3.606342142888665*^9, 
   3.606342144367857*^9}, {3.634487095857211*^9, 3.634487096606947*^9}, {
   3.634487129879526*^9, 3.6344871433985777`*^9}, {3.634742143159111*^9, 
   3.634742145402265*^9}, {3.634742361330851*^9, 3.634742366163485*^9}, {
   3.6362227507911167`*^9, 3.636222752517633*^9}, 3.636544524018591*^9, 
   3.6365445832520847`*^9, {3.636569231616334*^9, 3.636569233030232*^9}}],

Cell[CellGroupData[{

Cell["Initial data choices", "Section",
 CellChangeTimes->{{3.6068244794414597`*^9, 3.606824481336763*^9}, {
  3.6071619475467978`*^9, 3.607161953752968*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"A", "[", "n_", "]"}], ":=", 
   RowBox[{"Product", "[", 
    RowBox[{
     RowBox[{"2", 
      RowBox[{"a", "[", "k", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "n", ",", "500"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B", "[", "n_", "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{"b", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"n", "+", "1"}], ",", "500"}], "}"}]}], "]"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.634580100752487*^9, 3.634580101102833*^9}, {
  3.636549971069035*^9, 3.6365499723908863`*^9}, {3.636569944909704*^9, 
  3.636569946104454*^9}}],

Cell[CellGroupData[{

Cell["Quad solition w/dispersion", "Subsection",
 CellChangeTimes->{{3.647343317059429*^9, 3.647343322728187*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", "2"}], " ", "-", " ", 
     RowBox[{"1.", "n", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"n", "^", "2"}]}], "+", "n"}], "]"}]}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{"n", " ", 
     RowBox[{"Sech", "[", "n", "]"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "[", "n", "]"}], ",", " ", 
     RowBox[{"b", "[", "n", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", 
     RowBox[{"-", "30"}], ",", "30"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ll", "=", "100"}], ";"}]}], "Input",
 CellChangeTimes->{{3.647343325872445*^9, 3.6473434578999767`*^9}, 
   3.647455558712944*^9, {3.647455634267282*^9, 3.647455634647936*^9}, {
   3.6474556648723917`*^9, 3.647455694935977*^9}, {3.6474565739354553`*^9, 
   3.647456574486342*^9}, {3.6474566116396008`*^9, 3.64745661191393*^9}, 
   3.648225441014339*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJxF2Wk8VV37B3DHzDk4xhSKDNEgUxKxFkUiJVEyJdGkUAm3BmOmRCEVUolo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     "]]}, 
   {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwUV3c8198XFlkle+/xsffen/s2y0iSKAkZyUxGA8mIkJJRCtkyI/Pb8Hnf
W0ZIVlb2FsmMJPTr99d5Pfe87nOee1/n3HuOkPNVKzdyMjIyKkoysv9b7ZHA
73//6qLxnqmcwKqnpIrNglWTP7rIgtm385vwM5IwXf9myrYuAlbTWW5PnpGO
6Kruif/QRaeFgzOyotJJw1lbdJbDukj7/c8ivpuZJIv/RJnS+3XR4cz31+Z2
M0kfus6yzXbrIpUFJiPK8OekErJ6vpsfddF8Krv8zaQs0k3n63I5tbpo9BoT
rZJHDmk5+IXSUqUu+k3gXU2qzSE5pQyoqZTpok+P65+aHcolHW9SA625uui9
wirzXFYuiV3s16m1h7roeazrL9fveaTaxRvXMA9dpFaerJPdVUiSIC8OinfV
Rd/a1O81Kr8gZXIP3epz1EWQn5uq5tkLUpSZRuQVG12UahOZy+pVRLJ6uZP8
yEAXOfUlVvcQSkgtzRJpw0RdROn5lJL4tISkNX4ug6Cli4YO8qPfHSslCTO8
yX+toIu8YllZGP+Wktb9btVO8umiyek9ReW9cpJrXMlrKS5dVGfN+lQ74iVp
KPdrQyCrLoqrmmwtpKkgoV7NZpqjukh3IPz8J/5K0iOV3X6FHR20k80a2lH7
iiS3E/wrvFcH+Zd/1lzRqyF1X+uJd/usgxYtGsrbcmtI/t/F+U1bdZDaPcP8
CIpaUv14nyELroNSL+URyztqSbrNcsmFJTrI+qDl4u71etI4MVo0vkAH6bKS
L7bM15PCX4+89s3WQfi785zw3H+kprLYCfXHOsiP53DlRYPXJPPkaZn2cB3k
lS5a91DlLWnlqCaqCNFBVyqiN9fr35IeRSeeSbmug9yLdFnHtN+R+m7qBNt7
/8N5JkG3TzaQLjg++bhiq4P+s7GbOpuEkzxlTJ1Z5HVQ9koqw/iX9yS6Fzlb
vyR1kD7p/atYmQ+kCoFfsaMEHTR4saX6e8wH0gZzQWUhtw6q8vQU2ccaSbd+
7++pU/3TL6ggefxTE4k7wPoR7yEdZCZ/UfylUjOpYblU5NCeNlJNeJjCmtlM
Ipu0NW1f10aHCspeMgS1kGJbqtLsx7RR81xZ8VeslSSF0UjrDWmjTWG+BO83
raSONw646BdttHFDgcJGpY3E+PLo3EqrNqoYJ+ldUGwnPU1xU4qo1Ub7+S5T
ESYdpCInrs+F97XR+Tvhbj1h3SSrjJDDUzHaKMvT5LnFp27SQf+YNm+kNrLO
Hvsry9VDsjHLK02+qY3mGvR3ZN70kA6rScfecdNGEaKHZeePfCG98nsA3zpp
o6PCmJecyxfShbLV7a0L2qjzwbQtA+kLqVqw1s3bShtdrTqYeh3UR3I6qmtw
HmijpFTJgYg//SQ64+zgVC1tVPPoPe52aYD0X/ih6i5VbZRtYKgp1DZAot9u
FjSW0UYlSVc59LIGSQ2TFgdKXNqIxfBTFq/TVxJXvdMbuk0t1PFTlSzRdIzU
tPZh7fiKFiLPOvvYsHeM5CctKhG1qIWYA2l2fOzHSa05i09+T2ghxbOexSY3
J0jX7/sHzndooXt1jAH/LUyShFv6yoRatZAVecgopdoU6TOZ+ox9oxaqdynw
w6OnSITrf05/eaOF1tZMz8VKTpN6ne7Koxda6Nxl1hTdqBlSWMb85T+5WoiR
Bd9KH5shSQ6cyFJ7roV2Vznk0zVnSeFmx469TNFC1nyfvDK3Z0lyak+WnoVr
IbJhpur70fOk+0eLCwPstJCeqay/z8EiKU8nsKvlrBa6dv24q2PgEum1D/ab
6/Q//tSBIvflJdJ815A5Oq6FfCefM0xNfydhqbQ/6VS1kGE4Zh2/9INk29zP
56Sghb4wMBRi/isk3+3c4zXSWujOcG7Wxb0VUsY5rYzzwlrodf7T1D9H10jb
vF76Lxi0kLvrtPuG2jrpmIW69+8jWkhN72gxZfQ6iXCH4ok5lRYqjFK9Gty3
Tjo9lbG4saeJsrhSXuTe2CCVF3Y8Akua6IlLbHxm1ybJWU5uYqhJEzEs3JK1
6dgm3XLcpZFBmuhY7jv5V8q/SI8etSjdeaeJyIpD1scyf5FIGw4xotWa6NE3
vrH+wB0S53+Jsv7Zmqj5edJ7cZ1dkty3C7bN6f/4Ql0UGWp2SUZcEhGcTzRR
ijNrLqPMH5J/COrDEzSRkgp33j3CHukzWA85GqyJ3h8SzLZTOCDN+pEKHYI0
0RL/+0uibw5Iu7lxXVV+muivbtF3O8O/JInDwiLn3DVRi8s6O5ciGR7ZatVe
YP3vPItJhe4Oh3CN07WcRHlNZFjNe1JhjwK/PfOiR1pKEwmysjj6OxzGPwQ9
i+cS1URfwadXTz4cxs3Sw/Z+cmui0AwuqbJHlLjDzInJMqp//B/EhZiMqPH8
IO1nzw5ponja8Ypr/1Hj36jlrO7taaDLSzVXKWRocH8ZlibnDQ1kOUN8NcdD
i0cHjRVxjWuglozSuXGOo3g7dbcT9VcN1C4c6Xro+VGcPv0D19YXDfTC5ePK
KwId/hQvut/dpoG691/aLGofw8up/a/eq9NA5lo33WTuM+C9z6jUtxI0UDPJ
YvO5PTPOIfN7dfqeBlIP+7TwqZ4Zt8e/F3dHaqDRzYa1GmYWfG66m7v8pgYS
KotU6etiwXekMw6cXTXQg0mCm7kTG66LP/jP0lEDqdXGtmFtbHikZbgf0U4D
EV7WxqqrsONHg9ymuSw10G5+0eMzjBw4Py7f0q2tgYpcsujdpjlxF0vhO7ja
P7734dLx9lx48TSrRrmixr98qa+m/MqFK1LvltwT10Db/DUrsl+5cUPLpgdE
Fg3EvzDKmPSLF/eaPne2fEkdLdzNmfw+Ioi/VbWtXptTR2fFvRbpJYVwmriz
DKpT6uhIg55i8g0hvEDeqo00qI5CTOkrezmF8fFQM92uJnX0saqDecNbBJfp
NklnQepIsecKxedmETxE5MQv23fqSEiAPk1XkIBzthtWTVapo+jVG0V7Xwm4
FQdRdCNLHemNZr9tuiSG53jqRKqlqyM1grQKf6sYvkrSmgh+rI7UH860mCqI
4wmu6s8oEtTRoYnpZ0QqCbylSuEY2y11tNnVczSqTRLXMhfZUj+jjgbsb2s8
rpPFY7OFrEIt1JGnF/eova4cPrghUIlM1NEIJ21r4kc5PPAZr4cJpo44zO/U
uMzI4xXzbGN2supoKLbfhJxPEd/TZNXKllBHdUFf15W8FHGzB8xpMyLqaHrr
GU/rW0X8mzLDaW9udcRjo3lF00EJF4qgab5NrY6S7gzcWKtXxv36qIQ/kKsj
2fKP+3uMKjguTnmH6kANNR9v28r3VsHtOg9pJv5UQ5a87PfGJVTxVJ4/5TlT
auj5u5hnw3VqOE39j9TGd2rISk2sjkpSC7/ryRyRV6+GvHxX/8aVauGHBNR9
IqrUUHaPI8cDOW189164EShSQ/yhRFlDog6+fJ5l+22yGlr2oNsbu03Er9Br
TD97oIamxtR5W1gBPvfBvvNmrBq621oWkFYB8HHpFy/UwtRQUURHXVoQhvfs
a9hWe6gh3cft/d+b9HCL6osGSa5qqLpK27ufVx9vvxwp7+eohsojufb8ruvj
TV2fqOXOqqGsa1qPJ+QM8Ppch9clmBriPEH28mGdIZ5udJcrl0MNHY9V0Lws
fAJn3y2mDGdWQ4t/rV+8fnYCT6n4vO5wTA25ZPkU27KY4AkcHO28FGqINqJ7
uviYKR62WBL8dEUVnVnu+jItYI7vPu+8fGNRFVXHrrDPlJrjN6w2rWxmVVG9
QhLpkcZJ3O+djjTr8D9854SQpL0F7vygaySxWRVh250PFpwt8XG9nx99kSrK
atvoHq2xxC9sc9aefKeK4lITeS9RncatHZ0TjlapoqC6c89UX53GjRW3dO5l
qiLNXUb+FY4zuHQ/d1ZYgCp6q+EfLQxscObwktAgX1WUak+H1ktt8F0pjQve
HqqoU4pcsp3TFm8PP8tp56iKxDO5dki7tvgVmUfJqmaqKE8jS7Z76DxuOch/
TcZYFak0nsSobOxwjciXp0T0VNG7q1+cn/Xb4dRD7XRM6qqoRc7n+eHRC/iL
KMp7y8KqaEzAM1qb2gF/KJfqNsOnik6/lTEofOqAX/8qbDjMqYp8lU5c/izj
iBvJY4da6VXRDlfNXoucEz47HBySv6uC7tryC0leu4QLKa1dtetVQZE+MnTL
+q44zViYxenPKkisoHlqu8AVX7t3TPZEqwqyzGqZG6Zxw9GY1JIqroJUy6Q0
rAbccIc4N1emUhVEW8zVeCjOHTdW+alPU6iCyvMDS4Z23XG5iUihv9kqiNnv
CezzvYLvq+SMLz9WQTQ/xTbdLnrgmZPD51ojVNAPbLSZy8YLv3vfQx2GqqBw
0SVp42Ev3Ftth63+hgoaqxtZXnXyxrUT2L7k+6ggQc/yZ9+DfPBhdcuTd86r
oFMWBIEpeBXnSGzWU1NUQUkUckr4VX+c5o9jU5SMCuqezDNq+eCP717eNe4R
V0ENFzn0DTgC8FGivLk3vwpqmiiXrG8KwPNWntrkHVVBZ1ID0nSVgvAUO+Wv
q1QqqJbah7k0KQi/2/L5gi65CtJ5eHz1w0YQ7p5FfmloRxk9UXKb5Xh7HZex
8Pain1dGDUdjGiUcbuL8b6lWLkwpo69q3gE9n27iDGK5fiWjymjytazaZe1b
+MZ+f5DhF+V//VJ72HXBYPy/lyA8GCmjQuMXPjIUobj+MZbH8+nK6LCRRXM+
Vziucuslh8oTZTTam7lJ4xyOi84dT49IUkZvHm7UVJeF4zSk0GzeWGVk3Xjh
5ZJ+BP7Ze77EKkgZOTpO+SdFROL4ULhMjp8yWhpaug77IvFXhjyVP7yUUdY6
i7azZBSezGtZG+usjPwLF0QEB6Pwcx1vcPyUMopPlm3TMorGTTWs9ejM/sUn
RNp/KojGtQtWGs8bK6OFMaV9aqoYnD9UpO2njjJSbKV2yf8cg89IP/giJaWM
1FfUjuj4x+K+952+PTmsjGzYJ5RUOBPwh+eEdsP+KiGllmPXGHIT8Jei00fd
d5VQndAsFiXzAF+GLvLqa0qoaXOH0d3sIe758/L1wREldLg8Q+L42Ud4/Hvx
WDighH6wzVd9LniElzz89qyoRwn5TBwoDWw9wr9JeJJufFRCp641e8RnJuFu
F30Oc9YooRO+vs+s95Pxu1Jy7GQV//D16ln8fApe8GtF/FuxEsrebb+5+F8K
Pp3kZ/Y6SwkxbrmH5d5KxZ1aApLPxSuhfPNF8VSWJ7i9fLDgs0tK6N0VQtfn
kmd46J6WUoS9Ehpc7zhIFkvHM9r+GHjYKqFPnm9ItYXp+LDLbXfNk0rI+2/7
a+2yDPzc0/CKrxpKKHk9Ibqg7zl+000PvVdWQsv913KeuWXhaUrkvSVySohp
ObzW/HcWPtARtXWLoISmqGV3HrHm4NaH7ulwMyqh3tbgUEqbXDyw87gF+VEl
ZMo0qqlRmounZNA4LVEqoftKQzfIyfLwXtX4qLd/FFEJzm0e+ioPt/R80G63
oIh4+ZmvzIkW4GZfUs5l4IrosI1KBaNnER54yYl++I0iUrCneUXXV4Rnrco0
cdYpIt+TaZXzoBhfO9oi/6RMEQldHT5nw1eCpxruUCU9VUTysx2RnGulOKm3
qaErRRF5uVkV/PIow+edkvzpExURognk2psrwzVuS43fj1ZET21kXmXMluNj
dfZ1Mf6KiK7y5MHJ/QqcylDSq9lHEWWc1KC9GleJK/RuCR72UESkF5KlFHSv
8MiVhwkRjopI8LbCMbesV7iY+HuXUHNFRD48rfajtwq/+lSU2V9MEXFJxNj4
h9fiT8U2Pr4SUkQfZ91Ljo3V4h9q8durvIrovdxGkYl2Hc7aY7vozaKIyJgE
NtBeHf6aNh65kykiwtbiXnjqf/hUms31F38UkJTxAMvWwX/4ETERmbltBfRn
JnXwuNdr3F6/Ic35hwLyvn6KsszkDX4oZMX34rACijuUkn+B/x0uRfuOkNmv
gDaNHbv+e/oOt067NzzcrYCwNud+TbYG/EWNoPG5jwqIMjONZoCVhJsuW/Gd
qVVAZp6Nb2PkIZ5y8b9PJx4qoKDA1Xb6lfe4xPSPgOw4BdR1M13OQPcD3nCZ
wLt9VwFpyB3sfnnwAZ+9muSdH6KAplPeNAgrN+KqkV7HDq4ooFjfGgXhxCa8
nSqvztpVAb3azrkxv9iEO9wfuljmqIC6z+kjTeNmPCbVqOKcjQLi9x9+U0zR
gg++EDhVY6CA6PrGnvsmf8S9pW1+0QIFlN6UdMtv9yNO9ioh20lLAX1RYtTV
dm3FJd78Xj2mqIDIWbt6THXb8Fufvjy6wq+AROwQlyrVJ1xtkqFQe0Me7bqe
bGna7cQdFkO3vn2TR+uvVovNorrwexuLRk8m5JFWRxuJlbobHzrcNL/WIY/e
nBIMjnvcjQdL3pR4USSPXt0PZHZ534PnKc3dPJMlj6ZK6MSfMPTin7St2sge
y6NDq0foBB17cV4LGc8LkfJIv7L93SnyLzjuP1nGeFEepVcbRLWe78PnQ07u
kc7IIxZlcr0LNX04Q/Rbcy9TeWRYccP5On0/7pSW+qNZXR7ZC+TmO7X14+QN
J+RDmOURDlatPloN4scpq6rnPsoh6e6yLuu3w3hHt6dQK0kOrXF8NpzXHMEt
MwmPSmvkUExL1JP+dyO4nfJTn6vZcugnQer1bsso7n3pjsTv63Lo+TXJ/YI/
4/i6jGbaiLccCrbNP/BInMCv72xQ4s5yaCoxnWebeRK/k3h5JtJCDtHVKvFV
vJzEk0kns+jE5JC9VBCs+jmFc8RRH1vlkUO8FzI/GZpO45nW70N6mOQQzafs
ZJ/cabzwu8r5J/uy6JxCl3WW9Qz+mouXVbBfFlXf5U+w6ZrFx4OW4pTvyqIV
weUsb75vuItewQ5bsCyqNCsZkHn0Df9G5+C+c1UWkW3hYnSUi/h6fo8h6YIs
6vnkIm65tYgf7n3911hZFpUI3K5gXP+Oxz7395WUlEUO31kDvgct48c8ZMaO
CsiiYVpOT639ZZydLOdt9xFZ5Hwgoe/CsoJLyt0LspuWQevuJ72eyq/hFb+x
WZ0hGaRjaEgWFrqGKzXvWgl0yiB2s/rBzvY1XMfeV2H2jQziudPL8NlrHbeI
P/vdJ0kGBe+Jft2HG3jgvMilCEwGieVD2Vf/beF0KlscTOoy6NzarBeJYxsv
iGjpzJGVQeMNX7f9bm3jfbweOohbBun9DZta0PuFq5yp4Pj7UxrddK26Pb+w
g3fk3Ol8+F0ama0+aNw++xt3XbGM5p+WRktF4SFLzb/x1LjNDd0uaZQy2mLz
vGwX/wk1OkNLpJE80xMtwcQ9POHYkWi6HGkkOKGWo3VsHydcGNHOfCKNKpmE
nMMe7OPW27dL3kVJo1c7kZ+LUg/wWpnGu7sXpdHWI1MaU0cyGPTspPZNZmkU
XgQXfzWRQ/oF/g1qWmkkhRes1XBQwBcqa8Vpf6XQ5/MzJsNeFHCgK5n9v2Up
9Owxa3EY52GoRjW0vtUiheZn6haGoihh55mS4miSFNIf6st7Nk0JL+cGO7LV
SiFue8uZHX0q+ESH77NKrhTKeE+Qr6Shhtv+zsUBIVIoIZzM+GMxDXyIlB0p
/KXQKeOomuNstFCMnpI95YoUqnKUMs2LooU2JUVR1WelUFDPZyWqy0dg/cSy
w7q8FNIT+Wbnr08Hr5vfYLs6K4kW/jQZdyswQk/7x0vKw5LoTaY2XL/NCB28
a+BOlyR6+OMRdXgHIzyesOoR+U4SvfTvnNr3YYKcHe7442RJlNZzPl2vkRnS
jUan2MVKIjHZiKz7vCyQbDn/ikCYJFrzjvMOucECF49OMpd4SCLbpSo3LyVW
+NbsnHsDJom+q7aQfEhssOLCdZ0INUm0aRrA1EJgh3leqUzGMpLoYn/8JuVD
dnj/fve7Lg5JJLJ8SdLpMge0/3SCcWZFAtWIsm5GyHPBfVPNN7TPJVDB4cQT
kjJ8cMPO9mFnsgS63h3gFVPPB+c9g1xSYiWQhaTwI18DftgZX3WML1AChTGd
D2FwE4BZ7ZLOCmYSKDLNIv/6rCBMHj6uvoVJINnVYq3bKkIwZsmN7q2aBHLK
P9f9J1oIXj2SV28gLIHYj3F5hsoKQ8yU+6jtb3GU+mcjxCpRBKrYaUzyrIqj
wls8thPfRaCEp03d5Kw4SuMjuvObEiBTfLKjZ7c40j1p+6n3qCicbjtSe7tI
HOWe+ym3WyAG75r8sS84K46+nG6xWVWVghbGP9ifmYmjG+SRtPaVUpDLYKL7
gZ44GhgMVN6WkoYVOo2GN2TFEePVuy+GJWTgkPx9GVNKccR9Y3g7CpODeTK3
54l/xFDC+1nRkA456CN5NUd5XQwxmwksbdrJQ3KRM6x8Y2KI4F27+AkoQBl2
nr3VWjHEmRS4citQEW4zH6ufLRVDq9c04gSbFeF7hr9Xv+aIofYqRx0NDiVo
Qzsz8yFBDDGpefL3QyUYvlf66bGrGLpT3VYaKaIC+6a1MrRZxZBrVIggubY6
zJqQOatwRAyZvgw4TPdCHXqM8jOIkomh/4qjeA6YNeBBP3kU/bIoSt7bdyFt
aECJtnbPqUZRxB3F45DXrgU3mhsIA29E0ZSd79d5I21I+lAx3l4pisROvkiw
b9SGVg3JVrUZoujejoIcRbMODK2007oXIIrsaA3Y7GeJ0Ljc/GeIhyh6/Vtu
6rg/gEwlxAo/R1H0dmjZ0v4QBl/kCQvbmYkioWuvFMoeY7D78RKtrIgoavF/
0uzWqQcJocFfe3sJyPRbUXlrtCEk/xM1EthGQEHuiy+dxwzh5K0HY+yIgF53
dFn4qhnBzBs5U3YvCejKsGzCxrIRZAloWZy+R0CUw2LyF72Pw7X1ru93wwjI
nO3ue8Xu47DT7+sPsSACchCKh6WqJ2C87/K6pzMBNZ25ZFdIaQLJPZl3N3QI
qDB0qy7yrSmc/Mazl6pMQKGbMalAxgzi7qIHalIEZNltc2c42wzectMgD+Eg
oJHOCxFtCeZwzcnhCMWGCPo8eczZO8wCTtiWcrMUiSDubxGm3K6nYcNADW/d
cxHExjj8YfTlaZh+lsRvmyqC9v3Nfn3ZOQ1tznQLZ0SIoIdQOiow2Qp2WmxL
idiLoGE/nI++/wws//xXptlKBG0yGc9TSlrDeHNaeXcTEXSuiPeSfZg1NDLl
VS5TE0ENV7wO6ciehQ1G+trKTCKIWkVp50qmDUxvMtPtpxZB77s2m3f+2MCb
BmfBjQNhpGJ25BP7RVuoonfF4N13YZRxJPUIB+EcLNN5aGbQIoysAj+uTjaf
h+nKwxfOhAgjjuiS6v8cLsK+QIVQqWvCKNTgPNnq7EVIXx+TechdGB1ldvSM
9HGAkRrKY5VWwujLs2n3hWhH6Kmb4EAnJYz4RwXdvJecYEHYdNiMgDB6xVJu
nKh+CY5Djey3bMLIbYbDjS7mErTSn5u4ckgYTXt6aMuKO0Ot48RLzUNC6KmR
mUR9sAsMjE2NyOwUQoS7BAHbLy6wom0pN6BJCJ248KrprqwrFDZPmxZ6JYTU
3JMdcudd4ZHTay5h94RQgBfTkULvy3DELu+yupoQyufzOefW6QHZMndi6GWE
/vWPlJL6Bp7w1JhF0ZyQEEr1QV/E3nrCRsc/CynHhNDyERVR6QovWOZq7bE2
K4gOWo5tCrzygXOFpXEfhwWRn2Fhn5aaLxRYICvN6hZEs1tHLItxX5ji8XLJ
vEEQ1QRgXvkDV2GIL5V3SYog8tw32+BnvgbrKu0TwuMEEeKdZKVxvAZX16rL
be8IosXrX+iNXl6DLgGOPyi9BJHPT/GQnpP+0Ozma19nfUH0ftKVczg7AKof
7p9WmxZADgKsZ2UeXIe98a9qQJcAKhSa2/b5fh16MyXcPdEggO7rOhgpmt2A
efwGYnZPBNCu+8q6NcNNSKdZ5XHbVACdd2gbIZXegkUwQStGXQDpRx9Lf8MW
DPWNrxxNJAggvQaBEI/IYHjjjMDLnAN+lKC3V0l2KQRO+zxYa6zmR6bGLj1d
yrfh7Z9X3ndk86Olw81zci9vQ84Qw+T+hH/4KvlIsEQYPBn7R3nhMj+67fn4
0y/CHfg6z+PGER5+pOz73EUhIxw+HDQ6sIziQ8LRdwZYpyKhpINQ13k/PvRu
sGuPST4KNs3uZTtf5EP7WtFqJmFR8Pd6jV6gOh8SrEigvCV4F7rSCUenfedF
id+rx9wDo+FB8v7ZnCFe1Gcfsol3RMNnXF/FSpp5EZAYUr4pFgM7xR61vs3m
RcQatTyx8RioqXdwdPwML/I5/ynqmGMs7Pv4dXQe40WFT8VeMzTGQl+Luper
srwo3TLnd45EHCy44H3qEA0vcpC1fx67Ewfprw8nExp4UOYQ3R/O8vtwtrSe
y4vAg1yex4wsuydC9Xpp8XEGHiQ33X23cCMRxr/PUTn9hxtp9f9hGwKPoMJQ
/Cn1Xm40d4K1xa/7EbxN6RhNEc6NTAZ7MlzIkmE3Y1/ydS9u9CzkAH90KhkS
eE1yFm24kY3TmWH6nGTYrqT8rkuWGx1g6ZdYjFIguxP1esYIF/IytNsczE6F
Hl6hB/QfudA8T9Mjsd1U2HB9/WhkNRe6WfaSdvPsY+j8YETsShwXCsxNesTH
/ARWvK20V1H/568rG3N7ngaPs51r7UjmRMthlcbXKTNguuDnfhDGic5VyfPn
BWfAFWn9mWoPTqTs4Hmhfj0DpurLHDzFONHYfCVV/VwmnLxKpuK2woE+Gj5e
WJzLgsohQXpDXzlQ9t0UMgWvbBgTs2Rh1syBnCNwtecb2VDmeZ+HYiYHIndP
VqC+mwNvthdn75twIFz7+iRfUS781M/30k+VA7HNpdL2b+RC/qnktzOCHGjO
LTznA8iDTb9C+9t+sSO66oTcM2N5kEn09NEnhezoeSUfa694ASy98296OcSO
XjRvNT8/eAFLXdktDv1gQ2rT3zeIDkWwxERZtG+IDYXL8L48/686ill8vtx6
xYZGq6WkmWKKYVHRpHyzIxsKOBsVISRWCl8k7FM9NWNDG5zUY+LJ//A17nFP
dTb0JYhavu/vP6xtncDIwIY6qs6LqE2WwYKuj98u4KzosMz59Za6l7CgdhbK
lbIiK3xRoUC+AhY8O5R26AkrMn3KtG1bVgHzXbSNinxYUfFtuQz74kqY96si
d4P3337eB16to69gtsATu7gQFrQA3EZPCNTArMM1ivbuLMhQNeNe6L9eNGux
i0b+DAuSU+3y6X37D9fQ/tcnxYJ49lT7Nu1qYebx2yyCw8xIevCp9o2SOph+
1bWjXoMZXbOWbVmOfA3TrSPy4wjMKPfHUxfW2dfwmWZWsD0jMxoOZYp7bvwG
PqUYkiD/xoQCN5tPzDG8hWlpZtEn05jQ45lc7g8172AqVCLObjEi/bc/DsIN
IXxbHFbINMOIMoZcItPqIJxMaqcD3Yzo14yHDgMrgrKuziPPShmRAgEQW2IR
bKFJvnnKkREZdnQSJULew438abegJAZEP7roZB/dCInXg1W6vRjQvU+C+Sbt
jfD+CWYKaWMG1Dca0krH2AQJP/RyJnfpkcv2eVberCZoq5Y7bOZKj07L/y1O
amqGDa2Op4TVj6HM0Rhzd51WSJPxi+820zGksfs7PS6xFZ71SVwe/E6HijJf
fXo+0wpXmGDcgxw61CIVLpf3sA0KXeBv2qGlQ7OCn0eN1tphzI9Rja7RI4iS
45qq8sxnaMlsJxwaSYOuWbaMBB/vhfQrBM+y8zRI7gVPtXJML/zUtlo1rECD
vHLd0uKbe6FxRLSe5gQ1Csz+aM5k/AVqr71y2tamRsqP6l4HWvRBsU7qbL8t
SkQfeGSrN2QA7sXV8bhdoUDlhkeuyOuMwLdu4S6pgAJ9riJUTd4fgTf0zMoa
2SnQx3fzFfMjI3BjZ1JLuJkcJXEeVA2HjsIFdzq7CSFyJPvjqe7r92Ow18jl
6fkRMuTze4kxSGISPhKSm4ytJkPFSlyLZ09PwpP7O+Kv48jQ4OsFbuHgSdha
+/A/dg0yNHmLh+Pyp0kYfDzwZZHkX5jlkWq84TUFT1EIS2Vm7kG4mWmznTUN
XT8F7Lpa7sE+F8zz0PtpGJzS3C57eA8KWzwZT56ehgUiHl7Q6w/8KaYQKkGY
gbsGr8qntXbhG4JklWzODGSkI79dtvIbSqqMZISSZqBo35mTgXm/Yd8bh5gj
wzPQ0vXXD8ojv2FdaWPTW8ZZeFnGBO8k7cDNTkRolZqFIT/TH6Zd24FrEnGZ
Swaz8MVdorzk118wnqaSQj9gFjaYP/q7nvALEkQZZxzjZmEP63TXW+wXLDqh
9c41axbOjyrnRP3chuVFjx0Mq2fhXkG0n3nxNkz99MVho2kWMvkMYmz22zCN
jZfeeWAWiqlKMo0zbMObfAHhMfOzUGc/eOpF4xbsfuP0wGprFp5u7qi6emML
aqYN9bwmn4OXH/BHakhvQfJzHtVl9HMw9Kyf1aGJn/Crcf1FPq45mMT3Qbg9
+Se8Wg26/grNwRdzLJvJxj/hS4awXkPJOdjw0q3xwu4m5DpkTTUuNwd7gv5L
IVRswgP7kckGpTk4r0vr+uPSJvwAkmp6VebgHuUFlXq2TegiMlfJqDoHmTvL
D99p24AsQ3LL7spzUPzJQd/x2xvQnoXBo01+Duo4WBYyKm7ABi4ih5jUHLQS
ywv6OrsO/do/jfkKz0H3lU2jvKfr0JyuLyeV85/+eiN2L/N1WGpYeiKWbg4m
h6XNK5OtQyr+sDatg1lYZLxYv1ezBq9eC5F+/uPf/dNr32t2X4PxBZdTcoZn
Ye9Agu1DnjXIq1NvptY8Czt1SacqslbhPpLsPPVyFv7+7LQGqFahtvPY5/Hk
WUhwOJzU47MCc3eH9PqDZqHFSpGiS/8PSDDl9BO1mYUF9Kv+MQXLsCYjdOY5
/Szsykpm4aRbhmc6yEvK5//lm5xabUnAdxhy75X+9LsZeOrU7a0O/SU4/d/j
/NSLMzB4QvCJQ+ki1JEIsNqTnIEFV5vU1pgW4fhMKnLanIa7iUdvskwtwDDm
ldr90GkoKljJWXhiAQ7WGhmJ605Dy1dWb9RezcORWxIt8rtTsLD72e75O3Nw
/bu78r9JDVoySdzO4ZuBlVrC+LDoJJzwPeKlEDsNb00nfpzPnIC+Hcvn0MYU
5KBt/I/i2zh8cK9KZfLjJNQxYsgX8x6Dj/8EDYHZUdgw/3e9RnYY1tZr1Tq+
GYE0r8Y/fjn1FfZe+5t45+EwZAaOQwHeQ5DxW+xxqDEEP3f6jNQ9HoDxfRn1
xAdf4LBwh4tveS8sTnRKdnDu/Tf3P5gretEDP5qK+oap90CH8dQ7lZndkDby
ollo42c4foZRlXa3Ax7YRUmGeDdBjknt89lSTTC8c83+4cJ9OFX1I3t2/j48
l7FqvfzNH+wp0wlO/LPLKmvndK+kAfPN5JLyy2kg4YrMmqBzBeCuGT8aaF0B
5PTmLsatIvCTiap3tA2B9fYLL0yMGsHTZvhz/lgjqLXuXaHNaAbtkjrR0ieb
geYVeCfeuB0Yrv1nZPCuDeR97Ohu7uwBpx7PUvaK9IC7dDRbhb97weYu1a0q
6V7gdtqAK4bQB0QcjycYyn8BEiNvLhkHD4DuoVJDKNEPXq682GgRHQHPRTy9
NSaHwEPlafYiy1FwjedB4hf0Ffjd5NO+FzIG9G33WCYzhoESeWrU8Z4JEC+3
UzODjYLReOyIK3EaWPO6x1gb/lunTlaPnJwGlT+rmm+RTwKNuzOuOZEz4IFx
Npey4yRIuR0DR1tmQTXVz+2hY1MA2x1c3r0yB7YeyyU2OU6BleuS3FxH54G0
/tGfHBVTwNSvI/DsqQVwxkhAihKbBjvLfHkB6wugKVj+V0nUNHjhcbUrKeUb
SBx8c6mj8Z+OebRXqboIqEIiaILIZsAhF2apzsFFYDzIU/RScwZUTLjYLt9a
AkJ6OuQRV2eAvX3d3SO838ETG4m+3dwZ8PrsuQljp2Vww2aKj21/BlzuLaFz
I/8B5G4ISPWIzgLWU380owp+gFsmjlWeZrPgwydz91zjFaBza05g3WcWXD2R
lQq/rYAK6n2PwAezgLd59f1Y/CoQ7E/4c7h0Fszl5Py6zb4Gkn0ti2saZ4GO
own9A/c14PnmbWbS8CxI4dsgZL5eA80h9069WpkFSyPp2mW06+C+3t8AIbI5
gKUbWL21WweX8NXlbfo5kHZu+Upb2TpYij+P9HnmwAr74ztDe+tAZ6f3KIfo
HDDq132ycHID6Fdk/Y6WmQOZKfPl21kbIHgyoD5XcQ5snk5spFzbADHsW+6h
KnPAlFFjmFVvE4z09ohIqM6B3M7JNZHkTSD98eFCvfIc2EmIo1ae2QSJjauP
tBTmwCkzJX59lZ/gmuDBQJPUHHhBO6JyOvonIDv6wsBdZA7sf4wycxr4CUQH
ZmWVueeAdYyM81XxLUBNjKzVZJgDpYb9N8NubgEZd4s398nnwCGKsMQHbVvA
3Hx8VPPnLDj3XuxFJvc2mDFAwdazs6DiTldDmdc28Dkh/OJ77yygJN788rZh
G/S/mRFjQLPAfk9wqe3YLzDoTHejs2wW1LxtI/vq8AvIlOQhjSez4Mgtf45v
lb9AxvrwiP2dWfB6q9GQymoHyD88bkxnMQsYar0vsOXvABH6mZwa5Vlw2Z/N
n/BzByiXuUybc84CltXL2fpPfgPyG8m348ZngO832t2w4V1Q9SBjKsZpBjS/
qGZ8KP0HUP7az+cBM4DX7YL489A/YLPK1Iacbwa0T5Vbv+PfA6forE6sDkwD
0ZFTlb+c94HT8O2584bTYDpWJzqzYh8oHs1W4hWaBllqkhf0dvcBhY6lQOz+
FGBPJqe+n3QAqI3mqW7UTQEqkzoHfvT3X0eUBe2Fp0DghWP38ugPYXx6K6mU
SxPAps1frc2LAktemHNNVR0BKoIeuRlJFJhp2vkU5uVhwHzDkc73PwpsVa9Y
YzpvGHQSzKeZKQ5j527V5d9lGgbHw0Uf2qcfxj5T+AUpbw4BDfWhudVWSmyz
JYIqr30AcBXqPmYXo8HutT/bOz/QC2I2yO6xnqLBsvzmvFOe9IKfoOkm800a
TNYyTNPbthd0Dpva07fTYBUTV1v2hv+9V4znRKh8abHIr5cTMxa7wUqIf9VW
3REMf5bkf8qkE9i3qeZvjh/BaDmOf3829hm0sf9OXac+ijkWnZXhCfgMCqru
3Pxx/ih2vbX8bkNuBzi/kADm9o9iq2PvKCyPfQJNVkWf+4yOYfkmPVXKvK1A
KccT9voew7rubysTGj+C7B+yVd1px7C5DfkaOa+PIDi2NrVj8Rh2kX9hJxZv
AfL4+wtND+ixGTE6J1b/ZpAuObpY08+ApcGP5HePNALqG9kjVQcMGNVPr4DD
Hz4ALeeq+UEWRmyii2L9VvAHUFwZONSvw4iFjukFa628B5Gmf971PGTECm6+
iOqcREAjnCaqTYkJ26go7DwzSQL6J/WrvxkzYewWK619PiRgzh06RX2BCVPn
26ib3WsATrWrwDiKCXupy9eRLdAA4r4N7H34woQNn73VSnPjLRi2LLzeEMiM
lQSn2H/z+A/M8k0UjsQyY0I1yizW9P+BlSXO/t1MZkz07CL50dp6QB6doKzZ
zIytRcU9MqWoB9JvAtbq2FiwrwFAJu9VLQgV0vesrGfBsrHTaxcMqkHMSsiz
znYW7IzqLmX5bhV49K6u9cc4C3aupPrw0ZoqUHBWUlyGmhW7YGvcsSBWBT7H
Mc4W27JiFHN/Whu4X4EhG1OWVi9WTHnzyqUTtZVgWuSu/sIdViw56vTvA5VK
sE36lSNazIoJnyB7T6tTAfg3xi/m7bBiboP+XHOO5UACcj54T8eGVZya5Nf7
UQaUEqwaJgXZsCXiR8EzoWXAWKyFW8CEDQsqv+YfkV0KfO1eDmY8Y8Pus0xa
u/0uBvBDyOnHWuzYLb7eyqvbhSDvfsza+ZPs2KDlB/q4vEIQY52UyO/Ejv3Z
X+79cqoQmM+/+FwUzY5dz196+ONlARim7TV52/3PXz/g23QjH2xbSuhPXObA
FI2N+d4Qc8Ewl/JU/i0O7L22zjXBvRxAmtYNv5LAgRkU0IKwtzngbuAZfL2K
A1OICTjEqJUDmJ+GaR3e58AaUx63O8dmAbmJPiXJFE7M3d3zpRdFBmAunuj5
UciJST49+oYtPR1s+S35Vb/mxNhQpaWZUjpoICer1B7nxOqTYk4buD8DpmLS
0haSXFjgubDcnuk0ILeq2s6sw4VpE8Ke6kenAabXmMegBRfmsxyszCaZBoZM
bIqcArmwiKbe558CnwA3nwiRAMiFuUOahm2ex+CEWsIH9V4ujJFhcPBHayqQ
+fvk0t4sF0bolfogeCMVbDwqz44+wo0FJ+dpSQymgPDaQZ6nZ7mxd9FnbxoW
JoPMP7KspO/cmEDhxjX264/Av4q7zkHGgyWy7rJdkH8ENqIYv15j5cGYK8bV
HnxJBCfoNp+L6fJg9M6cO38bH4KfvK/FHz3kwUT85zT+4glA4JJk/FIeD0aX
SFu7p58ATAvTlw3/48G+M0ixk7fdBzmyt6t+T/BgX5ZsyQ+PxIOTRH1tF0Ve
7JbfiD41exy4GVnznGTEizm0pE25lcSCghYCGacdL8bq9NTmITEW7FpQN3dE
8mKxH0wmBHzvgReOHRZqfbxY4/06sYipaHAQbuNMe4MPM77bJuXHEgUkmz82
udz/hzfPimAoEljTaorj2XzYb/EnQv6+kaA0iWfZv5UPMwt+HjPXGQFs8iaD
Rrn4MQkRJ0G/7HAQMX96SE2OH7PsiuurswkH5VKNWkn6/JipoaqPEkM4IK8p
/GvkxY89tp2Jv0l9B1Q2esZVNvBjw15mVmxboWCYevQ7bQ8/JuW4wHoQFAqo
zE9auM7xY5OfXXxofocA+z55Fi56AcxgiDnagTIE0Mz9zIx0FMCqGY/4Card
AgpRYEjqkCCW+UtQf3EtCCjlO70vPSKIfVF8k+L3JAioNEaUSrEKYq/zv4S5
6QYBTYqmUClxQQz3kX8fkRgI9KNOCEmdFMRKtz4sfDcIAIb5HkdKbQQxU4Kg
w/Gf/sC4MX5T0kkQa+Ora5or9AemFJ+bJQMEMaqrDTGDdP7gTNRpT8lnghhF
xrcN6kU/YJPvf6YkTxDLwE1vbOb5gXONKTqS5YLYc6965r2LfsCeYoBeEgpi
JGaDucKKq8A1yq5GYk4QG36L+YOXPuB6lMueuKIQBq/8fXCexhPczL87V6Ql
hAkprL/cyvAAwY2FneKGQtj0CO21k4oe4A7FtxxxWyHsrr8dYL10BcRGeRuJ
3xbCTj9fcjDouwzi8x/IFcUIYSbPj2mSBV0GCY0VHOKPhLAAPjUuQ47LIIli
fVEsXwibOyd+64STG0iPCnoo1iaEJWhexp9TuILM/Cc3XvQKYYDbXWS50gVk
Nf7nJDYqhBGl5Q+nXHQB+RS7SmKrQliWuGVGX4MzKI8KGxRlE8YOf7/jmhp/
CZCi7gmKXhLGmq3+qriSHMC3+j5CkKcw9vfxZMMQ0QGwLglJNgcIY8/CFJ5Z
fLgIvC0bFN1ihLG2SYVI/i57wMu3rl9YJox9EI8Wv/HXDpywJB7fqhXG7tEO
RfM9sgOBUffNjHBhTL6itDRW2A50LIpaz3ULY66c1YQk8/MgtN7OTXRbGOOe
cOstq7UFxYtFHkF/hbETec1PXlvZgj7eLZ9mGhFMRO78I+sNGyATlXjdjUcE
Y3rNqSekZgNGTjXdK8REMB/bygrXLmugtShbKnpfBLPOePYmzcAKXOYNqQhK
FcHWBsW8xn6dBsmnWqubn4tgJC9K7vMvT4OlOud3bq9EsM7as4cmeE6D9Mi0
jsJ+EczSlIE9l8oStNTNdm+Ni2B3/u4+JMSeAhvfFPuNvolgZoSZXQnKU8D0
VMfY3K4I5tVklxlEaQF+8xxaFRUkYCs+h0RU+c0B4ZTFZpAkARvXmdrSLTED
lpEZv5qVCNjuUGSsuJoZKP6mSnbZiICNbKvnhZ01BefqPJleeBKwwQEl3qsl
J8Briz5lsToC9kBHDprkGIFY2MelBwmYKs9ejB/RCJxT6P97oY2ARd1cZjk5
bgh+MQ18ShojYK1VMtdoRQyBWv+gyz6lKHboJuWPRqgPqIyHTDgZRTGJkIrC
Dk99MFA/JK/MLYr94gkEVhz6IOjp1z9X5ESxAYUrU28C9UDthZGUPhtRjLB2
K8UEw8DdjpFbq06i2A+uxSD6HwBY6446HvESxTRemFgI2gOwyT8mjd0RxfQ2
Qxa/6hGB0vR4Y1mRKMaRE1F5VUoHvLoyvRm5I4rdW+WoYHPXAOFfp78+JxfD
bpQIPyHbUQeWpjPwNZ0YNq8tLD8Zrw5WpWfvrwiKYR7jnE129Wr//ps5ETsT
MYyX8t6UlYgqOHCcpw06I4YZfv5a8OuDCujsnl9NvCiGSRsdu3HKVQX4VC+8
a74mhp0XnmDZLVMG5UGLZxTTxTCfa29/+FoogdD5RU3zAjGMQTF9a3xXEZjb
Lgm4V4hhntePfGstVgTfNb5/z/wghqU81Ndfo1EEUnvLUTTfxTA8+M3R+hp5
UBS5VjOhLY7FR4czDl6TBq7Xvp4+aSSOkcl/rE7dkwKCTh9W31qIY3HKl3/r
x0mBp7qp0k8uiWNfT55hPF0sCeJ31PPN74ljPyaeLNnuiQPjBUG9t4/EsRqL
Wn38sTigGKCdEE8Xx65nmTYPKoiD0JoRboqX4hhRymWU2lsM+PreSX7TK44N
rnRWZWwRgNTFKwrio+KYD7Fv4WsGASyYne5MnRPHCJOXrR8bEICTpMgRvx1x
TFbOecIzTQScnm2JEOOXwAb75d8snBIGKnb011I8JLCdHTdbpwMBsHbiF/2h
AAnMuld1jjFIALxUnyz3DZXA9qPDJI6s8AMxtupvJokSmL9evc+reT7A0X3W
iaxOAruXZbH8cZ0H9OHEAx9cAss+eXv/9S0e8OileObIRwmspfjtegkFD6C5
/3uwflgCe6d/atSDjxvsGj0/5UMmib06zv/+tjsnqFeJ+TFMK4mFVBlsxh5w
gACRq/dPsEhi5DfrFKzTOMAymd5HETFJbJji88ljnexg/N0scdhMEnutVE/U
P8UG3ivKyB1Pk8SU83/5D6YzA2GH1pd3ciUxmTbV7H0DZhAZ7yr7ukwSe7TL
fql+hQnoz2TKSCJJjFRRP/rhBBP4kHpM+uiiJKbd/skomp4RCL8vKTXYlMTk
u37H/I5hAJE/jKRC9yWxlrOOOzmb9MDAOEzyB5MUtk9j57DQdww0/VoR79KS
wmKivrkcqj8KCIT7RdRGUlh8IHf2JZWj4K6luDh2SgrTPFkjzlt3BBiVOIpV
uUhh/b7Fa4EkWtBi101ISZDCpi4r1SR9owatpCoh23EpzCZx2Hs9+zCQWDqZ
m/hNCmM54el8HBwGsexLgq0bUthhv+xox0kKYHJVWFCTWhp7cKx2u06cArQL
pvDzKEhjt3mIa4Lth4DUSfmsM1rS2JtrQtXl1w+B+Fuf+BIMpbGmGEIciXAI
mPVS8O2fk8ZIykkBVtFkoCMqkGciQho7SK6S5Kw8IMq8YszgSJDGeEXapw4L
HBATRsu5LZ9IY6FhfdTJSfvEk6pzXO9LpbG44d+Ei2F7xM75s5z5X6Qxtwmr
C1eDdoldJups7qIy2N7Zl52bXdtE3p/vzDfkZLCh6KCxKq9t4pUs7O5tDRlM
f8PqsBjtNpF802QzxUwGu2N04TCLyRZRLdO+B12TwVaq3R+rj24So4ynaMxD
ZLBP/bFGY3c3id1rbtjgXRlMvk/88CH5TaKn0dXKH2ky2IRD6lDxvQ3i85WI
B9y4DLbc1cvyyWSduPSUqrnwowx2kB+bX7W/RlQzuL+n0CODvdYJspmrXiN2
p6V6HZ+VwX4PaKTzCa0RD+sVmQQekcWO//7N5M+5QvRK6aDstJHFVidUbxso
LhFf657WPe8kixV7Phz5RFokHv7WHzjrIYv9mSl7bGG+SMzSmZjZDZXFuCrj
WgSvfiP2zq2/F8+XxeZ+Rn9g+DRPFHh0/Xd1uSxG9kHgWcTleaK31h8FYr0s
puzS1VxOMU+kSjycY90mi1HXssswGcwRNTU4wiJWZTGKBe1bx/tniDHTGXV0
v2WxMuXdS69vzxB7EwR/pJHLYVuO1gsl4jNE7ylJ+wo2Oez5r5HCn3emiTnx
Oloj2nKY0TNNkZt6U0TqsUvbKrFymO0A8SwD1TgxLJ3Z5FGSHIY/rQ37FjVG
/GnbmPE9XQ47/cSVsEkxRpzuJejlvZTDgldNPG4cGSU2tC7cZ/gih3314eUl
KgwTlWKejnuOymEnHXNOFOBfiSUGJootc//iV3st/rT4SnyClw6E7shhN+xU
G1WChoh+tT5CS3zy2CWVS4dPDw4Q56/xBxqJy2O6wo7kMoEDxIvyXS05CvJY
4TiTfQ3zANG0VMHb1kAeq61svl1q3U8Uzdmsb7oij2VKn069+f0Lcfj+LfPs
GnnsWV/C+LRDD9HSRCp7t0Ee2wtwcnZl6SF+pBpZP9sij5lSkN+Xaesm1kbo
pNF9lcdwsS+LwRrdxMQbf6duHchjHxjcEn6ZdhKjuM+lL1EoYCc4bR20P34m
Em+9MnhKo4CpHhtIemP0mVindunJJpMCtv46eopo0kHMq/qgXUpQwIQu2p3z
9GgnXmTkmbOVVMAau2z0b2+3ETmvBjyklFPAjHo8+SKj24iJMoQpJ3UFLKbV
HGAlrcTQougYDlMFzBcBrnKqj0Tb5yd67l5VwOS7LVyymZuIs+nB39MC/8WP
szgyWNNI9H9aTll2SwELnSn06LBpJCakMGr1RClg7xPjx7tyPxBR3FAe31MF
bOd+b76D2XviyXtHSArPFbAHSu77Rb8RcfiuzqBBngLGOBQ6fq0EEbfu5Bz1
LFfAqohMyl7HEFHq+pXAeqSArc2dkfDtIBH/C0h/2NasgOkD0bMPAIloeK2j
eLRdAYsXcftmUNdAdPRWGCPvV8B+dbLPGBe/I6Y67xidWlTARB9bvrtY9oZ4
YBHL8Y1JEbsys9h7nLeeeN/8reIfdkXM6V1zYk5NHZHTdNmMnlcRk/SwbZo3
ryMqG1mGq4gpYo4+Rfc5omuJV7Q5F8O1FDHKh84eHEdriFsaphSpQBEbYTsc
u/CqmhipFspXZKiIbV/7T/bSuWpipuLk6c8WihjYLdtSLK8i9ogXv+VyUcRO
yFrm37j8iuggOtwnc0URk+/x53vP+Yq4LEy3CnwUMWu5+b2Np5VEKn4/kcs3
FDH94ThMw6+CqMWqkVB9XxEbe59auUAsJxaQtV40q1XEWqkolE2siokSuitf
qN8oYtQ5HzPi54uIZbdYTZtIilicV+mLotAiYvWGk5rux396rmFc1hUviGj2
N738sCLGmxnjmC5WSDQUEoz+Pq6I2aU/aBppLSB+vGj8p2hGEXPT/anxzruA
2DmQvCD4QxG7qsK3o/4mnzjWKo2YyZQwv5OP+Txc8/7Xwnn+c8H2YViiQqGJ
jGwyot9e19VXSlayR+mXWRLZRSgSlZHc9syoqCREhUi4QyrKTEIIdyQ7K55e
PO+Pz3mexz9wYhtuY0ozFwGeyE2f7d6WjYc0fPMjeAhgF+IvU1KThcfL65K4
thPA+ZDevhvyWXgp/6THvBwB1M5QLYVW7uBdMdHS3XoEcE1OkaI2p+KU96VJ
CYYEOOHbZ9lgkorFeXv4TcwIcFX8SKZ/dwqWDVFcbmIT4DHV9Kf0RDIm+Lxu
rfQgwOFpQY2Lqkn4WdGIzqULBBA/Xxy9uyYR0ye2VFP8CeD12XtHsmUihjPH
859cI4APW0VuY0QCNrCauZaVSIDu6Nj+t1zx+FO8yPLJNAJksJ2snHPjsNmn
Ax67swgQsUSyyNWLw9Z6kSdjH/717dp4+WtSLHZGcpTQSgIMd5zzv3T4H3xd
ymLEaZAAST25049ro3HPivmH8FEC/H7+fqFCKRoTusxL838SIDYXVPLibuGe
W+Yhk78JEJfV5D/kHoUJK2Z7fDcTYeHkDZcAnQh8o9NsQ8pWItR6qRbzvAnH
X4vNflbsIkLbHhFt/sPh+MZZs4o1SSJYzz9yNNC9iXs7TC2uk4kg2YGvubpf
x6RiU/yAQYShxSstF9bC8M0oU7mmA0Rw1FT9mXE7DJMOmc7w6xKhXcl6r0xZ
KA4vMolOYBNhfUqKwJjUNUyJNK6/d50IsrJlL8N0g3HkGeOC+kgiiKIII4nf
QfjbQeP4/2KIEFZMFTpyLwhHLhrZq6YRIWq8SHffhiA8cNporaSQCDtWfrC2
Pw3EtINGwx2lRDj7gMRVLROIo8SN3i+UE4GzVCVUIjEA09oMU1n/EqHQsAJX
hvrjKA1Dat1nInzfVpghH+yHB8QMJYZ7//o+fxPMtcEP0xaOcW8aIsLjU9pM
YpQvHig41qo3QYRV2/uT5tkXMU3smFsrJwm0ddbxRA374KH5o7kDyiRA6bvP
cX7wxB++DKaOq5Og6iPJq9HbE7+o9rs9TyaBRv+rJxRxTxwVfs+PF0hQ6NHz
dsjTA1Mk/ugRTEmgens5tErdHUuujwWWFQmuygbovq13w3yjimQtNgkSOgWU
fqm74f4iU4njTn/7t3+2Cec7j28ezp8MDiDBh0ZevYz+c9hb6eD3iGASPJ/I
Po2tz2G2QNfn+DASPLVUv2DU7YwJn9fXPrhNgrYyMYfsr2dxj8uJ+I93SfDb
OOzji7UzeF8cL0PqPQnKPjptz8tzwMJ+mfuUP5EgSHSszV/LAXOyKTLkThK8
UhGZkRy2x50Kdpt1vpHAoLSIv1LJHgdVlPW6z5EgcHpgzqzBFjtnHmu9tEQC
txzTh++8bLFZ6Pf6a2skiOkUPtgmaYuVjm0tSuIhw6VH3Rm+V2xw64BTSLU4
GSaKBo5kpLFxVf3qxbfSZKg+ICnCy8fGeflxLm0KZEgsz4lWDDiJAy5Um43u
JwONUJGse9oay/MKKwpqkWHHt9tH31kex77769+dOk+GGHKI/5t8c2xpZiS+
3YsM55bVHDZrm2O63xfXNxfJUHR4/1PB72Z4qfoXv2owGe7kG30ky5rhQENh
o6VYMohZcvtKPzPBbO/srMdJZPhYd2djBNsE4ySVaZv0v3ymzNjFTSaYox9i
6++TYSnj/nytjTG+6na2Pa6MDLDG6ecubYTtYmfktKvIICF2RlmrwxBrPg+8
sFxDhukZhzzXCEPMtRYjZPeODPWCB0PJM8fw9VvlVmp9ZEh38L6Z2XgURz7m
623kosCr8Qwu0SEd7PIxfl8gDwWCM0iuU+46+Ojcnivq/BSQPlLz682aNuZH
JMlEIQo0Hy7n15fRxjHvrO0clCjwQ2l9fkuQFvacHC4WUqNADqy8LhTTwsY7
PNY3ESkgP11x4mj5YbzDOvTufkSBsaA8v/SlQzhh7PHw6jEK7Jp8rvX2lia+
KECjFptSoLLhuUsVVRNbEmuuO1pRYCX8swJ54CAW8e9QfGdHgSW7uefRzIM4
jXfNOdmHAgSunTsOrwHO2mv4i5hKAQ9HR2gNR9h0/GmhfiYFNAVKXLVWWHjD
EyFPx3sUUOHg43RyZ2EXUt9swhMK5J9wEwqxYWLKgfNLi7UUcCv4w3jFpuPR
dZ8qtjVS4GlTn7zuEA2n1pEDlT9QoLPt3YS0Cw1z6P5Zs+6iwC+52JWYq1T8
1jSSu3qcAuqde7tZjWQcIDT5pmuKAgqjdb/4bMhYrdvkxtQ8BXbkrQy0L5Bw
3ClRPpl1VPD3PxlAUidhtvNDwbCdVNBy7FsVKyXg6SsNovqYCqN21MG9gur4
7kGVrw6aVDC+K7xfPFQNW3DfzgjUpoLTefP1reP78MtwC6knxlRIEG/obapT
xWHxw/LbzlBBzqFlyjdeGdMsdUeVXKjgPFivpiSojMd2FzzQ9KACW2+LCztK
CRtm+qj4+FPBXcarak/0Xiz6iIvQFU2Fey4VVq8LFPAHV6eZyTgqWLZSvA+x
FHCQ+rsSnhQqEB6Wz/5qksfDpbFU5l0qvB1f35QwJYcLq6VRxgsqHNlSvLjZ
TBYf6gBth29UaLp3QTnAWwr/7ExylB+mgumqzNE0OSmc8Hny6ugPKmSseqhK
dkni0Z7MSpdZKsiuV9RgaEjiiEEOos9GGhQ3XamR0JLApO+WhtTNNGgz/Fak
XSmOe4YLXRcFadCnorb0hSKO9/2wyQvcTYPoi38stu8Xw58mq8XDVGnA3Ri3
Mwt2Y/9pYaY2gQburhG0yUYRLDvrbslLpQFbuHLV3EwEX/gtGXsLaHBRwfrn
YU9hLLIatCnRhAZTOW/KHtXuwjZ8GjO5fjSA2Rds5crtmGdLsqDzZRrophl4
f7Pfjov5p1RVQmigIEt7rrR5O+baluVUGEkDeyGO4OO223Cu8LreF3doYOOc
JOsuvhUb7rZavnSXBlK8XFVrzYJ4QbRIGD2ggUX/lOjPEEGsu8fW5HUxDfis
55gxfQJ4Qu51Q+O/NPCOn/9d9ngLTlQQGY54S4MOfMLBSWELhr0e6w2aaZA8
OZXrk7MZ/6MihT910eCV/X/SV7P5MJkY/LR7jAZ/vlge1KzgwQGgkTG2lQ7j
XDvSlw024HI9tcb4XXTQ08lRnRzjxgvm4rMHROngZthYkRrOjb1cF3XiZOmg
K/opefEdF3ZOKZpjUekg2GgrwOW4HufduyM5wqTDpuMT+oP86/FwYZReDNBh
NV/fFso5sW392azvOnT47ZJYZ7WTE1vOSh29Zf2Xf1pWYtHDgRPWBHxptnQ4
/8Rgp1cMB27jXc0ecPy7Z9IytvsIBz4m1b1AcaNDX6vp1gn3NaRl8M/dvmA6
mP5KcEww/INIeZwr6rl08LlxLb7IfxF5Pp2U//KIDg9OkZs9eRdRYVWvUWgh
HRT1U/yUUheQcnt57ucyOrgvVQcfr/mNpDm9TK6+o4N0soVeq/w8stlie1nl
Ix2ejkX3W9fNoQzhYw862ulwab7mXKr9HBJRU15T6qNDqayRlkjuLBK0HnzY
OvXX781GF32NGWRw5mN74DwdeDZQ9hSNTaNIz1ccist0KBSN+RSTOI023kw1
D+BiQMi5wxsfz0yh1VITTjkhBnz7anoj+eUkGhOos7rAYoD6av9psvBPtFQW
MReqwYBrTWSe/yLGEa+DSUy8FgOIgSrKwDmOlF4MNJQYMiB7QsHt/vwP5GSz
jjbjwADVK7K3V1dGkS9vYyun819eb52A77VRdKPktts2NwbMlVevkflHUe4m
ydz9fgzgTd/UYqI4goYL8S73KAaIlxgnTvt8R/PHNxRf+YcBDpFn4s/yf0fc
3B+ORicygL3Dxbg1bwjJWp0MLchiwOvrRRVWg4PIfl3A7HgpA+QU/Nso5wdQ
v1HZp7O9DLAd/PmiMrcPTS4HnfcbZMClJR3CLH8fWrunzXtzlAFjzx5t4vPr
RRJLnRp50wyI31VZlG32FZ3Mni8c3sCELtrSlQ1qX5CLfpX+PB8TGsQI4W8f
daOA+dBR7q1MONvvQ9uo3I3SdHdKyoky4c6/B+Ur1D+j7mlitL0aE+KS+QU/
WHSiH2nLSl4kJkStYcddIx1oUav2zVU6E7RUFFiXfTuQcKrxapYmE26/TKwM
yWpHFpoerv0WTNg/Yl5twteG2mIL9E4GMWFhL8mYl/IRdQc4a+4KZUKO/Tk1
p9EW1O8oz2y+yYQW6daXMmktaJyaoaQRy4RB6Q/uqRtbEFdPFI/cfSYo7Ddo
bv7yHvH+q7Ou9yETzG3GjXabvUeCBdyLCU+YoJre87K25R0SCwoc3VTGhLw9
OZ82NTchkqxr/XgTEwq71ZdYw42IsWXvq3stTBCpkbFlezQimB96xm5nwrdX
Za63VhuQfoP1/ZZeJowkXEmZk2hADi76oSVTTDidmyU3cuENiitR1gwQYkE8
V97g5oBalJI+wiCLsUCs9nu7kGwtygzLIUxIsoBzocrgyfsalG8pKm2jxAKJ
IwECTnI1qG6Fd90hxIJ9TKx4eLgavf3+ZmFFgwWtnXfrfydXo5YPVydLtVhQ
+77Tm/NYNerJXOpTMGSB+Vn7KoFLr9DsoR9VfPYsuLtsQLYxrERLqvef1Z1h
wVE5jp1rTS8Rh5BdQaALCww0plemdV6izf99Tv/lw4JesZCthfoVSDaqMaD1
BgvO2BfnOriUIZP2PEZqAQsyPHXNPTc/Q87cLu/7n7KA77xbCTu9FF0lq9nI
l7EgPaxl0k+9FBXHl4YW1bJgf8ShE1tPliBB85qW+i4WME4NyGV8KEaKYaH2
W3pZoBAjtbPbrRgdeKY9bzzIAilm+Pj0tmJ0flezaO9PFqR51QkksIvQ+44v
p2c5EbwYtzuVy1uIhjbcWaRvQmC7wWEozesJWqHYRV7ZgiC1PXtSuL0AqSSO
FvEKI2i8PLrnRNZjFG4xtyKpisBDQ6X2xMlH6EgXf+xRCwTiL9r6+8xzEXvT
J7lYawR/Jnq9iN/uowu0+BddtgguuDxK6nS9j+4nifbauyAYlUrRGIy6h7is
FPdeCkagahmt0TKSg8RujlW8CkPQnl//43xIDiKWFRhwRyK4Iq6nvFEqB9mJ
kL1vJyDYpSE+smKbjV5/1nh1/xGCgaXn6jOLmaiLh9t4vBBBxnK8oMndTDRJ
bxja/+xv3kz2UTvDTCSZYsBbWY2A9nQJuo/fQZePnzBrbUfwcyRwb/ZsGkoI
lxgV/oLghOA5xWi7NPS4/Nsldj8CK/djBOvWVNSz2ynzvx8IFmQONVtXpqBZ
XWWi2iSCCf92XW9KCtrsP/Gv9xyCQIeoO8TiZCT7qMiyfAmB262XblHqyej/
f4Lw/z9B9D9CkSY/
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{-30, 30}, {-0.6627276835871324, 0.736156563495752}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.647343336241209*^9, 3.647343458346677*^9}, 
   3.647343559173223*^9, 3.647438176937273*^9, 3.6474555590740137`*^9, 
   3.647455635047103*^9, {3.6474556667554092`*^9, 3.6474556952424927`*^9}, 
   3.64745638735844*^9, 3.647456575031111*^9, 3.647456612426653*^9, 
   3.648225441844964*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Double Soliton w/dispersion", "Subsection",
 CellChangeTimes->{{3.6071624267804537`*^9, 3.607162427835446*^9}, {
  3.607162659032112*^9, 3.607162665533825*^9}, {3.6213477237374287`*^9, 
  3.621347724984668*^9}, {3.6344878015158043`*^9, 3.6344878025480223`*^9}, {
  3.6345869659642572`*^9, 3.634586967042912*^9}, {3.634599789551354*^9, 
  3.634599790917953*^9}, {3.636453032720829*^9, 3.636453033502743*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", "2"}], " ", "+", 
     RowBox[{".8", " ", "n", " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        RowBox[{"n", "^", "2"}]}], "]"}]}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{".1", 
     RowBox[{"Sech", "[", "n", "]"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "[", "n", "]"}], ",", " ", 
     RowBox[{"b", "[", "n", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", 
     RowBox[{"-", "30"}], ",", "30"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6070955575366*^9, 3.6070955764429283`*^9}, {
   3.6070966763884773`*^9, 3.607096683588462*^9}, {3.607103291583271*^9, 
   3.607103293270524*^9}, 3.607103673469784*^9, {3.6071066902433357`*^9, 
   3.607106693464693*^9}, {3.6071085035186977`*^9, 3.607108505173026*^9}, {
   3.607161871270149*^9, 3.607161880361247*^9}, {3.607162402147834*^9, 
   3.60716248608148*^9}, {3.60716264876372*^9, 3.607162655719994*^9}, {
   3.6071626973606052`*^9, 3.607162713308597*^9}, {3.607165073723678*^9, 
   3.607165092443801*^9}, {3.6071712440025*^9, 3.6071712462666407`*^9}, {
   3.607171434141273*^9, 3.607171448514019*^9}, 3.618142878492888*^9, {
   3.634487364212331*^9, 3.634487364340477*^9}, {3.634599794625374*^9, 
   3.634599794830822*^9}, {3.634648331542585*^9, 3.634648332150552*^9}, {
   3.634747712108593*^9, 3.634747713468987*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJxF2Xk0Vd/7B3Djda/xXlMkolSolCFEPLsBEUWDZGiQPilFg1ISyhAqfUpR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     "]]}, 
   {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwUl3c0198fx+1N9t5778373qsyMrIjFBVlk1GEsiohFUIoe7bsUfK5iZIk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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{-30, 30}, {0., 0.8431039325129133}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.607103674687817*^9, 3.6071059142978487`*^9, 3.607106693920917*^9, 
   3.6071083967161627`*^9, 3.6071085056955748`*^9, 3.607161415151122*^9, 
   3.607161880806589*^9, 3.607162320696134*^9, {3.60716239907682*^9, 
   3.607162486425859*^9}, {3.6071626499552383`*^9, 3.6071626673371267`*^9}, 
   3.607162748801285*^9, 3.607163489668972*^9, 3.607164903371418*^9, 
   3.6071650932824163`*^9, 3.607165141081737*^9, 3.607166524973679*^9, 
   3.607166869892997*^9, 3.607166965278014*^9, 3.607168497263784*^9, 
   3.6071706012721252`*^9, 3.6071712466747427`*^9, {3.607171435120922*^9, 
   3.607171448834656*^9}, 3.607252323663968*^9, 3.607252644134388*^9, 
   3.6072585614656057`*^9, 3.6072654165583963`*^9, 3.607267520297332*^9, 
   3.607270898544763*^9, 3.607278541555463*^9, 3.607331359797974*^9, 
   3.607602000467147*^9, 3.607607284608039*^9, 3.60760796184455*^9, 
   3.607677963603763*^9, 3.607678940930737*^9, 3.607679949427497*^9, 
   3.607720297966318*^9, {3.6181428541364326`*^9, 3.618142878786026*^9}, 
   3.618143771510894*^9, 3.620044936828672*^9, 3.6200464832855587`*^9, 
   3.620128102075254*^9, 3.634487364831038*^9, 3.6344874292628736`*^9, 
   3.634487804151752*^9, 3.634551235817226*^9, 3.63456516287261*^9, 
   3.634568548987978*^9, 3.6345791760935307`*^9, 3.6345835375948763`*^9, 
   3.634586839349971*^9, 3.634587021970519*^9, 3.6345890680934896`*^9, 
   3.634589116074245*^9, 3.634597470777131*^9, 3.6345987084407043`*^9, 
   3.634599795547434*^9, 3.634648332721313*^9, 3.634651713052607*^9, 
   3.634653668705427*^9, 3.634655540554537*^9, 3.6346559225029783`*^9, 
   3.6346570375122766`*^9, 3.6346580873206863`*^9, 3.634659218374926*^9, 
   3.634660127177478*^9, 3.634672780250351*^9, 3.634729532906402*^9, 
   3.634733754701977*^9, {3.6347423411050167`*^9, 3.63474235650663*^9}, 
   3.634742871691552*^9, 3.6347475960729437`*^9, 3.634747714035153*^9, 
   3.63474963779578*^9, 3.634826560966948*^9, 3.636221871614737*^9, 
   3.6362237315070553`*^9, 3.636368946695895*^9, 3.6363764581176*^9, 
   3.636381712119013*^9, 3.636382672432497*^9, 3.636382819732774*^9, 
   3.6363863045443993`*^9, 3.636387063867367*^9, 3.6363884090438423`*^9, 
   3.6364507649866953`*^9, 3.6364530351510897`*^9, 3.63647994352389*^9, 
   3.636480045203539*^9, 3.636483763891404*^9, 3.6365440409794283`*^9, 
   3.636544186976823*^9, 3.63654458719153*^9, 3.636549426642935*^9, 
   3.6365494697775517`*^9, 3.636549533058372*^9, 3.636549973967085*^9, 
   3.636557705334757*^9, 3.6365604094328117`*^9, 3.636561183140716*^9, 
   3.636565666589271*^9, 3.636565901204925*^9, 3.636566529264826*^9, 
   3.636569235942416*^9, 3.63656994769881*^9, 3.636589883186595*^9, 
   3.636813012334136*^9, 3.636814845992806*^9, 3.6374374577074957`*^9, 
   3.645285703929021*^9, 3.645287812872069*^9, 3.645287873819213*^9, 
   3.645291287848977*^9, 3.6452919457408857`*^9, 3.645356152311569*^9, {
   3.6453561843188677`*^9, 3.645356198615819*^9}, 3.6453565292729073`*^9, 
   3.645370820131413*^9, 3.645444596960309*^9, 3.645446301272748*^9, 
   3.645447420111012*^9, 3.645447965499341*^9, {3.645463654766156*^9, 
   3.6454636701995993`*^9}, 3.645466724563764*^9, 3.645467651334518*^9, 
   3.6454846037829933`*^9, 3.645980977656993*^9, 3.647265957246673*^9, 
   3.658591170558692*^9, 3.669901747783606*^9, 3.6699041972578697`*^9, 
   3.669906699207325*^9, 3.6702359514812117`*^9, 3.6706823450653257`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Non-solitonic", "Subsection",
 CellChangeTimes->{{3.6071614312472057`*^9, 3.6071614343907747`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"a", "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "/", "2"}], " ", "-", 
     RowBox[{
      RowBox[{"1", "/", "4"}], " ", 
      RowBox[{"Exp", "[", 
       RowBox[{"-", 
        RowBox[{"n", "^", "2"}]}], "]"}]}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"b", "[", "n_", "]"}], ":=", 
   RowBox[{
    RowBox[{".1", 
     RowBox[{"Sech", "[", "n", "]"}]}], "//", "N"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "[", "n", "]"}], ",", " ", 
     RowBox[{"b", "[", "n", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", 
     RowBox[{"-", "30"}], ",", "30"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6070955575366*^9, 3.6070955764429283`*^9}, {
   3.6070966763884773`*^9, 3.607096683588462*^9}, {3.607103291583271*^9, 
   3.607103293270524*^9}, 3.607103673469784*^9, {3.6071066902433357`*^9, 
   3.607106693464693*^9}, {3.6071085035186977`*^9, 3.607108505173026*^9}, {
   3.607161871270149*^9, 3.607161880361247*^9}, {3.607162402147834*^9, 
   3.60716241379963*^9}, 3.60716272384447*^9, 3.6071651019085007`*^9, {
   3.621853302248516*^9, 3.6218533023997183`*^9}, {3.634487332597899*^9, 
   3.634487332918416*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJxF2Xk8VF/8P/CxzzAYa4vShtIiWyjpHJUlUoiSpRCfikKlKLKTSmRJC0XW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     "]]}, 
   {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwUl3c0198fx+1N9t5778373qsyMrIjFBVlk1GEsiohFUIoe7bsUfK5iZIk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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{-30, 30}, {0., 0.5}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.607103674687817*^9, 3.6071059142978487`*^9, 3.607106693920917*^9, 
   3.6071083967161627`*^9, 3.6071085056955748`*^9, 3.607161415151122*^9, 
   3.607161880806589*^9, 3.607162320696134*^9, {3.60716239907682*^9, 
   3.60716241451115*^9}, 3.60716510274893*^9, 3.620046696202523*^9, 
   3.620128598142475*^9, 3.620132475932602*^9, 3.620141627969079*^9, 
   3.6201533067907953`*^9, 3.620471361287805*^9, 3.620472948125104*^9, 
   3.620488494549176*^9, 3.6212473952094107`*^9, 3.6213477273161087`*^9, 
   3.6213488307502937`*^9, 3.621348957380828*^9, 3.621367948458105*^9, 
   3.621852268567794*^9, 3.621853177995221*^9, 3.6218533036413918`*^9, 
   3.6344854652106667`*^9, {3.6344873254128017`*^9, 3.634487333607069*^9}, 
   3.634487419093617*^9, 3.6345828105097923`*^9, 3.6345839386907988`*^9, 
   3.634586971156705*^9, 3.634588506504692*^9, 3.634597343310173*^9, 
   3.634598549867696*^9, 3.645527177841709*^9, 3.645613839579012*^9, 
   3.6457036883725233`*^9, 3.645807716802744*^9, 3.645809186575273*^9, 
   3.6458102732559443`*^9, 3.645826810677196*^9, 3.647283201573842*^9, 
   3.6699032529992523`*^9, 3.66990490560645*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tiny soliton", "Subsection",
 CellChangeTimes->{{3.6071619016382427`*^9, 3.607161902994658*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Flipped", " ", "Soliton", " ", 
    RowBox[{"(", 
     RowBox[{"no", " ", "eigenvalues"}], ")"}], " ", "data"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"aa", "[", "n_", "]"}], ":=", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", "2"}], 
        RowBox[{"(", "0.4", ")"}], "n"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "n_", "]"}], ":=", 
     RowBox[{"1.0", " ", "-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"1", "/", "2"}], " ", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"aa", "[", 
            RowBox[{"n", "-", "1"}], "]"}], 
           RowBox[{"aa", "[", 
            RowBox[{"n", "+", "1"}], "]"}]}], "]"}], "/", 
         RowBox[{"aa", "[", "n", "]"}]}]}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"zz", "=", 
     RowBox[{"Exp", "[", 
      RowBox[{"-", 
       RowBox[{"(", "0.4", ")"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"b", "[", "n_", "]"}], ":=", " ", "0"}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"b", "[", "n_", "]"}], ":=", 
     RowBox[{
      RowBox[{".9999", " ", 
       RowBox[{"1", "/", "2"}], 
       RowBox[{"(", 
        RowBox[{"zz", "-", 
         RowBox[{"zz", "^", 
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}]}]}], ")"}], 
       RowBox[{"(", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"aa", "[", "n", "]"}], "-", "1"}], ")"}], "/", 
          RowBox[{"aa", "[", "n", "]"}]}], " ", "-", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"aa", "[", 
             RowBox[{"n", "-", "1"}], "]"}], "-", "1"}], ")"}], "/", 
          RowBox[{"aa", "[", 
           RowBox[{"n", "-", "1"}], "]"}]}]}], ")"}]}], "+", 
      RowBox[{".0000", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", 
         RowBox[{"n", "^", "2"}]}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "[", "n", "]"}], ",", " ", 
       RowBox[{"b", "[", "n", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"-", "30"}], ",", "30"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.606738820645568*^9, 3.6067388315929193`*^9}, {
   3.6067469531035748`*^9, 3.606747053855321*^9}, {3.606747853724188*^9, 
   3.606747911643997*^9}, {3.6067480217599077`*^9, 3.6067480219818583`*^9}, {
   3.606756362808383*^9, 3.606756374765408*^9}, {3.606756429006898*^9, 
   3.606756429375524*^9}, 3.60675972829417*^9, {3.606759766682432*^9, 
   3.6067597668251057`*^9}, {3.60708044889326*^9, 3.6070804519435873`*^9}, 
   3.6070804879167547`*^9, {3.607080576148489*^9, 3.607080578145192*^9}, {
   3.607096686059794*^9, 3.607096761838904*^9}, {3.607096794259136*^9, 
   3.6070968052094793`*^9}, {3.607096914602667*^9, 3.6070969297677317`*^9}, {
   3.607096981339583*^9, 3.607096989484791*^9}, {3.607097086137371*^9, 
   3.607097110288994*^9}, {3.60709816597717*^9, 3.6070982000357428`*^9}, 
   3.607099511488907*^9, 3.607100264596387*^9, {3.60710032124819*^9, 
   3.607100347521586*^9}, {3.607103196859823*^9, 3.607103197619108*^9}, {
   3.607103351663739*^9, 3.6071033697103357`*^9}, {3.607103736563098*^9, 
   3.6071037846909*^9}, {3.607103884679851*^9, 3.60710388591156*^9}, {
   3.607104008504548*^9, 3.6071040094950943`*^9}, 3.6071043699724283`*^9, {
   3.607104592990301*^9, 3.607104594812413*^9}, 3.607104846663352*^9, {
   3.607105122620716*^9, 3.607105122979086*^9}, {3.607105195050503*^9, 
   3.607105197790069*^9}, 3.607105281861862*^9, {3.607105380662223*^9, 
   3.607105382084363*^9}, {3.607105498406726*^9, 3.607105500732924*^9}, 
   3.607105571809019*^9, {3.607105689318726*^9, 3.607105690820606*^9}, {
   3.607105778891407*^9, 3.607105787152236*^9}, {3.607105834353868*^9, 
   3.607105835194496*^9}, {3.607105925599038*^9, 3.607105933359343*^9}, {
   3.607106006474934*^9, 3.607106049422003*^9}, {3.6071061145038013`*^9, 
   3.607106114983891*^9}, {3.607107170422572*^9, 3.6071072025110903`*^9}, {
   3.6071090841881647`*^9, 3.607109085818255*^9}, {3.607109129304578*^9, 
   3.6071091304798717`*^9}, {3.607161887688628*^9, 3.607161891270163*^9}, 
   3.6071627298691063`*^9, 3.6071651102451267`*^9, {3.634487342613248*^9, 
   3.634487343037809*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJw12nk8VF/YAHBRWVLZ930Z22AsIdE9FAkhSZJKlhJC2QrZlyyp8ENRZE8q
RYrKnAohSVIJY2TLvqZs6T3H+77/8Pl+ZubembM/93kknbytXRkZGBjm0B/8
f1e33/i/f/qwhVj79+8fnagcDTwPzupDAfW/61ZZDPoT3q4HKZEr63Ynmzpx
q+rB2qjFdRc7Cn4oTNwFS2Ln1y1Y5VjNPq8LPX+OrztxS0mhr70unMmhr9tJ
RYXeWbcTjhxqWbfOwUqB3ao7YVXcg3W339ysvZCkA923Ba7bo9/ucNmYNiy9
KbJuXXPpBe1D2nBmIWUNm6VqMu3tCy3Yxlj1F/uWUbTgXX4tWHlAeRVb6YvQ
nVDfHXDN/fYStqT6jLd9uyZMPu29gM1/rd5AS00TLk9HT2GTLTw9tg1rQBP9
wVFsw63c/w3f0oC5o6yD2B88h+9Z+2tA8PdqH7ZdS3VtraUG7JnM68EeULr6
WVFRA9r363ZieyU6jqRv1ICD+4w/Y09QnVW1Z9RhePrhtvX2/HU64Fu3Ohw5
q/EBe0Te/VXgO3VoGtHThO16/NxGgQp1aOt6oAG7/4aP2fM76lDRJfINtmOD
b4pdgjrsvRpYi+2gGiRx85Q67D944yl2l/PlMzsPqEObR2Xl6983M/zhdx11
2Ffhfx87Q52x/Z6KOrQrri7B/toStXBJRh2173Ahts2GOD0hDnVoXb6cg52a
xeI4tkkdNqfQs9f7a0dCVM2KGtR9VXoT28r9arP9TzXIcW0mBdvsc6pdVq0a
7BSRjMa+M02uE3iqBknJLuHYM1saVNPvq8E8mcQQ7LS9i5tvZKpBRyLUD3vY
8caFbdfUYPasic/6eLms2JsYowYfysx7YNOeOjyNvaAGhwX7nbAp7QsSG8+q
QYuPMiewI6eSkyJOqkGnccOj2CS5184h5mqwYJDdEts7U5brAkkNhjZX6WBn
kubelUuqwR62Fzuw31TWXp4WUYPkngp1bJ5PR0Y9udXgckQkGfs5awI8w6AG
uYaSxbF/ZNgGFK1QIN8rdRFsNpI0eeg3BRZUNgms94/hywynSQok67VxYm8I
nvI63kWBJAFdJmxF1hcy2V8o0M/h/L813P4ZcV1dbRQoJHFrBbuoQsLY7h26
njF1Htt0wlr0UCUFdjQcHMBOPf7svUkyBfY5OlGx5fsnfXPiKVB97UEN9svT
MiK/oynQZvrnU+xB7xue+cEUePGNbBn2jkiPrWtuFNhS+joD+1uRuGXFHgrs
593lge2pZPuHlaDAzjRTV2yG8qQcR10K/P12z8n1+1UvTW9Vo8DG/llr7Evv
P193E6PAnhKNndhafdsLd82pwiDDvwzYJ0ZDFkZGVKFI6eWlv8hxc6NG6XRV
ODP8Yxa7c2Pd8EyLKpTRtunHDlK4KF9UrArT9TpeY9de6LvPcVwVOrzpCcIe
Dj6w+uqQKmQ45Hoee3tMjbmHqSo0tGk+g+2YkTZZr60KN16Xs8FmfGmiGsyl
Cu98FlfC3rfp8ZOhdyowejTu0ypyS5u7ZOMrFehlmFyHbZUtc720QgW2l598
hm2vkXnOO0cFAg/HbGzPU2HySwHo833QGXuWvDOj21MFMsYyH8YOWJzbVOuk
AsXEuYyxw66dHoi0UIH9Nt5y2CmvDtxhJ6nA5S0qP1fw+hTPvHVaWAW2Fl38
ip1t8zr4E6cKDBINq8cuHNc8mv5XGbIYvsjDfi4owiPxRRk6jrQdxe71H4vX
iFaGCTKnq5eRnQ0KFnmDlKHfxv587BH2E2cWvZUhm+zmZOzZ/E97Xx1ThjqJ
BqewN7Y//2esoQztHByYsK/cvuCloKAMGzpnx5aQt54l07aIK0O3N9Lt2HwM
uTVtbMowMtQ2B1tBJc7fvp8M/VKbNLEfLoFBvU4yBHd4BLHV65etxVvJ8E3p
1Ooisp6DF2Wwmgwdkk3eYlskHB4/d4MMrYxOmmL7DUufigBk6PLdAfxBZtdc
4OfUJsOAZj5x7IKIhtZcZTKMVrX++xu5Q+SsHhQiw6Amo+fYmoce8v/7pQQ3
fxqVw27JDWtNHleCI6RLjNguU1YxYv1K8I5AUM8CXo/i5+f0PyrBYavGZOxf
VJ3WkHtKUKjLbuIXctJWthj2XCWYxKLzBlvmWPeu7HQl+GQtIAPb5vfley+i
lOCFCjaAXUl+G718XAnyHd0bP4/sf/PArotcSrCmsXppFnnbT7E5ZlYleHGL
cx12keZMScY/RSjgZ5CM/fVjCt+zCUWYdPuGOLbW5s7ZhQZF6MYvrzOD3Hro
XknMK0U4kiW9Oo18+m7QSd5KRejXp0vFTtcT/aB5VxHab31kiP37glOJb7Ai
VGwz2z2FnAw1TjJdUIRpcW+XJ/F6uW0TX6qbIkzw0K3Ctr1XHPXksCIscONT
xK6iT5yYVVWEFxoFNk3g8W0eyOs9qAAtmO5Gj+L9zeG/MY0uBVj1dUAO+4Rn
BXXxowKskS5pGsHzLWn6bOQLBRjkns2CLdBypva/FAWY0BDuO4z7tycm1f6K
AixSFmXDZpjIdxMPRe7fnDOEPLqlj+veWQXIxl/0dhC5xszuzEugAHsdTf70
4/F2LEAvQksBfn0SHYad55HGaUxWgBfZPm/CTkxse/GRXwFaf4lh/4HX5/cm
HANT8lCz22EDHfmv6c5q1tvycC1eNqILec7+SHJrCnq9LHj4O15v3P2dU6/I
w5mxQ/uxWxMebxX1k4eeQaeYO/F+16zgRDGTh+q5Dc5f8Pzu2qe9AORhSNTG
yg7k2DFX9hoteXjlyrkN2N5seVV7pOShLW9KajsyMBXacmRJDq5Zt6d+xOPX
XqdPeFoOGhbwt7Ti9dbd9mnfoBxan2Q3YHMmpJx0b5ODy2Iup1qQ+5vYKi8X
o9eNphcbkaP3rzgUHJaDL5suBL7G88t4ku+mmRy82LcvCCIL7qG3XTWQg71a
IpeouP303u4NVJaDoZkR7q/weqyaSDbdJAer7M4KVeP2JF8e3r1CghetXVae
IZ9T8M7VmCXBgv++fKvC66v0IR5RGgm67f4UWYlM5hNena4kwbJYgZxHePxx
ba0aLCXBW6oVRx8iv97+z/t7LgnK9Mtvf4DHG+vAwJskEmRvP+heihy+Wvr+
PxcS1NXYTS/A87tfN2sXDwm6fw55lInbm04+TGEjwUoZo60ZyGd7xLbLMpBg
OOd5l/+Q174wRm2bkIU2p66s3cDt19Ts/uOtLNS1fdCbgPu3/qXM12pZuLn7
6sZ45FdvHvY2P5KFaWPTUnHI1i9TrCuzZKH8aq1JFHLII3vdOF9Z2L8ouCMY
2bjM/FfwWfR5iSzhS7g/7u1+6HNSFsKs20sBeD7nSUnZm8nCr/eysy4gt/03
xqosLQtbmXJ8z+L1IyToe3u7DFRke2h9GLffSlS3X5MMDHnf1mqN3HfpKo0P
ykD2mUADK7wfBOb+sH8gA0MZ6ljNkLl9G0b742QgeLNfCiDPzH4cjw6VgZXl
8Rb6eHz6fJ8k+ctARrKkjy5ygtfErLuTDKwte5qiie/nzrU8pycDGe6MW8nj
+40Ir6ZpyMDs507Ssni/PSO7pqWIvs8x+qgk3t9ddRiD+WWgoZamtTC+n+MJ
NqY5adj5n0biVmT6kVIh7mJpWAX8fafX0Pnja4XI09vSEAze9h5HvnX4ldiR
NGloX1Lo8BPZ9lCbVFaENKwV82KhI7da/FaUdpCGLvv8cj8gl334R663loYj
gsqiTcgJ5qyqZ/ZLQ72WoSt1yEamIhr3taRhtqYt+QW+n5HhLg1OaXi9fCmr
GN+vzkz/C7M0/BoYGp+HfHHPYSJwTQo+/DTifBtZ08Btz4txKdjFbNGbgnxf
L9lsT4MU/HVO/0cI/rxG17FDwVJQnVu82xy5w48SonheCi6HbP9phLytKjZ7
wxkpuFc18+tu5EgdDdojaylY+eruCQqyu37SCXZFdL3ki5u4kAtC+0MHxKXg
VLmQJBtyL1Unp4ZXCu4OixRhRLY2HKK7bZCCQhZp5bN/Ufyzb/ep+k5JSNo+
sPsjst+VtIjsVklYsti/vwH5YdPYXd86SSijcojyClnKPKNfslwSGh9RvVqK
zHZwxjk0ThLq6vz1j0Luts87ra0lCdP0J/2UkXmzF2O3kSXh87Zv45LIljSL
4iFJSWiT91yDD/ntyZWfqVslIfvRExprq6h9XGzOzgxKwK9/M3veIw8Vlsa/
65KAXrCkvhZZ/CdD6Z02CRjQ43jpMXLq2Qdj5i8loFC7q346crDXZs97qRLQ
6fce8ePITx85JIXHS8C+lypGFsjTM0/KjoRJwPBdd1QIZGffk5ObPCRgp7Gm
iQSy2cXnXk6GElAiKCKIvkIntDd+6dfqF4fJMm4zVsjtCeUVxEdxGB0UIkwg
e3ImRZu8FIexm2YYlZHzxPaQ7NPFocr2P4wsyOw7H5+9bCoOyZS60pplFN9S
k3RjtcVhn79idhGyobHblmsy4pDy64ZBCnLgIfEHuWtiMKBxLN8Nuf/c1Zm3
T8SgyH8xRZzIl3+5vW7JEYOaDp/5V5bQ/ha8N+VLkhhUvw41BpEPXFnR+Hla
DLZ98jv9FPl53tlANmFkA8nUQ8jJ34zWrKJEIWkwuPPyIjpPnZD8eNRHFD4Z
Nzp0CrlucDXH6bgoHKO6OO1FXpqtMPDTFoWO+Ye1WZFd2KViMsZFoIlURfLV
P2j9S/l7OLdTBEqJLIWeQ74p+J10r14ERuu7/jZHbiVdb6zJEYGaFoW+bMg7
Dda29B4SgTxS3P5hv9F4f/e9ZxiIwMERJs9jyF4WTx9MK4tAkq1DtxZywTFP
yw0sItC+00V4YgHNh4CuFJmXwjDviNKIJfJgaZWgh4ww9LH783V5HvVXlZJc
73Zh+ItrW3QTcsLrXM2DK0JQ/jJ0y0CmdCZYarcLwfYrAS0U5MubTsYwhQvB
noqlvKNzaP3k6EgJ8BCCd3o5KiSRZUT2547aCqHzVGTfyCydaFbXePFRWQiW
apyO8UPmc2SezeoWhM9/vL8RPoP2B4+QtW3vBKHNngo5A+SXAbNbIp8IwilB
v1cMyE5Xu0lu8YLQ7uizzpBpNL9qHjloagvCh76hDm5T6PzCa9fYkiKA9u+E
TpYJtD5IfPhChApA450tF56N04kpJcOBJ2cFoOGFmgYX5DRD8lomEICNuW1x
L8bQ+urNoOk6xQ89TTz77EbphEawv0Hnd34YxMRdszqCzgexYxZm9fzQaXRJ
OgeZfLvjrFo2er/f+RT6T7R+NZfk/N3PDwNGFXdZDNOJ919EH/js4Icp9EuL
Q0N0QuxHSs2ABD8cKaLxhyDX/Qn50vQH7SCHLV3yB9H+JHtwS3ohH+yM0o6i
9dOJ0jAUvWzgg1rP9LYu9yK78FlsmOSFU6euWgYi39uvIdvRyQs7rd7dmqPR
iRLuc58vlfNCBsYA1YEeNF+K+1TrT/JC3axTMfe70H6X9HdzphkvNFTT3iOA
fV6o110bXY/7cWvkd+RdNkkc23lhrYeB6sFONH4+vhs5VssDl8NTtdq/IFcO
UlVKeeAd07EIMvbNDRkb0nmgVPnI0egOOpHvvMuo+BwPHBnJuUr+jObzn4d3
50R4YH+V6PYTbXQiRzzdPj6YG8I5oRj9ZnQ+2Fih5nCGGz7x9z3t2YQ8+pFF
9RA3HMkvB5mNyBWszzoUuWEua9Gz4Qa0v+67zC3RxQW5vBavH3+L+tfbpaVK
hwtmW71/fO8Fsk1EfrwMF+Tzeb0rvwbNp513ghw4uGDZq1Dum9V0IpOpU55x
hBPaDqSFXnpGJzIyzGIOZHBCT//utS0VaDxQ1XcPLnDA53/8TM/dQ+fXktBC
zgEOyHb4pJFeCRofN5rZ0SCH8mHnnJmL6YSyi1P3zVIOaCFW1HejgE40sKRc
tDzJAaeM378NyEHnl/x+V/8b26HdB5vdgWl0YndAkGabx3aoEvmsiCkVnXdN
uJiUjLfDgrX55MQbaL5MGuT2LW+DOp+Eq64m04kjWne7zFy2Qam9Dob2V9B8
aDxpKaW9Fe72dE7cEkwnWLL+iF7m3ArD1YmdZpfoxOFz1ya+jbPDIAPFxphA
NN45qfFXc9lh0et253FfOiF5TKxukZUdMqS3pQR6ovE82aPzsYcNxgal6SU5
oHiay14qJJIFJjc+U/bVQevFlIz7/aMssMXgaEHzDjSem6Yfd1FYoPHrQEFh
DXS+iogx2Elnhuajz+eLlOnErplyx9+7mGFbVt8OdykUr7Qy5/gsbILuwhwm
OWx0YjX+qbCrGxPU1D9TOvall6hxDXdOI5jgV0vLMLf2XiLQwOz+Wz4m2HFk
wbivtZeYW+zTlapnhLZmV5lr3/USP8+w29MlGaHNldIlzepeot3IOfNoNwOc
8tMoU8jqJSyZpBSzs1epQL9iQNOhl3B577vsYrVKFZDcwR9g10sEpdY3K29c
pT7pF3GssuklCqTPelA9VqgOS79+ax7oJZb3lJf16y5T+5y+tKju7iWKoner
Knz/Q3W87Z1oJtFLvDS//m826Q+1oHNwNl2kl/jE0/+xBvyhakk5DQwK9BKr
BTE+5iW/qe6jiSfjOXuJg/Utj70DF6iO13hLVhjR65uOaVbxzlNLz37IqB2m
EVytZRvDmuao9iKvfloN0Ai59LWOfZfnqEJCT3pH6TTCmpTn/31wlrp6vbWD
8p1GFBuPVq1WzFC1lnPOCbXQiJfbdsXVn5lBu+KfsNFGGtH+NelIsvAMNVxA
7NTrehqx9MFxhtg8TX0eUp+XRKURBdumL8QWTFD33hHPyqygER/vpHALsE9Q
c+f3ZD8tpxHLKlqV93zHqVZpzQm0BzTC0vLyQovhGJUttlzbsgS9fm3LRe4f
P6mrH94Nwds0QlbikUChyU/qhMB2d70sGmFVbl2tVT5MHbno3VWXSSMK224u
Hw0boi6vWfn8TUWvc8pfzhUdoN5y5/rEnUgj6F5sHpQr/dQAjpMXmeNphFfL
hB2c+0Ft2LFKsMbRiKtxjzX73vVR7b73z6EVkRAZSpXyUe+jprVm6blG0Ai7
mAkJBl061fT6eee7YTTivxX/TmKwh2p1qfiPcQiNqKzSrTxZ3U211TpaXR6E
2uf8v2thyV3UzSPVDIqXaATHyJV9VJ1OqpbjxhqzABqhkn9Amr71G7VAiMv/
lx+NOHCC699a/xeqdTGzyQNfGpHQkVW1++pnaoLJpWeW52lEyTXHlBNO7VTF
8yvXd/rQiHemsl6h2p+oAl9cVjW8acTwprH9d9jbqG+GdXkILxrBGnncLOTt
B+ogr+Os/TkaYbw4zPjy3HvqtuRt9+M8aUS0l0/NCn8T1cfss229B414Pbh0
ftebBmpsXDwLD/KafZRCsGcdNSTMtt3XnUbs+sT+o4bvDbX0v8K6wbM0YjaZ
rLYQQaUmfJSZOo3sGUzk+n2toYY/fn1s2Q19nzPW238pVlGTLhUJ5CA72riG
+oY9pg5Xa6scRq6KmOkaKr5HPWHDVSCCfN+er3rQKpdq8o01fOEMjQhvnXFI
/plIDdeTa6Aj22VN20yMXCBW2UoudiNPaM7Y6btlEKbdfzNGkCMMrFvFtxQS
fESrFDO6XpIbeUbC6SHRuGWeVxu5ZR8T642eCkKCJdjzIvLBYzM3Oa88J9JW
S8XfI3/1oimmaLwiWEj/SKro96gYDB2Pn4bEXjbliwX49zYfK9pv9JaoeyDL
rITao9KmfYo1q54oVRBoeIMc0Gui3TzzjrC961fogdpvpxs1LMG4mZBPn06V
Re29Oruj0TS7hUjKjAmdQa4NLuPYMtdKtNuEWbWg/sl719JW3/qJSF85YlmF
+jOanWWhcKmd0JT1Mq1D/e16cI9grEwH4cd2qqkfjQf57upTxkFfialNETQr
NH5YJRZiSIXf0LrPrZnrTyPGXCilm9s6iY0u9jf+ofH2YKporkG2m2gzEGmf
ROMxWaOfr9iqh+iUXXEPCaYRPhdFd8Wh/ya1rv5Cl2mEOmNa1L5PdKKFqqsb
HU4jehIAm8vufmKso6aa9Qoan8wp2pF9/URVXv79XQk0Qid6wCU3coDgkhkW
Ck2iEamXY6k9DYPEFaP7nho3aISpT4vfYcufRKsT0zk7NH+fH7ajGztOENd5
d582f0IjTrffY3dlnCSmeruZXJ/SCB7LlZ1RBZOEqVFTVPxzGuFtcieNOjJF
WF91GP5Vi64vOieT/XyGCNjhZmCO1idTDp0uHoN5Iol6crhyhEbcbe2bkU6Z
J2YMbQVcJ2jEYlI8s8bAPHFnctMmkRkaUcTarXkw5heRIK/TmP2HRmxgCr12
tWmBCDiXK/Vjcy/xfOHt3s3Wi0Tv5qeXKKReQrbb8tEfp79EuGpD1pRrL9F/
RS8m++Ff4onIP8+7Z3uJO1oKxwyW/xKnI7ljrM/1EnwpjMyJN9aIouoA+kO/
XmLz/qcnxOA/ojFMpdEsqpfwO7Y1Lm/bBqDuc/HdQk4vYdt0QavJgwm8XDFg
2vG1l9CUOHs36wYTGCN5OXh/7yW4Ak+yez1jAuRfSycLenqJVhnzfi6mjYAc
Uqi41t9L7AuXTXa4tRH8uiJu6z3dS+hodw5NN24CPLrBsbuZ6YRgof5/fCQW
4MDeneKijvbjOYY4HksWMLHNcloA7be/iLqLXBdZQIhUz84GbRQPdJk6bGtm
ATYnHYu36NOJaA476c1erMB8qvaU4T603wdfeLzwlA246RqXutjTCYemHfnz
vWxAS10sqBTt7018S2mzzFuAoYHb3dET6Pz2OOzi5NEtoIH5uYiNM504+jOJ
GPq7BQyaHfjR5YHOp9bFHzqMtoLSQ4Fq1ei8oZ7rTm332grsstN8bl5G57lJ
5cdtGVsBB4N5tW8YnQi6UpnWMroV9A1fvckXRSdUa18fq7u6DUgYvlnkS0Dn
M4We0Yov24Gnl1/c1gw6wRyY0/14bTs4Pf/dJS0TxdNOj4e/cXMAq73XhPlu
ofPsI7/OL3ocwG5+aD/bbRS/m668+JTMAUw0ykWe5dEJnXCWqCZ1TtBT3Sik
8gDFgwcMn4wYc4ILRtIbnR/SCXOhkB/MxzhB+Ls6auojOuFYOU0YR3GCSlo7
beQxnYgf+br65jMnsH/susG5ik50WRUGvPTjAmzsadvv1qL4SJRe2H2FC5Q9
234zk4rad0zgy3I2FxDrfViWBOkEY0ySxs56LrDInnnb/Q2dUKr2nXnKyw3c
6ljb1urpRIikofujKm5wp2A45EYL6t+p4JutzdwA/HqWaPuBTlx/8bRxspcb
dFV5vhNoRf1xWEGOzMwDDCM3jKd9pBMf4jkGS47wgKQK1UHPdhQ/zPUez1vk
AXazNcfyv9EJearA1dfsvODNryFPAp3X1ZOsX/ZJ8AKXeiOt78jGpAYh8f28
YHHHPs7N6LzvZf/gW9ZNXlD25QM0QvEB9U3wwf90+YB1j224cx86ryfGzhw9
wAc23+079RU51ubGNTFHPtD50q9s3w/UnsNFH4pj+ECk8r8bsig+6WJt31/T
xgeGj7NTPg7Qid9W8ob00/ygbrCKsxfFP12CGj/yL/GDOVul/p0oPnrVrx/u
lsQPJuLpZ9OQo/0O1c4+5gfh32+VG6F4iiszVHfjX35QJHQu9SaKv1ToHeoK
qQLgTd2TPWwonuMqoX+aLBQAF7zGgw8hL/iM+Tx5LgCiG+D9LOSXjAyPdvUK
AHPuQgaFSTphSlJSslAQBGsJUT+0UXzoei5C2pcqCCrVTD0VUDxpopX0Rrtd
ECQ536hyRib/Sz+1OigILqT8Id9GnrtelhPDJgQoXz/d24ri1fDKb8KZh4WA
ia2fxhBy9ooyz6txISBDuA/5oHj4HZETwM8gDE74jojlI89FcXw/zyMMPPXD
b3Qgm7DP3ybpC4PdnRtUdvxC81vkudz1ZGEQ/mlT+iSy+CmFhLE8YZA9f3RM
EMXnpoW3JvY+EwaDmVXJRsi5ypcfL9GFgdCsTvst5AO7DXc5q4kAxqgNV/VR
vH8xsuL2KyMR0P8totQFx/8NMgwC9iKgStqDnIi8bMFc3xIpAsZiF05/RS46
2WKh1SECzCcc/7ji5xHhtk6sgaJgb+qRcx74+Ub9uzrnRFGQNKnRE49sw7pT
rjZHFDw5nPmpGLn0hvDEhUZRkF7sdaQf2Tavz79HUAyYLixusF6iExHDBzu1
VMRAm87sN0/kMsW3ujcMxYDjtSLDOGTGisJ/Rh7o/WCgpwb50Vv3+EcvxcCV
35cPii6j8cPcM876SQyc2H96WRN5s/kBC5chMTARlrPXHNmhQ5VbcJs4YOjo
eXMJmWXoV3bkSXGgWKiW3IZMiSI6FTdIALdooSSvFTQ/8h1fl7JJgNic88/C
kDXfRpQq8kgAnh9BedeRdzLVhSjKSQAy0/EXj5ENo0wkFQ9IgLGPTzhnkQ9F
HXRXuCkB+hzyOVxX0e/Nv3DoXp4E4Ghmz72AbPc2VU+hTAIkW99cDUN2YPq6
TYEqAcoHtkvcQnaJsq+QH5IAzbbxMi3IAVHOq3JqkqA3ZfyF3F/Uf/nRQ8W6
kqCDg+qjjhz0trBVbq8kmBk5/lcPOYxpJFfuiCSwfW+TexD5SpSnkdxlScCn
yCl6CflWlH8yqUkSbC62c3+NnJ2fHljULglCf7fQmpDvvH3mSOqRBLvNL6u1
I+czLauTpiXBrX2ewf3IZVGh32R5pUDeE+GiDWtovkbFSciekgJ1BxWrdJFH
qjpk/N2lwEyRHDBA5hmTVKj3lQLq1sxP9iF7Wr1Uc42VAs3qHy1skEVEZw0L
70sBtm9D/p7IIVX2rrK/pcBzhbOvM5FLRovP+v+TAr+vXZrBz3s7RBbO1bNI
A/lVN/Z8ZHLUtQBXYWnAkP93ywPkbsu6uEIgDSZyfNUgsu6ocqlsojSwLxG3
GEA+LRL80D9NGvziYnXHz69TLBuf1N+WBp7C7wLw8+2xp04vXMulQez3HOd5
/Pw4MqOl8Is00Ex4dJ3xH51YEt4wLSshA+y3K7iK4ef/lhbz/goyoFxksAg/
X7eKzPpTry4DsuUye2SQS0Z2MJw2kgFsjNkySsh2T905i9xlwLJSvZI2zv9a
dGiQnsqANB0d3QM4X0vtEDSgyoAW3rebcb7AjvLl37EmGWAYwt+I8wl/OL++
v0GTAS4PPirY4Xzil2/OfzfJAp1oXS8n5M3GnfsFOGQBKevzkAvOP1Z1qmoI
yYLT6gmHzuD8Zeb3FTcVWdAcN8npifObx7pTO2xlAYd5jZg/zje1dF+adpQF
4Mh5s0CcD9XvOcnmIQvuFJ/3xvmReTGaEgiTBS8Fvt++jPPB/b1v7xcj685l
xCCXu/XPRy7KAsMPAqJpOP/zvf/7bUYSaL+Q/QHnc6xMB6jP2Umg5ql9IM73
TCsNJk5JkMCgxHzVLWSV6SFp+/0kcPqqz2guzv+cHGb1P0QCeeR7p/NwPqRt
ePracRI40TNKy8f5qyc/X9SfJ4GGR/01Rchl/qOH1G6RgM9xHbUynO8ZHt1p
XkACCWd1I3B+yvzImPiZhyQAC5fe4/zVuM74ePYbEuC5x2T9GFlxdSKKZZwE
JBLCpHA+rDhypoK+Sw4sj/cN1eJ88/nvBw8YyYHayKTvON8m4fhmusZCDljv
LmnC+bhM/TSl9FNygLLbNecNztcsauebx8mBh8dOSDUge3mFpVS3y4Ff5JXr
ON+neNyNItcjB0gbww9+QP5pdrA1bUgO9BzT3I7zg44K0mw+i3JgIupwJM4n
HhxsiCCJyYP2lXST9vX84rbzqWflQbpq3PFvOJ9j8mfbBl95MOd7dwH7gXZf
mVeIPFA/H5mI85sk3icj+6+hz1Ory3H+k7/tsCPDU3kgJET/0Y28bHTb8hyD
AtgsXD6E86lVmrGTXawKwP5S9/E+ZF9p70QTbgWwbbtRB/YEg8E7aZICgDyT
L3A+tvfF4O4uMwXQUGIYOIDzg2pklX0ZCqCUeX8+zgdLnWh8EHZXAezWlmH7
iRyZ4KL8/L4CaDM/4Y1tOJBNVoAKoCuYdQfOL79J26q0ZVQB/HaaeoDz0VKv
75XumVcAYn99Wcbw5yeNFEP+KgD58IRT2HuMQxUmORWBvEfE9vF/+PnplNxH
XUVgPapxDOe7ZWQSi5mNFIFifG8pdrSVnBywVAR8fMZL2Eb3TpIeOysCN3vH
FJwvb7Bvk0lNUgRzLWZVON/e+Oqx5JFeRVBexNGE8/fyYwfuXhtRBDos9Ztx
fv8K35hE45wiiCSH7cHe7y0lsZNZCYArPDXYzRKpYsIUJVCWp5I9h/v/gOqd
Q7pKILkgpB074dJ70aS9SkDIY4oZ1xuYtTOJ/rVTAhZkMx/slig/YXqEEiiq
3aeN6xPI5RxZ/ElKwCSR68x6fUNPmZBVuhLwjBFOxz6wY0jwdakSqNP/NYvd
OnxYIP+zEtB7zH0X10d83K/Ne0aWDN6sBdNxPYXIrxfmcypk0GDCyYjrM9zu
gOjLOmRQFS8tg804v38+1YwM+kobTmNrZTt8gufJ4PrUrmHsKOMfLObBZDSf
Jjfi+o+2GVfwLZoMrvApSWO7G3k/mswgA91hyxPYt6cirgrVkkHAgvdH7LHM
zfWF78hgmOvhGLbWnsRVyicykPgTvQnXn7RlpHnsGySDTEUmXeyNBsX7/diU
wZVs9zvYHqktm1ptlcFEs5gtrn95rn9Q/6ijMohMT/NYr48Z+eI3eFYZlHNW
h2Pf0aMPLIcog4f9XKXY7UOzr+XylQGIVVzCFr8esPSkTBlkx2qx4/ocT90V
yu4qZXDi2LIY9uZrG3NtmpRB69sHe7B36vCHRkwrg9DLffHYsf1ZT9mXlAFZ
qfEWdnuSxGQGowr42ux9f/16PxQcHvKqANtixhbs3AQ93e5dKsAlwooN1xcx
00791ryiAhhZLUOwQ29x7b9+QwWU1x+Px/515G3W+C0V0LK2Kx27v13GIO+B
CiirPPsI+2Xjz8Ttn1UA2HObju1TeU5yTFQVpF9a0F6vvzov5mckpwr8NpoZ
Yh9X/diQS1EF7IpB5timpRTPI3tUAUvoGUds2dz5qjo3VXDF6WosdlfiJfOc
ClXwJOZiC7bVfsWc5ZeqQNOkqAP73ebu2cMNqiC2+GkPdmWEXgb7d1WQsBY0
gX0t8N+PS2uqIGBDGRuuL8t7/GZXqQwF2A5vMMQ+ziE8dESBAkR+B5lgC3j7
Jm9SoQCVpW4L7GtkmR+O2hRwWv/IMeyQ4phYflMK0NHQ88U+ctvkU7Q3BaRd
Zs5Zr5+7FTSe4UcBzVL/FWBfyCzbdP8SBUi4s5diJ6Vy6H6KogA+4+pKbBjf
mSeaSQF+T3mbsA/Esb2i3Eb3X1z6gN0VrfdtTx4FgLjmduyFsNwt7mUUkNyg
1oOtGODmVwXR9RUlp7Cf+d5KbqqngE4dnznsvedbSnqaKaBj4sFv7JOeFBrj
F/R7j/1ew05zWjSyHKWAJ4/fbMP1hmsWV/hHONVA+kS40nq9rnmN2gqfGmhr
6lTBFjCdMNsmogbGVKXX6x81jKzCNUlqoN3r+nq9pNsugdFwXTWw6NO+F3tB
x5QpjVADfTZ1+9brL7VCRIv3qoETDqWm2NlqfQc/WKiBi2mHrLA/yZXUCDqr
geUK8WPr9bFS7NPEOTUAnI0csTeL+UifDlQDJdMGruv1vzw6SU8S1UD28zov
7AKGxuNmlWrAK5FrvZ70/iUe07pXaiDp9Yco7Cdzjlr679SAufC5OGw4uLRN
tUsNPPc9lrxeP9qoBLkY1EHBRvas9fvX1GVu5FYHb3K/52Ivlx0//1tWHQx/
PViEzXfjmlSXmTpo9Di8Xk8rEyW/8v6EOnB6N1qJre7/+vOr8+qgrla3Gtvi
6Hz03Qx1UNkg+Xq9/tMs6XhqqTr4PVVbt17/qy+rFfNKHdSOkBqx4ySP/HQb
UAeOJ5xb16+3elj8IrsGUHnn0IHd+9XmSNwODSC18c537ITHh66ln9AAdYb6
vdhaSdbvCuM0wMRGi/71euHTB/9VlmsAAd8fQ9hXDay0675rgPaCzev1zToi
lt6fGTWBT1/zOPbg7wPF/UqaYLl953o9tEoam67kB00wMmC4Xi99Ue1dy0mv
HcBla9R6PXXSgy29TRu1gPn87Ar2XQWraY0sLdC/O3C9HnsurFHYfLc2EDMP
Wq/X3vsVmLj80AYBI7zr9dyOWwzmiy/pgJcJXusOAQZ3xjl3gvbbhevWLGFc
pRTvBEGW79Y9vr3uaICeLkg737PuvoPV7Wd7dUHp9bF1d6Q+NDsevguscf9v
PXpapdKeEH49QJr9s+5DX0p0sx7qgTtoNcbe17kt9cARffCQ5X/r3f+vHh78
fz38/wCvDum4
     "]]}, 
   {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwUWXc4Ft4XL3tnR/be+7W9914V2aFECCE7RcjeIWkYUSiyRYQ3pOKWVbJC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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{-30, 30}, {0., 0.49999999999363065`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.6070982018723087`*^9, 3.607098330115303*^9, 3.6070995120562563`*^9, 
   3.6071002654236803`*^9, {3.607100321856378*^9, 3.607100347951535*^9}, 
   3.6071030285547047`*^9, 3.6071031983646717`*^9, {3.607103353879417*^9, 
   3.607103370112318*^9}, {3.6071037376323843`*^9, 3.607103785333597*^9}, 
   3.6071038864640007`*^9, 3.607104009964285*^9, 3.607104370487406*^9, 
   3.60710459545*^9, 3.60710484753782*^9, 3.607105123421694*^9, 
   3.6071051988762217`*^9, 3.60710528276278*^9, 3.607105382863516*^9, 
   3.6071055013943577`*^9, 3.607105572539032*^9, 3.607105691557831*^9, {
   3.60710578036104*^9, 3.6071057876774397`*^9}, 3.607105835592649*^9, {
   3.6071058902493477`*^9, 3.6071059337900476`*^9}, {3.607106006840055*^9, 
   3.6071060498563766`*^9}, 3.607106115450757*^9, {3.6071071719540777`*^9, 
   3.607107202937104*^9}, 3.607108708527184*^9, 3.6071090862654533`*^9, 
   3.607109130864118*^9, 3.60711098629805*^9, 3.607161416706417*^9, 
   3.6071618917266893`*^9, 3.607165110799247*^9, 3.6344873435067577`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Pure Soliton", "Subsection",
 CellChangeTimes->{{3.607161916250906*^9, 3.607161920079171*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Soliton", " ", "data"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"aa", "[", "n_", "]"}], ":=", 
     RowBox[{"1", "+", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", "2"}], 
        RowBox[{"(", "0.4", ")"}], "n"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "n_", "]"}], ":=", 
     RowBox[{
      RowBox[{"1", "/", "2"}], " ", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"aa", "[", 
          RowBox[{"n", "-", "1"}], "]"}], 
         RowBox[{"aa", "[", 
          RowBox[{"n", "+", "1"}], "]"}]}], "]"}], "/", 
       RowBox[{"aa", "[", "n", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"zz", "=", 
     RowBox[{"Exp", "[", 
      RowBox[{"-", 
       RowBox[{"(", "0.4", ")"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"b", "[", "n_", "]"}], ":=", 
     RowBox[{
      RowBox[{"1", "/", "2"}], 
      RowBox[{"(", 
       RowBox[{"zz", "-", 
        RowBox[{"zz", "^", 
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}]}]}], ")"}], 
      RowBox[{"(", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"aa", "[", "n", "]"}], "-", "1"}], ")"}], "/", 
         RowBox[{"aa", "[", "n", "]"}]}], " ", "-", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"aa", "[", 
            RowBox[{"n", "-", "1"}], "]"}], "-", "1"}], ")"}], "/", 
         RowBox[{"aa", "[", 
          RowBox[{"n", "-", "1"}], "]"}]}]}], ")"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "[", "n", "]"}], ",", " ", 
       RowBox[{"b", "[", "n", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"-", "30"}], ",", "30"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.607096766447352*^9, 3.607096780982254*^9}, {
   3.60715502501369*^9, 3.607155028531309*^9}, {3.607161929711215*^9, 
   3.607161930008462*^9}, 3.60716273500425*^9, 3.6071651174675493`*^9, {
   3.634487352459873*^9, 3.634487352603434*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJw12nk8lN37OHBLZd/3fRvDMJihkO0+kn0PkWxJhUpKtNBiKYrI8kRRKUlJ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     "]]}, 
   {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwUV3c8lt8bLsome2XvvV6b95yjobKyFRlf2aFsZWSTSCGEQjJD4U1oOGWV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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{-30, 30}, {0., 0.5405360528673813}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.607161930633729*^9, 3.6071651180950117`*^9, 
  3.634487353152608*^9}]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Setup Reflection Coefficients", "Section",
 CellChangeTimes->{{3.568330677064375*^9, 3.568330681593184*^9}, {
   3.634487703159522*^9, 3.634487704158392*^9}, 3.634660402059456*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"scattering", " ", "data", " ", "for", " ", "n"}], " ", 
    "\[GreaterEqual]", "0"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "need", " ", "to", " ", "make", " ", "this", " ", "all", " ", "more", " ", 
    "automatic"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ll", "=", "10"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"H1", "=", 
     RowBox[{"ScatteringMatrixFiniteTodaC", "[", 
      RowBox[{"a", ",", "b", ",", "ll"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"aa1", "//", "Clear"}], ";", 
    RowBox[{"bb1", "//", "Clear"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"aa1", "[", "k_", "]"}], ":=", 
     RowBox[{
      RowBox[{"aa1", "[", "k", "]"}], "=", 
      RowBox[{
       RowBox[{"H1", "[", "k", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"bb1", "[", "k_", "]"}], ":=", 
     RowBox[{
      RowBox[{"bb1", "[", "k", "]"}], "=", 
      RowBox[{
       RowBox[{"H1", "[", "k", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]1", "[", "k_", "]"}], ":=", 
     RowBox[{
      RowBox[{"bb1", "[", "k", "]"}], "/", 
      RowBox[{"aa1", "[", "k", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]1", "[", "1.", "]"}], ":=", 
     RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]1", "[", 
      RowBox[{"-", "1."}], "]"}], ":=", 
     RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"ma1", "=", 
    RowBox[{"LocatePolesToda", "[", 
     RowBox[{"a", ",", "b", ",", "200"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"mc1", " ", "=", 
    RowBox[{"ResiduesToda", "[", 
     RowBox[{"a", ",", "b", ",", "ma1", ",", "200"}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"scattering", " ", "data", " ", "for", " ", "n"}], " ", "<", " ",
      "0"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
      "We", " ", "only", " ", "solve", " ", "Toda", " ", "for", " ", "n"}], 
      " ", "\[GreaterEqual]", 
      RowBox[{"0.", "  ", "It", " ", "follows", " ", "that", " ", "if", " ", 
       RowBox[{"(", 
        RowBox[{"a_n", ",", "b_n"}], ")"}], " ", "solves", " ", "Toda", " ", 
       "then", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"a_", 
          RowBox[{"{", 
           RowBox[{"-", "n"}], "}"}]}], ",", 
         RowBox[{
          RowBox[{"-", "b_"}], 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "n"}], " ", "+", " ", "1"}], "}"}]}]}], ")"}], " ", 
       "also", " ", "solves", " ", 
       RowBox[{"Toda", ".", "  ", "So"}]}]}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "if", " ", "we", " ", "solve", " ", "Toda", " ", "with", " ", 
        "initial", " ", "data", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"a_", 
           RowBox[{"{", 
            RowBox[{"-", "n"}], "}"}]}], ",", 
          RowBox[{
           RowBox[{"-", "b_"}], 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "n"}], "+", "1"}], "}"}]}]}], ")"}], " ", "to", " ",
         "find", " ", 
        RowBox[{"(", 
         RowBox[{"A_n", ",", " ", "B_n"}], ")"}], " ", "for", " ", "only", 
        " ", "n"}], " ", ">", " ", 
       RowBox[{"0", " ", "then", " ", "we", " ", "can", " ", "find", " ", 
        RowBox[{"(", 
         RowBox[{"a_n", ",", "b_n"}], ")"}], " ", "for", " ", "n"}], " ", "<",
        " ", 
       RowBox[{
       "0", "  ", "by", " ", "the", " ", "relation", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{"a_n", ",", "b_n"}], ")"}]}]}], " ", "=", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"A_", 
          RowBox[{"{", 
           RowBox[{"-", "n"}], "}"}]}], ",", " ", 
         RowBox[{
          RowBox[{"-", " ", "B_"}], 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "n"}], "+", "1"}], "}"}]}]}], ")"}], "."}]}]}], 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"H2", "=", 
     RowBox[{"ScatteringMatrixFiniteTodaC", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"-", "#"}], "]"}], "&"}], ",", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"b", "[", 
          RowBox[{
           RowBox[{"-", "#"}], "+", "1"}], "]"}]}], "&"}], ",", "ll"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"aa2", "//", "Clear"}], ";", 
    RowBox[{"bb2", "//", "Clear"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"aa2", "[", "k_", "]"}], ":=", 
     RowBox[{
      RowBox[{"aa2", "[", "k", "]"}], "=", 
      RowBox[{
       RowBox[{"H2", "[", "k", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"2", ",", "2"}], "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"bb2", "[", "k_", "]"}], ":=", 
     RowBox[{
      RowBox[{"bb2", "[", "k", "]"}], "=", 
      RowBox[{
       RowBox[{"H2", "[", "k", "]"}], "[", 
       RowBox[{"[", 
        RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]2", "[", "k_", "]"}], ":=", 
     RowBox[{
      RowBox[{"bb2", "[", "k", "]"}], "/", 
      RowBox[{"aa2", "[", "k", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]2", "[", "1.", "]"}], ":=", 
     RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Rho]2", "[", 
      RowBox[{"-", "1."}], "]"}], ":=", 
     RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"ma2", "=", 
    RowBox[{"LocatePolesToda", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"-", "#"}], "]"}], "&"}], ",", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"b", "[", 
         RowBox[{
          RowBox[{"-", "#"}], "+", "1"}], "]"}]}], "&"}], ",", "200"}], 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"mc2", "=", 
    RowBox[{"ResiduesToda", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", 
        RowBox[{"-", "#"}], "]"}], "&"}], ",", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"b", "[", 
         RowBox[{
          RowBox[{"-", "#"}], "+", "1"}], "]"}]}], "&"}], ",", "ma2", ",", 
      "200"}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"strip", " ", "of", " ", "analyticity", " ", "guess"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"min", " ", "=", " ", 
     RowBox[{"Min", "[", 
      RowBox[{".3", ",", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"ma1", "-", "1"}], "]"}], ",", 
          RowBox[{"Abs", "[", 
           RowBox[{"ma1", "+", "1"}], "]"}], ",", 
          RowBox[{"Abs", "[", 
           RowBox[{"ma2", "+", "1"}], "]"}], ",", 
          RowBox[{"Abs", "[", 
           RowBox[{"ma2", "-", "1"}], "]"}]}], "]"}], "//", "Min"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"setup", " ", "scattering", " ", "data"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetScatteringData", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Rho]1", ",", "ma1", ",", "mc1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Rho]2", ",", "ma2", ",", "mc2"}], "}"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"various", " ", 
       RowBox[{"parameters", " ", "--"}]}], "-", " ", 
      RowBox[{"third", ":", " ", 
       RowBox[{"truncation", " ", "tolerance"}]}]}], ",", " ", 
     RowBox[{"fourth", ":", " ", "smallN"}], ",", " ", 
     RowBox[{"fifth", ":", " ", "largeN"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", "15"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SetParams", "[", 
     RowBox[{
      RowBox[{"min", "/", "1.1"}], ",", 
      RowBox[{"min", "/", "1.1"}], ",", 
      RowBox[{
       RowBox[{"(", "10", ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"-", "12"}], ")"}]}], ",", "m", ",", 
      RowBox[{"2", "m"}]}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.568127921959548*^9, 3.568127932853901*^9}, {
   3.568128002566908*^9, 3.5681280074903717`*^9}, {3.5681284474414454`*^9, 
   3.568128447659729*^9}, {3.568131062720419*^9, 3.568131064253304*^9}, {
   3.568132433801778*^9, 3.568132434221836*^9}, {3.5681417040964003`*^9, 
   3.5681417043272867`*^9}, {3.568330300693228*^9, 3.568330301361621*^9}, 
   3.568380261582943*^9, {3.568380349871984*^9, 3.568380350016452*^9}, {
   3.5683804920372257`*^9, 3.568380492621241*^9}, {3.568380549398284*^9, 
   3.568380559486307*^9}, {3.568381034245331*^9, 3.568381034384123*^9}, {
   3.568381609284*^9, 3.568381621050935*^9}, {3.56838171791359*^9, 
   3.5683817193011923`*^9}, {3.568382065575877*^9, 3.568382065889907*^9}, {
   3.568382103092526*^9, 3.56838210351702*^9}, {3.5683822158837852`*^9, 
   3.568382261358132*^9}, {3.568382298383832*^9, 3.56838230519163*^9}, 
   3.568383541840426*^9, {3.568393458291432*^9, 3.56839346835115*^9}, {
   3.568395341812977*^9, 3.5683953420047493`*^9}, {3.568396002096843*^9, 
   3.568396048536149*^9}, 3.568398265869356*^9, {3.5684003659023533`*^9, 
   3.5684003680156507`*^9}, 3.568400462185608*^9, {3.5684005082646637`*^9, 
   3.568400508610486*^9}, {3.5684008142416067`*^9, 3.5684008193686438`*^9}, 
   3.568408679247623*^9, 3.568427458744276*^9, 3.606334782365445*^9, {
   3.606334899797213*^9, 3.606334923278202*^9}, {3.6344873183516083`*^9, 
   3.634487322175232*^9}, {3.634487433167691*^9, 3.634487500863851*^9}, {
   3.634551484662747*^9, 3.634551485680566*^9}, {3.634554704501254*^9, 
   3.634554705463745*^9}, 3.63458703608225*^9, {3.634588771538206*^9, 
   3.6345887734460793`*^9}, {3.634597040354413*^9, 3.634597041920375*^9}, {
   3.6345980619036217`*^9, 3.634598065701995*^9}, {3.634599133240531*^9, 
   3.634599137022954*^9}, {3.634599259240555*^9, 3.634599261112322*^9}, {
   3.6345993936013603`*^9, 3.63459946429637*^9}, {3.634599574430828*^9, 
   3.634599574516617*^9}, {3.634599687095737*^9, 3.634599688053783*^9}, {
   3.6345998459439583`*^9, 3.634599846160742*^9}, {3.634646889386169*^9, 
   3.63464698575704*^9}, {3.6346470226171217`*^9, 3.63464708427806*^9}, {
   3.634647200513029*^9, 3.634647220657658*^9}, {3.634648206499818*^9, 
   3.634648208123184*^9}, {3.6346483402475*^9, 3.634648351870151*^9}, {
   3.634648394045569*^9, 3.634648400637271*^9}, {3.634648624725906*^9, 
   3.63464862666171*^9}, {3.6346489163394413`*^9, 3.634648920620256*^9}, {
   3.634649254480884*^9, 3.634649394358411*^9}, {3.634649451052813*^9, 
   3.634649566657051*^9}, {3.6346496243654947`*^9, 3.634649678577157*^9}, {
   3.634651568135417*^9, 3.634651582544364*^9}, {3.634651724852954*^9, 
   3.634651747010193*^9}, {3.6346538253635597`*^9, 3.634653827602309*^9}, {
   3.6346593514068336`*^9, 3.634659351675948*^9}, {3.634660327154319*^9, 
   3.634660334197047*^9}, {3.6346622791193438`*^9, 3.634662281246945*^9}, {
   3.634672494282363*^9, 3.634672498031003*^9}, {3.6346739825350943`*^9, 
   3.634673995870124*^9}, {3.634730565215188*^9, 3.63473057041434*^9}, {
   3.634730700164702*^9, 3.6347307005941687`*^9}, {3.63473148888319*^9, 
   3.634731507022571*^9}, {3.634733518766261*^9, 3.634733534664599*^9}, {
   3.634742914705929*^9, 3.63474291635316*^9}, {3.634750134374564*^9, 
   3.634750196178236*^9}, {3.6347502570022087`*^9, 3.634750265377737*^9}, {
   3.634826528267282*^9, 3.634826542185071*^9}, {3.634830265428549*^9, 
   3.6348302675546513`*^9}, {3.634830577075926*^9, 3.634830579559712*^9}, {
   3.634830657409191*^9, 3.6348306608554497`*^9}, {3.634831108870076*^9, 
   3.634831111765032*^9}, {3.634832380822528*^9, 3.634832383633574*^9}, {
   3.634832698838833*^9, 3.6348327014373293`*^9}, {3.6364833252731667`*^9, 
   3.6364833284440613`*^9}, {3.636483668864217*^9, 3.636483672619129*^9}, {
   3.636483926406249*^9, 3.63648392863614*^9}, {3.6365448941198263`*^9, 
   3.636544895664378*^9}, {3.63654575079173*^9, 3.636545753246736*^9}, {
   3.636545939654492*^9, 3.636545944540885*^9}, {3.636549544825492*^9, 
   3.636549547064083*^9}, {3.636549726365365*^9, 3.636549737560587*^9}, {
   3.6365667720680113`*^9, 3.636566775506854*^9}, {3.63656709249057*^9, 
   3.63656709494558*^9}, {3.63656715313701*^9, 3.6365671561920652`*^9}, {
   3.636567758273856*^9, 3.6365677609841757`*^9}, {3.636568030352228*^9, 
   3.636568032229825*^9}, {3.63656826895324*^9, 3.636568271072805*^9}, {
   3.6365686424937963`*^9, 3.636568645411717*^9}, {3.636568979399499*^9, 
   3.636568983166533*^9}, {3.6368149373967867`*^9, 3.636814940067411*^9}, {
   3.6374373634940968`*^9, 3.637437365617481*^9}, {3.637437516638946*^9, 
   3.637437569884763*^9}, {3.6454637649594193`*^9, 3.6454637671090603`*^9}, {
   3.6454640643120213`*^9, 3.645464065797468*^9}, {3.645464416901739*^9, 
   3.645464420484593*^9}, {3.645464459981757*^9, 3.6454644762431097`*^9}, {
   3.6454645910093307`*^9, 3.645464610855571*^9}, {3.645465901697023*^9, 
   3.645465904814413*^9}, {3.6455415499895983`*^9, 3.645541555347293*^9}, {
   3.645613802873624*^9, 3.645613805250339*^9}, {3.6456223329535847`*^9, 
   3.645622333840748*^9}, {3.6456308767571297`*^9, 3.645630877023076*^9}, {
   3.645874051004511*^9, 3.64587405343141*^9}, {3.645874414391643*^9, 
   3.645874420478368*^9}, {3.645884382849118*^9, 3.645884387292397*^9}, {
   3.6458852999888153`*^9, 3.6458853032399263`*^9}, {3.645885338487*^9, 
   3.645885338709251*^9}, {3.6459669914239407`*^9, 3.6459669951284103`*^9}, {
   3.645981172254602*^9, 3.645981173956319*^9}, {3.64726597511452*^9, 
   3.647265984515049*^9}, {3.647268315504574*^9, 3.6472683431590137`*^9}, {
   3.647280314396285*^9, 3.647280314506496*^9}, {3.647280891931698*^9, 
   3.647280893746375*^9}, {3.6472811291778097`*^9, 3.6472811293290167`*^9}, {
   3.64728320893908*^9, 3.647283209280567*^9}, {3.6473559093134947`*^9, 
   3.647355919301302*^9}, {3.64743787160861*^9, 3.647437874287624*^9}, {
   3.6474383662022657`*^9, 3.647438368576933*^9}, {3.647439028266683*^9, 
   3.6474390608640957`*^9}, {3.64744078613078*^9, 3.647440791048232*^9}, {
   3.6474502375441093`*^9, 3.6474502378792143`*^9}, {3.6474526682053003`*^9, 
   3.647452672147517*^9}, {3.6474541544054117`*^9, 3.647454170890525*^9}, {
   3.647455463885013*^9, 3.647455476491713*^9}, {3.64745571512912*^9, 
   3.647455715559943*^9}, {3.6474562031121397`*^9, 3.6474562034310617`*^9}, 
   3.6474564641121264`*^9, {3.647456499626141*^9, 3.647456500433098*^9}, {
   3.647456863085932*^9, 3.647456879108511*^9}, 3.6474569110765667`*^9, {
   3.6585911862660313`*^9, 3.658591188897155*^9}, {3.6699019137577457`*^9, 
   3.669901913875519*^9}, {3.6702379132716703`*^9, 3.670237914231017*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5961420789683354`", ",", 
   RowBox[{
    RowBox[{"-", "0.7048589863302892`"}], "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.636462646851384*^9, 3.63646280628603*^9, 3.636462874853283*^9, {
   3.636462933576659*^9, 3.636462951358379*^9}, 3.636479562324979*^9, 
   3.636479603364944*^9, 3.636479943729957*^9, 3.636480045382715*^9, 
   3.636480192424007*^9, 3.636480542112059*^9, 3.636480598515188*^9, 
   3.63648214268475*^9, 3.636482589615883*^9, 3.636482642254519*^9, 
   3.636483329098032*^9, 3.636483628049892*^9, 3.636483673063673*^9, 
   3.636483765115247*^9, 3.63648392906851*^9, 3.6364842824029703`*^9, 
   3.636542547977421*^9, 3.636543239885788*^9, 3.6365432907762337`*^9, 
   3.636543458711968*^9, {3.636544021553356*^9, 3.6365440414400263`*^9}, {
   3.636544164968217*^9, 3.636544189317101*^9}, 3.636544299226224*^9, 
   3.636544386416114*^9, 3.636544423031928*^9, 3.6365445273325987`*^9, 
   3.636544588973103*^9, 3.636544780397634*^9, 3.6365448137377863`*^9, 
   3.636544896147871*^9, 3.6365450015861197`*^9, 3.636545356011181*^9, 
   3.6365455631734667`*^9, {3.6365456254155293`*^9, 3.636545655387309*^9}, 
   3.6365457166784983`*^9, 3.636545753593766*^9, 3.636545945178433*^9, 
   3.636549427530669*^9, 3.636549471726996*^9, {3.636549535078075*^9, 
   3.636549547480281*^9}, {3.636549728954068*^9, 3.63654973788682*^9}, 
   3.636549792668211*^9, 3.636549975688675*^9, 3.636550106123747*^9, 
   3.636551767636756*^9, 3.636552217263549*^9, {3.636557690949176*^9, 
   3.6365577075738077`*^9}, 3.636559455850911*^9, 3.6365600440102587`*^9, 
   3.636560189133195*^9, {3.636560389970348*^9, 3.636560409769514*^9}, 
   3.636560594524077*^9, 3.636561081746148*^9, {3.6365611629066753`*^9, 
   3.636561184731662*^9}, 3.636562506810142*^9, 3.636562726980426*^9, 
   3.636562805980872*^9, 3.636563007106784*^9, 3.63656307927901*^9, {
   3.636563163120838*^9, 3.636563204577136*^9}, 3.636563281563301*^9, 
   3.636563320222787*^9, 3.636565667556663*^9, 3.6365659028141603`*^9, 
   3.6365665309186153`*^9, 3.636566775862789*^9, 3.6365670953360863`*^9, {
   3.636567143105894*^9, 3.636567156567916*^9}, 3.636567455957905*^9, 
   3.636567631254016*^9, 3.6365677617877293`*^9, {3.636568032548525*^9, 
   3.6365680440989637`*^9}, 3.6365682723362827`*^9, 3.636568524203781*^9, 
   3.636568646987482*^9, {3.636568976606017*^9, 3.636568983701004*^9}, 
   3.636569238034401*^9, 3.6365695806116037`*^9, 3.6365699504043503`*^9, 
   3.63656998742902*^9, 3.6365896366523952`*^9, 3.636589721791129*^9, 
   3.6365897903882008`*^9, 3.636589845919959*^9, 3.6365898850998898`*^9, 
   3.636813013941802*^9, 3.636813095470265*^9, {3.636813153854212*^9, 
   3.636813175804471*^9}, 3.636813680090459*^9, 3.636813733143071*^9, 
   3.636813866043968*^9, 3.636814688645596*^9, 3.636814755790698*^9, 
   3.636814846450329*^9, 3.6368149404485607`*^9, 3.63743746525592*^9, 
   3.645285706452883*^9, 3.645285776688691*^9, 3.6452862224298067`*^9, 
   3.645286322278376*^9, 3.645286356682782*^9, 3.645287819551196*^9, 
   3.645287875283737*^9, 3.6452894480778503`*^9, 3.6452908904648314`*^9, 
   3.645291289856914*^9, 3.645291908570244*^9, {3.645292010772605*^9, 
   3.645292050640725*^9}, 3.645292367661249*^9, 3.6453562004922867`*^9, 
   3.645356443738459*^9, 3.6453565295782557`*^9, 3.645370820453113*^9, 
   3.6454463032414923`*^9, 3.645446669230735*^9, {3.645447066334998*^9, 
   3.6454470842259407`*^9}, 3.645447244057193*^9, 3.645447317131607*^9, {
   3.6454473929042397`*^9, 3.645447421760517*^9}, 3.645447625304206*^9, 
   3.6454477188504333`*^9, {3.645447967470718*^9, 3.645447987713724*^9}, {
   3.645448613417533*^9, 3.645448662588633*^9}, {3.645463656856164*^9, 
   3.645463672413319*^9}, 3.645463767476856*^9, 3.6454639364604893`*^9, {
   3.645464045691842*^9, 3.645464066171341*^9}, 3.645464163642479*^9, 
   3.645464262682786*^9, 3.645464331147489*^9, 3.645464388834178*^9, 
   3.6454644208801193`*^9, {3.645464462498644*^9, 3.6454644766356792`*^9}, {
   3.645464592161812*^9, 3.645464611153736*^9}, 3.645464904928524*^9, 
   3.645465107450404*^9, 3.6454652925934687`*^9, 3.645465330787938*^9, 
   3.645465813630231*^9, {3.6454659051830893`*^9, 3.645465921793579*^9}, 
   3.645466215757279*^9, 3.6454664888652487`*^9, 3.645466725820237*^9, 
   3.645466785495235*^9, 3.6454668634566097`*^9, 3.645467136465808*^9, 
   3.645467455841037*^9, 3.6454675231340437`*^9, 3.645467651917748*^9, 
   3.6454680348652353`*^9, 3.645484607044248*^9, 3.645484887686599*^9, 
   3.6455271807425823`*^9, 3.645541556900447*^9, {3.6456138166512547`*^9, 
   3.645613839785892*^9}, {3.6456192017911777`*^9, 3.64561921622015*^9}, 
   3.6456195387879543`*^9, 3.645619667430282*^9, 3.645619813683123*^9, 
   3.645619899436285*^9, {3.645620651074247*^9, 3.645620663479725*^9}, 
   3.645620844345819*^9, {3.645622329583362*^9, 3.645622335975501*^9}, 
   3.645630877474362*^9, 3.645703658595695*^9, 3.645703688988763*^9, 
   3.64580773654949*^9, 3.645809192347973*^9, 3.645810274896647*^9, 
   3.645826815028632*^9, 3.645874056523356*^9, 3.6458744208322773`*^9, 
   3.64587447936917*^9, 3.645884387868865*^9, 3.64588530364738*^9, 
   3.645885340256029*^9, 3.645966996067706*^9, 3.645980983379129*^9, 
   3.645981174970478*^9, {3.6472659574446583`*^9, 3.647265985081423*^9}, {
   3.647268339976733*^9, 3.647268343818327*^9}, {3.6472802984502497`*^9, 
   3.6472803149323273`*^9}, {3.647280881362988*^9, 3.6472808942013903`*^9}, 
   3.647281013732481*^9, {3.647281119732574*^9, 3.647281130007667*^9}, {
   3.647281236428999*^9, 3.647281263943698*^9}, 3.647281323431468*^9, 
   3.647283209606392*^9, {3.6473433420685*^9, 3.6473434602882338`*^9}, 
   3.647343559329129*^9, {3.64735591305345*^9, 3.6473559202353067`*^9}, 
   3.647392863975567*^9, 3.647433618687199*^9, 3.6474338050865173`*^9, 
   3.6474344365807056`*^9, 3.647436720039749*^9, 3.6474367850059023`*^9, 
   3.647436995689939*^9, 3.647437254215172*^9, 3.647437874952529*^9, 
   3.647438177111039*^9, 3.647438369051793*^9, 3.647438975012682*^9, 
   3.64743903251899*^9, 3.647439063596448*^9, 3.647439161624094*^9, 
   3.6474392903318863`*^9, 3.6474393428645697`*^9, 3.647439775323319*^9, 
   3.647440795182186*^9, 3.6474412153950253`*^9, 3.647450239118894*^9, 
   3.647452673019517*^9, 3.647454171418743*^9, {3.647455365969874*^9, 
   3.6474553751803217`*^9}, {3.647455466102232*^9, 3.647455476921639*^9}, 
   3.647455561617284*^9, 3.6474556379168158`*^9, {3.6474556694301434`*^9, 
   3.647455716227996*^9}, 3.647456204088505*^9, 3.6474563897388144`*^9, {
   3.6474564539901237`*^9, 3.647456501273264*^9}, {3.6474565424517803`*^9, 
   3.647456580477581*^9}, 3.6474566146063643`*^9, {3.64745664721033*^9, 
   3.647456708586362*^9}, {3.647456748375803*^9, 3.647456824014111*^9}, {
   3.647456863609393*^9, 3.6474569115226727`*^9}, {3.647457601728671*^9, 
   3.6474576573996897`*^9}, {3.6585911722134457`*^9, 3.6585911922837343`*^9}, 
   3.6699017497011213`*^9, 3.669901914403544*^9, 3.669903255482321*^9, 
   3.669904199787301*^9, 3.669904908509965*^9, 3.669906701387601*^9, 
   3.670235953603693*^9, 3.670237914640579*^9, 3.670682347898528*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.2579054623495054`", ",", "1.4305443225812722`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.636462646851384*^9, 3.63646280628603*^9, 3.636462874853283*^9, {
   3.636462933576659*^9, 3.636462951358379*^9}, 3.636479562324979*^9, 
   3.636479603364944*^9, 3.636479943729957*^9, 3.636480045382715*^9, 
   3.636480192424007*^9, 3.636480542112059*^9, 3.636480598515188*^9, 
   3.63648214268475*^9, 3.636482589615883*^9, 3.636482642254519*^9, 
   3.636483329098032*^9, 3.636483628049892*^9, 3.636483673063673*^9, 
   3.636483765115247*^9, 3.63648392906851*^9, 3.6364842824029703`*^9, 
   3.636542547977421*^9, 3.636543239885788*^9, 3.6365432907762337`*^9, 
   3.636543458711968*^9, {3.636544021553356*^9, 3.6365440414400263`*^9}, {
   3.636544164968217*^9, 3.636544189317101*^9}, 3.636544299226224*^9, 
   3.636544386416114*^9, 3.636544423031928*^9, 3.6365445273325987`*^9, 
   3.636544588973103*^9, 3.636544780397634*^9, 3.6365448137377863`*^9, 
   3.636544896147871*^9, 3.6365450015861197`*^9, 3.636545356011181*^9, 
   3.6365455631734667`*^9, {3.6365456254155293`*^9, 3.636545655387309*^9}, 
   3.6365457166784983`*^9, 3.636545753593766*^9, 3.636545945178433*^9, 
   3.636549427530669*^9, 3.636549471726996*^9, {3.636549535078075*^9, 
   3.636549547480281*^9}, {3.636549728954068*^9, 3.63654973788682*^9}, 
   3.636549792668211*^9, 3.636549975688675*^9, 3.636550106123747*^9, 
   3.636551767636756*^9, 3.636552217263549*^9, {3.636557690949176*^9, 
   3.6365577075738077`*^9}, 3.636559455850911*^9, 3.6365600440102587`*^9, 
   3.636560189133195*^9, {3.636560389970348*^9, 3.636560409769514*^9}, 
   3.636560594524077*^9, 3.636561081746148*^9, {3.6365611629066753`*^9, 
   3.636561184731662*^9}, 3.636562506810142*^9, 3.636562726980426*^9, 
   3.636562805980872*^9, 3.636563007106784*^9, 3.63656307927901*^9, {
   3.636563163120838*^9, 3.636563204577136*^9}, 3.636563281563301*^9, 
   3.636563320222787*^9, 3.636565667556663*^9, 3.6365659028141603`*^9, 
   3.6365665309186153`*^9, 3.636566775862789*^9, 3.6365670953360863`*^9, {
   3.636567143105894*^9, 3.636567156567916*^9}, 3.636567455957905*^9, 
   3.636567631254016*^9, 3.6365677617877293`*^9, {3.636568032548525*^9, 
   3.6365680440989637`*^9}, 3.6365682723362827`*^9, 3.636568524203781*^9, 
   3.636568646987482*^9, {3.636568976606017*^9, 3.636568983701004*^9}, 
   3.636569238034401*^9, 3.6365695806116037`*^9, 3.6365699504043503`*^9, 
   3.63656998742902*^9, 3.6365896366523952`*^9, 3.636589721791129*^9, 
   3.6365897903882008`*^9, 3.636589845919959*^9, 3.6365898850998898`*^9, 
   3.636813013941802*^9, 3.636813095470265*^9, {3.636813153854212*^9, 
   3.636813175804471*^9}, 3.636813680090459*^9, 3.636813733143071*^9, 
   3.636813866043968*^9, 3.636814688645596*^9, 3.636814755790698*^9, 
   3.636814846450329*^9, 3.6368149404485607`*^9, 3.63743746525592*^9, 
   3.645285706452883*^9, 3.645285776688691*^9, 3.6452862224298067`*^9, 
   3.645286322278376*^9, 3.645286356682782*^9, 3.645287819551196*^9, 
   3.645287875283737*^9, 3.6452894480778503`*^9, 3.6452908904648314`*^9, 
   3.645291289856914*^9, 3.645291908570244*^9, {3.645292010772605*^9, 
   3.645292050640725*^9}, 3.645292367661249*^9, 3.6453562004922867`*^9, 
   3.645356443738459*^9, 3.6453565295782557`*^9, 3.645370820453113*^9, 
   3.6454463032414923`*^9, 3.645446669230735*^9, {3.645447066334998*^9, 
   3.6454470842259407`*^9}, 3.645447244057193*^9, 3.645447317131607*^9, {
   3.6454473929042397`*^9, 3.645447421760517*^9}, 3.645447625304206*^9, 
   3.6454477188504333`*^9, {3.645447967470718*^9, 3.645447987713724*^9}, {
   3.645448613417533*^9, 3.645448662588633*^9}, {3.645463656856164*^9, 
   3.645463672413319*^9}, 3.645463767476856*^9, 3.6454639364604893`*^9, {
   3.645464045691842*^9, 3.645464066171341*^9}, 3.645464163642479*^9, 
   3.645464262682786*^9, 3.645464331147489*^9, 3.645464388834178*^9, 
   3.6454644208801193`*^9, {3.645464462498644*^9, 3.6454644766356792`*^9}, {
   3.645464592161812*^9, 3.645464611153736*^9}, 3.645464904928524*^9, 
   3.645465107450404*^9, 3.6454652925934687`*^9, 3.645465330787938*^9, 
   3.645465813630231*^9, {3.6454659051830893`*^9, 3.645465921793579*^9}, 
   3.645466215757279*^9, 3.6454664888652487`*^9, 3.645466725820237*^9, 
   3.645466785495235*^9, 3.6454668634566097`*^9, 3.645467136465808*^9, 
   3.645467455841037*^9, 3.6454675231340437`*^9, 3.645467651917748*^9, 
   3.6454680348652353`*^9, 3.645484607044248*^9, 3.645484887686599*^9, 
   3.6455271807425823`*^9, 3.645541556900447*^9, {3.6456138166512547`*^9, 
   3.645613839785892*^9}, {3.6456192017911777`*^9, 3.64561921622015*^9}, 
   3.6456195387879543`*^9, 3.645619667430282*^9, 3.645619813683123*^9, 
   3.645619899436285*^9, {3.645620651074247*^9, 3.645620663479725*^9}, 
   3.645620844345819*^9, {3.645622329583362*^9, 3.645622335975501*^9}, 
   3.645630877474362*^9, 3.645703658595695*^9, 3.645703688988763*^9, 
   3.64580773654949*^9, 3.645809192347973*^9, 3.645810274896647*^9, 
   3.645826815028632*^9, 3.645874056523356*^9, 3.6458744208322773`*^9, 
   3.64587447936917*^9, 3.645884387868865*^9, 3.64588530364738*^9, 
   3.645885340256029*^9, 3.645966996067706*^9, 3.645980983379129*^9, 
   3.645981174970478*^9, {3.6472659574446583`*^9, 3.647265985081423*^9}, {
   3.647268339976733*^9, 3.647268343818327*^9}, {3.6472802984502497`*^9, 
   3.6472803149323273`*^9}, {3.647280881362988*^9, 3.6472808942013903`*^9}, 
   3.647281013732481*^9, {3.647281119732574*^9, 3.647281130007667*^9}, {
   3.647281236428999*^9, 3.647281263943698*^9}, 3.647281323431468*^9, 
   3.647283209606392*^9, {3.6473433420685*^9, 3.6473434602882338`*^9}, 
   3.647343559329129*^9, {3.64735591305345*^9, 3.6473559202353067`*^9}, 
   3.647392863975567*^9, 3.647433618687199*^9, 3.6474338050865173`*^9, 
   3.6474344365807056`*^9, 3.647436720039749*^9, 3.6474367850059023`*^9, 
   3.647436995689939*^9, 3.647437254215172*^9, 3.647437874952529*^9, 
   3.647438177111039*^9, 3.647438369051793*^9, 3.647438975012682*^9, 
   3.64743903251899*^9, 3.647439063596448*^9, 3.647439161624094*^9, 
   3.6474392903318863`*^9, 3.6474393428645697`*^9, 3.647439775323319*^9, 
   3.647440795182186*^9, 3.6474412153950253`*^9, 3.647450239118894*^9, 
   3.647452673019517*^9, 3.647454171418743*^9, {3.647455365969874*^9, 
   3.6474553751803217`*^9}, {3.647455466102232*^9, 3.647455476921639*^9}, 
   3.647455561617284*^9, 3.6474556379168158`*^9, {3.6474556694301434`*^9, 
   3.647455716227996*^9}, 3.647456204088505*^9, 3.6474563897388144`*^9, {
   3.6474564539901237`*^9, 3.647456501273264*^9}, {3.6474565424517803`*^9, 
   3.647456580477581*^9}, 3.6474566146063643`*^9, {3.64745664721033*^9, 
   3.647456708586362*^9}, {3.647456748375803*^9, 3.647456824014111*^9}, {
   3.647456863609393*^9, 3.6474569115226727`*^9}, {3.647457601728671*^9, 
   3.6474576573996897`*^9}, {3.6585911722134457`*^9, 3.6585911922837343`*^9}, 
   3.6699017497011213`*^9, 3.669901914403544*^9, 3.669903255482321*^9, 
   3.669904199787301*^9, 3.669904908509965*^9, 3.669906701387601*^9, 
   3.670235953603693*^9, 3.670237914640579*^9, 3.6706823479576674`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "0.5961420789683383`"}], "+", 
    RowBox[{"0.`", " ", "\[ImaginaryI]"}]}], ",", "0.7048589863302852`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.636462646851384*^9, 3.63646280628603*^9, 3.636462874853283*^9, {
   3.636462933576659*^9, 3.636462951358379*^9}, 3.636479562324979*^9, 
   3.636479603364944*^9, 3.636479943729957*^9, 3.636480045382715*^9, 
   3.636480192424007*^9, 3.636480542112059*^9, 3.636480598515188*^9, 
   3.63648214268475*^9, 3.636482589615883*^9, 3.636482642254519*^9, 
   3.636483329098032*^9, 3.636483628049892*^9, 3.636483673063673*^9, 
   3.636483765115247*^9, 3.63648392906851*^9, 3.6364842824029703`*^9, 
   3.636542547977421*^9, 3.636543239885788*^9, 3.6365432907762337`*^9, 
   3.636543458711968*^9, {3.636544021553356*^9, 3.6365440414400263`*^9}, {
   3.636544164968217*^9, 3.636544189317101*^9}, 3.636544299226224*^9, 
   3.636544386416114*^9, 3.636544423031928*^9, 3.6365445273325987`*^9, 
   3.636544588973103*^9, 3.636544780397634*^9, 3.6365448137377863`*^9, 
   3.636544896147871*^9, 3.6365450015861197`*^9, 3.636545356011181*^9, 
   3.6365455631734667`*^9, {3.6365456254155293`*^9, 3.636545655387309*^9}, 
   3.6365457166784983`*^9, 3.636545753593766*^9, 3.636545945178433*^9, 
   3.636549427530669*^9, 3.636549471726996*^9, {3.636549535078075*^9, 
   3.636549547480281*^9}, {3.636549728954068*^9, 3.63654973788682*^9}, 
   3.636549792668211*^9, 3.636549975688675*^9, 3.636550106123747*^9, 
   3.636551767636756*^9, 3.636552217263549*^9, {3.636557690949176*^9, 
   3.6365577075738077`*^9}, 3.636559455850911*^9, 3.6365600440102587`*^9, 
   3.636560189133195*^9, {3.636560389970348*^9, 3.636560409769514*^9}, 
   3.636560594524077*^9, 3.636561081746148*^9, {3.6365611629066753`*^9, 
   3.636561184731662*^9}, 3.636562506810142*^9, 3.636562726980426*^9, 
   3.636562805980872*^9, 3.636563007106784*^9, 3.63656307927901*^9, {
   3.636563163120838*^9, 3.636563204577136*^9}, 3.636563281563301*^9, 
   3.636563320222787*^9, 3.636565667556663*^9, 3.6365659028141603`*^9, 
   3.6365665309186153`*^9, 3.636566775862789*^9, 3.6365670953360863`*^9, {
   3.636567143105894*^9, 3.636567156567916*^9}, 3.636567455957905*^9, 
   3.636567631254016*^9, 3.6365677617877293`*^9, {3.636568032548525*^9, 
   3.6365680440989637`*^9}, 3.6365682723362827`*^9, 3.636568524203781*^9, 
   3.636568646987482*^9, {3.636568976606017*^9, 3.636568983701004*^9}, 
   3.636569238034401*^9, 3.6365695806116037`*^9, 3.6365699504043503`*^9, 
   3.63656998742902*^9, 3.6365896366523952`*^9, 3.636589721791129*^9, 
   3.6365897903882008`*^9, 3.636589845919959*^9, 3.6365898850998898`*^9, 
   3.636813013941802*^9, 3.636813095470265*^9, {3.636813153854212*^9, 
   3.636813175804471*^9}, 3.636813680090459*^9, 3.636813733143071*^9, 
   3.636813866043968*^9, 3.636814688645596*^9, 3.636814755790698*^9, 
   3.636814846450329*^9, 3.6368149404485607`*^9, 3.63743746525592*^9, 
   3.645285706452883*^9, 3.645285776688691*^9, 3.6452862224298067`*^9, 
   3.645286322278376*^9, 3.645286356682782*^9, 3.645287819551196*^9, 
   3.645287875283737*^9, 3.6452894480778503`*^9, 3.6452908904648314`*^9, 
   3.645291289856914*^9, 3.645291908570244*^9, {3.645292010772605*^9, 
   3.645292050640725*^9}, 3.645292367661249*^9, 3.6453562004922867`*^9, 
   3.645356443738459*^9, 3.6453565295782557`*^9, 3.645370820453113*^9, 
   3.6454463032414923`*^9, 3.645446669230735*^9, {3.645447066334998*^9, 
   3.6454470842259407`*^9}, 3.645447244057193*^9, 3.645447317131607*^9, {
   3.6454473929042397`*^9, 3.645447421760517*^9}, 3.645447625304206*^9, 
   3.6454477188504333`*^9, {3.645447967470718*^9, 3.645447987713724*^9}, {
   3.645448613417533*^9, 3.645448662588633*^9}, {3.645463656856164*^9, 
   3.645463672413319*^9}, 3.645463767476856*^9, 3.6454639364604893`*^9, {
   3.645464045691842*^9, 3.645464066171341*^9}, 3.645464163642479*^9, 
   3.645464262682786*^9, 3.645464331147489*^9, 3.645464388834178*^9, 
   3.6454644208801193`*^9, {3.645464462498644*^9, 3.6454644766356792`*^9}, {
   3.645464592161812*^9, 3.645464611153736*^9}, 3.645464904928524*^9, 
   3.645465107450404*^9, 3.6454652925934687`*^9, 3.645465330787938*^9, 
   3.645465813630231*^9, {3.6454659051830893`*^9, 3.645465921793579*^9}, 
   3.645466215757279*^9, 3.6454664888652487`*^9, 3.645466725820237*^9, 
   3.645466785495235*^9, 3.6454668634566097`*^9, 3.645467136465808*^9, 
   3.645467455841037*^9, 3.6454675231340437`*^9, 3.645467651917748*^9, 
   3.6454680348652353`*^9, 3.645484607044248*^9, 3.645484887686599*^9, 
   3.6455271807425823`*^9, 3.645541556900447*^9, {3.6456138166512547`*^9, 
   3.645613839785892*^9}, {3.6456192017911777`*^9, 3.64561921622015*^9}, 
   3.6456195387879543`*^9, 3.645619667430282*^9, 3.645619813683123*^9, 
   3.645619899436285*^9, {3.645620651074247*^9, 3.645620663479725*^9}, 
   3.645620844345819*^9, {3.645622329583362*^9, 3.645622335975501*^9}, 
   3.645630877474362*^9, 3.645703658595695*^9, 3.645703688988763*^9, 
   3.64580773654949*^9, 3.645809192347973*^9, 3.645810274896647*^9, 
   3.645826815028632*^9, 3.645874056523356*^9, 3.6458744208322773`*^9, 
   3.64587447936917*^9, 3.645884387868865*^9, 3.64588530364738*^9, 
   3.645885340256029*^9, 3.645966996067706*^9, 3.645980983379129*^9, 
   3.645981174970478*^9, {3.6472659574446583`*^9, 3.647265985081423*^9}, {
   3.647268339976733*^9, 3.647268343818327*^9}, {3.6472802984502497`*^9, 
   3.6472803149323273`*^9}, {3.647280881362988*^9, 3.6472808942013903`*^9}, 
   3.647281013732481*^9, {3.647281119732574*^9, 3.647281130007667*^9}, {
   3.647281236428999*^9, 3.647281263943698*^9}, 3.647281323431468*^9, 
   3.647283209606392*^9, {3.6473433420685*^9, 3.6473434602882338`*^9}, 
   3.647343559329129*^9, {3.64735591305345*^9, 3.6473559202353067`*^9}, 
   3.647392863975567*^9, 3.647433618687199*^9, 3.6474338050865173`*^9, 
   3.6474344365807056`*^9, 3.647436720039749*^9, 3.6474367850059023`*^9, 
   3.647436995689939*^9, 3.647437254215172*^9, 3.647437874952529*^9, 
   3.647438177111039*^9, 3.647438369051793*^9, 3.647438975012682*^9, 
   3.64743903251899*^9, 3.647439063596448*^9, 3.647439161624094*^9, 
   3.6474392903318863`*^9, 3.6474393428645697`*^9, 3.647439775323319*^9, 
   3.647440795182186*^9, 3.6474412153950253`*^9, 3.647450239118894*^9, 
   3.647452673019517*^9, 3.647454171418743*^9, {3.647455365969874*^9, 
   3.6474553751803217`*^9}, {3.647455466102232*^9, 3.647455476921639*^9}, 
   3.647455561617284*^9, 3.6474556379168158`*^9, {3.6474556694301434`*^9, 
   3.647455716227996*^9}, 3.647456204088505*^9, 3.6474563897388144`*^9, {
   3.6474564539901237`*^9, 3.647456501273264*^9}, {3.6474565424517803`*^9, 
   3.647456580477581*^9}, 3.6474566146063643`*^9, {3.64745664721033*^9, 
   3.647456708586362*^9}, {3.647456748375803*^9, 3.647456824014111*^9}, {
   3.647456863609393*^9, 3.6474569115226727`*^9}, {3.647457601728671*^9, 
   3.6474576573996897`*^9}, {3.6585911722134457`*^9, 3.6585911922837343`*^9}, 
   3.6699017497011213`*^9, 3.669901914403544*^9, 3.669903255482321*^9, 
   3.669904199787301*^9, 3.669904908509965*^9, 3.669906701387601*^9, 
   3.670235953603693*^9, 3.670237914640579*^9, 3.670682348023827*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.044761012257869166`", ",", "0.009992494532082442`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.636462646851384*^9, 3.63646280628603*^9, 3.636462874853283*^9, {
   3.636462933576659*^9, 3.636462951358379*^9}, 3.636479562324979*^9, 
   3.636479603364944*^9, 3.636479943729957*^9, 3.636480045382715*^9, 
   3.636480192424007*^9, 3.636480542112059*^9, 3.636480598515188*^9, 
   3.63648214268475*^9, 3.636482589615883*^9, 3.636482642254519*^9, 
   3.636483329098032*^9, 3.636483628049892*^9, 3.636483673063673*^9, 
   3.636483765115247*^9, 3.63648392906851*^9, 3.6364842824029703`*^9, 
   3.636542547977421*^9, 3.636543239885788*^9, 3.6365432907762337`*^9, 
   3.636543458711968*^9, {3.636544021553356*^9, 3.6365440414400263`*^9}, {
   3.636544164968217*^9, 3.636544189317101*^9}, 3.636544299226224*^9, 
   3.636544386416114*^9, 3.636544423031928*^9, 3.6365445273325987`*^9, 
   3.636544588973103*^9, 3.636544780397634*^9, 3.6365448137377863`*^9, 
   3.636544896147871*^9, 3.6365450015861197`*^9, 3.636545356011181*^9, 
   3.6365455631734667`*^9, {3.6365456254155293`*^9, 3.636545655387309*^9}, 
   3.6365457166784983`*^9, 3.636545753593766*^9, 3.636545945178433*^9, 
   3.636549427530669*^9, 3.636549471726996*^9, {3.636549535078075*^9, 
   3.636549547480281*^9}, {3.636549728954068*^9, 3.63654973788682*^9}, 
   3.636549792668211*^9, 3.636549975688675*^9, 3.636550106123747*^9, 
   3.636551767636756*^9, 3.636552217263549*^9, {3.636557690949176*^9, 
   3.6365577075738077`*^9}, 3.636559455850911*^9, 3.6365600440102587`*^9, 
   3.636560189133195*^9, {3.636560389970348*^9, 3.636560409769514*^9}, 
   3.636560594524077*^9, 3.636561081746148*^9, {3.6365611629066753`*^9, 
   3.636561184731662*^9}, 3.636562506810142*^9, 3.636562726980426*^9, 
   3.636562805980872*^9, 3.636563007106784*^9, 3.63656307927901*^9, {
   3.636563163120838*^9, 3.636563204577136*^9}, 3.636563281563301*^9, 
   3.636563320222787*^9, 3.636565667556663*^9, 3.6365659028141603`*^9, 
   3.6365665309186153`*^9, 3.636566775862789*^9, 3.6365670953360863`*^9, {
   3.636567143105894*^9, 3.636567156567916*^9}, 3.636567455957905*^9, 
   3.636567631254016*^9, 3.6365677617877293`*^9, {3.636568032548525*^9, 
   3.6365680440989637`*^9}, 3.6365682723362827`*^9, 3.636568524203781*^9, 
   3.636568646987482*^9, {3.636568976606017*^9, 3.636568983701004*^9}, 
   3.636569238034401*^9, 3.6365695806116037`*^9, 3.6365699504043503`*^9, 
   3.63656998742902*^9, 3.6365896366523952`*^9, 3.636589721791129*^9, 
   3.6365897903882008`*^9, 3.636589845919959*^9, 3.6365898850998898`*^9, 
   3.636813013941802*^9, 3.636813095470265*^9, {3.636813153854212*^9, 
   3.636813175804471*^9}, 3.636813680090459*^9, 3.636813733143071*^9, 
   3.636813866043968*^9, 3.636814688645596*^9, 3.636814755790698*^9, 
   3.636814846450329*^9, 3.6368149404485607`*^9, 3.63743746525592*^9, 
   3.645285706452883*^9, 3.645285776688691*^9, 3.6452862224298067`*^9, 
   3.645286322278376*^9, 3.645286356682782*^9, 3.645287819551196*^9, 
   3.645287875283737*^9, 3.6452894480778503`*^9, 3.6452908904648314`*^9, 
   3.645291289856914*^9, 3.645291908570244*^9, {3.645292010772605*^9, 
   3.645292050640725*^9}, 3.645292367661249*^9, 3.6453562004922867`*^9, 
   3.645356443738459*^9, 3.6453565295782557`*^9, 3.645370820453113*^9, 
   3.6454463032414923`*^9, 3.645446669230735*^9, {3.645447066334998*^9, 
   3.6454470842259407`*^9}, 3.645447244057193*^9, 3.645447317131607*^9, {
   3.6454473929042397`*^9, 3.645447421760517*^9}, 3.645447625304206*^9, 
   3.6454477188504333`*^9, {3.645447967470718*^9, 3.645447987713724*^9}, {
   3.645448613417533*^9, 3.645448662588633*^9}, {3.645463656856164*^9, 
   3.645463672413319*^9}, 3.645463767476856*^9, 3.6454639364604893`*^9, {
   3.645464045691842*^9, 3.645464066171341*^9}, 3.645464163642479*^9, 
   3.645464262682786*^9, 3.645464331147489*^9, 3.645464388834178*^9, 
   3.6454644208801193`*^9, {3.645464462498644*^9, 3.6454644766356792`*^9}, {
   3.645464592161812*^9, 3.645464611153736*^9}, 3.645464904928524*^9, 
   3.645465107450404*^9, 3.6454652925934687`*^9, 3.645465330787938*^9, 
   3.645465813630231*^9, {3.6454659051830893`*^9, 3.645465921793579*^9}, 
   3.645466215757279*^9, 3.6454664888652487`*^9, 3.645466725820237*^9, 
   3.645466785495235*^9, 3.6454668634566097`*^9, 3.645467136465808*^9, 
   3.645467455841037*^9, 3.6454675231340437`*^9, 3.645467651917748*^9, 
   3.6454680348652353`*^9, 3.645484607044248*^9, 3.645484887686599*^9, 
   3.6455271807425823`*^9, 3.645541556900447*^9, {3.6456138166512547`*^9, 
   3.645613839785892*^9}, {3.6456192017911777`*^9, 3.64561921622015*^9}, 
   3.6456195387879543`*^9, 3.645619667430282*^9, 3.645619813683123*^9, 
   3.645619899436285*^9, {3.645620651074247*^9, 3.645620663479725*^9}, 
   3.645620844345819*^9, {3.645622329583362*^9, 3.645622335975501*^9}, 
   3.645630877474362*^9, 3.645703658595695*^9, 3.645703688988763*^9, 
   3.64580773654949*^9, 3.645809192347973*^9, 3.645810274896647*^9, 
   3.645826815028632*^9, 3.645874056523356*^9, 3.6458744208322773`*^9, 
   3.64587447936917*^9, 3.645884387868865*^9, 3.64588530364738*^9, 
   3.645885340256029*^9, 3.645966996067706*^9, 3.645980983379129*^9, 
   3.645981174970478*^9, {3.6472659574446583`*^9, 3.647265985081423*^9}, {
   3.647268339976733*^9, 3.647268343818327*^9}, {3.6472802984502497`*^9, 
   3.6472803149323273`*^9}, {3.647280881362988*^9, 3.6472808942013903`*^9}, 
   3.647281013732481*^9, {3.647281119732574*^9, 3.647281130007667*^9}, {
   3.647281236428999*^9, 3.647281263943698*^9}, 3.647281323431468*^9, 
   3.647283209606392*^9, {3.6473433420685*^9, 3.6473434602882338`*^9}, 
   3.647343559329129*^9, {3.64735591305345*^9, 3.6473559202353067`*^9}, 
   3.647392863975567*^9, 3.647433618687199*^9, 3.6474338050865173`*^9, 
   3.6474344365807056`*^9, 3.647436720039749*^9, 3.6474367850059023`*^9, 
   3.647436995689939*^9, 3.647437254215172*^9, 3.647437874952529*^9, 
   3.647438177111039*^9, 3.647438369051793*^9, 3.647438975012682*^9, 
   3.64743903251899*^9, 3.647439063596448*^9, 3.647439161624094*^9, 
   3.6474392903318863`*^9, 3.6474393428645697`*^9, 3.647439775323319*^9, 
   3.647440795182186*^9, 3.6474412153950253`*^9, 3.647450239118894*^9, 
   3.647452673019517*^9, 3.647454171418743*^9, {3.647455365969874*^9, 
   3.6474553751803217`*^9}, {3.647455466102232*^9, 3.647455476921639*^9}, 
   3.647455561617284*^9, 3.6474556379168158`*^9, {3.6474556694301434`*^9, 
   3.647455716227996*^9}, 3.647456204088505*^9, 3.6474563897388144`*^9, {
   3.6474564539901237`*^9, 3.647456501273264*^9}, {3.6474565424517803`*^9, 
   3.647456580477581*^9}, 3.6474566146063643`*^9, {3.64745664721033*^9, 
   3.647456708586362*^9}, {3.647456748375803*^9, 3.647456824014111*^9}, {
   3.647456863609393*^9, 3.6474569115226727`*^9}, {3.647457601728671*^9, 
   3.6474576573996897`*^9}, {3.6585911722134457`*^9, 3.6585911922837343`*^9}, 
   3.6699017497011213`*^9, 3.669901914403544*^9, 3.669903255482321*^9, 
   3.669904199787301*^9, 3.669904908509965*^9, 3.669906701387601*^9, 
   3.670235953603693*^9, 3.670237914640579*^9, 3.6706823480349503`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Quad soliton computations", "Section",
 CellChangeTimes->{{3.648225477641464*^9, 3.6482254837674503`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data1", "=", 
   RowBox[{"Monitor", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"TodaabAuto", "[", 
            RowBox[{"n", ",", "2000"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Re"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"-", "2300"}], ",", "2300"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "contours"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPlot", "[", 
  RowBox[{"data1", ",", 
   RowBox[{"Axes", "\[Rule]", "False"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", ".4"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
   RowBox[{"FrameStyle", "\[Rule]", "20"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.6473559509899282`*^9, 3.647356008788887*^9}, {
   3.647437526126679*^9, 3.6474375389264593`*^9}, {3.647438130648171*^9, 
   3.6474381308942747`*^9}, {3.647438317880199*^9, 3.647438334981867*^9}, {
   3.647438637683631*^9, 3.647438642827961*^9}, {3.647440931246853*^9, 
   3.647440937852583*^9}, {3.647447144705364*^9, 3.647447151664164*^9}, {
   3.647450231800569*^9, 3.647450234374893*^9}, {3.64745073782263*^9, 
   3.647450747498026*^9}, {3.647452240373199*^9, 3.6474522543209553`*^9}, {
   3.647452681653163*^9, 3.647452699634618*^9}, {3.647454166810659*^9, 
   3.647454167010387*^9}, {3.6474569216758537`*^9, 3.647456949347386*^9}, {
   3.647457003981833*^9, 3.6474570062920322`*^9}, 3.647457139426659*^9, {
   3.64745725692914*^9, 3.64745725970308*^9}, {3.64745797720735*^9, 
   3.6474579935002613`*^9}, {3.647458032971382*^9, 3.647458042194601*^9}, {
   3.647458112091831*^9, 3.647458135176874*^9}, {3.647458304466805*^9, 
   3.647458321900798*^9}, {3.6474584394119263`*^9, 3.647458439833898*^9}, {
   3.647458749405546*^9, 3.647458754490527*^9}, {3.647460811179553*^9, 
   3.647460816049678*^9}, {3.647465825844927*^9, 3.6474658399807243`*^9}, {
   3.647480118811318*^9, 3.647480147947215*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.005555555555555556], 
     AbsoluteThickness[1.6], PointBox[CompressedData["
1:eJxcXXlcTG3YDiFbQshaXlsIIWTPWgghhBBCCGnRIjXte03NVNMszWQNeYUQ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      "]]}, {}}, {}},
  AspectRatio->0.4,
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0.4780151085902743},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->20,
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageMargins->0.,
  ImageSize->800,
  ImageSizeRaw->Automatic,
  Method->{},
  PlotRange->{{-2300., 2300.}, {0.4872796731013286, 0.6725709633224153}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.647354873613242*^9, 3.6473548992655153`*^9}, 
   3.647355896913967*^9, {3.647355957007078*^9, 3.647356009708549*^9}, 
   3.6473624071540203`*^9, 3.647378877126536*^9, 3.647437866290783*^9, 
   3.647438072364997*^9, 3.6474381566454268`*^9, {3.647438315756743*^9, 
   3.647438322930537*^9}, 3.64743836125494*^9, 3.647438500516902*^9, {
   3.647438765612308*^9, 3.6474387917623863`*^9}, 3.647438988082705*^9, {
   3.6474390407585*^9, 3.64743906979368*^9}, 3.647439166851943*^9, {
   3.6474393199961653`*^9, 3.647439349026506*^9}, 3.647439783624878*^9, 
   3.647440917494266*^9, 3.647441209649194*^9, {3.647447143083725*^9, 
   3.6474471465132313`*^9}, 3.6474499293667717`*^9, 3.64745018541609*^9, 
   3.647450286151492*^9, {3.647450735202013*^9, 3.647450739998849*^9}, {
   3.647452238751985*^9, 3.647452251465283*^9}, 3.647452618160735*^9, {
   3.6474541212636414`*^9, 3.647454124591606*^9}, {3.6474553368064623`*^9, 
   3.647455340309206*^9}, 3.6474569456413727`*^9, 3.6474570014308643`*^9, 
   3.647457137358714*^9, 3.64745722321799*^9, 3.647457573774778*^9, {
   3.647457961948296*^9, 3.6474579943636427`*^9}, {3.647458034151273*^9, 
   3.647458037708357*^9}, {3.647458108586247*^9, 3.647458124135089*^9}, {
   3.6474583060594263`*^9, 3.647458307988736*^9}, 3.647458356371994*^9, {
   3.647458739056234*^9, 3.647458750751802*^9}, 3.647460636283169*^9, 
   3.647460803710782*^9, {3.647465823677835*^9, 3.647465826396679*^9}, {
   3.647480117009036*^9, 3.647480123152988*^9}, 3.647489239975326*^9, 
   3.647522748513834*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"data1", "=", 
   RowBox[{"Monitor", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"TodaabAuto", "[", 
            RowBox[{"n", ",", "2000"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "//", "Re"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"-", "1900"}], ",", "1900"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "contours"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"pl1", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{"data1", ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", ".4"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", "20"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1900"}], ",", "1900"}], "}"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", ".1"}], ",", ".1"}], "}"}], "/", "4"}], "+", ".5"}]}],
       "}"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.647542866860903*^9, 3.647542894481915*^9}, {
  3.6475429285069857`*^9, 3.647542970317368*^9}, {3.647543044310795*^9, 
  3.647543147714197*^9}, {3.647543302569659*^9, 3.6475433078532124`*^9}, {
  3.647543364994225*^9, 3.647543367288824*^9}, {3.647543908561096*^9, 
  3.647543938284122*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.005555555555555556], 
     AbsoluteThickness[1.6], PointBox[CompressedData["
1:eJxEfXlcjG/U/iBkSwhZy56EELJnLYQihFAUoTRK2mva95pmppqaibFn+4pC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      "]]}, {}}, {}},
  AspectRatio->0.4,
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0.47524999999999995`},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->20,
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->800,
  Method->{},
  PlotRange->{{-1900, 1900}, {0.475, 0.525}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0, 0}, {0, 0}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.6475428744055567`*^9, 3.647542896629778*^9}, {
   3.647542932785426*^9, 3.647542972455916*^9}, {3.6475430471828613`*^9, 
   3.647543149773966*^9}, {3.6475433055729017`*^9, 3.647543309834*^9}, 
   3.647543370740975*^9, {3.647543917983058*^9, 3.647543940342922*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{719, 851},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (December 4, \
2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 546, 12, 63, "Input"],
Cell[1106, 34, 1324, 26, 97, "Input"],
Cell[CellGroupData[{
Cell[2455, 64, 158, 2, 64, "Section"],
Cell[2616, 68, 754, 24, 46, "Input"],
Cell[CellGroupData[{
Cell[3395, 96, 114, 1, 44, "Subsection"],
Cell[CellGroupData[{
Cell[3534, 101, 1193, 36, 80, "Input"],
Cell[4730, 139, 37242, 622, 242, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[42021, 767, 413, 5, 36, "Subsection"],
Cell[CellGroupData[{
Cell[42459, 776, 1644, 40, 80, "Input"],
Cell[44106, 818, 40032, 661, 242, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[84187, 1485, 105, 1, 44, "Subsection"],
Cell[CellGroupData[{
Cell[84317, 1490, 1346, 37, 80, "Input"],
Cell[85666, 1529, 36996, 617, 242, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[122711, 2152, 102, 1, 44, "Subsection"],
Cell[CellGroupData[{
Cell[122838, 2157, 4577, 109, 165, "Input"],
Cell[127418, 2268, 41578, 692, 242, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[169045, 2966, 100, 1, 36, "Subsection"],
Cell[CellGroupData[{
Cell[169170, 2971, 2262, 69, 114, "Input"],
Cell[171435, 3042, 40502, 677, 242, "Output"]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[211998, 3726, 186, 2, 64, "Section"],
Cell[CellGroupData[{
Cell[212209, 3732, 15114, 340, 709, "Input"],
Cell[227326, 4074, 7149, 102, 28, "Output"],
Cell[234478, 4178, 7071, 100, 28, "Output"],
Cell[241552, 4280, 7152, 103, 28, "Output"],
Cell[248707, 4385, 7075, 100, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[255831, 4491, 112, 1, 64, "Section"],
Cell[CellGroupData[{
Cell[255968, 4496, 2193, 44, 80, "Input"],
Cell[258164, 4542, 59095, 979, 346, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[317296, 5526, 1607, 44, 97, "Input"],
Cell[318906, 5572, 50961, 845, 346, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
